STATIC saVersion := {'SqlQuery','2.0.159'}

#INCLUDE "types.ch"
#INCLUDE "dccolors.CH"
#INCLUDE "dcdialog.CH"
#INCLUDE "dcprint.CH"
#INCLUDE "dctree.CH"
#INCLUDE "adsdbe.CH"
#INCLUDE "dcads.CH"
#INCLUDE "dcicon.CH"
#INCLUDE "dcpick.CH"
#INCLUDE "dmlb.CH"
#INCLUDE "SqlQuery.CH"
#INCLUDE "appevent.CH"
#INCLUDE "sqlcmd.CH"
#INCLUDE "dll.CH"
#include "odbcdbe.ch"
#include "common.ch"

#if XPPVER > 2000000
  #INCLUDE "pgdbe.CH"
#endif
#INCLUDE "xpppp.CH"
#INCLUDE "odbcdbe.ch"
#INCLUDE "dccursor.CH"
#INCLUDE "foxdbe.CH"
#INCLUDE "cdxdbe.CH"

#DEFINE LINK_DIALOG xbeP_User + 100
#DEFINE LINK_MESSAGE xbeP_User + 101
#DEFINE RESIZE_WINDOW xbeP_User + 102
#DEFINE SCOPE_REFRESH xbeP_User + 103

#DEFINE VIEWTYPE_SQLSELECT              1
#DEFINE VIEWTYPE_SQLSELECT_ONE2MANY     2
#DEFINE VIEWTYPE_SQLPROCEDURE           3
#DEFINE VIEWTYPE_XBASECOMMANDS          4
#DEFINE VIEWTYPE_ISAMBROWSE             5
#DEFINE VIEWTYPE_COLUMNBROWSE           6

#DEFINE WINDOWPOS_CENTERMAIN         0
#DEFINE WINDOWPOS_ANCHORTREERIGHT    1
#DEFINE WINDOWPOS_ANCHORTREELEFT     2


// Execute a statement
#xcommand DDSTATEMENT <(x)> [VIA <session>] [TO <y>] [ALIAS <a>];
              => [<y> :=] DD_SqlStmtExec(<(x)>,<session>,<(a)>)

// Execute a stored procedure
#xcommand DDPROCEDURE <(x)> [VIA <session>] [TO <y>] ;
              => [<y> :=] DD_SqlProcedure(<(x)>,<session>)

// Execute a statement, get result, close result set
#xcommand DDSQLRESULT <(x)> INTO <result> [VIA <session>];
              => DD_SqlResult(<(x)>,<session>,<result>)

// Execute a statement, no result set expected
#xcommand DDSQLCMD <(x)> [VIA <session>];
              => DD_SqlCmd(<(x)>,<session>,, .F.)

#Pragma Library("dclip1.lib")
#Pragma Library("asinet10.lib")
#Pragma Library("dcxml.lib")
#if XPPVER > 2000000
  #Pragma Library("aspapi.lib")
  #Pragma Library("aspapib.lib")
  #Pragma Library("asued10.lib")
#else
  #Pragma Library("aspp18b.lib")
  #Pragma Library("aspp18.lib")
#endif

#DEFINE CRLF Chr(13)+Chr(10)

#DEFINE OBJECT_TABLES              1
#DEFINE OBJECT_USERS               2
#DEFINE OBJECT_VIEWS               3
#DEFINE OBJECT_GROUPS              4
#DEFINE OBJECT_PROCEDURES          5
#DEFINE OBJECT_TRIGGERS            6
#DEFINE OBJECT_RELATIONS           7
#DEFINE OBJECT_LINKS               8
#DEFINE OBJECT_ARTICLES            9
#DEFINE OBJECT_SUBSCRIPTIONS      10
#DEFINE OBJECT_PUBLICATIONS       11
#DEFINE OBJECT_COMMAND_SCRIPTS    12
#DEFINE OBJECT_SQL_SCRIPTS        13
#DEFINE OBJECT_ISAM_SCRIPTS       14

#DEFINE OBJECT_SIZE               14

#ifndef ADSDBE_VFP
#DEFINE ADSDBE_VFP    4
#endif

STATIC soMessageBox, saStatement[30], saRowCount[30], saConnections[30], ;
       soSqlQuery, saAdsStatement[30], saSqlExecuteTime[30], ;
       saSqlExecuteTimeObject[30]

FIELD connection, title, viewtype, table

// EXTERN UINTEGER AdsRegisterCallbackFunction( lpfnCallback AS ACALLBACK, ulCallbackID AS UINTEGER ) IN ace32.dll
// EXTERN UINTEGER AdsClearCallbackFunction() IN ace32.dll


* ----------------

/*
FUNCTION Main( cIniName )

LOCAL oSqlQuery

DC_Sett('EDITOR','C:\public\q.bat')
DC_Sett('ODIR',DC_Path(AppName(.t.)))
DC_Sett('PDIR',DC_Path(AppName(.t.)))

DC_IconDefault(ICON_DICTIONARY)

DbSetNullValue(.f.)
SET NULLVALUE OFF

soSqlQuery := SqlQuery():new( cIniName )

soSqlQuery:LoadSessions()

soSqlQuery:showDialog()

RETURN nil
*
* ---------

PROC appsys ; RETURN

*/

CLASS SqlQuery

EXPORTED:

  VAR aSelectWhere, ;
      aBrowPres, ;
      aEvenColorCol, ;
      aEvenColorRow, ;
      aOddColorCol, ;
      aOddColorRow, ;
      aSelectColumns, ;
      aSelectJoin, ;
      aSelectOrder, ;
      cDataPath, ;
      cDictName, ;
      cDictServer, ;
      cFreeServer, ;
      cMessageFont, ;
      cPassword, ;
      cSelectFrom, ;
      cStatement, ;
      cTreeFont, ;
      cUserName, ;
      cIniFile, ;
      cIniPath, ;
      cUpdateMessage, ;
      cSourceEditor, ;
      lPrintGrid, ;
      lShowBrowseMessages, ;
      lIsAdmin, ;
      nDictHandle, ;
      nFreeHandle, ;
      nLastExecuteTime, ;
      nPrintFudge, ;
      nPrintOrientation, ;
      nTreeFGColor, ;
      nTreeBGColor, ;
      nBrowseWindowPos, ;
      oAdsSessionDict, ;
      oAdsSessionFree, ;
      oCellContents, ;
      oMainWindow, ;
      oMenuBar, ;
      oMessageBox, ;
      oODBCSession, ;
      oPropDlg, ;
      oSession, ;
      oStatement, ;
      oToolBar, ;
      oTree, ;
      oTreeWindow, ;
      oBrowseParentWindow, ;
      sessionsArray, ;
      oBrowseParent, ;
      oBrowseParentDlg, ;
      oBrowseChild, ;
      oBrowseChildDlg, ;
      oBrowseChildPick, ;
      cChildAlias, ;
      oChildAliasSay, ;
      oChildAliasScope, ;
      lChildAliasScope, ;
      cSqlQueryDbf, ;
      cSqlQueryCdx, ;
      cChildSqlStatement, ;
      cLastSqlErrorText, ;
      aScaleFactor, ;
      cMenuFont, ;
      oButtonConfig, ;
      nCachedColumns, ;
      oSortConfig, ;
      oAdsSession, ;
      lShowWorkingMessage

  METHOD Init(), ;
      AddAdsIndexSQL(), ;
      AddODBCIndexSQL(), ;
      AddTableSQL(), ;
      AddFieldSQL(), ;
      AdsArray2DD(), ;
      ApplySqlParams(), ;
      AdsDDAddTable(), ;
      AdsDDGetFieldStructure(), ;
      AdsDDRemoveTable(), ;
      BrowseISAM(), ;
      BrowseSqlQueryDbf(), ;
      BuildDDAds(), ;
      BuildDictArrayAds(), ;
      BuildDictArrayODBC(), ;
      BuildIndexArrayODBC(), ;
      BuildIndexArrayAds(), ;
      BuildFreeArrayAds(), ;
      BuildObjectArrayAds(), ;
      BuildSqlSelect(), ;
      BuildTree(), ;
      BuildTreeBranch(), ;
      BuildTreeFields(), ;
      BuildTreeViews(), ;
      BuildTreeProcedures(), ;
      BuildTreeScripts(), ;
      BuildProcedureArrayODBC(), ;
      BuildProcedureArrayADS(), ;
      CancelQuery(), ;
      CancelQueryDialog(), ;
      CheckForUpdate(), ;
      DownloadLatestVersion(), ;
      CreateConnection(), ;
      CreateAccessSchemaArray(), ;
      DataBrowse(), ;
      DeleteScript(), ;
      DictFieldProperties(), ;
      DictGroupProperties(), ;
      DictIndexProperties(), ;
      DictRIProperties(), ;
      DictReindexTable(), ;
      DictTableProperties(), ;
      DictUserProperties(), ;
      ViewExecute(), ;
      ViewProperties(), ;
      DictProcedureExecuteSql(), ;
      DictProcedurePropertiesADS(), ;
      DictProcedurePropertiesODBC(), ;
      UpdateProcedureCommentADS(), ;
      UpdateTableCommentADS(), ;
      DisconnectSessions(), ;
      DisconnectConnections(), ;
      Disconnect(), ;
      DropAdsIndexSQL(), ;
      DropFieldSQL(), ;
      DropTableSQL(), ;
      DropProcedureSQL(), ;
      ZapTableAds(), ;
      ZapTableSQL(), ;
      CreateProcedureSQL(), ;
      EditRecord(), ;
      ExecuteSql(), ;
      ExecuteLinkedView(), ;
      FieldList(), ;
      GetFieldNameArrayADS(), ;
      HexToRGBColor(), ;
      RGBToHexColor(), ;
      ConvertColor(), ;
      LinkWindow(), ;
      ListODBCDrivers(), ;
      ListODBCSources(), ;
      ListODBCDataTypes(), ;
      LoadSessions(), ;
      LoadSqlScript(), ;
      LoadCommandScript(), ;
      LoadScripts(), ;
      CreateViewSql(), ;
      DeleteViewSql(), ;
      LoadScript(), ;
      SqlScriptProperties(), ;
      AlterFieldSQL(), ;
      Browse2Database(), ;
      Browse2Export(), ;
      Table2Database(), ;
      Table2Export(), ;
      ObjectBrowse(), ;
      PackTable(), ;
      ParseIt(), ;
      ReadGuiHandler(), ;
      ReBuildTree(), ;
      ReExecuteSql(), ;
      ReLoadScripts(), ;
      ReplaceNullValues(), ;
      ResetFilter(), ;
      RunProc(), ;
      SaveLinkedView(), ;
      SendLinkedMessage(), ;
      SaveSqlScript(), ;
      SaveCommandScript(), ;
      SetDefaultValues(), ;
      SetLinkedData(), ;
      SetWindowPos(), ;
      ShowDialog(), ;
      ShowConnectionProperties(), ;
      EditConnectionProperties(), ;
      DeleteConnection(), ;
      ShowTableProperties(), ;
      ShowTreeInfo(), ;
      ShowDataTypes(), ;
      SqlAddUUIDField(), ;
      SqlFillUUIDField(), ;
      SqlAddUUIDIndex(), ;
      SqlPickFields(), ;
      SqlQueryPick(), ;
      SqlResult(), ;
      TableProperties(), ;
      TagAction(), ;
      TagArray(), ;
      TreeMenu(), ;
      TreeWindow(), ;
      UnixTime2DateTime(), ;
      Array2Database(), ;
      Array2Xml(), ;
      Array2Sql(), ;
      Array2Json(), ;
      Array2Html(), ;
      Array2Text(), ;
      WorkArea2Excel(), ;
      WorkArea2Database(), ;
      WorkArea2Xml(), ;
      WorkArea2Sql(), ;
      WorkArea2Json(), ;
      WorkArea2Html(), ;
      WorkArea2Text(), ;
      ValidateScriptTitle(), ;
      OpenViewsFile(), ;
      BrowseColumnsISAM(), ;
      GetBrowseColumnsArray(), ;
      SaveBrowseColumnsArray(), ;
      UpdatePickedFieldList(), ;
      BuildAdsIndexSQL(), ;
      BuildAdsIndexSqlAll(), ;
      BuildODBCIndexSQL(), ;
      ShowResponse(), ;
      BrowseColors(), ;
      DropODBCIndexSQL(), ;
      CopyRecordsToClipBoard(), ;
      PasteRecordsFromClipBoard(), ;
      CopyCellToClipBoard(), ;
      AdsDebugSqlMode(), ;
      CommandWindow(), ;
      ExecuteCommands(), ;
      WriteSchema(oConnection), ;
      OdbcTest1(), ;
      AdsTest1(), ;
      ChooseCachedColumns(), ;
      ;// SaveCachedColumns(), ;
      TableNameFromStatement(), ;
      AdsIsTableEncrypted(), ;
      AdsTableSetEncrypted(), ;
      AdsTestDictionary(), ;
      AdsListFilesNotInDictionary(), ;
      ExecuteSQLScript(), ;
      SqlSearchTable(), ;
      WorkingMessage()

#if XPPVER > 2000000
  METHOD BuildDictArrayPg()
#endif

ENDCLASS

* ---------

METHOD SqlQuery:init( cIniFile )

LOCAL aStru, cFileName, aData, aRef, cPath, cCDX, cDBF, cBAK, ;
      GetOptions, nScale, oThread, nSaveArea

DEFAULT cIniFile := DC_Path(AppName(.t.)) + 'SqlQuery.Ini'

::cIniFile := cIniFile
::cIniPath := DC_Path(cIniFile)
DC_ChDir(::cIniPath)

/*
IF !FExists(::cIniFile)
  DCMSGBOX 'Ini file: ' + ::cIniFile + ' not found!', ;
           'Quitting!' FONT '10.Lucida Console'
  QUIT
ENDIF
*/

::cUpdateMessage := ''
::lShowWorkingMessage := .f.

AdsCacheOpenCursors(0)
AFill(saSqlExecuteTime,0)

oThread := Thread():new()
Sleep(5)
oThread:start({||::checkForUpdate()})

soSqlQuery := self

DC_SetIconResource(7800,7823)

aRef := { 'TreeFont','ShowBrowseCautionMessages', ;
          'TreeFGColor', 'TreeBGColor', ;
          'BrowseFGColorOdd','BrowseBGColorOdd', ;
          'BrowseFGColorEven','BrowseBGColorEven', ;
          'BrowseWindowsOnDesktop', ;
          'SourceEditor', ;
          'Administrator', ;
          'BrowseWindowPos', ;
          'WindowScaleFactor', ;
          'MenuFont', ;
          'CacheColumns' }

aData := { Pad('10.Lucida Console',30), ;
           .t., ;
           Pad('{0,0,0}',15), ;
           Pad('{240,240,240}',15), ;
           Pad('{0,0,0}',15), ;
           Pad('{202,225,255}',15), ;
           Pad('{0,0,0}',15), ;
           Pad('{117,186,229}',15), ;
           .t., ;
           Space(50), ;
           .f., ;
           0, ;
           1, ;
           Pad('10.Arial Bold',50), ;
           30 }

DC_IniLoad( ::cIniFile,'SYSTEM',aData,aRef )

IF aData[9]
  ::oBrowseParentWindow := AppDeskTop()
ENDIF

::nCachedColumns := aData[15]

::cTreeFont := Alltrim(aData[1])
::lShowBrowseMessages := aData[2]
::nTreeFgColor := ::ConvertColor(aData[3])
::nTreeBGColor := ::ConvertColor(aData[4])
::aOddColorRow := {::ConvertColor(aData[5]),::ConvertColor(aData[6])}
::aEvenColorRow := {::ConvertColor(aData[7]),::ConvertColor(aData[8])}
::cSourceEditor := Alltrim(aData[10])
::nBrowseWindowPos := aData[12]
nScale := aData[13]
::cMenuFont := aData[14]
::aOddColorCol := {GRA_CLR_BLACK,GraMakeRGBColor({240,240,240})}
::aEvenColorCol := {GRA_CLR_BLACK,GraMakeRGBColor({210,210,210})}
::sessionsArray := {}
::aSelectColumns := {}
::aSelectWhere := {}
::aSelectJoin := {}
::aSelectOrder := {}
::cSelectFrom := ''
/*
::nPrintOrientation := 2
::nPrintFudge := 3
::lPrintGrid := .f.
*/
::lIsAdmin := GetEnv('SQLQUERY_ISADMIN')='Y' .OR. aData[11]
::nLastExecuteTime := 0
::cMessageFont := '10.Lucida Console'
::cLastSqlErrorText := ''
::aBrowPres := ;
  {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },;           // Header FG Color
   { XBP_PP_COL_HA_BGCLR, GRA_CLR_BACKGROUND },;      // Header BG Color
   { XBP_PP_COL_FA_FGCLR, GRA_CLR_DARKRED},;          // Footer FG Color
   { XBP_PP_COL_FA_BGCLR, GRA_CLR_WHITE},;            // Footer BG Color
   { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },;           // Cell FG Color
   { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE},;            // Cell BG Color
   { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_LINE },;  // Row Sep
   { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_LINE },;  // Col Sep
   { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLACK },;    // Cell Highlighted FG
   { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_WHITE},;     // Cell Highlighted BG
   { XBP_PP_COL_DA_HILITEFRAMELAYOUT,164},;           // Cell outline
   { XBP_PP_COL_DA_CELLFRAMELAYOUT ,  2 },;           /// Cell Frame Layout - no lines
   { XBP_PP_COL_DA_COLSEPARATOR  ,    1 },;           /// Column Separator - no lines
   { XBP_PP_COL_DA_FRAMELAYOUT  ,     0 },;           /// Frame Layout - no lines
   { XBP_PP_COL_DA_ROWHEIGHT, 22 },;                  /// Row Height
   { XBP_PP_COL_FA_HEIGHT, -1 },;                     /// Row Height
   { XBP_PP_COL_DA_CELLHEIGHT, 22 },;                 /// Cell Height
   { XBP_PP_COL_HA_COMPOUNDNAME,'10.Lucida Console Bold'},;
   { XBP_PP_COL_FA_COMPOUNDNAME,'10.Lucida Console Bold'} }


::oSortConfig := DC_XbpPushButtonXPDefault()
::oSortConfig:radius := 5
::oSortConfig:fgColor := GRA_CLR_WHITE
::oSortConfig:bgColor := GRA_CLR_DARKCYAN
::oSortConfig:fgColorMouse := GRA_CLR_WHITE
::oSortConfig:bgColorMouse := GRA_CLR_DARKPINK

/*
::oButtonConfig := DC_XbpPushButtonXPDefault():new()
::oButtonConfig:mouseOverScale := 1.1
::oButtonConfig:mouseOverFont := '9.Helv Bold'
::oButtonConfig:fgColorMouse := GRA_CLR_BLACK
::oButtonConfig:gradientStep := 3
::oButtonConfig:bgColor := GRA_CLR_WHITE

IF Empty(DC_PushButtonStyle())
  DC_PushButtonStyle( ::oButtonConfig )
ENDIF
IF Empty(DC_ExpressButtonStyle())
  DC_ExpressButtonStyle( ::oButtonConfig )
ENDIF
IF Empty(DC_PopupButtonStyle())
  DC_PopupButtonStyle( ::oButtonConfig )
ENDIF
*/

LoadDbes()

aStru := { { 'CONNECTION','C', 10, 0 }, ;
           { 'TITLE',     'C', 50, 0 }, ;
           { 'TABLE',     'C', 50, 0 }, ;
           { 'STATEMENT', 'M', 10, 0 }, ;
           { 'STATEMENT1','M', 10, 0 }, ;
           { 'STATEMENT2','M', 10, 0 }, ;
           { 'FROMFIELD1','C', 30, 0 }, ;
           { 'FROMFIELD2','C', 30, 0 }, ;
           { 'TOFIELD1',  'C', 30, 0 }, ;
           { 'TOFIELD2',  'C', 30, 0 }, ;
           { 'FROMWIN',   'C', 20, 0 }, ;
           { 'TOWIN1',    'C', 20, 0 }, ;
           { 'TOWIN2',    'C', 20, 0 }, ;
           { 'VIEWTYPE',  'N',  1, 0 }, ;
           { 'ALIAS',     'C', 30, 0 }, ;
           { 'ALIAS1',    'C', 30, 0 }, ;
           { 'ALIAS2',    'C', 30, 0 }, ;
           { 'SETSCOPE1', 'L',  1, 0 }, ;
           { 'SETSCOPE2', 'L',  1, 0 }, ;
           { 'FROMCOLOR', 'C', 50, 0 }, ;
           { 'TOCOLOR1',  'C', 50, 0 }, ;
           { 'TOCOLOR2',  'C', 50, 0 }, ;
           { 'UUID',      'C', 36, 0 } }

cPath := DC_Path(::cIniFile)

cCDX := cPath + 'SQLQUERY.CDX'
cDBF := cPath + 'SQLQUERY.DBF'
cBAK := cPath + 'SQLQBAK.DBF'

::cSqlQueryDbf := cDBF
::cSqlQueryCdx := cCDX

nSaveArea := Select()

IF !File(cDBF)
  dbCreate( cDBF, aStru, 'FOXCDX' )
  USE (cDBF) VIA 'FOXCDX' EXCL NEW
ELSE
  USE (cDBF) VIA 'FOXCDX' NEW
ENDIF

IF !SQLQUERY->(DC_IsStru(aStru))
  COPY TO (cBAK)
  SQLQUERY->(dbCloseArea())
  dbCreate(cDBF,aStru,'FOXCDX')
  USE (cDBF) new EXCLUSIVE VIA 'FOXCDX' EXCL
  APPEND FROM (cBAK)
  IF SQLQUERY->(IsFieldVar('UUID'))
    SQLQUERY->(dbEval({||FIELD->uuid := UuidToChar(UuidCreate())}, ;
               {||Empty(FIELD->uuid)}))
  ENDIF
  FErase(cCDX)
ENDIF

IF !File(cCDX)
  INDEX ON CONNECTION TAG CONNECTION TO (cCDX)
  INDEX ON CONNECTION+TITLE TAG TITLE TO (cCDX)
  INDEX ON CONNECTION+Alltrim(Str(VIEWTYPE)) TAG VIEWTYPE TO (cCDX)
  INDEX ON CONNECTION+TABLE+TITLE TAG TABLE TO (cCDX)
ENDIF

SQLQUERY->(dbCloseArea())
SELE (nSaveArea)

DC_Sett("KEYSTAT",.f.)
IF !Empty(::cSourceEditor)
  DC_Sett('EDITOR',::cSourceEditor)
  DC_Sett('ODIR','C:\expd20\source\sqlquery')
  DC_Sett('PDIR','C:\expd20\source\sqlquery')
ENDIF

::aScaleFactor := {nScale,nScale,nScale,nScale,.t.}

RETURN self

* -------

METHOD SqlQuery:OpenViewsFile( cDbe )

IF Empty(cDbe)
  cDbe := 'FOXCDX'
ENDIF

IF !DC_DbSel('SQLQUERY')
  USE (::cSqlQueryDbf) NEW VIA (cDbe) NEW ALIAS 'SQLQUERY'
  SET INDEX TO (::cSqlQueryCdx)
ENDIF

RETURN .t.

* -------

METHOD Sqlquery:ReadGuiHandler( nEvent, mp1, mp2, oXbp, oDlg, GetList )

LOCAL oBrowse, i, aWindows, lStatus

IF nEvent == xbeM_RbDown .AND. oXbp:isDerivedFrom('DC_XbpDialog1') .AND. ;
    oXbp:parent == ::oMainWindow:drawingArea
  DCMSGBOX oXbp:title, ;
           '', ;
           'Move this window to the Desktop?' YESNO TO lStatus ;
           FONT ::cMessageFont
  IF lStatus
    oXbp:setParent(AppDeskTop())
  ENDIF
ENDIF

IF Valtype(::oBrowseParentDlg) == 'O' .AND. ;
      nEvent == xbeP_SetDisplayFocus .AND. oXbp:isDerivedFrom('XbpDialog') ;
      .AND. 'BROWSING' $ Upper(oXbp:title) .AND. !(oXbp == ::oBrowseParentDlg)

  aWindows := oXbp:drawingArea:childList()
  FOR i := 1 TO Len(aWindows)
    IF aWindows[i]:isDerivedFrom('DC_XbpBrowse')
      oBrowse := aWindows[i]
      ::oBrowseChild := oBrowse
      ::oBrowseChildDlg := oXbp
      ::oBrowseChildPick:dataSource := oBrowse:dataStructure
      ::cChildAlias := oBrowse:linkedAlias
      ::cChildSqlStatement := oBrowse:sqlStatementOriginal
      ::lChildAliasScope := Empty(::cChildSqlStatement)
      ::oChildAliasSay:refresh()
      ::oChildAliasScope:refresh()
      ::oBrowseChildPick:refreshAll()
      PostAppEvent(LINK_DIALOG,,,::oBrowseChildPick)
      EXIT
    ENDIF
  NEXT
ENDIF

RETURN DCGUI_NONE

* -------

METHOD SqlQuery:WorkingMessage( oScrn, oOwner )

IF ::lShowWorkingMessage
  IF Empty(oScrn)
    oScrn := DC_WaitOn('Working.  Please wait...')
  ELSEIF Valtype(oScrn) $ 'AO'
    DC_Impl(oScrn)
  ENDIF
ELSE
  IF Empty(oScrn)
    DC_PointerWait(oOwner)
    oScrn := 'xxx'
  ELSE
    DC_PointerArrow(oOwner)
  ENDIF
ENDIF

RETURN oScrn

* -------

METHOD SqlQuery:checkForUpdate()

LOCAL cResponse, cUrl, aVersion

IF !Is_Internet()
  ::cUpdateMessage := 'No internet connection. Cannot check for updates'
  RETURN nil
ENDIF

cUrl := 'http://bb.donnay-software.com/sqlquery/testversion.cxp'

cResponse := LoadFromUrl( cUrl,, , , , 'GET' )

cResponse := Strtran(cResponse,CRLF,'')

IF Left(cResponse,1) # '{'
  DC_WinAlert('Error connecting to server (check for update)')
ELSE
  aVersion := &(cResponse)
  IF saVersion[2] < aVersion[2]
    ::cUpdateMessage := 'There is a new version of SqlQuery - ' + aVersion[2]
  ELSE
    ::cUpdateMessage := 'Your version of SqlQuery is current - ' + saVersion[2]
  ENDIF
  IF Valtype(soMessageBox) == 'O'
    soMessageBox:setData(::cUpdateMessage)
  ENDIF
ENDIF

RETURN nil

* -------

METHOD SqlQuery:downloadLatestVersion( nMode )

LOCAL cUrl, cMessage := ::checkForUpdate(), cResponse, nHandle, lStatus, ;
      cFileName, oScrn

::checkForUpdate()

#if XPPVER > 2000000
  cFileName := 'SqlQuery20.Zip'
#else
  cFileName := 'SqlQuery19.Zip'
#endif

cMessage := ::cUpdateMessage

IF Empty(cMessage)
  RETURN .f.
ELSEIF nMode == 0
  cUrl := 'http://bb.donnay-software.com/sqlquery/builds.txt'
  cResponse := LoadFromUrl( cUrl,, , , , 'GET' )
  nHandle := FCreate('Builds.Txt')
  FWrite( nHandle, cResponse )
  FClose(nHandle)
  DC_SpawnUrl(DC_Path(AppName(.t.)) + 'Builds.Txt')
ELSEIF nMode == 1 // .AND.  !' current ' $ cMessage
  DCMSGBOX cMessage, ;
     'Download the most current version now?' YESNO TO lStatus ;
     FONT ::cMessageFont TO lStatus OWNER AppDeskTop()
  IF lStatus
    oScrn := DC_WaitOn('Downloading ' + cFileName)
    cUrl := 'http://bb.donnay-software.com/sqlquery/' + cFileName
    cResponse := LoadFromUrl( cUrl,, , , , 'GET' )
    DC_Impl(oScrn)
    IF Len(cResponse) < 1000000
      ::ShowResponse(cResponse)
      RETURN .f.
    ELSE
      nHandle := FCreate(cFileName)
      FWrite( nHandle, cResponse )
      FClose(nHandle)
      DC_SpawnUrl(DC_Path(AppName(.t.)) + cFileName)
    ENDIF
  ENDIF
ELSE
  DCMSGBOX cMessage FONT ::cMessageFont OWNER AppDeskTop()
ENDIF

RETURN .t.

* -------

METHOD SqlQuery:commandWindow( oConnection, aData, lExecute )

LOCAL GetList[0], cCommands := '', oCommands, cResult := '', oResult, ;
      aPrompt[0], i, GetOptions, oDlg, cTitle, nRecNo, cSaveCommands := '', ;
      lStatus

DEFAULT lExecute := .f.

saConnections[ThreadID()] := oConnection

IF !Empty(aData)
  IF Valtype(aData) = 'C'
    cTitle := aData
  ELSE
    cTitle := Pad(aData[2,2],50)
  ENDIF
  ::openViewsFile()
  IF SQLQUERY->(dbSeek(Pad(oConnection:groupName,10)+cTitle,,'TITLE'))
    cCommands := SQLQUERY->statement
    cSaveCommands := cCommands
  ENDIF
  nRecNo := SQLQUERY->(RecNo())
  SQLQUERY->(dbCloseArea())
ENDIF

IF lExecute
  RETURN GuiRun({|a|::ExecuteCommands(cCommands,soMessageBox,.f.,oConnection)})
ENDIF

AAdd(aPrompt,"dbeSetDefault('ADSDBE') ;")
AAdd(aPrompt,"USE Dtr_2017 VIA (oSession) ;")
AAdd(aPrompt,"APPEND FROM Dtr_201701 ;")
AAdd(aPrompt,"APPEND FROM Dtr_201702 ;")

@ 0,0 DCSAY 'Variable <oSession> may be used in commands' ;
      SAYSIZE 0 RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
      FONT '10.Lucida Console' COLOR GRA_CLR_BLUE

@ 1,0 DCSAY '(Add your custom Commands and defines to "COMMANDS.CH")' ;
      SAYSIZE 0 RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
      FONT '10.Lucida Console' COLOR GRA_CLR_BLUE

@ 2,0 DCSAY 'Sample Command Script:' SAYSIZE 0 RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
      FONT '10.Lucida Console' COLOR GRA_CLR_BLUE

FOR i := 1 TO Len(aPrompt)
  @ i+2.5,0 DCSAY aPrompt[i] SAYSIZE 100,1 FONT ::cMessageFont ;
        COLOR GRA_CLR_BLACK, DC_ICEGREY ;
        RESIZE DCGUI_RESIZE_REPOSONLY_Y
NEXT

@ 9,0 DCSAY 'Enter Xbase++ commands:' SAYSIZE 0 SAYBOTTOM FONT ::cMessageFont ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION ICON_CHECKSQL ;
     SIZE 4,1 ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
     TOOLTIP 'Check (test) this command set' ;
     ACTION {||oResult:setData(''), ;
               GuiRun({|a|::ExecuteCommands(cCommands,@oResult,.t.,oConnection,self), ;
                          DC_GetRefresh(oCommands)})} ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Execute' ;
     SIZE 10,1 ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
     TOOLTIP 'Execute the Commands' ;
     ACTION {||oResult:setData(''), ;
               GuiRun({|a|::ExecuteCommands(cCommands,@oResult,.f.,oConnection), ;
                          DC_GetRefresh(oCommands)})} ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Save Script' ;
   SIZE 12,1 ACTION {||::SaveCommandScript(@cCommands,oConnection,oDlg,cTitle,nRecNo)} ;
   RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
   WHEN {||Valtype(oCommands)=='O' .AND. !Empty(oCommands:getData())}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Load Script' ;
   SIZE 12,1 ACTION {||cCommands := ::LoadCommandScript(cCommands,oConnection,oDlg),oCommands:setData(cCommands)} ;
   RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'More Examples' ;
   SIZE 12,1 ACTION {||MoreCommandExamples()} ;
   RESIZE DCGUI_RESIZE_REPOSONLY_Y

@10,0 DCMULTILINE cCommands OBJECT oCommands SIZE 100,13 FONT ::cMessageFont ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

@24,0 DCSAY 'Result window:' SAYSIZE 0 FONT ::cMessageFont

@25,0 DCMULTILINE cResult OBJECT oResult SIZE 100,10 FONT ::cMessageFont ;
      RESIZE DCGUI_RESIZE_RESIZEONLY_X

DCGETOPTIONS RESIZE SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT TITLE 'Command window' NOAUTORESTORE OPTIONS GetOptions ;
   PARENT @oDlg EVAL {|o|::setWindowPos(o)}

IF cCommands # cSaveCommands
  DCMSGBOX 'Script text has changed. Save this script?' ;
     YESNO TO lStatus FONT ::cMessageFont OWNER AppDeskTop()
  IF lStatus
    IF Empty(cSaveCommands)
      ::SaveCommandScript(cCommands,oConnection,oDlg,cTitle)
    ELSE
      ::SaveCommandScript(cCommands,oConnection,oDlg,cTitle,nRecNo)
    ENDIF
  ENDIF
ENDIF

saConnections[ThreadID()] := nil

RETURN nil

* -------

METHOD SqlQuery:TableNameFromStatement( cStatement )

LOCAL nFound, cTableName := ''

cStatement := Upper(cStatement) + ' '

IF ' FROM ' $ cStatement
  DO WHILE ' FROM  ' $ cStatement
    cStatement := Strtran( cStatement, ' FROM  ', ' FROM ')
  ENDDO
  nFound := At( ' FROM ', cStatement)
  IF nFound > 0
    cStatement := SubStr(cStatement, nFound + 6)
    cTableName := Alltrim(Substr(cStatement,1,At(' ',cStatement)-1))
  ENDIF
ENDIF

RETURN cTableName

* -------

METHOD SqlQuery:ExecuteCommands( cCommands, oResult, lTestOnly, _oConnection )

LOCAL i, c, nError, cOutput := Space(4096), aCommands, lStatus := .t., cCommand, ;
      nLen := 4096, bError

IF Valtype(oResult) == 'O'
  bError := ErrorBlock({|e|oResult:setData('Error >> ' + aCommands[i] + CRLF), ;
                            Break(e)})
ELSE
  bError := ErrorBlock({|e|(DCMSGBOX 'Error >> ' + aCommands[i] FONT ::cMessageFont), ;
                            Break(e)})
ENDIF

PRIVATE oSession := _oConnection:sessionDict, ;
        oConnection := _oConnection

saConnections[ThreadID()] := _oConnection

nError := PreprocessorInstall('commands.ch')

IF nError > 0
  DCMSGBOX 'Could not load pre-processor.', ;
           'Look for errors in COMMANDS.CH' ;
           OWNER AppDeskTop()
  RETURN .f.
ENDIF

BEGIN SEQUENCE

aCommands := BuildCommandArray(cCommands)
cCommands := ''

FOR i := 1 TO Len(aCommands)
  IF !Empty(aCommands[i])
    cCommand := Alltrim(aCommands[i])
    IF Right(cCommand,1) = ';'
      cCommand := Substr(cCommand,1,Len(cCommand)-1)
    ENDIF
    cCommand += ' ;' + IIF(i<Len(aCommands),CRLF,'')
    cCommands += cCommand
  ENDIF
NEXT

IF nError # XPP_ERR_NONE
  cOutput := DC_XtoC(PPGetMessage(nError))
  oResult:setData(cOutput)
  lStatus := .f.
  BREAK
ENDIF

nError := PreProcessLine( cCommands, @cOutput, @nLen )

IF nError # XPP_ERR_NONE
  cOutput := DC_XtoC(PPGetMessage(nError))
  IF Empty(cOutput)
    cOutput := 'Error in Script'
  ENDIF
  lStatus := .f.
  oResult:setData(cOutput)
  BREAK
ENDIF

aCommands := PPSplitLine(cOutput)

cOutput := ''

PreprocessorUninstall()

FOR i := 1 TO Len(aCommands)
  IF Empty(aCommands[i])
    LOOP
  ENDIF
  IF Left(aCommands[i],1) = '?'
    aCommands[i] := Strtran(aCommands[i],'?','')
  ENDIF
  c := Strtran(aCommands[i],Chr(0),'')
  IF !lTestOnly .AND. !Empty(c)
    c := &(c)
    IF c == NIL
      c := 'Nil'
    ELSE
      c := DC_XtoC(c)
    ENDIF
  ENDIF
  IF Valtype(oResult) == 'O'
    c := Alltrim(Str(i)) + ': ' + c
    oResult:setData(oResult:getData() + CRLF + DC_XtoC(c) )
  ENDIF
NEXT

END SEQUENCE

ErrorBlock(bError)

RETURN lStatus

* ---------------

STATIC FUNCTION BuildCommandArray( cCommands )

LOCAL i, aCommands1 := DC_StrWrap( cCommands,1000 ), aCommands[0], cString, cCommand

cCommand := ''
FOR i := 1 TO Len(aCommands1)
  cString := Trim(aCommands1[i])
  IF Right(cString,1) = ';'
    cCommand += Substr(cString,1,Len(cString)-1)
  ELSE
    cCommand += cString
    IF !Empty(cCommand)
      AAdd(aCommands,cCommand)
    ENDIF
    cCommand := ''
  ENDIF
NEXT

RETURN aCommands

* ---------------

STATIC FUNCTION MoreCommandExamples()

LOCAL GetList[0], cPrompt1, cPrompt2

TEXT INTO cPrompt1 WRAP
// GetInput from user
a := SqlQueryInput()

// Pre-processes SQL Statement to SqlQueryExecute()
SQL SELECT mednum, make, model from mn_mdn

COUNT TO n for Upper(make) = Upper(a[1])

DCMSGBOX 'There are ' + Alltrim(Str(n)) + a[1] + ' cars in inventory' ;
         OWNER AppDeskTop()
ENDTEXT

TEXT INTO cPrompt2 WRAP
SQL SELECT hack, mednum, shift from mn_drv WHERE shift='C'

// Pre-processes to SqlQueryBrowse()
BROWSE
ENDTEXT

@ 0,0 DCSAY cPrompt1 SIZE 110,8 FONT '12.Lucida Console' ;
      SAYWORDBREAK COLOR GRA_CLR_BLACK, GRA_CLR_WHITE

@ 9,0 DCSAY cPrompt2 SIZE 110,4 FONT '12.Lucida Console' ;
      SAYWORDBREAK COLOR GRA_CLR_BLACK, GRA_CLR_WHITE

DCREAD GUI FIT BUTTONS DCGUI_BUTTON_OK ;
   TITLE 'Command Script examples' MODAL NOAUTORESTORE

RETURN nil

* ---------------

METHOD SqlQuery:LoadCommandScript( cCommands, oConnection, oOwner )

LOCAL GetList[0], cFileName := Space(100), aFileFilters, lStatus, ;
      nChoice := 1, oStatement, oBrowse, GetOptions

DCMSGBOX 'This selection will load a Command Script', ;
         'Please choose the source of the text' ;
         BUTTONS {'Load From SqlQuery Dictionary','Load From File','Cancel'} ;
         CHOICE @nChoice ;
         FONT ::cMessageFont ;
         OWNER oOwner

IF nChoice == 2

  aFileFilters := { {"Command Files", "*.Txt"}, ;
                    {"All Files", "*.*"  } }

  @ 0,0 DCSAY 'File Name to Load (*.Txt)' SAYSIZE 0
  @ 1,0 DCGET cFileName POPUP {|c|DC_PopFile(c,,'*.Txt','Load a Script Text File',aFileFilters)} GETSIZE 50

  DCREAD GUI FIT ADDBUTTONS TITLE 'Load Script from File' ;
     MODAL TO lStatus OWNER oOwner NOAUTORESTORE EVAL {|o|::SetWindowPos(o)}

  IF lStatus
    cFileName := Alltrim(cFileName)
    IF !(Upper(Right(cFileName,4))) == '.TXT'
      cFileName += '.TXT'
    ENDIF
    cCommands := MemoRead(cFileName)
  ENDIF

ELSEIF nChoice == 1

  ::openViewsFile()
  SqlQuery->(OrdSetFocus('VIEWTYPE'))
  SqlQuery->(DC_SetScope(0,Pad(oConnection:GroupName,10) + Alltrim(Str(VIEWTYPE_XBASECOMMANDS))))
  SqlQuery->(DC_SetScope(1,Pad(oConnection:GroupName,10) + Alltrim(Str(VIEWTYPE_XBASECOMMANDS))))
  SqlQuery->(DC_DbGoTop())

  @ 0,0 DCBROWSE oBrowse ALIAS 'SqlQuery' SIZE 60,10 FIT ;
        FONT ::cMessageFont HEADLINES 2 ;
        ITEMMARKED {||oStatement:setData(SqlQuery->statement)} ;
        ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
        RESIZE DCGUI_RESIZE_REPOSONLY_Y

  DCBROWSECOL FIELD SqlQuery->Connection HEADER 'Connection;Group Name' ;
     PARENT oBrowse

  DCBROWSECOL FIELD SqlQuery->Title HEADER 'Title' ;
     PARENT oBrowse

  @ 11,0 DCMULTILINE SqlQuery->statement SIZE 80,10 ;
         FONT ::cMessageFont ;
         NOHSCROLL OBJECT oStatement ;
         RESIZE DCGUI_RESIZE_RESIZEONLY

  DCGETOPTIONS RESIZE SCALEFACTOR ::aScaleFactor

  DCREAD GUI FIT ADDBUTTONS TITLE 'Choose a Command Script' ;
    TO lStatus NOAUTORESTORE OPTIONS GetOptions ;
    MODAL SETAPPWINDOW EVAL {|o|::SetWindowPos(o)}

  IF lStatus
    cCommands := SqlQuery->Statement
  ENDIF

  SqlQuery->(dbCloseArea())

ENDIF

RETURN cCommands

* -----------

METHOD SqlQuery:SaveCommandScript( cCommands, oConnection, oOwner, cTitle, nRecNo )

LOCAL GetList[0], cFileName := Space(100), aFileFilters, lStatus, ;
      nChoice := 1, lNewScript := Empty(nRecNo), aButtons[0]

AAdd(aButtons,'Save to SqlQuery Dictionary Scripts')
AAdd(aButtons,'Save to Text File')
AAdd(aButtons,'Cancel')

DCMSGBOX 'This selection will save the SQL Statement', ;
         'Please choose the destination of the text' ;
         BUTTONS aButtons ;
         CHOICE @nChoice ;
         FONT ::cMessageFont ;
         OWNER oOwner

DEFAULT cTitle := Space(50)

IF nChoice = 2

  aFileFilters := { {"Command (text) Files", "*.TXT"}, ;
                    {"All Files", "*.*"  } }

  @ 0,0 DCSAY 'File Name to Save (*.TXT)' SAYSIZE 0
  @ 1,0 DCGET cFileName POPUP {|c|DC_PopFile(c,,'*.TXT','Save a Command (Text) File',aFileFilters)} GETSIZE 50

  DCREAD GUI FIT ADDBUTTONS TITLE 'Save Command Script to File' ;
     MODAL TO lStatus OWNER oOwner

  IF lStatus
    cFileName := Alltrim(cFileName)
    IF !(Upper(Right(cFileName,4))) == '.TXT'
      cFileName += '.TXT'
    ENDIF
    MemoWrit(cFileName,cCommands)
  ENDIF

ELSEIF nChoice == 1

  IF Empty(cTitle)
    @ 0,0 DCSAY 'Title for this Command Script:' SAYSIZE 0
    @ 1,0 DCGET cTitle VALID {||::ValidateScriptTitle(cTitle,oConnection,@nRecNo)}

    DCREAD GUI FIT TITLE 'Save Command Script to Script Database' ;
       ADDBUTTONS OWNER oOwner MODAL TO lStatus NOAUTORESTORE ;
       ENTEREXIT EVAL {|o|::SetWindowPos(o)}
  ELSE
    lStatus := .t.
  ENDIF

  IF lStatus
    ::openViewsFile()
    IF !Empty(nRecNo)
      SqlQuery->(dbGoTo(nRecNo))
    ENDIF
    IF !Empty(nRecNo) .OR. SqlQuery->(dbSeek(Space(10),,'VIEWTYPE'))
      SqlQuery->(DC_RecLock())
    ELSE
      SqlQuery->(DC_AddRec())
    ENDIF
    REPLACE SqlQuery->connection WITH oConnection:GroupName, ;
            SqlQuery->title WITH cTitle, ;
            SqlQuery->statement WITH cCommands, ;
            SqlQuery->viewtype WITH VIEWTYPE_XBASECOMMANDS
    SqlQuery->(dbRUnlock())
    SqlQuery->(dbCloseArea())
  ENDIF
  IF Empty(nRecNo)
    ::reloadScripts( oConnection,{VIEWTYPE_XBASECOMMANDS} )
  ENDIF
ENDIF

RETURN lStatus

* -------

METHOD SqlQuery:showResponse( cResponse )

LOCAL GetList[0]

@ 0,0 DCMULTILINE cResponse SIZE 100,30 FONT '9.Lucida Console' NOHSCROLL

DCREAD GUI FIT TITLE 'Download Problem' MODAL ADDBUTTONS

RETURN nil

* -------

METHOD SqlQuery:showDialog()

LOCAL GetList[0], GetOptions, oMenuBar, oStatBot1, oMenuHelp, ;
      oMenuFile, oMenuUtil, oMenuODBC, lStatus, oStatBot2, cSearch, ;
      oGoButton, oMenuConn

cSearch := Space(20)

DC_ReadGuiHandler({|a,b,c,d,e,f,g|::ReadGuiHandler(a,b,c,d,e,f,@g)})

DC_AutoRestoreWindow( { HKEY_CURRENT_USER, 'Software\Donnay\SqlQuery\Windows' })

DCMENUBAR oMenuBar ;
   OWNERDRAW ;
   MENUBARFONT ::cMenuFont ;
   MENUBARCOLOR {0,0,0}, {210,210,210} ;
;//   SUBCOLOR {0,0,0}, {220,220,220} ;
   SUBBARFONT ::cMenuFont ;
   SUBITEMFONT ::cMenuFont ;
;//   SUBBARCOLOR {100,100,100}, { 220,220,220 } ;

  * --------- File menu --------

  DCSUBMENU oMenuFile PROMPT 'File' PARENT oMenuBar

    DCMENUITEM 'Data Tree Menu' PARENT oMenuFile ;
      ACTION {||GuiRun({|a|::TreeWindow()})} ;
      WHEN {||::oTree == nil}

    DCMENUITEM SEPARATOR PARENT oMenuFile

    DCMENUITEM 'Restart SqlQuery.Exe' PARENT oMenuFile ;
      ACTION {||RunShell(::cIniFile,AppName(.t.),.t.,.t.),Sleep(10),_quit()}

    DCMENUITEM 'Browse SqlQuery.Dbf (Dictionary) File' PARENT oMenuFile ;
      ACTION {||::BrowseSqlQueryDbf()}

    DCMENUITEM SEPARATOR PARENT oMenuFile

    DCMENUITEM 'Run SqlQuery with the Sample Data' PARENT oMenuFile ;
      ACTION {||RunShell('.\SampleData\SqlQuery.ini',AppName(.t.),.t.,.t.)}


  * -------- Connection Menu -------

  DCSUBMENU oMenuConn PROMPT 'Connection' PARENT oMenuBar

    DCMENUITEM 'Create New Connection' PARENT oMenuConn ;
      ACTION {||::CreateConnection()}

    DCMENUITEM 'Disconnect all Connections' PARENT oMenuConn ;
      ACTION {||::DisconnectConnections()}

    DCMENUITEM SEPARATOR PARENT oMenuConn

    DCMENUITEM 'Edit SqlQuery.Ini File' PARENT oMenuConn ;
      ACTION {||RunShell(::cIniFile,'Notepad.exe',.t.,.f.)}

    DCMENUITEM 'Edit ADS.Ini File' PARENT oMenuConn ;
      ACTION {||RunShell('Ads.Ini','Notepad.exe',.t.,.f.)}


  * -------- Util Menu -------

  DCSUBMENU oMenuUtil PROMPT 'Util' PARENT oMenuBar
    DCMENUITEM 'Dot Prompt' ACTION {||GuiRun({||DC_Dot()})} PARENT oMenuUtil
    DCMENUITEM 'Run a Procedure' ACTION {||::RunProc()} PARENT oMenuUtil
    DCMENUITEM SEPARATOR
    DCMENUITEM 'Advantage Utilities' ACTION {||RunShell('','ADSMGMT.EXE',.t.,.t.)} PARENT oMenuUtil

  * --------- ODBC Menu ------

  DCSUBMENU oMenuODBC PROMPT 'ODBC' PARENT oMenuBar
    DCMENUITEM 'List ODBC Drivers' ACTION {||::ListODBCDrivers()} PARENT oMenuODBC
    DCMENUITEM 'List ODBC Data Sources' ACTION {||::ListODBCSources()} PARENT oMenuODBC
    DCMENUITEM 'ODBC Administrator' ACTION {||OdbcAdmin(::oMainwindow)} ;
       PARENT oMenuODBC
    DCMENUITEM 'List ODBC Data Types' ACTION {||::ListODBCDataTypes()} ;
       PARENT oMenuODBC

  * --------- Help Menu ------

  DCSUBMENU oMenuHelp PROMPT 'Help' PARENT oMenuBar
    DCMENUITEM 'About SqlQuery' ACTION {||(DCMSGBOX 'SqlQuery',saVersion[2])} PARENT oMenuHelp
    DCMENUITEM 'Read about Latest Version' ACTION {||::downloadLatestVersion(0)} PARENT oMenuHelp
    DCMENUITEM 'Download Latest Version' ACTION {||::downloadLatestVersion(1)} PARENT oMenuHelp
    IF Fexists(DC_Path(AppName(.t.)) + 'advantage.chm')
      DCMENUITEM 'Advantage SQL Help' ;
         ACTION {||DC_SpawnUrl(DC_Path(AppName(.t.))+'advantage.chm')} PARENT oMenuHelp
    ENDIF
    DCMENUITEM 'SqlQuery.Exe Command Line parameters' ;
         ACTION {||SqlQueryCommandLineHelp()} PARENT oMenuHelp
    DCMENUITEM 'Browse Color Definitions' ACTION {||::BrowseColors()} PARENT oMenuHelp
    DCMENUITEM SEPARATOR PARENT oMenuHelp
    DCMENUITEM 'Browse SqlQuery Forum' ;
         ACTION {||DC_SpawnUrl('http://bb.donnay-software.com/donnay/viewforum.php?f=19')} ;
         PARENT oMenuHelp

DCSTATUSBAR oStatBot1 HEIGHT 25 ALIGN DCGUI_ALIGN_BOTTOM ANCHOR DCGUI_ALIGN_LEFT

@ 0,2 DCSAY '' SIZE 10,20 PIXEL PARENT oStatBot1

@ 0,2 DCSAY 'Search Tree ' GET cSearch PARENT oStatBot1 SAYSIZE 0 SAYRIGHTBOTTOM ;
      SAYFONT ::cTreeFont ;
      GETFONT ::cTreeFont ;
      KEYBLOCK {|n|IIF(n==xbeK_ENTER,(SetAppFocus(oGoButton),PostAppEvent(xbeP_Activate,,,oGoButton)),nil)}

@ 0,2 DCPUSHBUTTON CAPTION 'Go' SIZE 30,20 ;
      ACTION {||TableSearch( ::oTree, cSearch,GetList)} PARENT oStatBot1 ;
      OBJECT oGoButton

DCSTATUSBAR oStatBot2 HEIGHT 60 ALIGN DCGUI_ALIGN_BOTTOM ANCHOR DCGUI_ALIGN_LEFT

@ 0,0 DCMULTILINE ::cUpdateMessage OBJECT soMessageBox SIZE 400,60 PIXEL;
   COLOR GRA_CLR_RED, GRA_CLR_WHITE PARENT oStatBot2 ;
   FONT '11.Lucida Console' NOHSCROLL READONLY

@ 0,2 DCSAY '' SIZE 1,20 PIXEL PARENT oStatBot2 COLOR GRA_CLR_RED, GRA_CLR_WHITE

DCGETOPTIONS TABSTOP
DC_GetOptDefault(GetOptions)

DCGETOPTIONS ;
   ICON ICON_DICTIONARY ;
   PIXEL ;
   RESIZE ;
   WINDOWWIDTH 1000 ;
   WINDOWHEIGHT 800 ;
   COLOR GRA_CLR_WHITE ;
   MESSAGEINTO {|c|soMessageBox:setData(c)} ;

DCREAD GUI ;
   TITLE 'Database Query (SQL-based)' ;
   OPTIONS GetOptions ;
   SETAPPWINDOW  ;
   EVAL {|o|_ResizeTree(o,self), ;
            soMessageBox:setData(::cUpdateMessage)}

RETURN nil

* --------------

STATIC FUNCTION _ResizeTree( oDlg, self )

LOCAL n := 1

::oMainWindow := oDlg

IF Empty(::oBrowseParentWindow)
  ::oBrowseParentWindow := oDlg:drawingArea
  n := 2
ELSE
  n := 1
ENDIF

oDlg:resize := ;
   {|a,b,o,p|o := ::oTreeWindow, ;
             IIF(Valtype(o)=='O', ;
                (o:setSize({IIF(n=1,o:parent:currentSize()[1]-10,o:currentSize()[1]), ;
                               o:parent:currentSize()[2]}),;
                o:setPos({0,0})),nil), ;
              soMessageBox:setSize({oDlg:drawingArea:currentSize()[1]-5,60})}

GuiRun({||::TreeWindow(oDlg)})

RETURN nil

* --------------

METHOD SqlQuery:TreeWindow(oDlg)

LOCAL GetList[0], bItemMarked := {|a,b,o|::ShowTreeInfo(a,b,o)}, ;
      oTreeTables, GetOptions, n, oParent, oAppWindow, bResize

IF ::oBrowseParentWindow == oDlg:drawingArea
  n := 2
ELSE
  n := 1
ENDIF

@ 25,0 DCTREEROOT OBJECT ::oTree SIZE 400,600 ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      HASLINES ;
      HASBUTTONS ;
      FONT ::cTreeFont ;
      COLOR ::nTreeFgColor, ::nTreeBgColor ;
      ALWAYSSHOWSELECTION ;
      ITEMSELECTED {|oItem|::BuildTreeBranch(oItem,.t.)} ;
      ITEMEXPANDED {|oItem|::BuildTreeBranch(oItem,.f.)} ;
      ITEMMARKED bItemMarked ;
      EVAL {|o|o:lbClick := {|aPos|::oTree:SetData(::oTree:itemFromPos(aPos))}, ;
               o:rbDown := {|aPos|::oTree:SetData(::oTree:itemFromPos(aPos)), ;
                               ::TreeMenu(aPos,@oTreeTables,::oTree:GetData())}}

DCGETOPTIONS ;
   ICON ICON_DICTIONARY ;
   PIXEL ;
   RESIZE ;
   NOMINBUTTON ;
   NOMAXBUTTON ;
   COLOR GRA_CLR_WHITE ;
   HIDE ;
   NOESCAPEKEY ;
   EXITQUERY MSG {||.f.} ;
   CLOSEQUERY MSG {||.f.} ;
   ABORTQUERY MSG {||.f.} ;
   MESSAGEINTO {|c|soMessageBox:setData(c)}

IF n = 2 // windows on desktop
  oAppWindow := ::oMainWindow:drawingArea
  bResize := {||::oTree:setPos({0,0}), ;
                ::oTree:setSize(::oTree:parent:currentSize())}
ELSE  // windows on drawingArea
  oParent := ::oMainWindow:drawingArea
ENDIF

DCREAD GUI ;
   TITLE 'Tree Menu' ;
   APPWINDOW oAppWindow ;
   PARENT oParent ;
   OPTIONS GetOptions ;
   EVAL {|o| o := IIF(n=2,o,::oTree), ;
            o:resize := bResize, ;
            o:setSize({IIF( n=2,350,o:parent:currentSize()[1]-10),o:parent:currentSize()[2]-30}), ;
            o:setPos({0,30}), ;
            o:show(), ;
            ::oTreeWindow := o, ;
            oTreeTables := ::rebuildTree()} ;
   NOAUTORESTORE

::oTree := nil
::oTreeWindow := nil

RETURN nil

* --------------

METHOD SqlQuery:ShowTreeInfo( oTreeItem )

LOCAL cString := '', aCargo := oTreeItem:cargo, aField, oConnection, ;
      cTableName

IF Valtype(aCargo) # 'A'

ELSEIF aCargo[1] == 'Field'

  aField := aCargo[6]
  cString := aField[1] + ', ' + aField[2] + ', ' + ;
             DC_XtoC(aField[3]) + ', ' + DC_XtoC(aField[4])

ELSEIF aCargo[1] == 'Index Tag' .AND. Len(aCargo[2]) > 1

  cString := 'Key: ' + aCargo[2,2] + IIF(!Empty(aCargo[2,3]),' For: ' + aCargo[2,3],'')

ELSEIF aCargo[1] == 'Dict'

  oConnection := aCargo[3]
  IF oConnection:type == 'ADS'
    IF !Empty(oConnection:serverDict)
      cString := 'ADS - ' + oConnection:serverDict
    ELSE
      cString := 'ADS - ' + oConnection:serverFree
    ENDIF
  ELSEIF oConnection:type == 'ODBC'
    cString := 'ODBC - ' + oConnection:database + ' - ' + oConnection:driver
  ELSEIF oConnection:type == 'PG'
    cString := 'PG - ' + oConnection:database + ' - ' + oConnection:driver
  ENDIF

ELSEIF aCargo[1] == 'Table'

  cTableName := aCargo[2,1]
  oConnection := aCargo[5]

  IF ::AdsIsTableEncrypted( cTableName, oConnection )
    cString := 'Table ' + cTableName + ' is ENCRYPTED'
  ENDIF

ELSEIF aCargo[1] == 'Tables'

  cString := Alltrim(Str(Len(aCargo[2]))) + ' Tables'

ELSEIF aCargo[1] == 'Views'

  cString := ;
   'Views are pre-defined SQL SELECT statements that are executed ' + ;
   'by the SQL server (ADS, ODBC, PG, etc.)'

ELSEIF aCargo[1] == 'Command Scripts'

  cString := ;
   'Command scripts are used to create a set of Xbase++ commands ' + ;
   'that are pre-processed, compiled and executed.'

ELSEIF aCargo[1] == 'SQL Scripts'

  cString := ;
   'SQL scripts are used to create a set of SQL statements ' + ;
   'that are executed by the SQL server (ADS, ODBC, PG, etc.)'

ELSEIF aCargo[1] == 'ISAM Scripts'

  cString := ;
   'ISAM scripts are used to define a set of browse columns ' + ;
   'for a table that is opened and browsed.'

ELSEIF aCargo[1] == 'Procedures'

  cString := ;
   'Procedures are pre-defined SQL statements and functions that are executed ' + ;
   'by the SQL server (ADS, ODBC, PG, etc.)'

ELSEIF aCargo[1] == 'Procedure'

  cString := aCargo[4,2,1]

ENDIF

soMessageBox:setData(cString)

RETURN Nil

* --------------

METHOD SqlQuery:RebuildTree()

DC_PointerWait( ::oTree )

::oTree:lockUpdate(.t.)
::BuildTree()
::oTree:lockUpdate(.f.)
::oTree:invalidateRect()

DC_PointerArrow( ::oTree )

RETURN nil

* --------------

STATIC FUNCTION TableSearch( oTree, cSearch, aGetList )

LOCAL i, aChildList, oTreeItem

oTreeItem := oTree:getData()

IF !Empty(oTreeItem)
  aChildList := oTreeItem:getChildItems()
  IF !Empty(aChildList) .AND. aChildList[1]:caption = 'Tables'
    aChildList := aChildList[1]:getChildItems()
  ELSEIF oTreeItem:caption $ {'Tables','Views','Command Scripts','SQL Scripts','ISAM Scripts'}
    aChildList := oTreeItem:getChildItems()
  ELSEIF oTreeItem:getParentItem():caption $ {'Tables','Views','Command Scripts','SQL Scripts','ISAM Scripts'}
    aChildList := oTreeItem:getParentItem():getChildItems()
  ENDIF
ELSE
  aChildList := oTree:rootItem:getChildItems()
ENDIF

cSearch := Alltrim(Upper(cSearch))

FOR i := 1 TO Len(aChildList)
  IF cSearch $ Upper( aChildList[i]:caption)
    oTreeItem := aChildList[i]
    oTree:setData(aChildList[i])
    EXIT
  ENDIF
NEXT

SetAppFocus(oTree)
DC_LastFocus(aGetList,oTree)

RETURN nil

* --------------

METHOD SqlQuery:TreeMenu( aPos, oTreeTables, oTreeItem )

LOCAL GetList[0], aData, oTreeMenu, lRebuild := .f., oConnection, ;
      oSession, oMenuODBC, oMenuTests

aData := ::oTree:getData():cargo

IF Empty(oTreeItem)
  oTreeItem := ::oTree:getData()
ENDIF

IF Valtype(aData) # 'A'
  RETURN nil
ENDIF

IF Len(aData) >= 5
  oConnection := aData[5]
ELSE
  oConnection := aData[3]
ENDIF
oSession := oConnection:sessionDict
// DCSUBMENU oTreeMenu PROMPT 'Tree Menu' // OWNERDRAW

DCSUBMENU oTreeMenu PROMPT "Tree Menu" OWNERDRAW ;
   BARTEXT 'Menu' ;
   ;// COLOR GRA_CLR_BLACK, {200,150,150} ;
   ITEMFONT ::cMenuFont

IF Empty(aData)
  // No menu attached

ELSEIF aData[1] = 'Dict'

  IF oConnection:IsConnected
    DCMENUITEM 'Disconnect' PARENT oTreeMenu ACTION {||::disconnect(oConnection)}

  ELSE
    DCMENUITEM 'Connect' PARENT oTreeMenu ;
      ACTION {||oConnection:ConnectionBranch := oTreeItem, ;
                oConnection:connect(self), ;
                ::BuildTreeBranch(oTreeItem,.t.)}
  ENDIF

  DCMENUITEM 'SQL Query Window (Cursor)' PARENT oTreeMenu ;
     ACTION {||GuiRun({|a|::SQLQueryPick(nil,::oTree:getData())})} ;
     MESSAGE 'Open SQL query window that returns a Cursor' ;
     WHEN {||oConnection:IsConnected}

  DCMENUITEM 'SQL Result Window (Result)' PARENT oTreeMenu ;
     ACTION {||::SQLResult(oConnection)} ;
     MESSAGE 'Open SQL window that returns a result (no cursor)' ;
     WHEN {||oConnection:IsConnected}

  DCMENUITEM 'Execute a SQL Script File' PARENT oTreeMenu ;
     ACTION {||::ExecuteSqlScript(oConnection)} ;
     MESSAGE 'Run a Script from a *.SQL file' ;
     WHEN {||oConnection:IsConnected}

  DCMENUITEM SEPARATOR PARENT oTreeMenu

  DCMENUITEM 'Command Window' PARENT oTreeMenu ;
     ACTION {||::CommandWindow(oConnection)} ;
     WHEN {||::lIsAdmin .AND. oConnection:IsConnected}

  DCMENUITEM 'Connection Properties' PARENT oTreeMenu ;
     ACTION {||::ShowConnectionProperties(oConnection)} ;
     MESSAGE 'Display the Properties of this Connection'

  DCMENUITEM 'Edit Connection' PARENT oTreeMenu ;
     ACTION {||::EditConnectionProperties(oConnection)} ;
     MESSAGE 'Change the Properties of this Connection'

  DCMENUITEM 'Delete Connection' PARENT oTreeMenu ;
     ACTION {||::DeleteConnection(oConnection,oTreeItem)} ;
     MESSAGE 'Delete this Connection'

  DCMENUITEM SEPARATOR PARENT oTreeMenu

  IF oConnection:type == 'ADS' .AND. !Empty(oConnection:serverFree)
    DCMENUITEM 'Build Data Dictionary' PARENT oTreeMenu ;
       ACTION {||::buildDDAds(oConnection)} ;
       WHEN {||oConnection:IsConnected} ;
       MESSAGE 'Create a Data Dictionary for selected files'
  ENDIF

  IF oConnection:type = 'ADS' .AND. !Empty(oConnection:database)

    DCMENUITEM 'Add a Table to this Data-Dictionary' PARENT oTreeMenu ;
      ACTION {||::AdsDDAddTable( aData, oConnection, oTreeItem )} ;
      WHEN {||oConnection:IsConnected}
  ENDIF

  IF oConnection:type = 'ADS'
    DCMENUITEM SEPARATOR PARENT oTreeMenu
    IF !DC_AdsDebugMode()
      DCMENUITEM 'Start ADS SQL Debug Mode' PARENT oTreeMenu ;
        ACTION {||::AdsDebugSqlMode(.t.)}
    ELSE
      DCMENUITEM 'Stop ADS SQL Debug Mode' PARENT oTreeMenu ;
        ACTION {||::AdsDebugSqlMode(.f.)}
    ENDIF
    DCMENUITEM SEPARATOR PARENT oTreeMenu
    DCMENUITEM IIF(oConnection:isShowDeleted,'HIDE','SHOW') + ;
        ' Deleted Records' ;
        ACTION {||oConnection:isShowDeleted := ! oConnection:isShowDeleted, ;
                  Set(_SET_DELETED,!oConnection:isShowDeleted)} ;
        PARENT oTreeMenu
  ENDIF

  IF oConnection:type $ {'ODBC','PG'}
    DCMENUITEM SEPARATOR PARENT oTreeMenu

      DCMENUITEM 'Import' PARENT oTreeMenu ;
        ACTION {||oConnection:ConnectionBranch := oTreeItem, ;
                  oConnection:ImportData(self)} ;
        MESSAGE 'Import data from another data source' ;
        WHEN {||oConnection:IsConnected}

    DCMENUITEM SEPARATOR PARENT oTreeMenu

    DCSUBMENU oMenuODBC PROMPT 'ODBC Options' PARENT oTreeMenu

      DCMENUITEM 'Session Properties (ODBC)' PARENT oMenuODBC ;
        ACTION {||oConnection:sessionPropertiesODBC()} ;
        WHEN {||Valtype(oConnection:sessionDict) == 'O'}
      DCMENUITEM 'List Data Types' PARENT oMenuODBC ;
         ACTION {||::ListODBCDataTypes(oSession)} ;
         MESSAGE 'List the Field Data Types for this ODBC source' ;
         WHEN {||oConnection:IsConnected}
      DCMENUITEM 'Debug this Connection' PARENT oMenuODBC ;
         ACTION {||DC_ArrayView(OdbcDebug(oSession))} ;
         MESSAGE 'Show debug info for this ODBC connection' ;
         WHEN {||oConnection:IsConnected}
      IF !oConnection:IsTraceODBC
        DCMENUITEM 'Trace this Connection' PARENT oMenuODBC ;
           ACTION {||oConnection:TraceODBC(.t.)} ;
           MESSAGE 'Write ODBC Trace info to a log file' ;
           WHEN {||oConnection:IsConnected}
      ELSE
        DCMENUITEM 'Set Trace OFF and view Trace Log' PARENT oMenuODBC ;
           ACTION {||oConnection:TraceODBC(.f.)} ;
           MESSAGE 'Stop the ODBC tracing and View Log' ;
           WHEN {||oConnection:IsConnected}
      ENDIF
      DCMENUITEM 'List SQL Keywords' PARENT oMenuODBC ;
         ACTION {||DC_ArrayView(OdbcListSQLKeywords(oSession))} ;
         MESSAGE 'List all the SQL key words for this ODBC connection' ;
         WHEN {||oConnection:IsConnected}
      DCMENUITEM 'Show Data Types Mapping' PARENT oMenuODBC ;
        ACTION {||::ShowDataTypes(oConnection)} ;
        WHEN {||oConnection:IsConnected}
      DCMENUITEM 'Import' PARENT oMenuODBC ;
        ACTION {||oConnection:ConnectionBranch := oTreeItem, ;
                  oConnection:ImportData(self)} ;
        MESSAGE 'Import data from another data source' ;
        WHEN {||oConnection:IsConnected}

      DCMENUITEM SEPARATOR PARENT oMenuODBC

      DCMENUITEM 'Multiple Result Sets' PARENT oMenuODBC ;
           ACTION {||::OdbcTest1(oConnection)} ;
           WHEN {||oConnection:IsConnected}

  ENDIF

ELSEIF aData[1] = 'Tables'

  DCMENUITEM 'Properties' PARENT oTreeMenu ;
    ACTION {||::ShowTableProperties( aData[2], oConnection )} ;
    MESSAGE 'Browse a list of the tables'

  DCMENUITEM 'Create New Table' PARENT oTreeMenu ;
    ACTION {||::AddTableSQL( oConnection )} ;
    MESSAGE 'Create a New Table for this Database'

  IF 'Microsoft Access Driver' $ oConnection:driver
    DCMENUITEM 'Create Schema Array for all Columns' ;
      ACTION {||::CreateAccessSchemaArray(aData[2],oConnection)} ;
      PARENT oTreeMenu
  ENDIF

  DCMENUITEM 'Add UUID field to all tables' PARENT oTreeMenu ;
    ACTION {||GuiRun({||::SQLAddUUIDField(aData[2],oConnection,.t.)})} ;
    MESSAGE 'Add a UUID,C,36,0 field to all tables for a Unique Identifier'

  DCMENUITEM 'Fill UUID field in all tables' PARENT oTreeMenu ;
    ACTION {||GuiRun({||::SQLFillUUIDField(aData[2],oConnection,.t.)})} ;
    MESSAGE 'Fill all empty UUID fields in all tables with a Unique Identifier'

  IF oConnection:type = 'ADS'
    DCMENUITEM 'Add UUID Index to all tables' PARENT oTreeMenu ;
      ACTION {||GuiRun({||::SQLAddUUIDIndex(aData[2],oConnection,.t.)})} ;
      MESSAGE 'Add a UUID Index Tag to all tables (indexed on UUID)'
  ENDIF

  DCMENUITEM SEPARATOR PARENT oTreeMenu

  DCMENUITEM 'Write Schema for all Tables' ;
           ACTION {||::WriteSchema(aData,oConnection)} ;
           PARENT oTreeMenu WHEN {||oConnection:IsConnected}

  IF oConnection:type = 'ADS' .AND. !Empty(oConnection:handleDict)
    DCMENUITEM 'Test files in this Data-Dictionary' PARENT oTreeMenu ;
      ACTION {||::AdsTestDictionary( aData[2], oConnection, oTreeItem )} ;
      WHEN {||oConnection:IsConnected}
  ENDIF

  IF oConnection:type = 'ADS' .AND. !Empty(oConnection:handleDict)
    DCMENUITEM 'List DBF files not in this Data-Dictionary' PARENT oTreeMenu ;
      ACTION {||::AdsListFilesNotInDictionary( aData[2], oConnection, oTreeItem )} ;
      WHEN {||oConnection:IsConnected}
  ENDIF

ELSEIF aData[1] = 'Table'

  DCMENUITEM 'Browse this Table (all fields - SQL Cursor)' PARENT oTreeMenu ;
    ACTION {||GuiRun({|a,b,c|;
              b:= Strtran(Upper(aData[2,1]),'.DBF',''), ;
              c := b + IIF(!oConnection:isShowDeleted,' WHERE TRUE',''), ;
              ::ExecuteSQL('SELECT * from "' + c + '"',b,oConnection,,1)})} ;
    MESSAGE 'Browse this table using SELECT *'

  DCMENUITEM 'Browse this Table (all fields - SQL Objects)' PARENT oTreeMenu ;
    ACTION {||GuiRun({|a,b|b:= Strtran(Upper(aData[2,1]),'.DBF',''), ;
              ::ExecuteSQL('SELECT * from "' + b + '"',b,oConnection,,2)})} ;
    MESSAGE 'Browse this table using SELECT *'

  DCMENUITEM 'Browse this Table (all fields - ISAM)' PARENT oTreeMenu ;
    ACTION {||GuiRun({|a|::BrowseISAM(aData[2],oConnection)})} ;
    MESSAGE 'Browse this table using ISAM method'

  DCMENUITEM SEPARATOR PARENT oTreeMenu

  DCMENUITEM 'Browse this Table (Select Fields)' PARENT oTreeMenu ;
    ACTION {||GuiRun({|a|::SQLQueryPick(aData,oConnection,,.t.)})} ;
    MESSAGE 'Browse this table using picked fields'

  DCMENUITEM 'Browse this Table (Pick Columns)' PARENT oTreeMenu ;
    ACTION {||GuiRun({|a,b|b:= Strtran(Upper(aData[2,1]),'.DBF',''), ;
              ::ExecuteSQL('SELECT * from "' + b + '"',b,oConnection,,1,,,,,,,,-1)})} ;
    MESSAGE 'Browse this table using picked columns from a SQL SELECT *'

  DCMENUITEM 'Browse this Table (Saved Columns)' PARENT oTreeMenu ;
    ACTION {||GuiRun({|a,b|b:= Strtran(Upper(aData[2,1]),'.DBF',''), ;
              ::BrowseColumnsISAM(b,oConnection)})} ;
    MESSAGE 'Browse this table using a saved column configuration'

  IF !Empty(oConnection:database)
    DCMENUITEM SEPARATOR PARENT oTreeMenu
    IF oConnection:type = 'ADS'
      DCMENUITEM 'Remove this Table from the Data-Dictionary' PARENT oTreeMenu ;
        ACTION {||::AdsDDRemoveTable( aData[2,1], oConnection, oTreeItem )}
    ELSE
      DCMENUITEM 'DROP (remove) this table from the Database' PARENT oTreeMenu ;
        ACTION {||::DropTableSQL( aData[2,1], oConnection, oTreeItem)}
    ENDIF
  ENDIF

  DCMENUITEM SEPARATOR PARENT oTreeMenu

  DCMENUITEM 'Add UUID field to this table' PARENT oTreeMenu ;
    ACTION {||GuiRun({||::SQLAddUUIDField({aData[2]},oConnection,.f.)})} ;
    MESSAGE 'Add a UUID,C,36,0 field to all tables for a Unique Identifier'

  DCMENUITEM 'Fill UUID field in all records' PARENT oTreeMenu ;
    ACTION {||GuiRun({||::SQLFillUUIDField({aData[2]},oConnection,.f.)})} ;
    MESSAGE 'Fill all empty UUID fields in all tables with a Unique Identifier'

  IF oConnection:type = 'ADS'

    DCMENUITEM 'Add UUID Index to this table' PARENT oTreeMenu ;
      ACTION {||GuiRun({||::SQLAddUUIDIndex({aData[2]},oConnection,.f.)})} ;
      MESSAGE 'Add a UUID Index Tag to this table (indexed on UUID)'

  ENDIF

   DCMENUITEM SEPARATOR PARENT oTreeMenu

  IF oConnection:type = 'ADS'

    DCMENUITEM 'ZAP (delete all records) in this table' PARENT oTreeMenu ;
      ACTION {||::ZapTableADS( aData[2,1], oConnection )}

    DCMENUITEM 'Pack (Remove Deleted Records)' PARENT oTreeMenu ;
      ACTION {||GuiRun({||::PackTable( aData[2,1], oConnection )})}

  ELSE

   DCMENUITEM 'ZAP (delete all records) in this table' PARENT oTreeMenu ;
     ACTION {||::ZapTableSQL( aData[2,1], oConnection )}

  ENDIF

  DCMENUITEM 'Export' PARENT oTreeMenu ;
    ACTION {||::Table2Export( aData[2,1], oConnection )}

  DCMENUITEM 'Properties' PARENT oTreeMenu ;
    ACTION {||GuiRun({||::TableProperties( aData, oConnection, oTreeItem )})}

  IF !Empty(oConnection:handleDict)

    DCMENUITEM 'Edit Comment' PARENT oTreeMenu ;
      ACTION {||::DictTableProperties( aData[2,1], oConnection:handleDict, oTreeItem )}

    DCMENUITEM SEPARATOR PARENT oTreeMenu

    DCMENUITEM IIF(::AdsIsTableEncrypted(aData[2,1],oConnection),'Decrypt','Encrypt') + ' this table' ;
      ACTION {||::AdsTableSetEncrypted( aData[2,1],oConnection,oTreeItem) } ;
      PARENT oTreeMenu

  ENDIF

ELSEIF aData[1] = 'Index File'

  DCMENUITEM 'Properties' PARENT oTreeMenu ;
    ACTION {||::TableProperties( aData, oConnection )}

  IF oConnection:type = 'ADS' .AND. oConnection:handleDict > 0
    DCMENUITEM 'Reindex this table' PARENT oTreeMenu ;
      ACTION {||::DictReindexTable( aData[2,1], oConnection )}
  ENDIF

ELSEIF aData[1] = 'Fields'

  DCMENUITEM 'Properties' PARENT oTreeMenu ;
    ACTION {||::TableProperties( aData, oConnection )}

ELSEIF aData[1] == 'Views'

  DCMENUITEM 'Create a new View' PARENT oTreeMenu ;
    ACTION {||DD_SqlErrorWindow(soMessageBox), ;
             ::CreateViewSQL( nil, oConnection, oTreeItem )}

ELSEIF aData[1] == 'View'

  DCMENUITEM 'Execute this View (Cursor Browse)' PARENT oTreeMenu ;
    ACTION {||DD_SqlErrorWindow(soMessageBox), ;
              ::ViewExecute( aData[2], oConnection, 1 )}

  DCMENUITEM 'Execute this View (Object Browse)' PARENT oTreeMenu ;
    ACTION {||DD_SqlErrorWindow(soMessageBox), ;
              ::ViewExecute( aData[2], oConnection, 2 )}

  DCMENUITEM 'Properties' PARENT oTreeMenu ;
    ACTION {||::ViewProperties( @aData[2], oConnection:handleDict, oConnection, oTreeItem )}

  DCMENUITEM 'Delete this View' PARENT oTreeMenu ;
    ACTION {||DD_SqlErrorWindow(soMessageBox), ;
             ::DeleteViewSQL( aData[2], oConnection, oTreeItem )}

ELSEIF aData[1] == 'Command Script'

  DCMENUITEM 'Load this Command Script' PARENT oTreeMenu ;
    ACTION {||::CommandWindow( oConnection, aData, .f. )}

  DCMENUITEM 'Execute this Command Script' PARENT oTreeMenu ;
    ACTION {||::CommandWindow( oConnection, aData, .t. )}

  DCMENUITEM 'Delete this Script' PARENT oTreeMenu ;
    ACTION {||::DeleteScript( aData[2,2], oConnection, oTreeItem, {4} )}

  DCMENUITEM 'Properties' PARENT oTreeMenu ;
    ACTION {||::SqlScriptProperties( @aData[2,2], oConnection, oTreeItem )}

ELSEIF aData[1] == 'Command Scripts'

  DCMENUITEM 'Create a new Command Script' PARENT oTreeMenu ;
    ACTION {||::CommandWindow(oConnection)}

ELSEIF aData[1] == 'ISAM Scripts'

  DCMENUITEM 'Create a new ISAM Script:' PARENT oTreeMenu ;
    ACTION {||(DCMSGBOX 'To create an ISAM script', '', ;
               '1. Select a Table.', ;
               '2. Right-Click for menu.', ;
               '3. Select "Browse Table (Select Fields)"' ;
               FONT ::cMessageFont OWNER AppDeskTop())}

ELSEIF aData[1] == 'SQL Scripts'

  DCMENUITEM 'Create a new SQL Script' PARENT oTreeMenu ;
    ACTION {||::SqlQueryPick( ,oConnection )}

ELSEIF aData[1] == 'SQL Script'

  DCMENUITEM 'Load this SQL Script' PARENT oTreeMenu ;
    ACTION {||::LoadScript( aData, oConnection, .f. )}

  DCMENUITEM 'Execute this SQL Script' PARENT oTreeMenu ;
    ACTION {||DD_SqlErrorWindow(soMessageBox), ;
              ::LoadScript( aData, oConnection, .t. )}

  IF aData[2,1] = 'SQLQUERY.DBF'
    DCMENUITEM 'Delete this Script' PARENT oTreeMenu ;
      ACTION {||::DeleteScript( aData[2,2], oConnection, oTreeItem, {0,1,2,3} )}
  ENDIF

  DCMENUITEM 'Properties' PARENT oTreeMenu ;
    ACTION {||::SqlScriptProperties( @aData[2,2], oConnection, oTreeItem )}

ELSEIF aData[1] == 'ISAM Script'

  DCMENUITEM 'Load this ISAM Script' PARENT oTreeMenu ;
    ACTION {||::LoadScript( aData, oConnection, .f. )}

  DCMENUITEM 'Execute this ISAM Script' PARENT oTreeMenu ;
    ACTION {||DD_SqlErrorWindow(soMessageBox), ;
              ::LoadScript( aData, oConnection, .t. )}

  IF aData[2,1] = 'SQLQUERY.DBF'
    DCMENUITEM 'Delete this Script' PARENT oTreeMenu ;
      ACTION {||::DeleteScript( aData[2,2], oConnection, oTreeItem, {5} )}
  ENDIF

  DCMENUITEM 'Properties' PARENT oTreeMenu ;
    ACTION {||::SqlScriptProperties( @aData[2,2], oConnection, oTreeItem )}

ELSEIF aData[1] == 'Procedures'

  DCMENUITEM 'Create a New Procedure' PARENT oTreeMenu ;
      ACTION {||GuiRun({||::CreateProcedureSQL( oConnection, oTreeItem )})}

ELSEIF aData[1] == 'Procedure'

  DCMENUITEM 'Execute this Procedure' PARENT oTreeMenu ;
    ACTION {||DD_SqlErrorWindow(soMessageBox), ;
              GuiRun({||::DictProcedureExecuteSQL( aData[2], oConnection, 1, .t. )})}

  DCMENUITEM 'Delete this Procedure' PARENT oTreeMenu ;
      ACTION {||DD_SqlErrorWindow(soMessageBox), ;
              ::DropProcedureSQL( aData[2], oConnection, oTreeItem )}

  IF oConnection:type = 'ADS' .AND. !Empty(oConnection:handleDict)

    DCMENUITEM 'Properties' PARENT oTreeMenu ;
      ACTION {||::DictProcedurePropertiesADS( .f., aData[2], oConnection )}

    DCMENUITEM 'Edit Comment' PARENT oTreeMenu ;
      ACTION {||::UpdateProcedureCommentADS( aData[2], oConnection, oTreeItem )}

  ENDIF

  IF oConnection:type = 'ODBC'
    DCMENUITEM 'Properties' PARENT oTreeMenu ;
      ACTION {||::DictProcedurePropertiesODBC( .f., aData[2], oConnection )}

    IF 'ADVANTAGE STREAMLINESQL' $ Upper(oConnection:driver)
      DCMENUITEM 'Edit Comment' PARENT oTreeMenu ;
        ACTION {||::UpdateProcedureCommentADS( aData[2], oConnection, oTreeItem )}
    ENDIF
  ENDIF

ELSEIF aData[1] = 'Field'

  DCMENUITEM 'Properties' PARENT oTreeMenu ;
    ACTION {||::DictFieldProperties( aData[3], aData[2,1], oConnection:handleDict )}

ELSEIF aData[1] = 'Group'

  DCMENUITEM 'Properties' PARENT oTreeMenu ;
    ACTION {||::DictGroupProperties( aData[2], oConnection:handleDict )}

ELSEIF aData[1] = 'User'

  DCMENUITEM 'Properties' PARENT oTreeMenu ;
    ACTION {||::DictUserProperties( aData[2], oConnection:handleDict )}

ELSEIF aData[1] = 'RI'

  DCMENUITEM 'Properties' PARENT oTreeMenu ;
    ACTION {||::DictRIProperties( aData[2], oConnection:handleDict )}

ELSEIF aData[1] = 'Index Tag'

  DCMENUITEM 'Properties' PARENT oTreeMenu ;
    ACTION {||::DictIndexProperties( .f., aData[6], aData[2], oConnection:handleDict )}

ENDIF

DCREAD GUI EXIT PARENT AppDeskTop()

oConnection:viewBranch := oTreeItem

oTreeMenu:popup( ::oTree, aPos, 2, ;
                XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN )

IF lRebuild
  ::RebuildTree()
ENDIF

RETURN nil

* --------------

METHOD SqlQuery:disconnect( oConnection )

LOCAL aChildList, i, oDlg

aChildList := ::oBrowseParentWindow:childList()

FOR i := 1 TO Len(aChildList)
  oDlg := aChildList[i]
  IF oDlg:isDerivedFrom('DC_XbpDialog1') .AND. oDlg:connection == oConnection
    PostAppevent(xbeP_Close,,,oDlg)
    Sleep(10)
  ENDIF
NEXT

oConnection:disconnect(self)

RETURN nil

* --------------

METHOD SqlQuery:WriteSchema( aData, oConnection )

LOCAL aTables := aData[2], nHandle, i, j, h, aFields, cTableName, cComment, ;
      cField, aIndexes, cIndex, aTags, cTag, cFileName, cExt

DC_PointerWait()

cFileName := 'Schema_' + oConnection:GroupName + '.Txt'

nHandle := FCreate(cFileName)

FWrite(nHandle,'Schema for [' + oConnection:groupName + '] ' + oConnection:name + CRLF )

FOR i := 1 TO Len(aTables)
  cTableName := aTables[i,1]
  cComment := IIF(!Empty(aTables[i,4]),' (' + aTables[i,4] + ')','')
  Fwrite(nHandle, CRLF + cTableName + cComment + CRLF )
  aFields := aTables[i,3]
  IF Empty(aFields)
    IF oConnection:type = 'ADS'
      aFields := ::GetFieldNameArrayADS( cTableName, oConnection:handleDict )
    ENDIF
  ENDIF
  FOR j := 1 TO Len(aFields)
    cField := aFields[j,1] + ', ' + aFields[j,2] + ', ' + ;
      DC_XtoC(aFields[j,3]) + ', ' + DC_XtoC(aFields[j,4])
    FWrite(nHandle, '  ' + cField + CRLF)
  NEXT
  aIndexes := aTables[i,2]
  IF Empty(aIndexes)
    IF oConnection:type = 'ADS'
      aIndexes := ::BuildIndexArrayAds( cTableName, oConnection )
    ELSEIF oConnection:type = 'ODBC'
      aIndexes := ::BuildIndexArrayODBC( cTableName, oConnection )
    ENDIF
    aIndexes := {{ cTableName, aIndexes }}
  ENDIF
  FOR j := 1 TO Len(aIndexes)
    IF '.CDX' $ Upper(aIndexes[j,1])
      cExt := ''
    ELSE
      cExt := '.Cdx'
    ENDIF
    cIndex := aIndexes[j,1] + IIF(oConnection:type = 'ADS',cExt,'') + ' (Indexes)'
    aTags := aIndexes[j,2]
    IF !Empty(aTags)
      FWrite(nHandle,'  ' + cIndex + CRLF)
      FOR h := 1 TO Len(aTags)
        cTag := aTags[h,1] + ', ' + aTags[h,2] + ', ' + ;
                aTags[h,3] + ', ' + IIF(aTags[h,4],'Unique','') + ', ' + ;
                IIF(aTags[h,5],'Descending','')
        FWrite(nHandle, '    ' + cTag + CRLF)
      NEXT h
    ENDIF
  NEXT j
NEXT i

FClose(nHandle)
DC_PointerArrow()

DCMSGBOX 'Schema saved to ' + cFileName FONT ::cMessageFont  ;
   OWNER AppDeskTop()

RunShell( cFileName,'Notepad.exe',.t.,.f.)

RETURN nil

* --------------

METHOD SqlQuery:tagArray( aData, aHeaders, nEditColumn, cTitle )

LOCAL GetList[0], oBrowse, i, nTagElement, lStatus, bProtect

nTagElement := Len(aData[1])+1

FOR i := 1 TO Len(aData)
  AAdd(aData[i],.f.)
NEXT

DCHOTKEY xbeK_SPACE ;
   ACTION {||aData[oBrowse:arrayElement,nTagElement] := ;
             !aData[oBrowse:arrayElement,nTagElement], ;
             oBrowse:refreshCurrent()} ;
   WHEN {||SetAppFocus() == oBrowse}

@ 0,0 DCSAY 'Use Space bar to tag/untag' SAYSIZE 0 FONT ::cMessageFont
@ 1,0 DCSAY 'Use ENTER to enter description' SAYSIZE 0 FONT ::cMessageFont

@ 3,0 DCPUSHBUTTON CAPTION 'Tag All' SIZE 10 ;
      ACTION {||AEval(aData,{|a|a[nTagElement] := .t.}),oBrowse:refreshAll()}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'UnTag All' SIZE 10 ;
      ACTION {||AEval(aData,{|a|a[nTagElement] := .f.}),oBrowse:refreshAll()}

@ 4.5,0 DCBROWSE oBrowse DATA aData SIZE 100,25 FIT ;
      FONT ::cMessageFont ;
      EDIT xbeBRW_ItemSelected ;
      COLOR {||IIF( aData[oBrowse:arrayElement,nTagElement],{nil,GRA_CLR_YELLOW},{nil,GRA_CLR_WHITE})}

FOR i := 1 TO Len(aHeaders)
  IF i == nEditColumn
    bProtect := nil
  ELSE
    bProtect := {||.t.}
  ENDIF
  DCBROWSECOL ELEMENT i HEADER aHeaders[i] PARENT oBrowse PROTECT bProtect
NEXT

DCREAD GUI FIT ADDBUTTONS TITLE cTitle TO lStatus MODAL ;
   NOAUTORESTORE EVAL {|o|::SetWindowPos(o)}

RETURN lStatus

* --------------

METHOD SqlQuery:CreateConnection()

LOCAL oConnection := SqlQueryConnection():new(nil,self)

RETURN oConnection:CreateConnection(self,.t.)

* --------------

METHOD SqlQuery:EditConnectionProperties( oConnection )

oConnection:Type := Pad(oConnection:Type,4)
oConnection:Name := Pad(oConnection:Name,30)
oConnection:Driver := Pad(oConnection:Driver,50)
oConnection:Server := Pad(oConnection:Server,100)
oConnection:ServerDict := Pad(oConnection:ServerDict,100)
oConnection:ServerFree := Pad(oConnection:ServerFree,100)
oConnection:Database := Pad(oConnection:Database,100)
oConnection:Network := Pad(oConnection:Network,50)
oConnection:UID := Pad(oConnection:UID,30)
oConnection:PWD := Pad(oConnection:PWD,30)

RETURN oConnection:CreateConnection(self,.f.)

* --------------

METHOD SqlQuery:DeleteConnection( oConnection, oTreeItem )

LOCAL lStatus

DCMSGBOX oConnection:type + ': ' + oConnection:name, ;
  'Delete this connection from ' + ::cIniFile + ' ?' ;
   YESNO TO lStatus FONT ::cMessageFont OWNER AppDeskTop()

IF lStatus
  oConnection:disConnect(self)
  oTreeItem:getParentItem():delItem(oTreeItem)
  DC_IniDelete( ::cIniFile, Alltrim(oConnection:groupName))
ENDIF

RETURN lStatus

* --------------

METHOD SqlQuery:CreateAccessSchemaArray( aTables, oConnection )

LOCAL aSchema[0], i, cTableName, cDatabase, nFound, cSchema

dbeSetDefault('ODBCDBE')

FOR i := 1 TO Len(aTables)
  cTableName := aTables[i,1]
  USE (cTableName) VIA (oConnection:sessionDict) ALIAS 'QUERY'
  IF !Empty(Alias())
    AAdd(aSchema,{cTableName,QUERY->(dbStruct())})
    QUERY->(dbCloseArea())
  ENDIF
  Sleep(10)
NEXT

cDatabase := oConnection:database
nFound := _AtLast(cDatabase,'.')
cSchema := Substr(cDatabase,1,nFound-1) + '.Columns'
MemoWrit(cSchema,DC_ArrayString(aSchema))

DCMSGBOX 'Schema has been saved to:','',cSchema, '', ;
         'Disconnect and Connect again to load', ;
         'column (field) definitions.' FONT ::cMessageFont ;
         OWNER AppDeskTop()

RETURN nil

* --------------

METHOD SqlQuery:BrowseSqlQueryDbf()

LOCAL oConnection := SqlQueryConnection():new(nil,self)

oConnection:type := 'ADS'
oConnection:groupName := 'SqlQueryDict'
oConnection:AdsTableType := ADS_CDX
oConnection:AdsLockingType := 0
oConnection:serverFree := DC_Path(AppName(.t.))
oConnection:uid := 'ADSSYS'
oConnection:sqlStatement := ''
oConnection:name := 'SqlQuery.Dbf Dictionary (Views/Scripts)'

oConnection:connectAds(nil,self)

::OpenViewsFile(oConnection:sessionFree)

GuiRun({|a|::BrowseISAM(::cSqlQueryDbf,oConnection)})

RETURN nil

* --------------

METHOD SqlQuery:BuildFreeArrayAds( nSort, oConnection )

LOCAL aTables[0], aDir, nTableHandle := 0, aFields, ;
      nIndexHandle, nError, cTableName, cIndexName, ;
      aIndex := {}, i, j, nLen := 100, aObjects[OBJECT_SIZE], ;
      lGoodFile, bError, aStru, cPath, aTags

dbeSetDefault('ADSDBE')

DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE, oConnection:AdsTableType )
DbeInfo( COMPONENT_ORDER, ADSDBE_TBL_MODE, oConnection:AdsTableType )
DbeInfo( COMPONENT_DATA, ADSDBE_LOCK_MODE, oConnection:AdsLockingType )
DbeInfo( COMPONENT_DATA, ADSDBE_TABLENAME_IS_ALIAS, .f. )

IF oConnection:AdsTableType = ADS_ADT
  aDir := Directory( oConnection:serverFree + '\*.ADT')
ELSE
  aDir := Directory( oConnection:serverFree + '\*.DBF')
ENDIF

FOR i := 1 TO Len(aDir)

  cTableName := Upper(aDir[i,1])

  bError := ErrorBlock({|e|Break(e)})

  lGoodFile := .f.
  aFields := {}
  cPath := DC_CurPath()
  DC_ChDir(oConnection:serverFree)
  BEGIN SEQUENCE
    USE (cTableName) VIA (oConnection:sessionFree) // ALIAS 'TEMP'
    lGoodFile := .t.
    aStru := dbStruct()
    FOR j := 1 TO Len(aStru)
      AAdd(aFields,aStru[j])
      AAdd(Atail(aFields),j)
    NEXT
    aTags := DC_TagInfo()
    dbCloseArea()
  END SEQUENCE
  DC_ChDir(cPath)

  ErrorBlock(bError)

  IF !lGoodFile
    cTableName += ' (Error opening file)'
  ENDIF

  IF oConnection:AdsTableType $ { ADS_CDX, ADSDBE_VFP }
    cIndexName := oConnection:serverFree + '\' + Strtran(cTableName,'.DBF','.CDX')

    IF File(cIndexName)
      cIndexName := DC_Path(cIndexName,.t.)
      aIndex := {{ cIndexName,aTags }}
    ELSE
      aIndex := {}
    ENDIF
  ELSE
    aIndex := {}
  ENDIF

  AAdd( aTables, { cTableName, aIndex, aFields, '', cTableName, cIndexName } )

NEXT

aObjects[OBJECT_TABLES] := aTables
aObjects[OBJECT_USERS] := {}
aObjects[OBJECT_VIEWS] := {}
aObjects[OBJECT_GROUPS] := {}
aObjects[OBJECT_PROCEDURES] := {}
aObjects[OBJECT_LINKS] := {}
aObjects[OBJECT_TRIGGERS] := {}
aObjects[OBJECT_RELATIONS] := {}
aObjects[OBJECT_PUBLICATIONS] := {}
aObjects[OBJECT_ARTICLES] := {}
aObjects[OBJECT_SUBSCRIPTIONS] := {}
aObjects[OBJECT_COMMAND_SCRIPTS] := {}
::loadScripts( oConnection, aObjects[OBJECT_COMMAND_SCRIPTS],{4})
aObjects[OBJECT_SQL_SCRIPTS] := {}
::loadScripts( oConnection, aObjects[OBJECT_SQL_SCRIPTS],{0,1,2,3})
aObjects[OBJECT_ISAM_SCRIPTS] := {}
::loadScripts( oConnection, aObjects[OBJECT_ISAM_SCRIPTS],{5})

RETURN aObjects

* -------------

METHOD SqlQuery:BuildIndexArrayODBC( cTableName, oConnection, oTreeItem )

LOCAL cSql, cAlias, aIndexes[0], aIndex, cIndexName, oIndexItem, ;
      oTagItem, i

BEGIN SEQUENCE

IF 'ADVANTAGE STREAMLINESQL' $ Upper(oConnection:driver)

  TEXT INTO cSql WRAP
  SELECT Left(parent,20) as TableName,
  Left(Index_File_Name,20) as IndexName,
  Left(name,20) as TagName,
  Left(index_expression,60) as KeyExpr,
  Left(index_condition,60) as Condition
  FROM system.indexes WHERE Left(parent,20) = ?
  ORDER BY TableName
  ENDTEXT

ELSEIF 'Microsoft Access Driver' $ oConnection:driver

  BREAK

ELSE

  TEXT INTO cSql WRAP
  SELECT TableName = t.Name, IndexName = i.Name, IndexType = i.type_desc,
    ColumnOrdinal = Ic.key_ordinal, ColumnName = c.name, ColumnType = ty.name
    FROM sys.indexes i
    INNER JOIN sys.tables t ON t.object_id = i.object_id
    INNER JOIN sys.index_columns ic ON ic.object_id = i.object_id AND ic.index_id = i.index_id
    INNER JOIN sys.columns c ON c.object_id = ic.object_id AND c.column_id = ic.column_id
    INNER JOIN sys.types ty ON c.system_type_id = ty.system_type_id
    WHERE t.Name = ? ORDER BY t.Name, i.name, ic.key_ordinal
  ENDTEXT

ENDIF

cSql := DC_ApplySqlParams(cSql,{cTableName})

IF !Empty(cSql)
  SELECT 0
  DDSTATEMENT (cSql) VIA oConnection:sessionDict
  cAlias := Alias()

  DO WHILE !(cAlias)->(Eof())

    IF (cAlias)->(IsFieldVar('TagName'))
      AAdd(aIndexes,{Trim((cAlias)->TagName),Trim((cAlias)->KeyExpr),Trim((cAlias)->Condition),.f.,.f.})
      (cAlias)->(dbSkip())
    ELSE
      AAdd(aIndexes,{Trim((cAlias)->IndexName),Trim((cAlias)->ColumnName),'',.f.,.f.})
      cIndexName := (cAlias)->IndexName
      (cAlias)->(dbSkip())
      DO WHILE !(cAlias)->(Eof()) .AND. (cAlias)->TableName == cTableName .AND. (cAlias)->IndexName == cIndexName
        aIndex := ATail(aIndexes)
        aIndex[2] += ',' + Trim((cAlias)->ColumnName)
        (cAlias)->(dbSkip())
      ENDDO
    ENDIF
  ENDDO

ENDIF

(cAlias)->(dbCloseArea())

END SEQUENCE

IF Valtype(oTreeItem) == 'O'
  AAdd( oTreeItem:cargo[2,2], {cTableName,aIndexes})
  oIndexItem := oTreeItem:addItem(cTableName,ICON_INDEXFILE,ICON_INDEXFILE,ICON_INDEXFILE)
  oIndexItem:cargo := { 'Index File', oTreeItem:cargo[2], oTreeItem,, oConnection }
  FOR i := 1 TO Len(aIndexes)
    oTagItem := oIndexItem:addItem(aIndexes[i,1],ICON_INDEXTAG,ICON_INDEXTAG,ICON_INDEXTAG)
    oTagItem:cargo := { 'Index Tag', aIndexes[i], oIndexItem,, oConnection, cTableName }
  NEXT
ENDIF

RETURN aIndexes

* -------------

METHOD SqlQuery:BuildProcedureArrayODBC( oConnection, oTreeItem )

LOCAL cSql, cAlias, aProcedures[0], lAdsODBC, cComment, cRoutine, cProcedure

BEGIN SEQUENCE

lAdsODBC := 'ADVANTAGE STREAMLINESQL' $ Upper(oConnection:driver)
IF lAdsODBC
   cSql := "SELECT * FROM system.storedprocedures ORDER BY name"

ELSEIF 'Microsoft Access Driver' $ oConnection:driver

  BREAK

ELSE
   cSql := "SELECT SPECIFIC_NAME AS Name, ROUTINE_DEFINITION, CREATED, LAST_ALTERED " + ;
           "FROM INFORMATION_SCHEMA.ROUTINES WHERE ROUTINE_TYPE = 'PROCEDURE' " + ;
           "ORDER BY SPECIFIC_NAME"
ENDIF

DDSTATEMENT (cSql) VIA oConnection:sessionDict

cAlias := Alias()

DO WHILE !(cAlias)->(Eof())
  IF lAdsODBC
    cComment := (cAlias)->comment
    cProcedure := (cAlias)->name
    IF Empty(cComment)
      cComment := _GetComment((cAlias)->SQL_Script)
    ENDIF
    AAdd( aProcedures, {Trim((cAlias)->name),{cComment,(cAlias)->SQL_Script}} )
  ELSE
    cProcedure := (cAlias)->name
    cRoutine := (cAlias)->routine_definition
    cComment := _GetComment(cRoutine)
    AAdd( aProcedures, {Trim(cProcedure),{cComment,cRoutine}} )
  ENDIF
  (cAlias)->(dbSkip())
ENDDO

(cAlias)->(dbCloseArea())

END SEQUENCE

RETURN aProcedures

* --------------

METHOD SqlQuery:BuildProcedureArrayADS( oConnection, oTreeItem )

LOCAL aProcedures, aProcData, i, cProcedure, cComment

aProcedures := ::BuildObjectArrayAds( ADS_DD_PROCEDURE_OBJECT,,,oConnection )
ASort(aProcedures)

FOR i := 1 TO Len(aProcedures)
  cProcedure := aProcedures[i]
  aProcData := ::DictProcedurePropertiesADS( .t., cProcedure, oConnection )
  cComment := aProcData[1]
  IF Empty(cComment)
    cComment := _GetComment(aProcData[7])
  ENDIF
  aProcedures[i] := { aProcedures[i], { cComment, aProcData[7]}}
NEXT

RETURN aProcedures

* --------------

STATIC FUNCTION _GetComment( cScript )

LOCAL nFound

nFound := At('/' + '*',cScript)
IF nFound > 0
  cScript := Substr(cScript,nFound+2)
  nFound := At( '*/', cScript )
  IF nFound > 0
    cScript := Alltrim(Substr(cScript,1,nFound-1))
  ELSE
    cScript := ''
  ENDIF
ELSE
  cScript := ''
ENDIF

RETURN cScript

* --------------

METHOD SqlQuery:BuildDictArrayODBC( nSort, oConnection )

LOCAL lAds, cAlias1, cAlias2, cAlias3, aTables[0], aViews[0], cSql, cTableName, nElement, ;
      aObjects[OBJECT_SIZE], nFieldLen, nFieldDec, cFieldType, nType, nTable, cComment, ;
      cIndexName, aTable, bError, aProcedures[0], aScripts[0], aField, cTables, ;
      cSchema, nFound, cViews, cDatabase, i, cColumns, aColumns[0], cTable, aFields, ;
      nFieldPos

BEGIN SEQUENCE

IF 'ADVANTAGE STREAMLINESQL' $ Upper(oConnection:driver)

  TEXT INTO cSql WRAP
  SELECT Left(parent,30) as table_name, Left(name,30) as column_name,
         field_type, field_length, field_decimal, field_num
         FROM system.columns
         ORDER BY table_name, column_name
  ENDTEXT
  lAds := .t.

ELSEIF 'Microsoft Access Driver' $ oConnection:driver

  cDatabase := oConnection:database
  nFound := _AtLast(cDatabase,'.')
  cSchema := Substr(cDatabase,1,nFound-1) + '.Tables'
  cTables := MemoRead(cSchema)
  IF Empty(cTables)
    DCMSGBOX 'Table Schema file not found:', ;
             cSchema FONT ::cMessageFont OWNER AppDeskTop()
  ENDIF

  cSchema := Substr(cDatabase,1,nFound-1) + '.Columns'
  cColumns := MemoRead(cSchema)
  IF !Empty(cColumns) .AND. Left(cColumns,1) = '{'
    cColumns := Alltrim(Strtran(cColumns,CRLF,''))
    cColumns := Alltrim(Strtran(cColumns,';',''))
    aColumns := &(cColumns)
  ENDIF
  IF !Empty(cTables) .AND. Left(cTables,1) = '{'
    cTables := Alltrim(Strtran(cTables,CRLF,''))
    cTables := Alltrim(Strtran(cTables,';',''))
    aTables := &(cTables)
    FOR i := 1 TO Len(aTables)
      cTable := aTables[i]
      nFound := AScan(aColumns,{|a|a[1]==cTable})
      IF nFound > 0
        aFields := aColumns[nFound,2]
        AAdd(aFields,nFound)
      ELSE
        aFields := {}
      ENDIF
      aTables[i] := { cTable, {},aFields,''}
    NEXT
  ENDIF
  nFound := _AtLast(cDatabase,'.')
  cSchema := Substr(cDatabase,1,nFound-1) + '.Views'
  cViews := MemoRead(cSchema)
  IF !Empty(cViews) .AND. Left(cViews,1) = '{'
    cViews := Alltrim(Strtran(cViews,CRLF,''))
    cViews := Alltrim(Strtran(cViews,';',''))
    aViews := &(cViews)
  ENDIF
  BREAK

ELSE

  TEXT INTO cSql WRAP
  SELECT table_name, column_name, data_type as field_type,
  character_maximum_length as field_len,
  numeric_precision, numeric_scale,
  ordinal_position as field_pos
  FROM INFORMATION_SCHEMA.COLUMNS ORDER BY table_name, column_name
  ENDTEXT
  lAds := .f.

ENDIF

SELECT 0
DDSTATEMENT (cSql) VIA oConnection:sessionDict
cAlias1 := Alias()

IF 'ADVANTAGE STREAMLINESQL' $ Upper(oConnection:driver)

  TEXT INTO cSql WRAP
  SELECT Left(name,20) as Table_Name,
  Left(comment,40) as Comment
  FROM system.tables
  ORDER BY table_name
  ENDTEXT

ELSE

  cSQL := nil

ENDIF

IF !Empty(cSql)
  SELECT 0
  DDSTATEMENT (cSql) VIA oConnection:sessionDict
  cAlias2 := Alias()
ENDIF

IF Empty(cAlias1)
  BREAK
ENDIF

cTableName := ''
DO WHILE !(cAlias1)->(Eof())
  IF cTableName # (cAlias1)->table_name
    IF Len(aTables) > 1000
      EXIT
    ENDIF
    cTableName := (cAlias1)->table_name
    cComment := ''
    IF !Empty(cAlias2)
      (cAlias2)->(dbLocate({||Upper(Trim((cAlias2)->table_name))==Upper(Trim((cAlias1)->table_name))}))
      cComment := (cAlias2)->comment
    ENDIF
    AAdd( aTables, { Trim(cTableName), {}, {}, cComment } )
  ENDIF

  nElement := Len(aTables)
  IF lAds
    nType := (cAlias1)->field_type
    IF nType == ADS_NUMERIC
      cFieldType := 'N'
    ELSEIF nType == ADS_DATE
      cFieldType := 'D'
    ELSEIF nType == ADS_STRING
      cFieldType := 'C'
    ELSEIF nType == ADS_MEMO
      cFieldType := 'M'
    ELSEIF nType == ADS_LOGICAL
      cFieldType := 'L'
    ENDIF
    nFieldLen := (cAlias1)->field_length
    nFieldDec := (cAlias1)->field_decimal
    nFieldPos := (cAlias1)->field_num
  ELSE
    cFieldType := (cAlias1)->field_type
    nFieldLen := (cAlias1)->field_len
    nFieldPos := (cAlias1)->field_pos
    nFieldDec := 0
    IF nFieldLen == 0 .AND. ;
        cFieldType $ {'numeric','bigint','tinyinit','mediumint','int','money','decimal','float'}
      nFieldLen := (cAlias1)->numeric_precision
      nFieldDec := (cAlias1)->numeric_scale
    ELSEIF nFieldLen == 0 .AND. cFieldType $ {'date','time'}
      nFieldLen := 8
    ELSEIF nFieldLen == 0 .AND. cFieldType = 'text'
      nFieldLen := 10
    ELSEIF nFieldLen == 0 .AND. cFieldType = 'boolean'
      nFieldLen := 1
    ENDIF
  ENDIF
  aField := {Trim((cAlias1)->column_name),Trim(cFieldType),nFieldLen,nFieldDec,nFieldPos}
  AAdd( aTables[nElement,3],aField )
  (cAlias1)->(dbSkip())
ENDDO

(cAlias1)->(dbCloseArea())
IF !Empty(cAlias2)
  (cAlias2)->(dbCloseArea())
ENDIF

IF 'ADVANTAGE STREAMLINESQL' $ Upper(oConnection:driver)
   cSql := "SELECT name AS table_name FROM system.views ORDER BY table_name"
ELSE
   cSql := "SELECT table_name FROM INFORMATION_SCHEMA.VIEWS ORDER BY table_name"
ENDIF

DDSTATEMENT (cSql) VIA oConnection:sessionDict

cAlias1 := Alias()

cTableName := ''
DO WHILE !(cAlias1)->(Eof())
  IF cTableName # (cAlias1)->table_name
    IF Len(aViews) > 500
      EXIT
    ENDIF
    cTableName := (cAlias1)->table_name
    AAdd( aViews, Alltrim(cTableName) )
  ENDIF
  (cAlias1)->(dbSkip())
ENDDO

(cAlias1)->(dbCloseArea())

END SEQUENCE

aObjects[OBJECT_TABLES] := aTables
aObjects[OBJECT_VIEWS] := aViews
aObjects[OBJECT_USERS] := {}
aObjects[OBJECT_GROUPS] := {}
aObjects[OBJECT_PROCEDURES] := {}
aObjects[OBJECT_LINKS] := {}
aObjects[OBJECT_TRIGGERS] := {}
aObjects[OBJECT_RELATIONS] := {}
aObjects[OBJECT_PUBLICATIONS] := {}
aObjects[OBJECT_ARTICLES] := {}
aObjects[OBJECT_SUBSCRIPTIONS] := {}
aObjects[OBJECT_SQL_SCRIPTS] := {}
::loadScripts( oConnection, aObjects[OBJECT_SQL_SCRIPTS],{0,1,2,3})
aObjects[OBJECT_COMMAND_SCRIPTS] := {}
::loadScripts( oConnection, aObjects[OBJECT_COMMAND_SCRIPTS],{4})
aObjects[OBJECT_ISAM_SCRIPTS] := {}
::loadScripts( oConnection, aObjects[OBJECT_ISAM_SCRIPTS],{5})

RETURN aObjects

* --------

STATIC FUNCTION _AtLast( cField, cChar )

LOCAL i

FOR i := Len(cField) TO 1 STEP -1
  IF cField[i] == cChar
    RETURN i
  ENDIF
NEXT

RETURN 0

* -----------

#if XPPVER > 2000000
METHOD SqlQuery:BuildDictArrayPG( nSort, oConnection )

LOCAL cAlias, aTables[0], cSql, cTableName, oStmt, nElement, aObjects[OBJECT_SIZE], ;
      cFieldType, nFieldLen, nFieldDec, oSession, nPos

cSql := "SELECT * FROM INFORMATION_SCHEMA.COLUMNS" + ;
        " WHERE table_schema = 'public' AND SubString(column_name,1,2)<>'__'" + ;
        ;// " ORDER BY table_name,column_name"
        " ORDER BY table_name"


oSession := oConnection:sessionDict

dbeSetDefault('PGDBE')
oStmt := DacSqlStatement(oSession):FromChar(cSql)
oStmt:Build():Query(,'TABLES')

cAlias := Alias()

cTableName := ''
nPos := 1
DO WHILE !(cAlias)->(Eof())
  IF cTableName # (cAlias)->table_name
    IF Len(aTables) > 1000
      EXIT
    ENDIF
    cTableName := (cAlias)->table_name
    AAdd( aTables, { cTableName, {}, {}, ''} )
    nPos := 1
  ENDIF
  nElement := Len(aTables)
  cFieldType := (cAlias)->data_type
  nFieldLen := (cAlias)->character_maximum_length
  nFieldDec := 0
  IF nFieldLen == 0 .AND. cFieldType = 'numeric'
    nFieldLen := (cAlias)->numeric_precision
    nFieldDec := (cAlias)->numeric_scale
  ELSEIF nFieldLen == 0 .AND. cFieldType = 'date'
    nFieldLen := 8
  ELSEIF nFieldLen == 0 .AND. cFieldType = 'text'
    nFieldLen := 10
  ELSEIF nFieldLen == 0 .AND. cFieldType = 'boolean'
    nFieldLen := 1
  ENDIF

  AAdd( aTables[nElement,3],{Trim((cAlias)->column_name), ;
                             Trim((cAlias)->data_type), ;
                             nFieldLen, ;
                             nFieldDec, ;
                             nPos } )
  (cAlias)->(dbSkip())
  nPos++
ENDDO

(cAlias)->(dbCloseArea())

aObjects[OBJECT_TABLES] := aTables
aObjects[OBJECT_USERS] := {}
aObjects[OBJECT_VIEWS] := {}
aObjects[OBJECT_GROUPS] := {}
aObjects[OBJECT_PROCEDURES] := {}
aObjects[OBJECT_LINKS] := {}
aObjects[OBJECT_TRIGGERS] := {}
aObjects[OBJECT_RELATIONS] := {}
aObjects[OBJECT_PUBLICATIONS] := {}
aObjects[OBJECT_ARTICLES] := {}
aObjects[OBJECT_SUBSCRIPTIONS] := {}
aObjects[OBJECT_SQL_SCRIPTS] := {}
::loadScripts( oConnection, aObjects[OBJECT_SQL_SCRIPTS],{0,1,2,3})
aObjects[OBJECT_COMMAND_SCRIPTS] := {}
::loadScripts( oConnection, aObjects[OBJECT_COMMAND_SCRIPTS],{4})
aObjects[OBJECT_ISAM_SCRIPTS] := {}
::loadScripts( oConnection, aObjects[OBJECT_ISAM_SCRIPTS],{5})

RETURN aObjects
#endif

* --------------

METHOD SqlQuery:BuildIndexArrayAds( cTableName, oConnection, oTreeItem )

LOCAL i, cData, nLen, nHandle, nError, cIndexName, ;
      aIndexes[0], aTagData, oIndexItem, oTagItem

IF oConnection:adsTableType $ { ADSDBE_CDX, ADSDBE_VFP }
  cIndexName := cTableName + '.Cdx'
  cIndexName := Strtran(cIndexName,'.DBF','')
ELSE
  cIndexName := '<No Indexes>'
ENDIF

* --------- Index Tags ---------

cData := Space(ADS_DD_MAX_OBJECT_NAME_LEN)
nLen := ADS_DD_MAX_OBJECT_NAME_LEN
nHandle := 0

nError := AdsDDFindFirstObject( oConnection:handleDict, ;
                  ADS_DD_INDEX_OBJECT, ;
                  cTableName, ;
                  @cData, ;
                  @nLen, ;
                  @nHandle )

IF nError == 0
  cData := Strtran(cData,Chr(0),'')
  aTagData := ::DictIndexProperties( .t., cTableName, cData, oConnection:handleDict )
  AAdd( aIndexes, aTagData )
ENDIF

DO WHILE nError == 0 .AND. nHandle > 0
  cData := Space(ADS_DD_MAX_OBJECT_NAME_LEN)
  nLen := ADS_DD_MAX_OBJECT_NAME_LEN
  nError := AdsDDFindNextObject( oConnection:handleDict, ;
                  nHandle, ;
                  @cData, ;
                  @nLen )
  IF nError == 0 .AND. !Empty(cData)
    cData := Strtran(cData,Chr(0),'')
    aTagData := ::DictIndexProperties( .t., cTableName, cData, oConnection:handleDict )
    AAdd( aIndexes, aTagData )
  ENDIF
ENDDO
AdsDDFindClose(nHandle)

IF Valtype(oTreeItem) = 'O'
  IF oConnection:AdsTableType $ { ADSDBE_CDX, ADSDBE_VFP }
    cIndexName := cTableName + '.Cdx'
    cIndexName := Strtran(cIndexName,'.DBF','')
  ELSE
    cIndexName := '<No Indexes>'
  ENDIF
  AAdd( oTreeItem:cargo[2,2], {cTableName,aIndexes})
  oIndexItem := oTreeItem:addItem(cIndexName,ICON_INDEXFILE,ICON_INDEXFILE,ICON_INDEXFILE)
  oIndexItem:cargo := { 'Index File', oTreeItem:cargo[2], oTreeItem,, oConnection }
  FOR i := 1 TO Len(aIndexes)
    oTagItem := oIndexItem:addItem(aIndexes[i,1],ICON_INDEXTAG,ICON_INDEXTAG,ICON_INDEXTAG)
    oTagItem:cargo := { 'Index Tag', aIndexes[i], oIndexItem,, oConnection, cTableName }
  NEXT
ENDIF

RETURN aIndexes

* --------------

METHOD SqlQuery:BuildDictArrayAds( nSort, oConnection )

LOCAL aTables, nError, cData, nLen, i, j, cTableName, cFieldName := '', ;
      nHandle, aObjects[OBJECT_SIZE], xValue, aTagData, aProcedures, ;
      cProcedureName

DEFAULT nSort := 1

* -------- Tables ---------

aTables := ::BuildObjectArrayAds( ADS_DD_TABLE_OBJECT, 2,, oConnection )

ASort(aTables,,,{|a,b|Upper(a[1])<Upper(b[1])})

FOR i := 1 TO Len(aTables)

  cTableName := aTables[i,1]
  xValue := Space(200)
  nLen := 200
  nError := AdsDDGetTableProperty( oConnection:handleDict, ;
                         cTableName, ;
                         ADS_DD_COMMENT, ;
                         @xValue, ;
                         @nLen )
  xValue := Trim(Substr(xValue,1,nLen))

  AAdd(aTables[i],xValue)

NEXT

IF nSort == 2
  ASort(aTables,,,{|a,b|a[4]<b[4]})
ENDIF

aObjects[OBJECT_TABLES] := aTables

* -------- Users ---------

aObjects[OBJECT_USERS] := ::BuildObjectArrayAds( ADS_DD_USER_OBJECT,,,oConnection )

* -------- Views ---------

aObjects[OBJECT_VIEWS] := ::BuildObjectArrayAds( ADS_DD_VIEW_OBJECT,,,oConnection )
ASort(aObjects[OBJECT_VIEWS])

* -------- Groups ---------

aObjects[OBJECT_GROUPS] := ::BuildObjectArrayAds( ADS_DD_USER_GROUP_OBJECT,,,oConnection )

* -------- Stored Procedures ---------

aObjects[OBJECT_PROCEDURES] := {}

* -------- Links ---------

aObjects[OBJECT_LINKS] := ::BuildObjectArrayAds( ADS_DD_LINK_OBJECT,,,oConnection )

* -------- Triggers ---------

aObjects[OBJECT_TRIGGERS] := ::BuildObjectArrayAds( ADS_DD_TRIGGER_OBJECT,,,oConnection )

* -------- Relations (RI) ---------

aObjects[OBJECT_RELATIONS] := ::BuildObjectArrayAds( ADS_DD_RELATION_OBJECT,,,oConnection )

* -------- Publications ---------

aObjects[OBJECT_PUBLICATIONS] := ::BuildObjectArrayAds( ADS_DD_PUBLICATION_OBJECT,,,oConnection )

* -------- Articles ---------

aObjects[OBJECT_ARTICLES] := ::BuildObjectArrayAds( ADS_DD_ARTICLE_OBJECT,,,oConnection )

* -------- Subscriptions ---------

aObjects[OBJECT_SUBSCRIPTIONS] := ::BuildObjectArrayAds( ADS_DD_SUBSCRIPTION_OBJECT,,,oConnection )

* -------- SQL Scripts ---------

aObjects[OBJECT_SQL_SCRIPTS] := {}
::loadScripts( oConnection, aObjects[OBJECT_SQL_SCRIPTS],{0,1,2,3})

* -------- Command Scripts ---------

aObjects[OBJECT_COMMAND_SCRIPTS] := {}
::loadScripts( oConnection, aObjects[OBJECT_COMMAND_SCRIPTS],{4})

* -------- Command Scripts ---------

aObjects[OBJECT_ISAM_SCRIPTS] := {}
::loadScripts( oConnection, aObjects[OBJECT_ISAM_SCRIPTS],{5})

* ------ Fields ---------

RETURN aObjects

* --------------

METHOD SqlQuery:BuildObjectArrayAds( nObject, nChildObjects, cParent, oConnection )

LOCAL i, cData, nLen, nHandle, nError, aObject[0]

DEFAULT nChildObjects := 0, ;
        cParent := ''

cData := Space(ADS_DD_MAX_OBJECT_NAME_LEN)
nLen := ADS_DD_MAX_OBJECT_NAME_LEN
nHandle := 0

nError := AdsDDFindFirstObject( oConnection:handleDict, ;
                      nObject, ;
                      cParent, ;
                      @cData, ;
                      @nLen, ;
                      @nHandle )

IF nError == 0
  cData := Strtran(cData,Chr(0),'')
  IF nChildObjects > 0
    AAdd( aObject, { Alltrim(cData) } )
    FOR i := 1 TO nChildObjects
       AAdd(ATail(aObject),{})
    NEXT
  ELSE
    AAdd( aObject, Alltrim(cData))
  ENDIF
ENDIF

DO WHILE nError == 0 .AND. nHandle > 0

  cData := Space(ADS_DD_MAX_OBJECT_NAME_LEN)
  nLen := ADS_DD_MAX_OBJECT_NAME_LEN
  nError := AdsDDFindNextObject( oConnection:handleDict, ;
                      nHandle, ;
                      @cData, ;
                      @nLen )

  IF nError == 0 .AND. !Empty(cData)
    cData := Strtran(cData,Chr(0),'')
    IF nChildObjects > 0
      AAdd( aObject, { Alltrim(cData) } )
      FOR i := 1 TO nChildObjects
         AAdd(ATail(aObject),{})
      NEXT
    ELSE
      AAdd( aObject, Alltrim(cData))
    ENDIF
  ENDIF

ENDDO
AdsDDFindClose(nHandle)

RETURN aObject

* ----------

METHOD SqlQuery:LoadScripts( oConnection, aObject, aTypes )

::openViewsFile()
SqlQuery->(OrdSetFocus('CONNECTION'))
SqlQuery->(DC_SetScope(0,Pad(oConnection:GroupName,10)))
SqlQuery->(DC_SetScope(1,Pad(oConnection:GroupName,10)))
SqlQuery->(DC_DbGoTop())
DO WHILE !SqlQuery->(DC_Eof())
  IF SqlQuery->viewType $ aTypes
    AAdd(aObject,{'SQLQUERY.DBF',Alltrim(SqlQuery->title),'',''})
  ENDIF
  SqlQuery->(DC_DbSkip())
ENDDO
SqlQuery->(dbCloseArea())

RETURN nil

* ----------

METHOD SqlQuery:BuildTree( oConnection )

LOCAL i, aObjects, oTreeDict

IF Empty(oConnection)
  ::oTree:destroy()
  ::oTree:create()
  ::oTree:hide()
  FOR i := 1 TO Len(::sessionsArray)
    oConnection := ::sessionsArray[i]
    _AddConnectionBranch(::oTree,oConnection)
  NEXT i
  ::oTree:show()
ELSE
  _AddConnectionBranch(::oTree,oConnection)
ENDIF

RETURN nil

* -----------

STATIC FUNCTION _AddConnectionBranch(oTree,oConnection)

LOCAL oTreeDict

oTreeDict := oTree:rootItem:addItem(PadL(oConnection:type,4) + ': ' + oConnection:name, ;
           ICON_DICTIONARY_GRAY,ICON_DICTIONARY_GRAY,ICON_DICTIONARY_GRAY)

oTreeDict:cargo := { 'Dict', oConnection:name, oConnection }

RETURN nil

* -----------

METHOD SqlQuery:BuildTreeBranch( oTreeDict, lItemSelected )

LOCAL oTreeTables, oTableItem, i, j, k, cDesc, oIndexItem, oTagItem, ;
      oFieldItem, aUsers, aViews, aGroups, aRelations, aArticles, ;
      aTables, oTreeItem, oTree, aCargo, oConnection, aObjects, ;
      aProcedures, aSqlScripts, aCommandScripts, aIsamScripts, nIcon

aCargo := oTreeDict:cargo

IF aCargo[1] == 'Table' .AND. Len(oTreeDict:getChildItems()) < 2 // Has NO index branch
  // RETURN nil
ELSEIF !Empty(oTreeDict:getChildItems())
  RETURN nil
ENDIF

IF aCargo[1] == 'Fields'
  RETURN ::BuildTreeFields(oTreeDict)
ELSEIF aCargo[1] == 'Views'
  RETURN ::BuildTreeViews(oTreeDict)
ELSEIF aCargo[1] == 'SQL Scripts'
  RETURN ::BuildTreeScripts(oTreeDict,'SQL')
ELSEIF aCargo[1] == 'Command Scripts'
  RETURN ::BuildTreeScripts(oTreeDict,'Command')
ELSEIF aCargo[1] == 'ISAM Scripts'
  RETURN ::BuildTreeScripts(oTreeDict,'ISAM')
ELSEIF aCargo[1] == 'Table'
  oConnection := aCargo[5]
  IF oConnection:type = 'ODBC'
    RETURN ::BuildIndexArrayODBC( aCargo[2,1], oConnection, oTreeDict )
  ELSEIF oConnection:type = 'ADS'
    RETURN ::BuildIndexArrayAds( aCargo[2,1], oConnection, oTreeDict )
  ENDIF
ELSEIF aCargo[1] == 'Procedures'
  RETURN ::BuildTreeProcedures(oTreeDict)
ENDIF

IF Valtype(aCargo) # 'A' .OR. Len(aCargo) # 3
  RETURN nil
ENDIF

oConnection := oTreeDict:cargo[3]
oConnection:ConnectionBranch := oTreeDict

IF !oConnection:isConnected
  IF !oConnection:Connect(self)
    RETURN nil
  ENDIF
ENDIF

IF Valtype(oConnection:treeBuildBlock) == 'B'
  DC_PointerWait()
  aObjects := Eval(oConnection:TreeBuildBlock)
  oConnection:TreeArray := aObjects
  DC_PointerArrow()
ELSE
  RETURN nil
ENDIF

IF Empty(aObjects)
  RETURN .f.
ENDIF

DC_PointerWait( ::oTree )

aUsers := aObjects[OBJECT_USERS]
aViews := aObjects[OBJECT_VIEWS]
aGroups := aObjects[OBJECT_GROUPS]
aRelations := aObjects[OBJECT_RELATIONS]
aArticles := aObjects[OBJECT_ARTICLES]
aTables := aObjects[OBJECT_TABLES]
aProcedures := aObjects[OBJECT_PROCEDURES]
aSqlScripts := aObjects[OBJECT_SQL_SCRIPTS]
aCommandScripts := aObjects[OBJECT_COMMAND_SCRIPTS]
aIsamScripts := aObjects[OBJECT_ISAM_SCRIPTS]

oTreeTables := oTreeDict:addItem('Tables',ICON_TABLE,ICON_TABLE,ICON_TABLE)
oTreeTables:cargo := { 'Tables', aTables, oConnection }

oConnection:TableBranch := oTreeTables

FOR i := 1 TO Len(aTables)
  cDesc := DC_CapFirst(aTables[i,4],.t.)
  cDesc := Strtran(cDesc,Chr(0),'')
  IF !Empty(cDesc)
    cDesc := ' (' + cDesc + ')'
  ENDIF
  IF ::AdsIsTableEncrypted(aTables[i,1],oConnection)
    nIcon := ICON_TABLE_LOCKED
  ELSE
    nIcon := ICON_TABLE
  ENDIF

  oTableItem := oTreeTables:addItem(aTables[i,1] + cDesc, nIcon,nIcon,nIcon)
  oTableItem:cargo := { 'Table', aTables[i], oTreeTables, aTables[i,3], oConnection }
  FOR j := 1 TO Len(aTables[i,2])
    oIndexItem := oTableItem:addItem(aTables[i,2,j,1],ICON_INDEXFILE,ICON_INDEXFILE,ICON_INDEXFILE)
    oIndexItem:cargo := { 'Index File', aTables[i], oTableItem,, oConnection }
    FOR k := 1 TO Len(aTables[i,2,j,2])
      oTagItem := oIndexItem:addItem(aTables[i,2,j,2,k][1],ICON_INDEXTAG,ICON_INDEXTAG,ICON_INDEXTAG)
      oTagItem:cargo := { 'Index Tag', aTables[i,2,j,2,k], oIndexItem,, oConnection, aTables[i,1] }
    NEXT k
  NEXT j
  oFieldItem := oTableItem:addItem('Fields',ICON_FIELD,ICON_FIELD,ICON_FIELD)
  oFieldItem:cargo := { 'Fields', aTables[i], oTableItem,, oConnection }
NEXT i

IF !Empty(oConnection:sessionDict)

  oTree := oTreeDict:addItem('Views',ICON_VIEWS,ICON_VIEWS,ICON_VIEWS)
  oTree:cargo := {'Views',aViews,oConnection}
  oConnection:viewBranch := oTree

  oTree := oTreeDict:addItem('Procedures',ICON_STOREDPROCEDURES,ICON_STOREDPROCEDURES,ICON_STOREDPROCEDURES)
  oTree:cargo := {'Procedures',aProcedures,oConnection}
  oConnection:ProcedureBranch := oTree

ENDIF

oTree := oTreeDict:addItem('SQL Scripts',ICON_EXECUTIONPLAN,ICON_EXECUTIONPLAN,ICON_EXECUTIONPLAN)
oTree:cargo := {'SQL Scripts',aSqlScripts,oConnection}
oConnection:SqlScriptBranch := oTree

oTree := oTreeDict:addItem('Command Scripts',ICON_EXECUTIONPLAN,ICON_EXECUTIONPLAN,ICON_EXECUTIONPLAN)
oTree:cargo := {'Command Scripts',aCommandScripts,oConnection}
oConnection:CommandScriptBranch := oTree

oTree := oTreeDict:addItem('ISAM Scripts',ICON_EXECUTIONPLAN,ICON_EXECUTIONPLAN,ICON_EXECUTIONPLAN)
oTree:cargo := {'ISAM Scripts',aIsamScripts,oConnection}
oConnection:ISAMScriptBranch := oTree

oTreeDict:expand(.t.)

DC_PointerArrow( ::oTree )

RETURN .t.

* ------------

METHOD SqlQuery:BuildTreeFields(oFieldItem)

LOCAL i, oTreeItem, cTableName, oConnection, aFields

oConnection := oFieldItem:cargo[5]
cTableName := oFieldItem:cargo[2,1]

aFields := oFieldItem:cargo[2,3]
IF Empty(aFields)
  IF oConnection:type = 'ADS'
    aFields := ::GetFieldNameArrayADS( cTableName, oConnection:handleDict )
    oFieldItem:cargo[2,3] := aFields
  ENDIF
ENDIF
FOR i := 1 TO Len(aFields)
  oTreeItem := oFieldItem:addItem(aFields[i,1],ICON_FIELD,ICON_FIELD,ICON_FIELD)
  oTreeItem:cargo := { 'Field', aFields[i], cTableName, oFieldItem, oConnection, aFields[i] }
NEXT

oFieldItem:expand(.t.)

RETURN nil

* ------------

METHOD SqlQuery:BuildTreeViews(oViewItem)

LOCAL i, oTreeItem, oConnection, aViews, cDesc

oConnection := oViewItem:cargo[3]
aViews := oViewItem:cargo[2]

FOR i := 1 TO Len(aViews)
  cDesc := DC_CapFirst(aViews[i,4],.t.)
  cDesc := Strtran(cDesc,Chr(0),'')
  IF !Empty(cDesc)
    cDesc := ' (' + cDesc + ')'
  ENDIF
  oTreeItem := oViewItem:addItem(aViews[i],ICON_VIEWS,ICON_VIEWS,ICON_VIEWS)
  oTreeItem:cargo := { 'View', aViews[i], oViewItem,, oConnection }
NEXT i

oViewItem:expand(.t.)

RETURN nil

* ------------

METHOD SqlQuery:BuildTreeScripts(oScriptItem,cPrefix)

LOCAL i, oTreeItem, oConnection, aScripts, cDesc

oConnection := oScriptItem:cargo[3]
aScripts := oScriptItem:cargo[2]
ASort(aScripts,,,{|a,b|a[2]<b[2]})

FOR i := 1 TO Len(aScripts)
  cDesc := DC_CapFirst(aScripts[i,4],.t.)
  cDesc := Strtran(cDesc,Chr(0),'')
  IF !Empty(cDesc)
    cDesc := ' (' + cDesc + ')'
  ENDIF
  oTreeItem := oScriptItem:addItem(aScripts[i,2],ICON_EXECUTIONPLAN,ICON_EXECUTIONPLAN,ICON_EXECUTIONPLAN)
  oTreeItem:cargo := { cPrefix + ' Script', aScripts[i], oScriptItem,, oConnection }
NEXT i

oScriptItem:expand(.t.)

RETURN nil

* ------------

METHOD SqlQuery:BuildTreeProcedures(oProcItem)

LOCAL i, oTreeItem, oConnection, aProcedures, cDesc

oConnection := oProcItem:cargo[3]
aProcedures := oProcItem:cargo[2]

IF oConnection:type == 'ODBC'
  aProcedures := ::BuildProcedureArrayODBC(oConnection)
ELSEIF oConnection:type == 'ADS'
  aProcedures := ::BuildProcedureArrayADS(oConnection)
ENDIF

oProcItem:cargo[2] := aProcedures

FOR i := 1 TO Len(aProcedures)
  oTreeItem := oProcItem:addItem(aProcedures[i,1],ICON_STOREDPROCEDURES,ICON_STOREDPROCEDURES,ICON_STOREDPROCEDURES)
  oTreeItem:cargo := { 'Procedure', aProcedures[i,1], oProcItem, aProcedures[i], oConnection }
NEXT i

oProcItem:expand(.t.)

RETURN nil

* ------------

/*
METHOD SqlQuery:BuildTreeTables(oTableItem)

LOCAL i, oTreeItem, cTableName, oConnection, aTables

oConnection := oTableItem:cargo[5]

aTables := oTableItem:cargo[2,3]
IF Empty(aTables)
  IF oConnection:type = 'ADS'
    aFields := ::GetTableNameArrayADS( cTableName, oConnection:handleDict )
    oTableItem:cargo[2,3] := aTables
  ENDIF
ENDIF
FOR i := 1 TO Len(aTables)
  oTreeItem := oFieldItem:addItem(aTables[i,1],ICON_TABLE,ICON_TABLE,ICON_TABLE)
  oTreeItem:cargo := { 'Table', aTables[i], cTableName, oTableItem, oConnection, aTables[i] }
NEXT

oTableItem:expand(.t.)

RETURN nil
*/

* ------------

METHOD SqlQuery:SqlAddUUIDField( aTablesX, oConnection, lAll )

LOCAL i, GetList[0], cSQL := '', cTableName, lStatus, aTables, lCancelled := .f., ;
      oBrowse

aTables := AClone(aTablesX)
FOR i := 1 TO Len(aTables)
  aTables[i,2] := .f.
  aTables[i,3] := 'Pending'
NEXT

IF lAll

  @ 0,0 DCSAY 'This routine will add a unique UUID field to all tables.;' + ;
              'The field will be UUID Char(36). ;' + ;
              'Tag the tables that you wish to update with the SPACE bar.' ;
              SAYSIZE 70,3 SAYWORDBREAK FONT '10.Lucida Console'

  DCHOTKEY xbeK_SPACE ;
     ACTION {||aTables[oBrowse:arrayElement,2]:=!aTables[oBrowse:arrayElement,2], ;
               oBrowse:refreshCurrent(), ;
               oBrowse:down(), ;
               oBrowse:forceStable()}

ELSE

  @ 0,0 DCSAY 'This routine will add a unique UUID field to this table.;' + ;
              'The field will be UUID Char(36).' ;
              SAYSIZE 70,3 SAYWORDBREAK FONT '10.Lucida Console'

  aTables[1,2] := .t.

ENDIF

@ 3,0 DCBROWSE oBrowse DATA aTables SIZE 90,21 ;
      CURSORMODE XBPBRW_CURSOR_ROW FONT '10.Lucida Console' ;
      COLOR {||IIF(aTables[oBrowse:arrayElement,2],{nil,GRA_CLR_YELLOW},{nil,nil})}

DCBROWSECOL ELEMENT 1 HEADER 'Table Name' WIDTH 25 PARENT oBrowse
DCBROWSECOL ELEMENT 4 HEADER 'Description' WIDTH 25 PARENT oBrowse
DCBROWSECOL ELEMENT 3 HEADER 'Status' WIDTH 15 PARENT oBrowse

@ 25,0 DCPUSHBUTTON CAPTION 'Start Update' SIZE 10,1.2 ;
   ACTION {||UUIDAdd(aTables, @lCancelled, oBrowse, oConnection, self) }

IF lAll

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Cancel' SIZE 10,1.2 ;
    ACTION {||lCancelled := .t.}

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Tag ALL' SIZE 10,1.2 ;
     ACTION {||AEval(aTables,{|a|a[2] := .t.}),oBrowse:refreshAll()}

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'UnTag ALL' SIZE 10,1.2 ;
     ACTION {||AEval(aTables,{|a|a[2] := .f.}),oBrowse:refreshAll()}

ENDIF

DCREAD GUI FIT TITLE 'Add UUID field to ' + IIF(lAll,'all tables','this table') ;
   NOAUTORESTORE TO lStatus

IF !lAll .AND. 'DONE' $ Upper(aTables[1,3])
  DCMSGBOX 'Fill all UUID fields now?' YESNO TO lStatus ;
     FONT ::cMessageFont OWNER AppDeskTop()
  IF lStatus
    ::SQLFillUUIDField(aTablesX, oConnection, lAll)
  ENDIF
ENDIF

RETURN lStatus

* -----------

STATIC FUNCTION UUIDAdd( aTables, lCancelled, oBrowse, oConnection, self )

LOCAL i, oSession, lStatus, cTableName, cSql

IF Valtype(oConnection:sessionDict) == 'O'
  oSession := oConnection:sessionDict
ELSE
  oSession := oConnection:sessionFree
ENDIF

oBrowse:goTop()
oBrowse:forceStable()

FOR i := 1 TO Len(aTables)
  DC_CompleteEvents()
  IF !aTables[i,2]
    oBrowse:down()
    oBrowse:forceStable()
    LOOP
  ENDIF
  IF lCancelled
    EXIT
  ENDIF
  cTableName := Strtran(Upper(aTables[i,1]),'.DBF','')

  cSQL := 'ALTER TABLE "' + cTableName + '" ADD UUID Char(36) ;' + CRLF
  lStatus := ::ExecuteSQL( cSQL,,oConnection,,0,,.f.,,'Adding UUID Field' )
  DC_CompleteEvents()
  IF !lStatus
    aTables[i,3] := 'Add Error'
  ELSE
    aTables[i,3] := 'Done!'
  ENDIF
  oBrowse:down()
  oBrowse:forceStable()
  oBrowse:refreshAll()
  IF lCancelled
    aTables[i,3] := 'Cancelled'
    oBrowse:refreshCurrent()
  ENDIF
NEXT

RETURN nil

* -----------

METHOD SqlQuery:SqlFillUUIDField( aTablesX, oConnection, lAll )

LOCAL GetList[0], lStatus, oProgress, nCount, oBrowse, lCancelled := .f., ;
      aTables, i

aTables := AClone(aTablesX)
FOR i := 1 TO Len(aTables)
  aTables[i,2] := .f.
  aTables[i,3] := 'Pending'
NEXT

IF lAll

  @ 0,0 DCSAY 'This routine will add unique UUID values to all records;' + ;
              'of all tables which contain a field named UUID Char(36). ;' + ;
              'Tag the tables that you wish to update with the SPACE bar.' ;
              SAYSIZE 70,3 SAYWORDBREAK FONT '10.Lucida Console'

  DCHOTKEY xbeK_SPACE ;
     ACTION {||aTables[oBrowse:arrayElement,2]:=!aTables[oBrowse:arrayElement,2], ;
               oBrowse:refreshCurrent(), ;
               oBrowse:down(), ;
               oBrowse:forceStable()}

ELSE

  @ 0,0 DCSAY 'This routine will add unique UUID values to all records;' + ;
              'of this table if it contains a field named UUID Char(36). ' ;
              SAYSIZE 70,3 SAYWORDBREAK FONT '10.Lucida Console'

  aTables[1,2] := .t.

ENDIF

@ 3,0 DCBROWSE oBrowse DATA aTables SIZE 100,21 FIT ;
      CURSORMODE XBPBRW_CURSOR_ROW FONT '10.Lucida Console' ;
      COLOR {||IIF(aTables[oBrowse:arrayElement,2],{nil,GRA_CLR_YELLOW},{nil,nil})}

DCBROWSECOL ELEMENT 1 HEADER 'Table Name' WIDTH 25 PARENT oBrowse
DCBROWSECOL ELEMENT 4 HEADER 'Description' WIDTH 25 PARENT oBrowse
DCBROWSECOL ELEMENT 3 HEADER 'Status' WIDTH 30 PARENT oBrowse

@ 25, 0 DCPROGRESS oProgress SIZE 80,1 PERCENT COLOR GRA_CLR_CYAN, GRA_CLR_WHITE

@ 27,0 DCPUSHBUTTON CAPTION 'Start Update' SIZE 10,1.2 ;
   ACTION {||UUIDUpdate(aTables, @lCancelled, oProgress, oBrowse, oConnection) }

IF lAll
  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Cancel' SIZE 10,1.2 ;
    ACTION {||lCancelled := .t.}

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Tag ALL' SIZE 10,1.2 ;
     ACTION {||AEval(aTables,{|a|a[2] := .t.}),oBrowse:refreshAll()}

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'UnTag ALL' SIZE 10,1.2 ;
     ACTION {||AEval(aTables,{|a|a[2] := .f.}),oBrowse:refreshAll()}
ENDIF

DCREAD GUI FIT TITLE 'Update UUID Fields' NOAUTORESTORE

RETURN nil

* -----------

STATIC FUNCTION UUIDUpdate( aTables, lCancelled, oProgress, oBrowse, oConnection )

LOCAL i, bError := ErrorBlock({|e|Break(e)}), oSession, lGoodUse, ;
      nRecCount, cTableName, nCount, nUpdate

IF Valtype(oConnection:sessionDict) == 'O'
  oSession := oConnection:sessionDict
ELSE
  oSession := oConnection:sessionFree
ENDIF

oBrowse:goTop()
oBrowse:forceStable()

FOR i := 1 TO Len(aTables)
  DC_CompleteEvents()
  IF !aTables[i,2]
    oBrowse:down()
    oBrowse:forceStable()
    LOOP
  ENDIF
  IF lCancelled
    EXIT
  ENDIF
  cTableName := aTables[i,1]
  lGoodUse := .f.
  BEGIN SEQUENCE
  USE (cTableName) VIA (oSession) EXCLUSIVE
  lGoodUse := .t.
  END SEQUENCE
  IF !lGoodUse
    aTables[i,3] := 'Open Error'
    oBrowse:down()
    oBrowse:forceStable()
    oBrowse:refreshAll()
    LOOP
  ENDIF
  oBrowse:refreshAll()
  IF IsFieldVar('UUID')
    aTables[i,3] := 'Updating'
  ELSE
    aTables[i,3] := 'No UUID Field'
    lGoodUse := .f.
  ENDIF
  IF !lGoodUse
    dbCloseArea()
    oBrowse:down()
    oBrowse:forceStable()
    oBrowse:refreshAll()
    LOOP
  ENDIF
  oBrowse:refreshAll()
  nRecCount := RecCount()
  OrdSetFocus(0)
  dbGoTop()
  nCount := 0
  nUpdate := 0
  lGoodUse := .f.
  BEGIN SEQUENCE
  DO WHILE !Eof() .AND. !lCancelled
    nCount++
    IF Empty(FIELD->UUID)
      REPLACE FIELD->UUID With UuidToChar(UuidCreate())
      nUpdate++
    ENDIF
    IF nCount%100 = 0
      DC_CompleteEvents()
    ENDIF
    IF nRecCount > 100 .AND. nCount%(Int(nRecCount/100)) == 0
      DC_GetProgress(oProgress,nCount,nRecCount)
    ENDIF
    dbSkip()
  ENDDO
  lGoodUse := .t.
  END SEQUENCE
  IF !lGoodUse
    aTables[i,3] := 'Update Error!'
  ELSE
    aTables[i,3] := 'Done! ' + Alltrim(Str(nUpdate)) + ' Records Updated'
  ENDIF
  dbCloseArea()
  oBrowse:down()
  oBrowse:forceStable()
  oBrowse:refreshAll()
  IF lCancelled
    aTables[i,3] := 'Cancelled'
    oBrowse:refreshCurrent()
    EXIT
  ENDIF
NEXT

ErrorBlock(bError)

RETURN nil

* ------------

METHOD SqlQuery:SqlAddUUIDIndex( aTablesX, oConnection, lAll )

LOCAL i, GetList[0], cSQL := '', cTableName, lStatus, aTables, lCancelled := .f., ;
      oBrowse

aTables := AClone(aTablesX)
FOR i := 1 TO Len(aTables)
  aTables[i,2] := .f.
  aTables[i,3] := 'Pending'
NEXT

IF lAll

  @ 0,0 DCSAY 'This routine will add a UUID Index Tag to all tables.;' + ;
              'The index will be on the UUID field, Char(36). ;' + ;
              'Tag the tables that you wish to update with the SPACE bar.' ;
              SAYSIZE 70,3 SAYWORDBREAK FONT '10.Lucida Console'

  DCHOTKEY xbeK_SPACE ;
     ACTION {||aTables[oBrowse:arrayElement,2]:=!aTables[oBrowse:arrayElement,2], ;
               oBrowse:refreshCurrent(), ;
               oBrowse:down(), ;
               oBrowse:forceStable()}

ELSE

  @ 0,0 DCSAY 'This routine will add a UUID Index Tag to this table.;' + ;
              'The index will be on the UUID field, Char(36).' ;
              SAYSIZE 70,3 SAYWORDBREAK FONT '10.Lucida Console'

  aTables[1,2] := .t.

ENDIF

@ 3,0 DCBROWSE oBrowse DATA aTables SIZE 90,21 ;
      CURSORMODE XBPBRW_CURSOR_ROW FONT '10.Lucida Console' ;
      COLOR {||IIF(aTables[oBrowse:arrayElement,2],{nil,GRA_CLR_YELLOW},{nil,nil})}

DCBROWSECOL ELEMENT 1 HEADER 'Table Name' WIDTH 25 PARENT oBrowse
DCBROWSECOL ELEMENT 4 HEADER 'Description' WIDTH 25 PARENT oBrowse
DCBROWSECOL ELEMENT 3 HEADER 'Status' WIDTH 15 PARENT oBrowse

@ 25,0 DCPUSHBUTTON CAPTION 'Start Update' SIZE 10,1.2 ;
   ACTION {||UUIDIndex(aTables, @lCancelled, oBrowse, oConnection, self) }

IF lAll

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Cancel' SIZE 10,1.2 ;
    ACTION {||lCancelled := .t.}

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Tag ALL' SIZE 10,1.2 ;
     ACTION {||AEval(aTables,{|a|a[2] := .t.}),oBrowse:refreshAll()}

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'UnTag ALL' SIZE 10,1.2 ;
     ACTION {||AEval(aTables,{|a|a[2] := .f.}),oBrowse:refreshAll()}

ENDIF

DCREAD GUI FIT TITLE 'Add UUID field to ' + IIF(lAll,'all tables','this table') ;
   NOAUTORESTORE TO lStatus

RETURN lStatus

* -----------

STATIC FUNCTION UUIDIndex( aTables, lCancelled, oBrowse, oConnection, self )

LOCAL i, oSession, lStatus, cTableName, cSql

IF Valtype(oConnection:sessionDict) == 'O'
  oSession := oConnection:sessionDict
ELSE
  oSession := oConnection:sessionFree
ENDIF

oBrowse:goTop()
oBrowse:forceStable()

FOR i := 1 TO Len(aTables)
  DC_CompleteEvents()
  IF !aTables[i,2]
    oBrowse:down()
    oBrowse:forceStable()
    LOOP
  ENDIF
  IF lCancelled
    EXIT
  ENDIF
  cTableName := aTables[i,1]
  cSQL := CreateUUIDIndexSql( cTableName )
  lStatus := ::ExecuteSQL( cSQL,,oConnection,,0,,.f.,,'Create UUID Index' )
  DC_CompleteEvents()
  IF !lStatus
    aTables[i,3] := 'Index Error'
  ELSE
    aTables[i,3] := 'Done!'
  ENDIF
  oBrowse:down()
  oBrowse:forceStable()
  oBrowse:refreshAll()
  IF lCancelled
    aTables[i,3] := 'Cancelled'
    oBrowse:refreshCurrent()
  ENDIF
NEXT

RETURN nil

* -----------

STATIC FUNCTION CreateUUIDIndexSql( cTableName )

LOCAL cSql

cSql := "EXECUTE PROCEDURE sp_ModifyTableProperty( '" + cTablename + "'," + ;
            "'TABLE_AUTO_CREATE', 'False', NULL ,NULL);" + CRLF + CRLF

cSql += CRLF + 'EXECUTE PROCEDURE sp_CreateIndex(' + CRLF
cSql += "  '" + cTableName + "'," + CRLF
cSql += "  '" + cTableName + ".cdx'," + CRLF
cSql += "  'UUID'," + CRLF
cSql += "  'UUID'," + CRLF
cSql += "  ''," + CRLF
cSql += "  2," + CRLF
cSql += "  " + Alltrim(Str(512)) + " );" + CRLF

cSql += CRLF + "EXECUTE PROCEDURE sp_ModifyTableProperty( '" + cTablename + "'," + ;
            "'TABLE_AUTO_CREATE', 'True', NULL ,NULL);" + CRLF

RETURN cSql

* -----------

METHOD SqlQuery:SqlPickFields( aStru, cAlias, oConnection )

LOCAL aData, aFields[0], i

IF !Empty(Alias()) .AND. Empty(aStru)
  aStru := dbStruct()
  cAlias := Alias()
ENDIF

IF Empty(oConnection:name)
  oConnection:name := cAlias
ENDIF

FOR i := 1 TO Len(aStru)
  AAdd(aFields,aStru[i,1])
NEXT

aData := {'Table',cAlias,nil,aFields,oConnection}

RETURN ::SqlQueryPick(aData,oConnection,,.t.)

* ------------

METHOD SqlQuery:BrowseColumnsISAM( cTable, oConnection )

LOCAL aColumns, cConfiguration

aColumns := ::GetBrowseColumnsArray( cTable, oConnection, @cConfiguration )

IF !Empty(aColumns)
  RETURN ::BrowseISAM({cTable},oConnection,,aColumns,cConfiguration,cConfiguration)
ENDIF

RETURN .f.

* ------------

METHOD SqlQuery:GetBrowseColumnsArray( cTable, oConnection, cConfiguration )

LOCAL aColumns[0], bEval, nRecord, GetList[0], oBrowse, lStatus, ;
      nViewType, cStatement, cConnection

::openViewsFile()

cConnection := Upper(Pad(oConnection:groupName,10))
cTable := Upper(Pad(cTable,50))

SQLQUERY->(OrdSetFocus('TABLE'))
SQLQUERY->(DC_SetScope(0,cConnection+cTable))
SQLQUERY->(DC_SetScope(1,cConnection+cTable))
SQLQUERY->(DC_DbGoTop())

IF SQLQUERY->(DC_Eof())
  aColumns := {}
  nRecord := 0
  DCMSGBOX 'No Column configurations have been saved for ' + Alltrim(cTable) ;
    FONT ::cMessageFont OWNER AppDeskTop()
ELSEIF SQLQUERY->(DC_KeyCount()) == 1
  nRecord := SQLQUERY->(RecNo())
ELSE
  @ 0,0 DCBROWSE oBrowse ALIAS 'SQLQUERY' SIZE 80,10 ;
    FONT '10.Lucida Console' ;
    ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}
  DCBROWSECOL FIELD SQLQUERY->table HEADER 'Table Name' WIDTH 25 PARENT oBrowse
  DCBROWSECOL FIELD SQLQUERY->title HEADER 'Title' WIDTH 35 PARENT oBrowse
  DCREAD GUI FIT ADDBUTTONS NOAUTORESTORE TITLE 'Choose Column Configuration' MODAL TO lStatus
  IF lStatus
    nRecord := SQLQUERY->(RecNo())
  ELSE
    nRecord := 0
  ENDIF
ENDIF

IF nRecord > 0
  SQLQUERY->(dbGoTo(nRecord))
  cStatement := SQLQUERY->statement
  nViewType := SQLQUERY->viewtype
  cConfiguration := SQLQUERY->title
  IF Left(cStatement,2) == '{{' .AND. Right(cStatement,2) = '}}' .AND. nViewType = VIEWTYPE_COLUMNBROWSE
    bEval := {||aColumns := &(cStatement)}
    Eval(bEval)
  ENDIF
ENDIF

SQLQUERY->(dbCloseArea())

RETURN aColumns

* ------------

METHOD SqlQuery:SaveBrowseColumnsArray(cTable,aFields,oConnection,cConfig)

LOCAL cTitle, GetList[0], GetOptions, cArrayString, cAlias := Pad(Alias(),10), ;
      lStatus, oOwner, nViewType, nRecNo := 0

IF !Empty(cConfig)
  cTitle := cConfig
ELSE
  cTitle := Space(50)
ENDIF

cTable := Upper(Pad(cTable,50))

@ 0,0 DCSAY 'Title for this Configuration:' SAYSIZE 0
@ 1,0 DCGET cTitle VALID {||cTitle==cConfig .OR. ::ValidateScriptTitle(cTitle,oConnection,cTable,@nRecNo)}
@ 3,0 DCSAY 'Alias to use for Cursor:' SAYSIZE 0
@ 4,0 DCGET cAlias

DCGETOPTIONS SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT TITLE 'Save Column Configuration' ;
   ADDBUTTONS OWNER oOwner MODAL TO lStatus NOAUTORESTORE ;
   ENTEREXIT EVAL {|o|::SetWindowPos(o)}

IF lStatus
  nViewType := VIEWTYPE_COLUMNBROWSE
  cArrayString := DC_ArrayString(aFields)
  ::openViewsFile()
  IF cTitle == cConfig .AND. ;
    SqlQuery->(dbSeek(Pad(oConnection:groupName,10)+cTable+cTitle,,'TABLE'))
    SqlQuery->(DC_RecLock())
  ELSEIF SqlQuery->(dbSeek(Space(10),,'CONNECTION'))
    SqlQuery->(DC_RecLock())
  ELSE
    SqlQuery->(DC_AddRec())
  ENDIF
  REPLACE SqlQuery->connection WITH oConnection:GroupName, ;
          SqlQuery->table WITH cTable, ;
          SqlQuery->title WITH cTitle, ;
          SqlQuery->viewtype WITH nViewType, ;
          SqlQuery->statement WITH cArrayString, ;
          SqlQuery->alias WITH cAlias

  SqlQuery->(dbRUnlock())
  SqlQuery->(dbCloseArea())

  DCMSGBOX 'Configuration: ' + Alltrim(cTable) + ' - ' + Alltrim(cTitle) + ' has been Saved' ;
     TIMEOUT 3 FONT ::cMessageFont OWNER AppDeskTop()
ENDIF

RETURN lStatus

* ------------

METHOD SqlQuery:LoadScript( aData, oConnection, lExecute, nBrowseType )

LOCAL cTitle, lStatus := .f., cStatement, cAlias, nViewType, bEval, oRecord

DEFAULT lExecute := .f., ;
        nBrowseType := 1

IF Valtype(aData) == 'C'
  cTitle := aData
ELSE
  cTitle := Pad(aData[2,2],50)
ENDIF

::openViewsFile()

IF SQLQUERY->(dbSeek(Pad(oConnection:groupName,10) + cTitle,,'TITLE'))
  cStatement := SQLQUERY->statement
  cAlias := SQLQUERY->alias
  nViewType := SQLQUERY->viewtype
  IF nViewType == VIEWTYPE_SQLSELECT_ONE2MANY
    oRecord := SqlQuery->(DC_DbRecord():new())
    SqlQuery->(DC_DbScatter(oRecord))
  ENDIF
  lStatus := .t.
ELSE
  DCMSGBOX 'Script: "' + Alltrim(cTitle) + '" not found in SqlQuery.Dbf' ;
           FONT ::cMessageFont OWNER AppDeskTop()
  lStatus := .f.
ENDIF

SQLQUERY->(dbCloseArea())

IF lStatus
  IF lExecute
    DD_SqlErrorWindow(soMessageBox)
    IF Left(cStatement,2) == '{{' .AND. Right(cStatement,2) = '}}' .AND. nViewType = VIEWTYPE_ISAMBROWSE
      bEval := {|aFields|aFields := &(cStatement), ;
                ::BrowseISAM({cAlias},oConnection,,aFields)}
      IF nBrowseType == 0
        Eval(bEval)
      ELSE
        GuiRun(bEval)
      ENDIF
    ELSEIF Valtype(oRecord) == 'O'
      ::ExecuteLinkedView(oRecord,oConnection)
    ELSE
      bEval := {|a|::ExecuteSQL(cStatement,,oConnection,,nBrowseType,,.t.)}
      IF nBrowseType == 0
        Eval(bEval)
      ELSE
        GuiRun(bEval)
      ENDIF
    ENDIF
  ELSE
    GuiRun({||::SqlQueryPick(cAlias,oConnection,cStatement)})
  ENDIF
ENDIF

RETURN lStatus

* ------------

METHOD SqlQuery:SQLQueryPick( aData, oConnection, cSQL, lPickFields, aIsamFields )

LOCAL GetList[0], GetOptions, aAvailFields[0], aPickedFields[0], ;
      cTableName, i, cField, aParams, oSql, oDlg, aOptions, oStatic, ;
      bResize, cResult := '', oResult, nRow, aFields, aOrigFields, ;
      lIsam := .f., bIsam

DEFAULT lPickFields := .f.

IF !Empty(aData)
  IF Valtype(aData) == 'C'
    cTableName := aData
  ELSE
    cTableName := Strtran(Upper(aData[2,1]),'.DBF','')
    IF Empty(aData[4]) .AND. oConnection:type = 'ADS'
      aData[4] := ::GetFieldNameArrayADS( cTableName, oConnection:handleDict )
    ENDIF
  ENDIF
ENDIF

IF Valtype(oConnection) == 'O' .AND. oConnection:isDerivedFrom('XbpTreeViewItem')
  aParams := oConnection:cargo
  IF Valtype(aParams) == 'A'
    IF Len(aParams) == 5
      oConnection := aParams[5]
    ELSEIF Len(aParams) == 3
      oConnection := aParams[3]
    ELSE
      RETURN .f.
    ENDIF
  ELSE
    RETURN .f.
  ENDIF
ENDIF

IF Empty(cSQL)
  cSQL := ''
ENDIF

IF (Left(cSql,2) == '{{' .AND. Right(cSql,2) = '}}')
  lIsam := .t.
ENDIF

@ 0,0 DCSAY IIF(lIsam,'ISAM Column Array:','Enter SQL Statement:') SAYSIZE 0 SAYBOTTOM ;
   RESIZE DCGUI_RESIZE_REPOSONLY_Y

IF oConnection:type = 'ADS' .AND. !lIsam
  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION ICON_CHECKSQL ;
     SIZE 4,1 ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
     TOOLTIP 'Check (test) this statement' ;
     ACTION {||DD_SqlErrorWindow(oResult), ;
               oResult:setData(''), ;
               GuiRun({|a|::ExecuteSQL(cSQL,cTableName,oConnection,,1,oDlg,.t.,,,,,.t.)})}
ENDIF

IF !lIsam

  IF Valtype(cTableName)='C'
    IF '.' $ cTableName
      cTableName := Substr(cTableName,1,At('.',cTableName))
    ENDIF
  ELSE
    cTableName := 'QUERY'
  ENDIF
  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Execute (SQL Cursor Browse)' ;
     SIZE 25,1 ACTION {||DD_SqlErrorWindow(oResult), ;
                         oResult:setData(''), ;
                         GuiRun({|a|::ExecuteSQL(cSQL,cTableName,oConnection,,1,oDlg,.t.)})} ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
     WHEN {||Valtype(oSql)=='O' .AND. !Empty(oSql:getData())}

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Execute (Object Browse)' ;
     SIZE 20,1 ACTION {||DD_SqlErrorWindow(oResult), ;
                         oResult:setData(''), ;
                         GuiRun({|a|::ExecuteSQL(cSQL,cTableName,oConnection,,2,oDlg,.t.)})}  ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
     WHEN {||Valtype(oSql)=='O' .AND. !Empty(oSql:getData())}

ENDIF

IF !Empty(aData) .OR. lIsam

  IF lIsam

    bIsam := {||oResult:setData(''), ;
                GuiRun({|aFields|aFields := &(cSql), ;
               ::BrowseISAM({cTableName},oConnection,,aFields)})}
  ELSE

    bIsam := {||oResult:setData(''), ;
                GuiRun({|aFields|aFields := ::UpdatePickedFieldList(AClone(aOrigFields),aPickedFields), ;
                ::BrowseISAM({cTableName},oConnection,,aFields)})}

  ENDIF

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Execute (ISAM Browse)' ;
    SIZE 20,1 ACTION bIsam ;
    RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
    WHEN {||Valtype(oSql)=='O' .AND. !Empty(oSql:getData()) .OR. !Empty(aPickedFields)}

ENDIF

IF !lIsam

  @ 1, 22 DCPUSHBUTTON CAPTION 'Save as View' ;
     SIZE 12,1 ACTION {||::CreateViewSQL(@cSQL,oConnection)} ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
     WHEN {||Valtype(oSql)=='O' .AND. !Empty(oSql:getData())}

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Save SQL' ;
     SIZE 12,1 ACTION {||::SaveSQLScript(@cSQL,oConnection,oDlg)} ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
     WHEN {||Valtype(oSql)=='O' .AND. !Empty(oSql:getData())}

ENDIF

IF lPickFields
  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Save ISAM' ;
     SIZE 12,1 ACTION {|aFields|aFields := ::UpdatePickedFieldList(AClone(aOrigFields),aPickedFields), ;
                               ::SaveSQLScript(@cSQL,oConnection,oDlg,cTableName,aFields)} ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
     WHEN {||!Empty(aPickedFields)}
ENDIF

IF lIsam

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Load ISAM' ;
     SIZE 12,1 ACTION {||cSQL := ::LoadSQLScript(cSQL,oConnection,oDlg,VIEWTYPE_ISAMBROWSE),oSql:setData(cSQL)} ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y

ELSE

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Load SQL' ;
     SIZE 12,1 ACTION {||cSQL := ::LoadSQLScript(cSQL,oConnection,oDlg),oSql:setData(cSQL)} ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y

ENDIF

IF Empty(aData)
  bResize := DCGUI_RESIZE_RESIZEONLY
ELSE
  bResize := DCGUI_RESIZE_REPOSY_RESIZEX
ENDIF

@ 2.1,0 DCMULTILINE cSQL SIZE 110,10 FONT ::cMessageFont ;
      NOHSCROLL ;
      OBJECT oSql ;
      EVAL {|o|o:keyboard := {|a,b,o|o:getData(),DC_GetWhen(GetList)}} ;
      RESIZE bResize

nRow := 12.5

IF lPickFields

  aFields := AClone(aData[4])
  aOrigFields := AClone(aFields)

  FOR i := 1 TO Len(aFields)
    AAdd(aAvailFields,{ aFields[i,1],i, .f. })
  NEXT
  aOrigFields := aClone(aFields)

  @ nRow,0 DCSAY 'Fields from table: ' + cTableName SAYSIZE 0 SAYBOTTOM ;
         FONT '10.Lucida Console Bold' ;
         RESIZE DCGUI_RESIZE_REPOSONLY_Y

  @ DCGUI_ROW, DCGUI_COL + 20 DCSAY '(Choose fields then Click OK to create Query)' ;
     SAYSIZE 0 COLOR GRA_CLR_BLUE SAYBOTTOM FONT '10.Arial Bold' ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y

  @ nRow + 1,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 108,16 OBJECT oStatic ;
         RESIZE DCGUI_RESIZE_RESIZEONLY_Y

  aOptions := {aPickedFields,aAvailFields,0,0,100,12,,,,,,,,,,,,,,,,,,,,,,,,,,}

  PickBrowse( GetList, @oStatic, aOptions, GetOptions )

  @ 14,2 DCPUSHBUTTON CAPTION 'OK' SIZE 10,1 FONT '10.Arial Bold' ;
          ACTION {||::BuildSQLSelect(cTableName,aPickedFields,oSql,GetList), ;
                    DC_GetWhen(GetList)} ;
          PARENT oStatic

  nRow := 29.5
ENDIF

@ nRow,0 DCMULTILINE cResult OBJECT oResult FONT ::cMessageFont ;
    SIZE 110,4 NOHSCROLL RESIZE DCGUI_RESIZE_RESIZEONLY_X

DCGETOPTIONS RESIZE SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT ;
   TITLE 'SQL Query for ' + oConnection:name ;
   OPTIONS GetOptions ;
   NOAUTORESTORE ;
   PARENT @oDlg ;
   APPWINDOW ::oBrowseParentWindow ;
   EVAL {|o|::SetWindowPos(o)}

RETURN nil

* ----------

METHOD Sqlquery:UpdatePickedFieldList( aFields, aPicked )

LOCAL i, nFound, aNewFields[0], aField, cField, cHeader, nAs, cExpr

FOR i := 1 TO Len(aFields)
  nFound := AScan( aPicked,{|a|a[2]==i})
  IF nFound > 0
    aField := aFields[i]
    cField := aPicked[nFound,1]
    cHeader := cField
    IF !(cField == aField[1])
      nAs := At(' AS ',Upper(cField))
      IF nAs > 0
        cExpr := Substr(cField,1,nAs)
        cHeader := Substr(cField,nAs+4)
        cField := '{||' + cExpr + '}'
      ELSE
        cField := '{||' + cField + '}'
        cHeader := aField[1]
      ENDIF
    ENDIF
    AAdd(aField,cField)
    AAdd(aField,cHeader)
    AAdd(aField,nFound)
    AAdd(aNewFields,aField)
  ENDIF
NEXT

FOR i := 1 TO Len(aPicked)
  IF aPicked[i,2] == 0
    cField := aPicked[i,1]
    nAs := At(' AS ',Upper(cField))
    IF nAs > 0
      cExpr := Substr(cField,1,nAs)
      cHeader := Substr(cField,nAs+4)
      cField := '{||' + cExpr + '}'
    ELSE
      cField := '{||' + cField + '}'
      cHeader := aField[1]
    ENDIF
    AAdd(aNewFields,{'EXPRESSION','X',0,0,cField,cHeader,i})
  ENDIF
NEXT

ASort(aNewFields,,,{|a,b|a[7]<b[7]})

RETURN aNewFields

* ------------

METHOD SqlQuery:SQLResult( oConnection )

LOCAL GetList[0], GetOptions, cSQL := '', oSql, xResult, oDlg, ;
      cResult := '', oResult

@ 0,0 DCSAY 'Enter SQL Statement:' SAYSIZE 0 SAYBOTTOM ;
   RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Execute' ;
   SIZE 25,1 ACTION {||DD_SqlResult(cSql,oConnection:sessionDict,@xResult), ;
                       oResult:setData(DC_XtoC(xResult))} ;
   RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ 1.2,0 DCMULTILINE cSQL SIZE 110,10 FONT ::cMessageFont ;
      NOHSCROLL ;
      OBJECT oSql ;
      EVAL {|o|o:keyboard := {|a,b,o|o:getData(),DC_GetWhen(GetList)}}

@ 12,0 DCSAY 'Result:' SAYSIZE 0 RESIZE DCGUI_RESIZE_NONE

@ 13,0 DCMULTILINE cResult SIZE 110,5 FONT ::cMessageFont ;
       NOHSCROLL ;
       OBJECT oResult ;
       RESIZE DCGUI_RESIZE_NONE

DCGETOPTIONS RESIZE RESIZEDEFAULT DCGUI_RESIZE_RESIZEONLY ;
   SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT ;
   TITLE 'SQL Result Query for ' + oConnection:name ;
   OPTIONS GetOptions ;
   NOAUTORESTORE ;
   PARENT @oDlg ;
   APPWINDOW ::oBrowseParentWindow ;
   EVAL {|o|::SetWindowPos(o)}

RETURN nil

* -----------

METHOD SqlQuery:DeleteViewSql( cViewName, oConnection, oViewItem )

LOCAL lStatus, aViews, oTreeItem, nFound, cSql

DCMSGBOX 'Delete this view? ','', ;
         cViewName YESNO TO lStatus FONT ::cMessageFont

IF lStatus
  cSql := 'DROP VIEW [' + cViewName + ']' + CRLF
  DD_SqlErrorWindow(soMessageBox)
  lStatus := ::ExecuteSQL( cSql,,oConnection,,0,,.f.,,'Dropping View: ' + cViewName )
  IF lStatus .AND. Valtype(oViewItem) == 'O'
    aViews := oViewItem:cargo[3]:cargo[2]
    nFound := AScan(aViews,cViewName)
    IF nFound > 0
      ARemove(aViews,nFound)
      oViewItem:getParentItem():delItem(oViewItem)
    ENDIF
  ENDIF
ENDIF

RETURN lStatus

* -----------

METHOD SqlQuery:CreateViewSql( cSql, oConnection, oViewItem )

LOCAL lStatus, GetList[0], cViewName := Space(50), aViews, oTreeItem, ;
      GetOptions

DEFAULT cSql := ''

@ 0,0 DCSAY 'Name of this View' GET cViewName ;
      SAYSIZE 0 SAYBOTTOM

@ 1,0 DCSAY 'SELECT Statement:' SAYSIZE 0 SAYBOTTOM

@ 2,0 DCMULTILINE cSql SIZE 100,10 FONT ::cMessageFont NOHSCROLL

DCGETOPTIONS SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT ADDBUTTONS TO lStatus MODAL SETAPPWINDOW ;
   NOAUTORESTORE TITLE 'Create new View - ' + oConnection:name ;
   EVAL {|o|::SetWindowPos(o)} OPTIONS GetOptions

IF lStatus .AND. !Empty(cSql)
  cViewName := Alltrim(cViewName)
  cSql := 'CREATE VIEW [' + cViewName + '] AS ' + CRLF + cSql + CRLF
  DD_SqlErrorWindow(soMessageBox)
  lStatus := ::ExecuteSQL( cSql,,oConnection,,0,,.f.,,'Creating View: ' + cViewName )
  IF lStatus .AND. Valtype(oViewItem) == 'O'
    aViews := oViewItem:cargo[2]
    AAdd(aViews,cViewName)
    oTreeItem := oViewItem:addItem(cViewName,ICON_VIEWS,ICON_VIEWS,ICON_VIEWS)
    oTreeItem:cargo := { 'View', cViewName, oViewItem,, oConnection }
  ENDIF
ENDIF

RETURN lStatus

* -----------

METHOD SqlQuery:SaveSQLScript( cSQL, oConnection, oOwner, cAlias, aFields )

LOCAL GetList[0], cFileName := Space(100), aFileFilters, lStatus, ;
      nChoice := 1, cTitle := Space(50), nViewType, aTypes, GetOptions, ;
      nRecNo := 0

DCMSGBOX 'This selection will save the SQL Statement', ;
         'Please choose the source of the text' ;
         BUTTONS {'Save To SqlQuery Dictionary Scripts','Save To File','Cancel'} ;
         CHOICE @nChoice ;
         FONT ::cMessageFont ;
         OWNER oOwner

DEFAULT cAlias := ''

cAlias := Pad(cAlias,30)

IF nChoice == 2

  aFileFilters := { {"SQL Files", "*.SQL"}, ;
                    {"All Files", "*.*"  } }

  @ 0,0 DCSAY 'File Name to Save (*.SQL)' SAYSIZE 0
  @ 1,0 DCGET cFileName POPUP {|c|DC_PopFile(c,,'*.SQL','Save a SQL File',aFileFilters)} GETSIZE 50

  DCGETOPTIONS SCALEFACTOR ::aScaleFactor

  DCREAD GUI FIT ADDBUTTONS TITLE 'Save SQL to File' ;
     MODAL TO lStatus OWNER oOwner OPTIONS GetOptions

  IF lStatus
    cFileName := Alltrim(cFileName)
    IF !(Upper(Right(cFileName,4))) == '.SQL'
      cFileName += '.SQL'
    ENDIF
    MemoWrit(cFileName,cSQL)
  ENDIF

ELSEIF nChoice == 1

  @ 0,0 DCSAY 'Title for this Script:' SAYSIZE 0
  @ 1,0 DCGET cTitle VALID {||::ValidateScriptTitle(cTitle,oConnection,@nRecNo)}
  @ 3,0 DCSAY 'Alias to use for Cursor:' SAYSIZE 0
  @ 4,0 DCGET cAlias

  DCGETOPTIONS SCALEFACTOR ::aScaleFactor

  DCREAD GUI FIT TITLE 'Save SQL to Script' ;
     ADDBUTTONS OWNER oOwner MODAL TO lStatus NOAUTORESTORE ;
     ENTEREXIT EVAL {|o|::SetWindowPos(o)}

  aTypes := {0,1,2,3}
  IF lStatus
    nViewType := VIEWTYPE_SQLSELECT
    IF !Empty(aFields)
      cSql := DC_ArrayString(aFields)
      nViewType := VIEWTYPE_ISAMBROWSE
      aTypes := {5}
    ENDIF

    ::openViewsFile()
    IF !Empty(nRecNo)
      SqlQuery->(dbGoTo(nRecNo))
      SqlQuery->(DC_RecLock())
    ELSEIF SqlQuery->(dbSeek(Space(10),,'CONNECTION'))
      SqlQuery->(DC_RecLock())
    ELSE
      SqlQuery->(DC_AddRec())
    ENDIF
    REPLACE SqlQuery->connection WITH oConnection:GroupName, ;
            SqlQuery->title WITH cTitle, ;
            SqlQuery->viewtype WITH nViewType, ;
            SqlQuery->statement WITH cSql, ;
            SqlQuery->alias WITH cAlias
    SqlQuery->(dbRUnlock())
    SqlQuery->(dbCloseArea())
  ENDIF
  ::reloadScripts( oConnection, aTypes )
ENDIF

RETURN lStatus

* ---------------

METHOD SqlQuery:ValidateScriptTitle( cTitle, oConnection, nRecNo)

LOCAL lStatus := .t.

::openViewsFile()

IF SqlQuery->(dbSeek(Pad(oConnection:groupName,10) + Pad(cTitle,50),,'TITLE'))
  DCMSGBOX 'There is already a script with this title', '', ;
           'Overwrite?' YESNO TO lStatus FONT ::cMessageFont ;
           OWNER AppDeskTop()
  IF lStatus
    nRecNo := SqlQuery->(RecNo())
  ENDIF
ENDIF

RETURN lStatus

* ---------------

METHOD SqlQuery:LoadSQLScript( cSQL, oConnection, oOwner, nViewType )

LOCAL GetList[0], cFileName := Space(100), aFileFilters, lStatus, ;
      nChoice := 1, oStatement, oBrowse, GetOptions

DEFAULT nViewType := 0

IF !(nViewType = VIEWTYPE_ISAMBROWSE)
  DCMSGBOX 'This selection will load a SQL Statement', ;
           'Please choose the source of the text' ;
           BUTTONS {'Load From SqlQuery Dictionary Views','Load From File','Cancel'} ;
           CHOICE @nChoice ;
           FONT ::cMessageFont ;
           OWNER oOwner
ELSE
  nChoice := 1
ENDIF

IF nChoice == 2

  aFileFilters := { {"SQL Files", "*.SQL"}, ;
                    {"All Files", "*.*"  } }

  @ 0,0 DCSAY 'File Name to Load (*.SQL)' SAYSIZE 0
  @ 1,0 DCGET cFileName POPUP {|c|DC_PopFile(c,,'*.SQL','Load a SQL File',aFileFilters)} GETSIZE 50

  DCGETOPTIONS SCALEFACTOR ::aScaleFactor

  DCREAD GUI FIT ADDBUTTONS TITLE 'Load SQL from File' ;
     MODAL TO lStatus OWNER oOwner NOAUTORESTORE EVAL {|o|::SetWindowPos(o)}

  IF lStatus
    cFileName := Alltrim(cFileName)
    IF !(Upper(Right(cFileName,4))) == '.SQL'
      cFileName += '.SQL'
    ENDIF
    cSQL := MemoRead(cFileName)
  ENDIF

ELSEIF nChoice == 1

  ::openViewsFile()
  SqlQuery->(OrdSetFocus('CONNECTION'))
  SqlQuery->(DC_SetScope(0,Pad(oConnection:GroupName,50)))
  SqlQuery->(DC_SetScope(1,Pad(oConnection:GroupName,50)))
  SqlQuery->(DbGoTop())

  @ 0,0 DCBROWSE oBrowse ALIAS 'SqlQuery' SIZE 60,10 FIT ;
        FONT ::cMessageFont HEADLINES 2 ;
        ITEMMARKED {||oStatement:setData(SqlQuery->statement)} ;
        ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
        RESIZE DCGUI_RESIZE_REPOSONLY_Y

  DCBROWSECOL FIELD SqlQuery->Connection HEADER 'Connection;Group Name' ;
     PARENT oBrowse

  DCBROWSECOL FIELD SqlQuery->Title HEADER 'Title' ;
     PARENT oBrowse

  DCBROWSECOL FIELD SqlQuery->ViewType HEADER 'Type' ;
     PARENT oBrowse

  @ 11,0 DCMULTILINE SqlQuery->statement SIZE 80,10 ;
         FONT ::cMessageFont ;
         NOHSCROLL OBJECT oStatement ;
         RESIZE DCGUI_RESIZE_RESIZEONLY

  DCGETOPTIONS RESIZE SCALEFACTOR ::aScaleFactor

  DCREAD GUI FIT ADDBUTTONS TITLE 'Choose a Script' ;
    TO lStatus NOAUTORESTORE OPTIONS GetOptions ;
    MODAL SETAPPWINDOW EVAL {|o|::SetWindowPos(o)}

  IF lStatus
    cSql := SqlQuery->Statement
  ENDIF

  SqlQuery->(dbCloseArea())

ENDIF

RETURN cSQL

* ---------------

METHOD SqlQuery:BuildSQLSelect( cTableName, aPickedFields, oSql, GetList)

LOCAL i, nFound, cSql, aPicked

aPicked := AClone(aPickedFields)

FOR i := 1 TO Len(aPicked)
  nFound := At('(',aPicked[i,1])
  IF nFound = 0
    aPicked[i,1] := '"' + aPicked[i,1] + '"'
  ENDIF
NEXT

cSQL := 'SELECT '
FOR i := 1 TO Len(aPicked)
  cSQL += Alltrim(aPicked[i,1]) + IIF(i<Len(aPicked),', ','')
NEXT

cSQL += ' FROM "' + cTableName + '"'

oSql:setData(cSql)

RETURN nil

* ---------------

METHOD SqlQuery:BrowseISAM( aData, oConnection, oBrowse, aFields, cTitle, cConfig )

LOCAL cFileName := aData[1], oSession, cDbe, cAlias

IF Valtype(aData) == 'A'
  cFileName := Trim(aData[1])
ELSEIF Valtype(aData) == 'C'
  cFileName := Trim(aData)
ELSE
  RETURN nil
ENDIF

oSession := oConnection:sessionDict
IF oSession = NIL
  oSession := oConnection:sessionFree
  IF Empty(DC_Path(cFileName))
    cFileName := oConnection:serverFree + '\' + cFileName
  ENDIF
ENDIF

saAdsStatement[ThreadID()] := nil

IF oConnection:type = 'ADS'
  cDbe := 'ADSDBE'
ELSEIF oConnection:type = 'ODBC'
  cDbe := 'ODBCDBE'
ELSEIF oConnection:type = 'PG'
  cDbe := 'PGDBE'
ENDIF

cFileName := Upper(cFileName)
cAlias := Strtran(DC_Path(cFileName,.t.),'.DBF','')

IF Len(cAlias) > 10
  cAlias := Substr(cAlias,1,10)
ENDIF

dbeSetDefault(cDbe)

USE (cFileName) VIA (oSession) NEW ALIAS (cAlias)

cAlias := Alias()

::DataBrowse( .t., cAlias, oConnection, @oBrowse, , , aFields, cTitle,,,,,cConfig )

CLOSE DATABASES

RETURN nil

* ----------

METHOD SqlQuery:DeleteScript( cViewName, oConnection, oTreeItem, aTypes )

LOCAL lStatus

DCMSGBOX 'Delete Script: ' + Alltrim(oConnection:groupName) + ' : ' + Alltrim(cViewName) ;
   YESNO TO lStatus FONT ::cMessageFont OWNER AppDeskTop()

IF !lStatus
  RETURN .f.
ENDIF

::openViewsFile()

IF !SqlQuery->(dbSeek(Pad(oConnection:GroupName,10)+Pad(cViewName,50),,'TITLE'))
  DCMSGBOX 'Script not found in SqlQuery.DBF file' FONT ::cMessageFont ;
     OWNER AppDeskTop()
  RETURN .f.
ELSEIF SqlQuery->(DC_RecLock())
  SqlQuery->(DC_Blank())
  SqlQuery->(dbRUnlock())
ENDIF
::reloadScripts( oConnection, aTypes )

RETURN .t.

* ----------

METHOD SqlQuery:reloadScripts( oConnection, aTypes )

LOCAL i, aData[0], aChildren, oTreeBranch

IF VIEWTYPE_XBASECOMMANDS $ aTypes
  oTreeBranch := oConnection:CommandScriptBranch
ELSEIF VIEWTYPE_SQLSELECT $ aTypes
  oTreeBranch := oConnection:SqlScriptBranch
ELSEIF VIEWTYPE_SQLSELECT_ONE2MANY $ aTypes
  oTreeBranch := oConnection:SqlScriptBranch
ELSEIF VIEWTYPE_SQLPROCEDURE $ aTypes
  oTreeBranch := oConnection:SqlScriptBranch
ELSEIF VIEWTYPE_ISAMBROWSE $ aTypes
  oTreeBranch := oConnection:ISAMScriptBranch
ENDIF

::loadScripts( oConnection, aData, aTypes )

IF Valtype(oTreeBranch) == 'O'
  oTreeBranch:cargo[2] := aData
  aChildren := oTreeBranch:getChildItems()
  ::oTree:lockUpdate(.t.)
  FOR i := 1 TO Len(aChildren)
    oTreeBranch:delItem(aChildren[i])
  NEXT
  ::BuildTreeBranch(oTreeBranch)
  ::oTree:lockUpdate(.f.)
  ::oTree:invalidateRect()
ENDIF

RETURN nil

* ----------

METHOD SqlQuery:ExecuteLinkedView( oRecord, oConnection )

LOCAL oBrowseParent, oBrowseChild1, oBrowseChild2, oDlgParent, oDlgChild1, ;
      oDlgChild2, cAlias1, cAlias2, nCount, aCoords, lSetScope1, lSetScope2, ;
      cFields, aFields, aColorParent, aColorChild

DD_SqlErrorWindow(nil)

cAlias1 := Trim(oRecord:alias1)
cAlias2 := Trim(oRecord:alias2)
lSetScope1 := oRecord:setScope1
lSetScope2 := oRecord:setScope2
IF !Empty(oRecord:fromColor)
  aColorParent := &(Alltrim(oRecord:fromColor))
ENDIF
IF !Empty(oRecord:toColor1)
  aColorChild := &(Alltrim(oRecord:toColor1))
ENDIF

Sleep(50)
cFields := Alltrim(oRecord:statement)
IF Left(cFields,6) = 'SELECT'
  GuiRun({|a|::ExecuteSQL(oRecord:statement,Trim(oRecord:alias),oConnection, ;
               @oBrowseParent,,,,,,'(PARENT)',,,,aColorParent)})
ELSE
  IF Left(cFields,1) = '{'
    aFields := &(cFields)
  ELSE
    aFields := nil
  ENDIF
  GuiRun({||::BrowseISAM( oRecord:alias, oConnection, @oBrowseParent, ;
            aFields, '(PARENT)',,,,aColorParent ) })
ENDIF

Sleep(50)
IF lSetScope1
  cFields := Alltrim(oRecord:statement1)
  IF Left(cFields,1) = '{'
    aFields := &(cFields)
  ELSE
    aFields := nil
  ENDIF
  GuiRun({||::BrowseISAM( cAlias1, oConnection, @oBrowseChild1, ;
            aFields, '(CHILD 1)',,, aColorParent ) })
ELSE
  GuiRun({|a|::ExecuteSQL(oRecord:statement1,cAlias1,oConnection,@oBrowseChild1,;
             ,,,,,'(CHILD 1)',,,,aColorChild)})
ENDIF

IF !Empty(cAlias2)
  Sleep(50)
  IF lSetScope2
    cFields := Alltrim(oRecord:statement2)
    IF Left(cFields,1) = '{'
      aFields := &(cFields)
    ELSE
      aFields := nil
    ENDIF
    GuiRun({||::BrowseISAM( cAlias2, oConnection, @oBrowseChild2, ;
              aFields, '(CHILD 2)',,,,aColorChild)})
  ELSE
    GuiRun({|a|::ExecuteSQL(oRecord:statement2,cAlias2,oConnection,@oBrowseChild2,;
                ,,,,,'(CHILD 2)',,,,aColorChild)})
  ENDIF
ENDIF

nCount := 0
DO WHILE (oBrowseParent == NIL .OR. oBrowseChild1 == NIL .OR. IIF(!Empty(cAlias2),oBrowseChild2==NIL,.f.))
  Sleep(100)
ENDDO

nCount := 0
DO WHILE ((oDlgParent := oBrowseParent:parent:parent) == NIL .OR. ;
          (oDlgChild1 := oBrowseChild1:parent:parent) == nil) .OR. ;
          (IIF(!Empty(cAlias2),(oDlgChild2 := oBrowseChild2:parent:parent)== NIL,.f.))
  Sleep(100)
ENDDO

IF Valtype(oBrowseParent) == 'O'
  AAdd(oBrowseParent:linkedArray, ;
       {nil,nil,oDlgChild1,oBrowseChild1,Trim(oRecord:FromField1),Trim(oRecord:ToField1), ;
         Trim(oRecord:alias),cAlias1,lSetScope1,oRecord:title})
  IF !Empty(cAlias2)
    AAdd(oBrowseParent:linkedArray, ;
       {nil,nil,oDlgChild2,oBrowseChild2,Trim(oRecord:FromField2),Trim(oRecord:ToField2), ;
         Trim(oRecord:alias),cAlias2,lSetScope2,oRecord:title})
  ENDIF
  aCoords := DC_TokenArray(Alltrim(oRecord:fromwin),',')
  IF Valtype(aCoords) == 'A' .AND. Len(aCoords) == 4 .AND. Valtype(oDlgParent) == 'O'
    Sleep(100)
    PostAppEvent(RESIZE_WINDOW, ;
      {Val(aCoords[3]),Val(aCoords[4])}, ;
      {Val(aCoords[1]),Val(aCoords[2])}, oDlgParent)
    Sleep(50)
  ENDIF
ENDIF

IF Valtype(oBrowseChild1) == 'O'
  aCoords := DC_TokenArray(Alltrim(oRecord:towin1),',')
  IF Valtype(aCoords) == 'A' .AND. Len(aCoords) == 4 .AND. Valtype(oDlgChild1) == 'O'
    Sleep(100)
    PostAppEvent(RESIZE_WINDOW, ;
      {Val(aCoords[3]),Val(aCoords[4])}, ;
      {Val(aCoords[1]),Val(aCoords[2])}, oDlgChild1)
    Sleep(50)
  ENDIF
ENDIF

IF Valtype(oBrowseChild2) == 'O'
  aCoords := DC_TokenArray(Alltrim(oRecord:towin2),',')
  IF Valtype(aCoords) == 'A' .AND. Len(aCoords) == 4 .AND. Valtype(oDlgChild2) == 'O'
    Sleep(50)
    PostAppEvent(RESIZE_WINDOW, ;
      {Val(aCoords[3]),Val(aCoords[4])}, ;
      {Val(aCoords[1]),Val(aCoords[2])}, oDlgChild2)
    Sleep(50)
  ENDIF
ENDIF

RETURN nil

* ----------

METHOD SqlQuery:ExecuteSQL( cStatement, cAlias, oConnection, oBrowse, ;
                            nBrowseType, oOwner, lAllowCancel, oAdsStatement, ;
                            cWaitMessage, cTitle, lNoCursor, lCheckSyntax, ;
                            nCachedColumns, aCustomColorBrowse )

LOCAL oSession, cPath, oScrn, nSeconds := Seconds(), nChoice, ;
      aStru, lStatus := .t., oCancelDialog, oPgStatement, oDlg, ;
      oErrorWindow := DD_SqlErrorWindow(), bAdsMsg := DC_AdsMessageOutput(), ;
      oAdsCallback, nResult

DEFAULT nBrowseType := 1, ;  // 1 == Cursor, 2 == Objects
        lAllowCancel := .f., ;
        lNoCursor := .f., ;
        lCheckSyntax := .f.

DEFAULT cWaitMessage := 'Please wait while executing Query...'

IF !::lIsAdmin .AND. !Left(Upper(Alltrim(cStatement)),6) == 'SELECT' .AND. lAllowCancel
  DCMSGBOX 'Only SELECT statements are allowed!', ;
           'Nice try!' ;
           TIMEOUT 5 ;
           FONT ::cMessageFont ;
           OWNER oOwner
  RETURN .f.
ENDIF

::nLastExecuteTime := 0

oSession := oConnection:sessionDict
IF Valtype(oSession) # 'O'
  oSession := oConnection:sessionFree
  cPath := DC_CurPath()
  DC_ChDir(oConnection:serverFree)
ENDIF

IF Empty(cAlias)
  cAlias := ::TableNameFromStatement( cStatement )
ENDIF

IF Empty(cAlias)
  cAlias := 'QUERY'
ENDIF

cAlias := Alltrim(cAlias)

IF Empty(oBrowse) // create new browse window
  SELECT 0
ELSEIF !Empty(Alias()) // refresh browse window with new query
  IF Valtype(oAdsStatement) == 'O'
    oAdsStatement:close()
  ELSE
    dbCloseArea()
  ENDIF
ENDIF

BEGIN SEQUENCE

/*
IF oConnection:isShowDeleted
  SET DELETED OFF
ELSE
  SET DELETED ON
ENDIF
*/

IF Empty(oConnection:type)
  IF 'ADSDBE' $ Upper(oConnection:sessionDict:getConnectionString())
    oConnection:type := 'ADS'
  ELSEIF 'ODBCDBE' $ Upper(oConnection:sessionDict:getConnectionString())
    oConnection:type := 'ODBC'
  ELSEIF 'PGDBE' $ Upper(oConnection:sessionDict:getConnectionString())
    oConnection:type := 'PG'
  ENDIF
ENDIF

IF oConnection:type = 'ADS'

  saAdsStatement[ThreadID()] := nil

  // oAdsCallback := AdsCallback():new()
  // nResult := AdsRegisterCallbackFunction( oAdsCallback, 123 )

  dbeSetDefault('ADSDBE')
  DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE, oConnection:AdsTableType )
  DbeInfo( COMPONENT_ORDER, ADSDBE_TBL_MODE, oConnection:AdsTableType )
  DbeInfo( COMPONENT_DATA, ADSDBE_LOCK_MODE, oConnection:AdsLockingType )
  DbeInfo( COMPONENT_DATA, ADSDBE_TABLENAME_IS_ALIAS, .f. )

  IF Valtype(oErrorWindow) == 'O'
    DC_AdsMessageOutput({|c|oErrorWindow:setData(c)})
  ENDIF

  oAdsStatement := DC_AdsStatement():New(cStatement,{oConnection:sessionDict,oConnection:sessionFree}, ;
                           oConnection:AdsLockingType,oConnection:AdsTableType)

  saAdsStatement[ThreadID()] := oAdsStatement

  IF oAdsStatement:LastError > 0
    lStatus := .f.
    DC_AdsMessageOutput(bAdsMsg)
    BREAK
  ENDIF

  IF lCheckSyntax
    lStatus := .t.
    IF Valtype(oErrorWindow) == 'O'
      oErrorWindow:setData('Success')
    ENDIF
    BREAK
  ENDIF

  IF .f. // lAllowCancel
    GuiRun({||::CancelQueryDialog( oSession, oConnection, @oCancelDialog )})
    Sleep(100)
  ENDIF

  IF lNoCursor
    oAdsStatement:isSelect := .f.
  ENDIF

  IF Valtype(oErrorWindow) = 'O'
    oErrorWindow:setData(cWaitMessage)
  ENDIF

  DC_AdsMessageOutput(bAdsMsg)
  oScrn := ::WorkingMessage(nil,oOwner)

  cAlias := oAdsStatement:Execute( cAlias )

  lStatus := oAdsStatement:LastError == 0

  ::WorkingMessage( oScrn, oOwner )

  IF Valtype(oCancelDialog) == 'O'
    PostAppEvent(xbeP_Close,,,oCancelDialog)
  ENDIF

  // nResult := AdsClearCallbackFunction()
  // oAdsCallback:destroy()

ELSEIF oConnection:type = 'ODBC'

  dbeSetDefault('ODBCDBE')

  IF Valtype(oErrorWindow) = 'O'
    oErrorWindow:setData(cWaitMessage)
  ENDIF

  oScrn := ::WorkingMessage(nil,oOwner)

  IF Left(cStatement,1) == '@'
    cStatement := Strtran(cStatement,CRLF,'')
    USE (cStatement) VIA (oSession) // execute procedure
  ELSEIF Left(Upper(cStatement),4) = 'EXEC'
    DDPROCEDURE (cStatement) VIA (oSession) TO lStatus
  ELSE
    DDSTATEMENT (cStatement) VIA (oSession) TO lStatus ALIAS (cAlias)
  ENDIF

#if XPPVER > 2000000
ELSEIF  oConnection:type = 'PG'

  IF Valtype(oErrorWindow) = 'O'
    oErrorWindow:setData(cWaitMessage)
  ENDIF

  oScrn := ::WorkingMessage(nil,oOwner)

  dbeSetDefault('PGDBE')

  oPgStatement := DacSqlStatement(oSession):FromChar(cStatement)
  oPgStatement:Build():Query(,cAlias)
#endif
ENDIF

END SEQUENCE

IF lCheckSyntax
  RETURN .t.
ENDIF

saSqlExecuteTime[ThreadID()] := Seconds() - nSeconds

DC_ChDir(cPath)

IF nBrowseType == 0
  ::WorkingMessage(oScrn,oOwner)
  RETURN lStatus
ELSEIF !Left(Upper(Alltrim(cStatement)),6) == 'SELECT' .AND. Empty(cAlias)
  ::WorkingMessage(oScrn,oOwner)
  RETURN lStatus
ELSEIF nBrowseType == 0
  ::WorkingMessage(oScrn,oOwner)
  RETURN !Empty(Alias())
ENDIF

oConnection:SqlStatement := cStatement

IF Empty(Alias())
  IF Valtype(oBrowse) == 'O'
    IF !Empty(oBrowse:filterSqlStatement)
      cStatement := oBrowse:filterSqlStatement
    ELSEIF !Empty(oBrowse:sqlStatementOriginal)
      cStatement := oBrowse:sqlStatementOriginal
    ENDIF

    oConnection:sqlStatement := cStatement
    saStatement[ThreadId()]:refresh()
    ::WorkingMessage(oScrn,oOwner)
    RETURN ::ExecuteSql(cStatement,cAlias,oConnection,oBrowse,,,,oAdsStatement)
  ELSE
    ::WorkingMessage(oScrn,oOwner)
    DC_PointerArrow(oOwner)
    RETURN .f.
  ENDIF
ENDIF

cAlias := Alias()

IF Valtype(oErrorWindow) = 'O'
  oErrorWindow:setData('Success. ' + Alltrim(Str((cAlias)->(RecCount()))) + ' rows returned.')
ENDIF

::nLastExecuteTime := Seconds() - nSeconds

aStru := (cAlias)->(dbStruct())

IF Len(aStru) > 40 .AND. ::lShowBrowseMessages
  ::WorkingMessage(oScrn,oOwner)
  DCMSGBOX 'Your SQL Query will create a browse of ' + Alltrim(Str(Len(aStru))) + ' columns.', ;
           'This can take extra time to build the browse', ;
           '', ;
           'It is suggested that you select a sub-set of fields rather than SELECT *', ;
           'to improve performance.', ;
           '', ;
           'Do you want to continue with creating the browse window?' ;
           YESNO TO lStatus FONT ::cMessageFont OWNER oOwner
  IF !lStatus
    CLOSE DATABASES
    RETURN .f.
  ENDIF
ENDIF

IF ::nLastExecuteTime > 60 .AND. ::lShowBrowseMessages
  ::WorkingMessage(oScrn,oOwner)
  nChoice := 2
  DCMSGBOX 'Your SQL Query took ' + Alltrim(Str(::nLastExecuteTime)) + ' seconds to Execute.', ;
           'It produced ' + Alltrim(Str(RecCount())) + ' rows of data.', ;
           '', ;
           'It is suggested that you browse this dataset as a set of objects', ;
           'to improve performance with sub-filtering of columns.', ;
           '', ;
           'If you do not intend to create a subset of data by sub-filtering', ;
           'then it is reccommended that you browse the SQL cursor', ;
           '', ;
           'If your dataset consists of more than 20,000 rows, then it is', ;
           'then it is reccommended that you browse the SQL cursor', ;
           '', ;
           'Choose a Browse Method' ;
           BUTTONS {'Browse SQL Cursor','Browse as Data Objects','Cancel'} ;
           CHOICE @nChoice FONT ::cMessageFont OWNER oOwner
   IF nChoice $ {1,2}
     nBrowseType := nChoice
   ELSE
     CLOSE DATABASES
     RETURN .f.
   ENDIF
ENDIF

::WorkingMessage( oScrn, oOwner )

IF Empty(oBrowse) .AND. !lNoCursor

  IF nBrowseType == 1
    ::DataBrowse( .f., cAlias, oConnection, @oBrowse, @oDlg, oAdsStatement,, cTitle,,,,nCachedColumns, ;
                  aCustomColorBrowse )
  ELSEIF nBrowseType == 2
    ::ObjectBrowse( cAlias, oConnection, oAdsStatement, cTitle )
  ENDIF
  IF Valtype(oAdsStatement) == 'O' .AND. oAdsStatement:isSelect
    oAdsStatement:close()
  ELSE
    CLOSE DATABASES
  ENDIF

ELSEIF lNoCursor

  RETURN .t.

ELSE

  IF Alias() == '_SEARCH_TABLE'
     oBrowse:dataSource := Alias()
  ENDIF

  oBrowse:refresh()
  oBrowse:goTop()
  oBrowse:forceStable()
  oBrowse:refreshAll()
  IF Valtype(saRowCount[ThreadID()]) == 'O'
    saRowCount[ThreadID()]:refresh()
  ENDIF

ENDIF

RETURN .t.

* -----------

METHOD SqlQuery:executeSQLScript( oConnection )

LOCAL GetList[0], cFileName := Space(100), cSQL, aFileFilters, lStatus, nHandle, ;
      oScrn, bError := ErrorBlock({|e|lStatus := .f., ScriptError(e,cSql,oScrn)})

aFileFilters := { {"SQL Script Files", "*.SQL"}, ;
                  {"All Files", "*.*"  } }

@ 0,0 DCSAY 'File Name to Load (*.SQL)' SAYSIZE 0
@ 1,0 DCGET cFileName POPUP {|c|DC_PopFile(c,,'*.Sql','Load a Script Text File',aFileFilters)} ;
      GETSIZE 50 VALID {||DC_ReadEmpty(cFileName)}

DCREAD GUI FIT TITLE 'Execute a SQL Script File' TO lStatus ADDBUTTONS

IF !lStatus
  RETURN .f.
ENDIF

cFileName := Alltrim(cFileName)

nHandle := DC_TxtOpen(cFileName)
IF nHandle <= 0
  DCMSGBOX 'Could not open file:', cFileName  FONT ::cMessageFont
  RETURN .f.
ENDIF

cSql := ''

oScrn := DC_WaitOn('Executing ' + cFileName)

DO WHILE !DC_TxtEof(nHandle) .AND. lStatus
  cSql += Trim(DC_TxtLine(nHandle))
  IF Right(cSql,1) == ';'
    IF !::executeSql(cSql,,oConnection)
      lStatus := .f.
      EXIT
    ENDIF
    cSql := ''
  ENDIF
  DC_TxtSkip(nHandle)
ENDDO

DC_TxtClose(nHandle)
DC_Impl(oScrn)
ErrorBlock(bError)

IF lStatus
  DCMSGBOX 'Done!' FONT ::cMessageFont
ENDIF

RETURN lStatus

* -----------

STATIC FUNCTION ScriptError( oError, cSql, oScrn )

LOCAL GetList[0], GetOptions

DC_Impl(oScrn)

@ 0,0 DCMULTILINE cSql SIZE 100,30 FONT '10.Lucida Console' ;
      RESIZE DCGUI_RESIZE_RESIZEONLY NOHSCROLL

DCGETOPTIONS RESIZE

DCREAD GUI FIT TITLE 'Sql Error' MODAL

RETURN Nil

* -----------

METHOD Sqlquery:CancelQueryDialog( oSession, oConnection, oCancelDialog )

LOCAL GetList[0]

@ 0,0 DCSAY 'Executing SQL Statement' SAYSIZE 0 FONT ::cMessageFont
@ 1,0 DCSAY 'Please wait ...' SAYSIZE 0 FONT ::cMessageFont

@ 3,5 DCPUSHBUTTON CAPTION 'Cancel Query' SIZE 20,1.5 ;
       ACTION {||::CancelQuery(oSession,oConnection)} ;
       FONT ::cMessageFont

DCREAD GUI FIT TITLE 'Executing SQL' FIT NOAUTORESTORE PARENT @oCancelDialog

RETURN nil

* -----------

METHOD SqlQuery:CancelQuery( oSession, oConnection )

LOCAL cAlias, ;
      cSql := 'EXECUTE PROCEDURE Sp_GetSqlStatements()', ;
      oSaveSession := oSession, oNewSession

oNewSession := DacSession():new(oSession:getConnectionString())
IF oNewSession:isConnected()
  oConnection:sessionDict := oNewSession
  IF !::ExecuteSQL( cSql,,oConnection,,0,,.f. )
    RETURN .f.
  ENDIF
  oConnection:sessionDict := oSession
  oNewSession:disconnect()
ENDIF

RETURN .f.

* -----------

METHOD Sqlquery:DataBrowse( lIsam, cAlias, oConnection, oBrowse, oDlg, oAdsStatement, ;
                            aFields, cTitleX, bIMarked, bISelected, bEval, nCachedColumns, ;
                            aCustomColor, oOwner )

LOCAL GetList[0], GetOptions, bGetSet, oSession, oCellStatic, ;
      i, cCellContents := '', bGetCell, cTitle, cArea, ;
      cHeader, nWidth, oCellContents, nBrow := 0, lBrow := .f., ;
      bColumn, bItemSelected, oSplitBar, bScope, oScope, nKeyCount := 0, ;
      cClassName, oRecord, oMenu, aStru, oSetAppWindow, oMoreButton, ;
      nFound, oReExecuteSql, nColCreate, oMenu2, bMenuAction

DEFAULT nCachedColumns := ::nCachedColumns, ;
        aCustomColor := {::aOddColorRow,::aEvenColorRow}, ;
        lIsam := .t.

IF Valtype(aFields) == 'A'
  nCachedColumns := Len(aFields)
ENDIF

cTitle := IIF( lIsam, 'Browsing ISAM: ' + Alias(),Alias() + ' - Browsing SQL Statement')
IF Valtype(cTitleX) = 'C'
  cTitle += ' ' + cTitleX
ENDIF
IF lIsam .AND. Valtype(oConnection) == 'O'
  oConnection:sqlStatement := ''
ENDIF

cAlias := Alias()
IF Valtype(oConnection) == 'O' .AND. !Empty(oConnection:name)
  cTitle += '     [' + oConnection:name + ']'
ELSE
  cTitle := 'Browsing ' + cAlias
ENDIF

cArea := Alltrim(Str(Select()))

aStru := (cAlias)->(dbStruct())

IF Valtype(oConnection) == 'O' .AND. (cAlias)->(DC_SetRdd()) $ {'ADSDBE','ODBCDBE','PGDBE'}
  IF Valtype(oConnection:sessionDict) == 'O'
    oSession := oConnection:sessionDict
  ELSEIF Valtype(oConnection:sessionFree) == 'O'
    oSession := oConnection:sessionFree
  ELSE
//    DC_Winalert('No session object for browse')
//    RETURN nil
  ENDIF
ENDIF

cClassName := 'DATA_' + Alltrim(Str(Seconds(),5))
oRecord := (cAlias)->(DC_DbRecord(cClassName):new())

DCUSEREVENT LINK_MESSAGE ACTION {|cWhere,aData|::setLinkedData(oBrowse,cWhere,aData,oScope,@nKeyCount)}
DCUSEREVENT RESIZE_WINDOW ACTION {|a,b,o|o:setSize(a),o:setPos(b)}
DCUSEREVENT SCOPE_REFRESH ACTION {||oScope:refresh()}

@ 0,0 DCPUSHBUTTON CAPTION 'Print' SIZE 8,1 ;
      ACTION {||oBrowse:PrintBrowse()} ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
      TOOLTIP 'Print this view'

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Export' SIZE 9,1 ;
      ACTION {||::Browse2Export(oBrowse,oDlg,oConnection)} ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
      TOOLTIP 'Export this view to Excel or Database'

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON ;
      CAPTION {||IIF(Valtype(oBrowse)=='O' .AND. oBrowse:isCollapsed,'Restore','Collapse')} SIZE 9,1 ;
      ACTION {|a,b,o|IIF(oBrowse:isCollapsed,oBrowse:restoreAll(oDlg),oBrowse:collapseAll(oDlg)),o:refresh()} ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
      TOOLTIP 'Collapse or Restore Columns'

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON ;
      CAPTION 'Link' ;
      SIZE 6,1 ;
      ACTION {|a,b,o|::linkWindow(oDlg,oBrowse,cAlias,GetList,oConnection)} ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
      TOOLTIP 'Link this window to another window in a One-2-Many Relationship' ;
      WHEN {||Empty(::oBrowseParentDlg)}

@ DCGUI_ROW, DCGUI_COL + 15 DCSAY 'Rows:' COLOR GRA_CLR_BLUE FONT ::cMessageFont;
       SAYSIZE 0 RESIZE DCGUI_RESIZE_REPOSONLY_Y

bGetSet := {|o,n|o:=oBrowse, n := IIF(Valtype(o)=='O', o:displayedRows(), -1 ), ;
                 IIF(n < 0, '??',Alltrim(DC_XtoC(o:displayedRows())))}

@ DCGUI_ROW, DCGUI_COL + 15 DCSAY bGetSet FONT '12.Lucida Console Bold' ;
       SAYSIZE 14 SAYLEFT RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
       OBJECT saRowCount[ThreadID()]

@ DCGUI_ROW, DCGUI_COL + 10 ;
   DCSAY 'Left click header to SORT. Right click header for FILTER.;' + ;
         ' SPACE to Tag/Untag.  ENTER to EDIT.  Alt-D for DOT prompt.' ;
       SAYSIZE 45,1.5 SAYWORDBREAK RESIZE DCGUI_RESIZE_REPOSONLY_Y

bGetSet := {|o,n|Alltrim(Str(saSqlExecuteTime[ThreadID()])) + ' Secs.'}

@ DCGUI_ROW, DCGUI_COL  DCSAY bGetSet FONT '9.Arial' ;
       SAYSIZE 14 SAYLEFT RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
       OBJECT saSqlExecuteTimeObject[ThreadID()]

bGetCell := {|x,o,cDate,cTime,b|o := oBrowse:getColumn(oBrowse:colPos), ;
                b := ErrorBlock({|e|_break(e)}), ;
                x := Eval(o:dataLink), ;
                ErrorBlock(b), ;
                x := IIF(IsMemberVar(o,'isDateField') .AND. o:isDateField,::UnixTime2DateTime(x),DC_XtoC(x)), ;
                IIF(Valtype(oCellContents)=='O',oCellContents:setData(x),nil), ;
                IIF(Valtype(bIMarked)=='B',Eval(bIMarked,o),nil)}

DCHOTKEY xbeK_ENTER ;
   ACTION {||IIF(oSession==nil .OR. !oSession:isDerivedFrom('DC_DacSession'),nil,oSession:IsSqlExecute := .f.), ;
             ::EditRecord( oRecord, aStru, cArea, oConnection, oBrowse, .t. ), ;
             IIF(oSession # nil .AND. oSession:isDerivedFrom('DC_DacSession') .AND. oSession:IsSqlExecute,CheckReExecuteSql(oReExecuteSql,oBrowse,oRecord),nil)} ;
   WHEN {||SetAppFocus() == oBrowse}

DCHOTKEY xbeK_SPACE ACTION {||::TagAction(oBrowse)} ;
   WHEN {||SetAppFocus() == oBrowse}

DCHOTKEY xbeK_CTRL_LEFT ACTION {||oBrowse:getColumn(oBrowse:colPos):moveColumnFiltered(1)} ;
   WHEN {||SetAppFocus() == oBrowse .AND. ;
           oBrowse:getColumn(oBrowse:colPos):displayIndex > Len(oBrowse:setLeftFrozen())+1}

DCHOTKEY xbeK_CTRL_RIGHT ACTION {||oBrowse:getColumn(oBrowse:colPos):moveColumnFiltered(2)} ;
   WHEN {||SetAppFocus() == oBrowse .AND. ;
           oBrowse:colPos < oBrowse:colCount}

DCHOTKEY xbeK_CTRL_END ACTION {|o|DC_PointerWait(), ;
                                 o := DC_WaitOn('Building ALL cached columns...'), ;
                                 oBrowse:NextCachedColumn( GetList, .t. ), ;
                                 DC_PointerArrow(), ;
                                 DC_Impl(o)}   ;
   WHEN {||SetAppFocus() == oBrowse}

DCHOTKEY xbeK_CTRL_DEL ACTION {||oBrowse:getColumn(oBrowse:colPos):deleteColumnFiltered(), ;
                                 oBrowse:refreshAll()} ;
   WHEN {||SetAppFocus() == oBrowse}

DCHOTKEY xbeK_CTRL_INS ACTION {||oBrowse:getColumn(oBrowse:colPos):addColumnFiltered(.t.), ;
                                 oBrowse:refreshAll()} ;
   WHEN {||SetAppFocus() == oBrowse}

DCHOTKEY Asc('+') ;
   ACTION {|o|oBrowse:lockUpdate(.t.), ;
              o := oBrowse:getColumn(oBrowse:colPos), ;
              o:setSize({o:currentSize()[1]+10,o:currentSize()[2]}), ;
              oBrowse:setSize(oBrowse:currentSize()),;
              oBrowse:lockUpdate(.f.)} ;
   WHEN {||SetAppFocus() == oBrowse}

DCHOTKEY Asc('-') ;
   ACTION {|o|oBrowse:lockUpdate(.t.), ;
              o := oBrowse:getColumn(oBrowse:colPos), ;
              o:setSize({o:currentSize()[1]-10,o:currentSize()[2]}), ;
              oBrowse:setSize(oBrowse:currentSize()), ;
              oBrowse:lockUpdate(.f.)} ;
   WHEN {||SetAppFocus() == oBrowse}

IF Valtype(bISelected) = 'B'
  bItemSelected := {||::SendLinkedMessage(oBrowse,cAlias),Eval(bISelected)}
ELSE
  bItemSelected := {||::SendLinkedMessage(oBrowse,cAlias)}
ENDIF

@ 1,0 DCBROWSE oBrowse ALIAS cAlias SIZE 120, 22 ;
      FONT '11.Arial' ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      SUBCLASS 'DD_XbpBrowseFiltered()' ;  // <<<<<<<<<<<<<<<<<<<<<
      SQLSESSION oSession               ;  // <<<<<<<<<<<<<<<<<<<<<
      PRESENTATION ::aBrowPres ;
      HEADPRES {{ XBP_PP_COMPOUNDNAME, '9.Lucida Console' }};
      FOOTPRES {{ XBP_PP_COMPOUNDNAME, '9.Lucida Console Bold' }};
      RBSELECT ;
      RBDOWN {|x,y,o|oMenu:popup( o:setParent(),{o:currentPos()[1],o:currentPos()[2]+x[2]-60}, , ;
                                  XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN )} ;
      SORTCONFIG ::oSortConfig;
      SCROLLBARHEIGHT 12;
      CURSORMODE XBPBRW_CURSOR_CELL ;
      ITEMMARKED bGetCell ;
      ITEMSELECTED bItemSelected ;
      CARGO {} ;
      OPTIMIZE ;
      ZEBRA ::aOddColorRow, ::aEvenColorRow ;
      CACHECOLUMNS nCachedColumns  AUTOADD ;        // <<<<<<<<<<<<<<<<<<<<<
      EVAL {|o|o:customColor := aCustomColor, ;
               o:columnTagColor := {|a,oColumn|ObjectColor(oBrowse,oColumn,.t.,self)}} ;
      ;// FREEZELEFT {1,2}

bColumn := {|o|o:dataArea:lbDown := {|a,b,o|o:parent:parent:isLeftMouseButton := .t.}, ;
               o:dataArea:lbUp := {|a,b,o|o:parent:parent:isLeftMouseButton := .f.}, ;
               nil}

DEFAULT aFields := {}

/*
DCBROWSECOL DATA {||(cAlias)->(Recno())} HEADER 'Row #' WIDTH 4 PARENT oBrowse ;
   PICTURE '99999' ;
   CACHECOLUMN DCBROWSECOL_CREATE_YES   // <<<<<<<<<<<<<<<<<<<<

DCBROWSECOL DATA {||IIF((cAlias)->(Deleted()),'Yes','')} HEADER 'Del' WIDTH 2 PARENT oBrowse ;
   COLOR {||IIF((cAlias)->(Deleted()),{GRA_CLR_RED,XBPSYSCLR_TRANSPARENT},nil)} ;
   CACHECOLUMN DCBROWSECOL_CREATE_YES   // <<<<<<<<<<<<<<<<<<<<
*/

FOR i := 1 TO Len(aStru)
  nWidth := aStru[i,3]
  nColCreate := DCBROWSECOL_CREATE_DEFAULT
  nFound := -1
  IF Len(aFields) > 0
    nFound := AScan(aFields,{|a|a[1]==aStru[i,1]})
    IF nFound > 0
      nColCreate := DCBROWSECOL_CREATE_YES
    ENDIF
  ENDIF
  AAdd(aStru[i],aStru[i,1])
  IF Valtype(aStru[i,1]) == 'C'
    IF nFound > 0 .AND. Len(aFields[nFound]) == 7 .AND. Left(aFields[nFound,5],1) == '{'
      cHeader := aFields[i,6]
      aStru[i,5] := &(aFields[i,5])
      aStru[i,2] := Valtype(Eval(aFields[i,1]))
    ELSE
      cHeader := aStru[i,1]
      aStru[i,5] := FieldWBlock(aStru[i,1],cArea)
    ENDIF
  ELSEIF Valtype(aStru[i,1]) == 'B'
    cHeader := DC_XtoC(aStru[i,1])
    aStru[i,2] := Valtype(Eval(aStru[i,1]))
  ENDIF

  IF nWidth > 10
    nWidth := 10
  ELSEIF nWidth < Len(cHeader)
    nWidth := Len(cHeader)/1.5
  ENDIF

  if aStru[i,2] = 'M'
    DbInfo( ODBCDBO_ODBC_TO_XPP, {{i, XPP_CHARACTER}} )
  endif
  if aStru[i,2] = 'T'
    DbInfo( ODBCDBO_ODBC_TO_XPP, {{i, XPP_DATE}} )
  endif

  IF nWidth > 10
    nWidth := 10
  ELSEIF nWidth < Len(cHeader)
    nWidth := Len(cHeader)/1.5
  ENDIF

  DCBROWSECOL DATA aStru[i,5] ;
    PARENT oBrowse HEADER cHeader TOOLTIP cHeader ;
    WIDTH nWidth ;
    SUBCLASS 'DD_XbpColumnFiltered()' ;   // <<<<<<<<<<<<<<<<<<<<
    SORT {|oBrowse,nColumn,oColumn|oBrowse:orderBy(nColumn,oColumn)} ;
    EVAL bColumn ;
    CARGO aStru[i] ;
    CACHECOLUMN nColCreate  // <<<<<<<<<<<<<<<<<<<<

NEXT

DCSUBMENU oMenu OWNERDRAW ;
   BARTEXT 'Menu' ;
   ITEMFONT ::cMenuFont

  DCMENUITEM 'Edit this Record' ;
    ACTION {||SetAppFocus(oBrowse),PostAppevent(xbeK_ENTER,,,oBrowse)} PARENT oMenu

  DCMENUITEM {||IIF((cArea)->(Deleted()),'RECALL','DELETE') + ' this record'} ;
    PARENT oMenu ;
    ACTION {||(cAlias)->(DC_RecLock()), ;
              IIF((cArea)->(Deleted()),(cArea)->(dbRecall()),(cArea)->(dbDelete())), ;
              oBrowse:refreshCurrent()}

  DCMENUITEM 'Select records where any field contains a value' ;
    PARENT oMenu ;
    ACTION {||::SqlSearchTable( cAlias, oConnection, aStru, oBrowse, oDlg )} ;
    WHEN {||oBrowse:dataSource # '_SEARCH_TABLE'}

  DCMENUITEM SEPARATOR PARENT oMenu

  DCMENUITEM 'Move Column LEFT (Ctrl-Left)' ;
     ACTION {||oBrowse:getColumn(oBrowse:colPos):moveColumnFiltered(1)} ;
     PARENT oMenu

  DCMENUITEM 'Move Column RIGHT (Ctrl-Right)' ;
     ACTION {||oBrowse:getColumn(oBrowse:colPos):moveColumnFiltered(2)} ;
     PARENT oMenu

  DCMENUITEM 'Delete Column (Ctrl-Delete)' ;
     ACTION {||oBrowse:getColumn(oBrowse:colPos):deleteColumnFiltered(2), ;
               oBrowse:refreshAll()} ;
     PARENT oMenu

  DCMENUITEM 'Insert Column (Ctrl-Insert)' ;
     ACTION {||oBrowse:getColumn(oBrowse:colPos):addColumnFiltered(.t.), ;
               oBrowse:refreshAll()} ;
     PARENT oMenu

  DCMENUITEM SEPARATOR PARENT oMenu

  DCMENUITEM 'Copy Contents of Cell to Windows Clip Board' ;
    ACTION {||::CopyCellToClipBoard(oBrowse,oRecord)} PARENT oMenu

  DCMENUITEM 'Copy this Record to SqlQuery Clip Board' ;
    ACTION {||::CopyRecordsToClipBoard(oBrowse,oRecord,.f.)} PARENT oMenu

  DCMENUITEM 'Copy TAGGED Records to SqlQuery Clip Board' ;
    ACTION {||::CopyRecordsToClipboard(oBrowse,oRecord,.t.)} PARENT oMenu ;
    WHEN {||!Empty((cArea)->(DC_RecTagArray()))}

  DCMENUITEM 'Clear SqlQuery Record Clipboard' PARENT oMenu ;
    ACTION {||oBrowse:RecordClipBoard := nil} ;
    WHEN {||Valtype(oBrowse)= 'O' .AND. !Empty(oBrowse:RecordClipBoard)}

  DCMENUITEM 'Paste SqlQuery Clipboard Records' ;
    ACTION {||::PasteRecordsFromClipboard(oBrowse,oRecord)} PARENT oMenu ;
    WHEN {{||Valtype(oBrowse)='O' .AND. !Empty(oBrowse:RecordClipBoard)}}

  DCMENUITEM SEPARATOR PARENT oMenu

  DCMENUITEM 'Freeze this column' ;
    ACTION {|a| a := oBrowse:setLeftFrozen(), ;
                AAdd(a,oBrowse:colPos), ;
                oBrowse:setLeftFrozen(a), ;
                oBrowse:forceStable(), ;
                oBrowse:refreshAll()} PARENT oMenu

  DCMENUITEM 'Un-Freeze columns' ;
    ACTION {||oBrowse:setLeftFrozen({}), ;
              oBrowse:forceStable(), ;
              oBrowse:refreshAll()} PARENT oMenu ;
    WHEN {||!Empty(oBrowse:setLeftFrozen())}

  DCMENUITEM SEPARATOR PARENT oMenu

  DCMENUITEM 'Choose Browse Row Colors' PARENT oMenu ;
    ACTION {||ChooseBrowseRowColors(oBrowse,self)}

  DCMENUITEM 'Select an Index' PARENT oMenu ;
    ACTION {||ChooseIndexTag(oBrowse,oDlg)}  ;
    WHEN {||!Empty((cArea)->(DC_TagInfo()))}

@ 23.5,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT OBJECT oCellStatic SIZE 120,2 ;
     RESIZE DCGUI_RESIZE_RESIZEONLY_X

@ 0,0 DCSAY 'Cell Contents:' SAYSIZE 0 PARENT oCellStatic ;
   RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ 1,0 DCMULTILINE cCellContents OBJECT oCellContents ;
   SIZE 120,2 NOHSCROLL FONT ::cMessageFont ;
   RESIZE DCGUI_RESIZE_RESIZEONLY PARENT oCellStatic

@ 23,0 DCSPLITBAR oSplitBar SIZE 120, .25 ;
    ORIENTATION DCGUI_SPLITBAR_HORIZONTAL ;
    PREDECESSOR oCellStatic ;
    SUCCESSOR oBrowse ;
    COLOR GRA_CLR_DARKGREEN ;
    MOVECOLOR GRA_CLR_GREEN ;
    RESIZE DCGUI_RESIZE_RESIZEONLY_X

@ 26,0 DCSAY 'Filter or SQL Statement:' SAYSIZE 0

bScope := {||IIF(!Empty((cArea)->(DC_SetScope(0))), ;
              (cArea)->(OrdSetFocus()) + ' : ' + ;
              DC_XtoC((cArea)->(DC_SetScope(0))) + ' / ' + ;
              DC_XtoC((cArea)->(DC_SetScope(1))), '')}

@ DCGUI_ROW, DCGUI_COL + 50 DCSAY 'Scope:' SAYSIZE 0
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY bScope SAYSIZE 50 FONT ::cMessageFont ;
    COLOR GRA_CLR_BLUE OBJECT oScope

bGetSet := {|| ShowFilter(oBrowse)}

@ 27,0 DCMULTILINE bGetSet OBJECT saStatement[ThreadID()] ;
   SIZE 103,4.5 NOHSCROLL FONT ::cMessageFont ;
   RESIZE DCGUI_RESIZE_RESIZEONLY_X

@ 27, 104 DCTOOLBAR ::oToolBar VERTICAL SIZE 15,4.7 BUTTONSIZE 15,1.1 ;
     RESIZE DCGUI_RESIZE_REPOSONLY_X

DCADDBUTTON CAPTION 'Execute' PARENT ::oToolBar ;
   ACTION {||::ReExecuteSql(oBrowse,cAlias,oConnection,,.f.,oDlg), ;
             saSqlExecuteTimeObject[ThreadID()]:refresh()} ;
   TOOLTIP 'Execute the modified SQL Statement ' ;
   OBJECT oReExecuteSql ;
   WHEN {||!Empty(oSession)}

DCADDBUTTON CAPTION 'Reset' PARENT ::oToolBar ;
   ACTION {||::ResetFilter(oBrowse,cAlias,oConnection,.t.)} ;
   TOOLTIP 'Reset the Custom Filter condition'

DCADDBUTTON CAPTION 'Objects' PARENT ::oToolBar ;
   ACTION {||::ReExecuteSql(nil,cAlias,oConnection,2,.t.)} ;
   TOOLTIP 'Browse this modified SQL Statement as a set of Objects' ;
   WHEN {||!Empty(oSession)}

DCADDBUTTON CAPTION 'Save' PARENT ::oToolBar ;
   ACTION {|x,y,o|oMenu2:PopUp( o:setParent(), o:currentPos(), 2 , ;
                    XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN  ) } ;
   TOOLTIP 'Save this Link / View to View catalog'

DCSUBMENU oMenu2 PROMPT 'Save Menu'

DCMENUITEM 'Save Sql to View Catalog' PARENT oMenu2 ;
   ACTION {||::SaveSQLScript( Eval(bGetSet), oConnection, oDlg, cAlias )}

DCMENUITEM 'Save Linked Windows' PARENT oMenu2 ;
   ACTION {|a,b,o|::linkWindow(oDlg,oBrowse,cAlias,GetList,oConnection,.t.)} ;
   WHEN {||!Empty(oBrowse:linkedArray)}

/*
bMenuAction := {|a,b,o|oMenu2:PopUp( o:setParent(), o:currentPos(), 2 , ;
                                    XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN  ) }

DCADDBUTTON CAPTION 'More Cols' PARENT ::oToolBar ;
   TOOLTIP 'Add More Columns to the Browse' ;
   ACTION {||::ChooseCachedColumns(oBrowse,GetList,oDlg,cAlias,oConnection)} ;
   WHEN {||Len(aStru)>20} ;
   OBJECT oMoreButton ;
   MENUACTION bMenuAction ;
   CONFIG ::oButtonConfig

DCSUBMENU oMenu2 PROMPT 'Menu'
  DCMENUITEM 'Save Column Configuration' PARENT oMenu2 ;
    ACTION {||::SaveCachedColumns(oBrowse,oConnection)}
*/

DCGETOPTIONS ;
   RESIZE ;
   COLOR oConnection:browseWindowBGColor ;
   BUSYMESSAGE 'Building Browse. Please wait..' ;
   COLOR GRA_CLR_DARKGREEN     ;
   SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT OPTIONS GetOptions ;
   NOAUTORESTORE ;
   PARENT @oDlg ;
   OWNER oOwner ;
   APPWINDOW ::oBrowseParentWindow ;
   TITLE cTitle ;
   SETFOCUS @oBrowse ;
   EVAL {|oDlg|saRowCount[ThreadID()]:refresh(), ;
           saSqlExecuteTimeObject[ThreadID()]:refresh(), ;
           oBrowse:AdsLockingType := oConnection:AdsLockingType, ;
           oBrowse:AdsTableType := oConnection:AdsTableType, ;
           oBrowse:dataStructure := (cAlias)->(dbStruct()), ;
           oBrowse:pickedFields := aFields, ;
           oBrowse:linkedAlias := cAlias, ;
           ;// oBrowse:columnConfiguration := cColumnConfig, ;
           ::SetWindowPos(oDlg), ;
           IIF(IsMemberVar(oDlg,'connection'),oDlg:connection := oConnection,nil), ;
           IIF(Valtype(bEval)=='B',Eval(bEval,oDlg),nil), ;
           IIF(nCachedColumns<5,PostAppEvent(xbeP_Activate,,,oMoreButton),nil) }

saStatement[ThreadID()] := nil
saRowCount[ThreadID()] := nil

IF Valtype(oAdsStatement) == 'O'
  oAdsStatement:close()
ENDIF

RETURN nil

* ------------

STATIC FUNCTION ChooseBrowseRowColors( oBrowse, self, nWhich )

LOCAL GetList[0]

@ 0,0 DCPUSHBUTTON CAPTION 'Even Row Color' SIZE 40,1.5  ;
      ACTION {|a| a := ::BrowseColors( nil, 'Even Rows'), ;
                  oBrowse:customColor[1] := { nil, a[1]}, ;
                  oBrowse:refreshAll()}

@ 2,0 DCPUSHBUTTON CAPTION 'Odd Row Color' SIZE 40,1.5 ;
      ACTION {|a| a := ::BrowseColors( nil, 'Odd Rows'), ;
                  oBrowse:customColor[2] := { nil, a[1]}, ;
                  oBrowse:refreshAll()}

DCREAD GUI FIT TITLE 'Choose Browse Colors' MODAL SETAPPWINDOW ;
   NOAUTORESTORE

RETURN nil

* ------------

STATIC FUNCTION ChooseIndexTag( oBrowse, oDlg )

LOCAL GetList[0], aTagInfo, oBrowse2, nPointer := 1, GetOptions, ;
      lStatus

aTagInfo := DC_TagInfo()

@ 0,0 DCBROWSE oBrowse2 DATA aTagInfo SIZE 50, 15 FIT ;
      FONT '10.Lucida Console' ;
      POINTER nPointer ;
      ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCBROWSECOL ELEMENT 1 HEADER 'Tag Name' WIDTH 12 PARENT oBrowse2
DCBROWSECOL ELEMENT 2 HEADER 'Index Key' WIDTH 50 PARENT oBrowse2
DCBROWSECOL ELEMENT 3 HEADER 'FOR Condition' WIDTH 30 PARENT oBrowse2

DCGETOPTIONS RESIZE

DCREAD GUI FIT TITLE 'Choose an Index' MODAL ADDBUTTONS TO lStatus ;
   OPTIONS GetOptions OWNER oDlg

IF lStatus
  OrdSetFocus(aTagInfo[nPointer,1])
  dbGoTop()
  oBrowse:refreshAll()
ENDIF

RETURN lStatus

* ------------

STATIC FUNCTION ShowFilter( oBrowse )

LOCAL cText := ''

IF !Empty(oBrowse:filterSqlStatement) .AND. !Empty(oBrowse:filterExpression)
  cText := '   SQL: ' + oBrowse:filterSqlStatement + CRLF + CRLF + 'Filter: ' + oBrowse:filterExpression
ELSEIF !Empty(oBrowse:filterSqlStatement)
  cText := oBrowse:filterSqlStatement
ELSEIF !Empty(oBrowse:filterExpression)
  cText := oBrowse:filterExpression
ELSEIF Valtype(saAdsStatement[ThreadID()]) == 'O'
  cText := saAdsStatement[ThreadID()]:statement
ENDIF

RETURN cText

* ------------

STATIC FUNCTION CheckReExecuteSql( oButton, oBrowse, oRecord )

LOCAL lStatus, cTagName, oOwner := oBrowse:parent:parent

DCMSGBOX 'The current row was updated by a SQL UPDATE.', ;
         'Do you want to display the updated cursor now?' YESNO ;
         TO lStatus FONT '10.Lucida Console' OWNER oOwner

IF lStatus
  PostAppEvent(xbeP_Activate,,,oButton)
  DC_CompleteEvents()
  cTagName := oBrowse:findGoodIndex('UUID')
  IF cTagName == 'UUID'
    (oBrowse:dataSource)->(dbSeek(oRecord:uuid,,cTagName))
  ELSE
    (oBrowse:dataSource)->(dbLocate({||FIELD->uuid==oRecord:uuid}))
  ENDIF
  IF (oBrowse:dataSource)->(Eof())
    (oBrowse:dataSource)->(DC_DbGoTop())
  ENDIF
  oBrowse:refreshAll()
ENDIF

RETURN lStatus

* ------------

METHOD SqlQuery:chooseCachedColumns(oBrowse,GetList,oDlg,cTable,oConnection)

LOCAL lStatus, aColumns[0], aFields[0], aCargo, oColumn, i

lStatus := oBrowse:ChooseCachedColumn(GetList,oDlg,.f.,@aColumns)

RETURN lStatus

* -------------

METHOD SqlQuery:SqlSearchTable( cTable, oConnection, aStru, oBrowse, oDlg )

LOCAL GetList[0], cValue, cSql, lStatus, i, nWhich := 1, cInto, nSaveArea, ;
      aTables, cDrop, nFound

cValue := Space(50)

aTables := oConnection:tableBranch:cargo[2]

@ 0,0 DCSAY 'Value to Select' GET cValue VALID {||DC_ReadEmpty(cValue)} SAYSIZE 0 SAYBOTTOM

@ 2,0 DCRADIOBUTTON nWhich PROMPT 'Starts With' VALUE 1
@ 3,0 DCRADIOBUTTON nWhich PROMPT 'Contained In' VALUE 2

DCREAD GUI FIT ADDBUTTONS TITLE 'Search (SELECT) all columns with specified value' ;
   MODAL SETAPPWINDOW NOAUTORESTORE TO lStatus OWNER oDlg

IF !lStatus
  RETURN .f.
ENDIF

cValue := Upper(Alltrim(cValue))

IF oConnection:type = 'ADS' .OR. 'ADVANTAGE STREAMLINESQL' $ Upper(oConnection:driver)
  cInto := '*' // '{static} *'
ELSE
  cInto := '* INTO _SEARCH_TABLE'
ENDIF

IF nWhich == 0
  cSql := 'SELECT ' + cInto + ' FROM ' + cTable + " WHERE '" + cValue + "' IN ("
  FOR i := 1 TO Len(aStru)
    IF aStru[i,2] $ 'CM'
      cSql += aStru[i,1] + ','
    ENDIF
  NEXT
  IF Right(cSql,1) = ','
    cSql := Substr(cSql,1,Len(cSql)-1)
  ENDIF
  cSql += ' );'
ELSEIF nWhich == 1
  cSql := 'SELECT ' + cInto + ' FROM ' + cTable + ' WHERE '
  FOR i := 1 TO Len(aStru)
    IF aStru[i,2] $ 'CM'
      cSql += "Upper(SubString(" + aStru[i,1] + ",1," + Alltrim(Str(Len(cValue))) + ")) = '" + cValue + "' OR "
    ENDIF
  NEXT
  IF Right(cSql,4) = ' OR '
    cSql := Substr(cSql,1,Len(cSql)-4)
  ENDIF
ELSEIF nWhich == 2
  cSql := 'SELECT ' + cInto + ' FROM ' + cTable + ' WHERE '
  FOR i := 1 TO Len(aStru)
    IF aStru[i,2] $ 'CM'
      cSql += "Upper(" + aStru[i,1] + ") LIKE '%" + cValue + "%' OR "
    ENDIF
  NEXT
  IF Right(cSql,4) = ' OR '
    cSql := Substr(cSql,1,Len(cSql)-4)
  ENDIF
ENDIF

saStatement[ThreadID()]:setData('Searching.  Please wait...')

nSaveArea := Select()

nFound := Ascan(aTables,{|a|a[1]=='_SEARCH_TABLE'})
IF nFound > 0 .AND. '_SEARCH_TABLE' $ cInto
  cDrop := 'DROP TABLE _SEARCH_TABLE'
  lStatus := ::ExecuteSql( cDrop, '_SEARCH_TABLE', oConnection,,, oDlg,.t.,,,,.t. )
  IF lStatus .AND. !Empty(Alias())
    dbCloseArea()
    ARemove(aTables,nFound)
  ENDIF
ENDIF

dbCloseArea()
oBrowse:filterSqlStatement := cSql

IF cInto == '*'
  lStatus := ::ExecuteSql( cSql, cTable, oConnection, oBrowse,, oDlg,.t.,,,,.t. )
ELSE
  lStatus := ::ExecuteSql( cSql, cTable, oConnection,,, oDlg,.t.,,,,.t. )
  IF !Empty(Alias())
    dbCloseArea()
    SELECT (nSaveArea)
    cSql := 'SELECT * FROM _SEARCH_TABLE'
    lStatus := ::ExecuteSql( cSql, cTable, oConnection, oBrowse,, oDlg,.t. )
  ENDIF
ENDIF

IF lStatus
  saStatement[ThreadID()]:setData(cSql)
  oBrowse:dataSource := Alias()
  oBrowse:refreshAll()
ELSE
  saStatement[ThreadID()]:setData('')
ENDIF

RETURN lStatus

* ------------

METHOD SqlQuery:setWindowPos( oDlg )

LOCAL oTreeWindow

IF Valtype(::oTree) # 'O'
  RETURN .f.
ENDIF

oTreeWindow := ::oTree:parent:parent

IF ::nBrowseWindowPos == WINDOWPOS_CENTERMAIN
   // Do nothing
ELSEIF ::nBrowseWindowPos == WINDOWPOS_ANCHORTREERIGHT
  oDlg:setPos({oTreeWindow:currentPos()[1]+oTreeWindow:currentSize()[1],oTreeWindow:currentPos()[2]})
ELSEIF ::nBrowseWindowPos == WINDOWPOS_ANCHORTREELEFT
  oDlg:setPos({oTreeWindow:currentPos()[1]-oDlg:currentSize()[1],oTreeWindow:currentPos()[2]})
ENDIF

oDlg:show()

RETURN .t.

* ------------

METHOD SqlQuery:copyCellToClipBoard( oBrowse )

LOCAL xValue, cValue, oColumn, oClipBoard

oColumn := oBrowse:getColumn(oBrowse:colPos)

xValue := Eval(oColumn:dataLink)

oClipBoard := XbpClipboard():new():create()
oClipBoard:open()
oClipBoard:clear()
oClipBoard:setBuffer(DC_XtoC(xValue),XBPCLPBRD_TEXT)
oClipBoard:close()
oClipBoard:destroy()

RETURN nil

* ------------

METHOD SqlQuery:CopyRecordsToClipBoard(oBrowse,oRecord,lTagged)

LOCAL i, cAlias := oBrowse:dataSource, nSaveRec, aRecords

oBrowse:RecordClipBoard := {}

IF lTagged
  aRecords := (cAlias)->(DC_RecTagArray())
  IF !Empty(aRecords)
    nSaveRec := (cAlias)->(RecNo())
    FOR i := 1 TO Len(aRecords)
      (cAlias)->(dbGoTo(aRecords[i]))
      (cAlias)->(DC_DbScatter(oRecord))
      AAdd(oBrowse:recordClipBoard,DC_DbRecordClone(oRecord))
    NEXT
    (cAlias)->(dbGoTo(nSaveRec))
  ENDIF
ELSE
  (cAlias)->(DC_DbScatter(oRecord))
  AAdd(oBrowse:recordClipBoard,DC_DbRecordClone(oRecord))
ENDIF

RETURN nil

* ------------

METHOD SqlQuery:PasteRecordsFromClipBoard(oBrowse)

LOCAL i, cAlias := oBrowse:dataSource, oRecord

FOR i := 1 TO Len(oBrowse:RecordClipBoard)
  oRecord := oBrowse:RecordClipBoard[i]
  (cAlias)->(DC_DbGather(oRecord,.t.))
NEXT
oBrowse:refreshAll()

RETURN nil

* ------------

METHOD SqlQuery:setLinkedData( oBrowse, cWhere, aData, oScope, nKeyCount )

LOCAL i, cAlias := oBrowse:dataSource, nSaveRec, nBottomKey, nTopKey, ;
      cFieldName := aData[1], lSetScope := aData[2], xValue := aData[3], ;
      lScope := .f., cTagName, oScrn

IF Empty(oBrowse:IndexTags)
  oBrowse:IndexTags := (cAlias)->(DC_TagInfo())
  DEFAULT oBrowse:IndexTags := {}
ENDIF

(cAlias)->(OrdSetFocus(0))

IF lSetScope
  cTagName := oBrowse:findGoodIndex(Alltrim(Upper(cFieldName)))
  IF !Empty(cTagName)
    (oBrowse:dataSource)->(OrdSetFocus(cTagName))
    lScope := .t.
  ELSE
    DC_Winalert('No Index Available to sort this column')
    RETURN .f.
  ENDIF
ENDIF

oScrn := DC_Waiton('Retrieving records that match ' + DC_Xtoc(xValue) + '...')

IF lScope
  (cAlias)->(DC_SetScope(0,xValue))
  (cAlias)->(DC_SetScope(1,xValue))
  (cAlias)->(dbSeek(xValue))
  nSaveRec := (cAlias)->(RecNo())
  (cAlias)->(dbGoBottom())
  nBottomKey := (cAlias)->(OrdKeyNo())
  (cAlias)->(dbGoTop())
  nTopKey := (cAlias)->(OrdKeyNo())
  IF nTopKey == NIL .OR. nBottomKey == NIL  // bug in ADSDBE when index is empty
    nKeyCount := 0
  ELSE
    nKeyCount := nBottomKey - nTopKey + 1
  ENDIF
  (cAlias)->(dbGoTo(nSaveRec))
  oBrowse:refreshAll()
  oScope:refresh()
ELSE
  oBrowse:setFilter(,cWhere)
ENDIF
DC_Impl(oScrn)

RETURN nil

* ------------

METHOD SqlQuery:SendLinkedMessage(oBrowse,cAlias)

LOCAL i, oXbp, cFromField, cToField, xValue

IF Empty(oBrowse:linkedArray)
  RETURN nil
ENDIF

FOR i := 1 TO Len(oBrowse:linkedArray)
  cFromField := oBrowse:linkedArray[i,5]
  cToField := oBrowse:linkedArray[i,6]

  xValue := (cAlias)->(&cFromField)

  IF Valtype(xValue) == 'C'
    cToField := 'Upper("'+cToField+'") = ' + DC_Var2Sql(Upper(xValue))
  ELSE
    cToField += ' = ' + DC_Var2Sql(xValue)
  ENDIF

  oXbp := oBrowse:linkedArray[i,4]

  PostAppEvent( LINK_MESSAGE,cToField,{oBrowse:linkedArray[i,6],oBrowse:LinkedArray[i,9],xValue},oXbp )
NEXT

RETURN nil

* ---------------

METHOD SqlQuery:TagAction( oBrowse )

LOCAL oColumn

IF oBrowse:isLeftMouseButton
  oColumn := oBrowse:getColumn(oBrowse:colPos)
  oColumn:isTagged := !oColumn:IsTagged
  oBrowse:refreshAll()
ELSEIF Valtype(oBrowse:dataSource) == 'A'
  oBrowse:dataSource[oBrowse:arrayElement,2] := ;
     !oBrowse:dataSource[oBrowse:arrayElement,2]
ELSEIF Valtype(oBrowse:dataSource) == 'C'
  (oBrowse:dataSource)->(DC_RecTagToggle())
ENDIF
oBrowse:refreshCurrent()

RETURN nil

* -------------

METHOD SqlQuery:LinkWindow( oDlg, oBrowse, cAlias, aGetList, oConnection, lSave )

LOCAL GetList[0], GetOptions, oBrow1, oBrow2, aStru1, aStru2, aChildList, ;
      lStatus := .f., i, nPointer1 := 1, nPointer2 := 1, nChoice := 1

DEFAULT lSave := .f.

IF !lSave .AND. !Empty(oBrowse:linkedArray)
  DCMSGBOX 'This window is already linked to another window', ;
           BUTTONS {'Clear this link','Add Another Link', 'Save to SqlQuery Dictionary Views','Cancel'} ;
           FONT ::cMessageFont CHOICE @nChoice OWNER oDlg

  IF nChoice $ {0,4}
    RETURN .f.
  ELSEIF nChoice == 1
    oBrowse:linkedArray := {}
    RETURN .t.
  ELSEIF nChoice == 3
    RETURN ::SaveLinkedView(oDlg,oBrowse,oConnection)
  ENDIF
ELSEIF lSave
  RETURN ::SaveLinkedView(oDlg,oBrowse,oConnection)
ENDIF

IF !Empty(::oBrowseParentDlg)
  DC_GetWhen(aGetList)
  RETURN .f.
ENDIF

::cChildAlias := '<pending>'

aChildList := oDlg:setParent():childList()

FOR i := 1 TO Len(aChildList)
  IF aChildList[i]:isDerivedFrom('XbpDialog') .AND. !(aChildList[i] == oDlg) ;
      .AND. 'BROWSING' $ Upper(aChildList[i]:title)
    lStatus := .t.
    EXIT
  ENDIF
NEXT

IF !lStatus
  DCMSGBOX 'There are no child windows opened to Link to' ;
   FONT ::cMessageFont OWNER oDlg
  RETURN nil
ENDIF

aStru1 := oBrowse:dataStructure
aStru2 := {}

DCUSEREVENT LINK_DIALOG ACTION {||SetAppFocus(oDlg)}

::lChildAliasScope := .f.

@ 0,0 DCSAY 'Click on a Child Window to Link to this Parent Window;' + ;
            'Then choose a field from each list to link.' ;
      SAYSIZE 80,2 SAYWORDBREAK FONT ::cMessageFont

@ 1.5,0 DCCHECKBOX ::lChildAliasScope PROMPT 'Set a SCOPE instead of WHERE' ;
      TOOLTIP 'This will improve performance on large datasets' ;
      OBJECT ::oChildAliasScope

@ 3,0 DCSAY 'Fields from Parent Window (' + cAlias + ')' SAYSIZE 0 ;
   FONT '9.Lucida Console'
@ 4,0 DCBROWSE oBrow1 DATA aStru1 SIZE 50,10 FONT ::cMessageFont ;
   NOHSCROLL FIT CURSORMODE XBPBRW_CURSOR_ROW POINTER nPointer1
DCBROWSECOL ELEMENT 1 HEADER 'Field Name' WIDTH 20 PARENT oBrow1
DCBROWSECOL ELEMENT 2 HEADER 'Type' WIDTH 4 PARENT oBrow1
DCBROWSECOL ELEMENT 3 HEADER 'Len' WIDTH 4 PARENT oBrow1 PICTURE '9999'
DCBROWSECOL ELEMENT 4 HEADER 'Dec' WIDTH 4 PARENT oBrow1 PICTURE '99'

@ 3,48 DCSAY 'Fields from Child Window' SAYSIZE 0
@ DCGUI_ROW, DCGUI_COL + 1 DCSAY {||'(' + ::cChildAlias + ')'} SAYSIZE 15 ;
    OBJECT ::oChildAliasSay FONT '9.Lucida Console' SAYVCENTER
@ 4,48 DCBROWSE oBrow2 DATA aStru2 SIZE 50,10 FONT ::cMessageFont ;
   NOHSCROLL FIT CURSORMODE XBPBRW_CURSOR_ROW POINTER nPointer2 ;
   ITEMMARKED {||aStru2 := oBrow2:dataSource}
DCBROWSECOL ELEMENT 1 HEADER 'Field Name' WIDTH 20 PARENT oBrow2
DCBROWSECOL ELEMENT 2 HEADER 'Type' WIDTH 4 PARENT oBrow2
DCBROWSECOL ELEMENT 3 HEADER 'Len' WIDTH 4 PARENT oBrow2 PICTURE '9999'
DCBROWSECOL ELEMENT 4 HEADER 'Dec' WIDTH 4 PARENT oBrow2 PICTURE '99'

DCGETOPTIONS ;
   NOMINBUTTON ;
   NOMAXBUTTON ;
   NOMOVE ;
   NORESIZE ;
   ALWAYSONTOP ;
   SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT TITLE 'Link this window' OPTIONS GetOptions ;
   ADDBUTTONS ;
   EVAL {|o|o:setParent(oDlg), ;
            o:setPos({0,0}), ;
            o:toFront(), ;
            ::oBrowseParent := oBrowse, ;
            ::oBrowseParentDlg := oDlg, ;
            ::oBrowseChildPick := oBrow2, ;
            DC_GetWhen(aGetList)}

IF !Empty(aStru2) .AND. !Empty(aStru2[nPointer2])
  AAdd(oBrowse:linkedArray,;
    {oDlg, oBrowse, ::oBrowseChildDlg, ::oBrowseChild, ;
     aStru1[nPointer1,1], aStru2[nPointer2,1], cAlias, ::cChildAlias, ::lChildAliasScope, '' })
ENDIF

::oBrowseParent := nil
::oBrowseParentDlg := nil
::oBrowseChild := nil
::oBrowseChildDlg := nil
::oBrowseChildPick := nil
::lChildAliasScope := nil
::cChildAlias := ''
::oChildAliasSay := nil
::oChildAliasScope := nil
::cChildSqlStatement := nil
DC_GetWhen(aGetList)

RETURN nil

* -------------

METHOD SqlQuery:SaveLinkedView( oDlg, oBrowse, oConnection, lSave )

LOCAL oRecord, GetList[0], lStatus, nRow, oTitle, GetOptions, cTitle, ;
      lAddRec, nRecNo

DEFAULT lSave := .t.

IF lSave
  cTitle := 'Save Linked View'
ELSE
  cTitle := 'Linked View Properties'
ENDIF

::openViewsFile()
oRecord := SqlQuery->(DC_DbRecord():new())
IF lSave
  IF !SqlQuery->(dbSeek(Space(10),,'CONNECTION'))
    SqlQuery->(dbGoTo(0))
  ENDIF
ENDIF
SqlQuery->(DC_DbScatter(oRecord))
oRecord:viewtype := VIEWTYPE_SQLSELECT_ONE2MANY

IF lSave

  IF Empty(oBrowse:linkedArray[1,1])
    oBrowse:linkedArray[1,1] := oBrowse:parent:parent
    oBrowse:linkedArray[1,2] := oBrowse
  ENDIF

  IF Empty(oRecord:title) .AND. !Empty(oBrowse:linkedArray[1,10])
    oRecord:title := Pad(oBrowse:linkedArray[1,10],50)
  ENDIF

  IF !Empty(oBrowse:sqlStatementOriginal)
    oRecord:statement := oBrowse:sqlStatementOriginal
  ELSE
    oRecord:statement := DC_ArrayString(oBrowse:pickedFields)
  ENDIF
  IF !Empty(oBrowse:LinkedArray[1,4]:sqlStatementOriginal)
    oRecord:statement1 := oBrowse:LinkedArray[1,4]:sqlStatementOriginal
  ELSE
    oRecord:statement1 := DC_ArrayString(oBrowse:LinkedArray[1,4]:pickedFields)
  ENDIF

  oRecord:FromField1 := oBrowse:LinkedArray[1,5]
  oRecord:ToField1 := oBrowse:LinkedArray[1,6]
  oRecord:alias := oBrowse:LinkedArray[1,7]
  oRecord:alias1 := oBrowse:LinkedArray[1,8]
  oRecord:setScope1 := oBrowse:LinkedArray[1,9]
  oRecord:fromwin := Alltrim(Str(oDlg:currentPos()[1])) + ',' + ;
                     Alltrim(Str(oDlg:currentPos()[2])) + ',' + ;
                     Alltrim(Str(oDlg:currentSize()[1])) + ',' + ;
                     Alltrim(Str(oDlg:currentSize()[2]))
  oRecord:towin1  := Alltrim(Str(oBrowse:LinkedArray[1,3]:currentPos()[1])) + ',' + ;
                     Alltrim(Str(oBrowse:LinkedArray[1,3]:currentPos()[2])) + ',' + ;
                     Alltrim(Str(oBrowse:LinkedArray[1,3]:currentSize()[1])) + ',' + ;
                     Alltrim(Str(oBrowse:LinkedArray[1,3]:currentSize()[2]))

  IF !Empty(oBrowse:linkedArray[1,2]:customColor)
    oRecord:FromColor := DC_ArrayString(oBrowse:linkedArray[1,2]:customColor)
  ENDIF

  IF !Empty(oBrowse:linkedArray[1,4]:customColor)
    oRecord:ToColor1 := DC_ArrayString(oBrowse:linkedArray[1,4]:customColor)
  ENDIF

  IF Len(oBrowse:LinkedArray) > 1
    IF !Empty(oBrowse:LinkedArray[2,4]:sqlStatementOriginal)
      oRecord:statement2 := oBrowse:LinkedArray[2,4]:sqlStatementOriginal
    ELSE
      oRecord:statement2 := DC_ArrayString(oBrowse:LinkedArray[2,4]:pickedFields)
    ENDIF
    oRecord:FromField2 := oBrowse:LinkedArray[2,5]
    oRecord:ToField2 := oBrowse:LinkedArray[2,6]
    oRecord:alias2 := oBrowse:LinkedArray[2,8]
    oRecord:setScope2 := oBrowse:LinkedArray[2,9]
    oRecord:towin2  := Alltrim(Str(oBrowse:LinkedArray[2,3]:currentPos()[1])) + ',' + ;
                       Alltrim(Str(oBrowse:LinkedArray[2,3]:currentPos()[2])) + ',' + ;
                       Alltrim(Str(oBrowse:LinkedArray[2,3]:currentSize()[1])) + ',' + ;
                       Alltrim(Str(oBrowse:LinkedArray[2,3]:currentSize()[2]))

    IF !Empty(oBrowse:linkedArray[2,10])
      oRecord:ToColor1 := DC_ArrayString(oBrowse:linkedArray[2,10])
    ENDIF

  ENDIF
  oRecord:connection := oConnection:groupName
ENDIF

// parent window #1
nRow := 0
@ nRow,0 DCSAY 'Parent Window (1):' FONT '10.Lucida Console Bold' SAYSIZE 0
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY oRecord:alias FONT '10.Lucida Console Bold' ;
   COLOR GRA_CLR_BLUE SAYSIZE 0
nRow++
@ nRow,0 DCSAY 'FROM Field: ' SAYSIZE 0
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY oRecord:FromField1 FONT ::cMessageFont ;
   SAYSIZE 0 COLOR GRA_CLR_BLUE
nRow++
@ nRow,0 DCMULTILINE oRecord:statement FONT ::cMessageFont NOHSCROLL ;
    SIZE 100,6 EDITPROTECT {||.t.}

// child window #1
nRow += 7
@ nRow,0 DCSAY 'Child Window (1):' FONT '10.Lucida Console Bold' SAYSIZE 0
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY oRecord:alias1 FONT '10.Lucida Console Bold' ;
   COLOR GRA_CLR_BLUE SAYSIZE 0
nRow++
@ nRow,0 DCSAY 'TO Field: ' SAYSIZE 0
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY oRecord:ToField1 FONT ::cMessageFont ;
   SAYSIZE 0 COLOR GRA_CLR_BLUE
IF oRecord:setScope1
   @ DCGUI_ROW, DCGUI_COL + 20 DCSAY 'Use SCOPE' SAYSIZE 0 COLOR GRA_CLR_BLUE
ENDIF

nRow++
@ nRow,0 DCMULTILINE oRecord:statement1 FONT ::cMessageFont NOHSCROLL ;
    SIZE 100,6 EDITPROTECT {||.t.}

nRow += 7

BEGIN SEQUENCE

BREAK

// parent window #2
@ nRow,0 DCSAY 'Parent Window (2):' FONT '10.Lucida Console Bold' SAYSIZE 0
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY oRecord:alias FONT '10.Lucida Console Bold' ;
   COLOR GRA_CLR_BLUE SAYSIZE 0
nRow++
@ nRow,0 DCSAY 'FROM Field: ' SAYSIZE 0
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY oRecord:FromField2 FONT ::cMessageFont ;
   SAYSIZE 0 COLOR GRA_CLR_BLUE

// child window #2
nRow += 2
@ nRow,0 DCSAY 'Child Window (2):' FONT '10.Lucida Console Bold' SAYSIZE 0
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY oRecord:alias2 FONT '10.Lucida Console Bold' ;
   COLOR GRA_CLR_BLUE SAYSIZE 0
nRow++
@ nRow,0 DCSAY 'TO Field: ' SAYSIZE 0
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY oRecord:ToField2 FONT ::cMessageFont ;
   SAYSIZE 0 COLOR GRA_CLR_BLUE
IF oRecord:setScope2
   @ DCGUI_ROW, DCGUI_COL + 20 DCSAY 'Use SCOPE' SAYSIZE 0 COLOR GRA_CLR_BLUE
ENDIF

nRow++
@ nRow,0 DCMULTILINE oRecord:statement2 FONT ::cMessageFont NOHSCROLL ;
    SIZE 100,6 EDITPROTECT {||.t.}

nRow += 7
END SEQUENCE

@ nRow,0 DCSAY 'Title' GET oRecord:title ;
   VALID {||::ValidateScriptTitle(oRecord:title,oConnection,@nRecNo)} ;
   SAYSIZE 0 SAYBOTTOM GETOBJECT oTitle

DCGETOPTIONS ;
   EDITPROTECT {||!lSave} ;
   NOMINBUTTON ;
   NOMAXBUTTON;
   NORESIZE

DCREAD GUI FIT ADDBUTTONS TO lStatus MODAL SETAPPWINDOW ;
   SETFOCUS oTitle OPTIONS GetOptions TITLE cTitle NOAUTORESTORE ;
   EVAL {|o|::SetWindowPos(o)}

IF lStatus .AND. lSave
  IF !Empty(nRecNo)
    SqlQuery->(dbGoTo(nRecNo))
    lAddRec := .f.
  ELSE
    lAddRec := !(SqlQuery->(dbSeek(Space(10),,'CONNECTION')))
  ENDIF
  SQLQUERY->(DC_DbGather(oRecord,lAddRec))
  DCMSGBOX 'Script has been saved' FONT ::cMessageFont OWNER AppDeskTop()
  ::reloadScripts( oConnection,{0,1,2,3} )
ELSE
  SQLQUERY->(dbCloseArea())
ENDIF

RETURN nil

* -------------

METHOD Sqlquery:ObjectBrowse( cAlias, oConnection )

LOCAL GetList[0], GetOptions, oBrowse, bGetSet, oSession, ;
      aFields, i, cCellContents := '', bGetCell, ;
      cHeader, nWidth, oCellContents, bColumn, bEditRecord, ;
      aObjects[0], oRecord, aStru, cClassName, oScrn, oDlg

cAlias := Alias()

aFields := dbStruct()

cClassName := 'DATA_' + Alltrim(Str(Seconds(),5))

oScrn := DC_WaitOn('Building Object Browse. Please wait...')
DO WHILE !(cAlias)->(Eof())
  oRecord := (cAlias)->(DC_DbRecord(cClassName):new())
  (cAlias)->(DC_DbScatter(oRecord))
  AAdd(aObjects,{oRecord,.f.})
  (cAlias)->(dbSkip())
ENDDO
DC_Impl(oScrn)

@ 0,0 DCPUSHBUTTON CAPTION 'Print' SIZE 10,1 ;
      ACTION {||oBrowse:PrintBrowse()} ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Export' SIZE 10,1 ;
      ACTION {||::Browse2Export(oBrowse,oDlg,oConnection)} ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
      TOOLTIP 'Export this view to Excel or Database'

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON ;
      CAPTION {||IIF(Valtype(oBrowse)=='O' .AND. oBrowse:isCollapsed,'Restore','Collapse')} SIZE 10,1 ;
      ACTION {|a,b,o|IIF(oBrowse:isCollapsed,oBrowse:restoreAll(oDlg),oBrowse:collapseAll(oDlg)),o:refresh()} ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
      TOOLTIP 'Collapse or Restore Columns'

@ DCGUI_ROW, DCGUI_COL + 25 DCSAY 'Rows:' COLOR GRA_CLR_BLUE FONT ::cMessageFont;
       SAYSIZE 0 RESIZE DCGUI_RESIZE_REPOSONLY_Y

bGetSet := {|o|o:=oBrowse,IIF(Valtype(o)=='O',Alltrim(DC_XtoC(o:displayedRows())),'0')}

@ DCGUI_ROW, DCGUI_COL + 15 DCSAY bGetSet FONT '12.Lucida Console' ;
       SAYSIZE 20 RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
       OBJECT saRowCount[ThreadID()]

@ DCGUI_ROW, DCGUI_COL + 10 ;
   DCSAY 'Left click header to SORT. Right click header for FILTER.;' + ;
         ' SPACE to Tag/Untag.  ENTER to EDIT.  Alt-D for DOT prompt.' ;
       SAYSIZE 50,1.5 SAYWORDBREAK RESIZE DCGUI_RESIZE_REPOSONLY_Y

bGetCell := {|x,o,cDate,cTime|o := oBrowse:getColumn(oBrowse:colPos), ;
                x := Eval(o:dataLink), ;
                x := IIF(o:isDateField,::UnixTime2DateTime(x),DC_XtoC(x)), ;
                IIF(Valtype(oCellContents)=='O',oCellContents:setData(x),nil)}

bEditRecord := {||::EditRecord( aObjects[oBrowse:arrayElement,1], aFields, cAlias, oConnection, oBrowse, .f. )}

DCHOTKEY xbeK_SPACE ACTION {||::TagAction(oBrowse)}  ;
   WHEN {||SetAppFocus() == oBrowse}

DCHOTKEY xbeK_ENTER ACTION bEditRecord

@ 1,0 DCBROWSE oBrowse DATA aObjects SIZE 120, 20 ;
      FONT '11.Arial' ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      SUBCLASS 'DD_XbpBrowseFiltered()' ;
      PRESENTATION ::aBrowPres ;
      HEADPRES {{ XBP_PP_COMPOUNDNAME, '9.Lucida Console' }};
      FOOTPRES {{ XBP_PP_COMPOUNDNAME, '9.Lucida Console Bold' }};
      RBSELECT;
      SORTCONFIG ::oSortConfig;
      SCROLLBARHEIGHT 12;
      CURSORMODE XBPBRW_CURSOR_CELL ;
      ITEMSELECTED bEditRecord ;
      ITEMMARKED bGetCell ;
      CARGO {} ;
      ZEBRA ::aOddColorRow, ::aEvenColorRow ;
      EVAL {|o|o:columnTagColor := {|a,oColumn|ObjectColor(oBrowse,oColumn,.f.,self)}} ;
      CACHECOLUMNS 20

aStru := (cAlias)->(dbStruct())

bColumn := {|o|o:dataArea:lbDown := {|a,b,o|o:parent:parent:isLeftMouseButton := .t.}, ;
               o:dataArea:lbUp := {|a,b,o|o:parent:parent:isLeftMouseButton := .f.} }

FOR i := 1 TO Len(aStru)

  cHeader := aStru[i,1]
  nWidth := aStru[i,3]
  IF nWidth > 10
    nWidth := 10
  ELSEIF nWidth < Len(cHeader)
    nWidth := Len(cHeader)/1.5
  ENDIF

  DCBROWSECOL OBJECTVAR (aStru[i,1]) ;
    ELEMENT 1 ;
    HEADER cHeader TOOLTIP cHeader WIDTH nWidth PARENT oBrowse ;
    SORT _SortBlock(aStru[i,1],aObjects) LEFTBUTTON _DEFAULT i==1 ;
    SUBCLASS 'DD_XbpColumnFiltered()' ;
    EVAL bColumn ;
    CARGO aStru[i] ;

NEXT

@ 21,0 DCSAY 'Cell Contents:' SAYSIZE 0

@ 22,0 DCMULTILINE cCellContents OBJECT oCellContents ;
   SIZE 105,5 NOHSCROLL FONT ::cMessageFont ;
   RESIZE DCGUI_RESIZE_RESIZEONLY_X

@ 22, 107 DCTOOLBAR ::oToolBar VERTICAL SIZE 12,5 BUTTONSIZE 12,1.1 ;
     RESIZE DCGUI_RESIZE_REPOSONLY_X

DCADDBUTTON CAPTION 'Reset' PARENT ::oToolBar ;
   ACTION {||::ResetFilter(oBrowse,cAlias,oConnection,.f.)}

DCADDBUTTON CAPTION 'SQL Query' PARENT ::oToolBar ;
   ACTION {||ShowSQLWindow(oConnection:sqlStatement)} ;
   TOOLTIP 'View the SQL Statement for this Data Set'

DCADDBUTTON CAPTION 'Save' PARENT ::oToolBar ;
   ACTION {||::SaveSQLScript( oConnection:sqlStatement, oConnection, oDlg )} ;
   TOOLTIP 'Save this view to View catalog'

/*
IF Len(aStru) > 20
  DCADDBUTTON CAPTION 'More Cols' PARENT ::oToolBar ;
    TOOLTIP 'Add More Columns to the Browse' ;
    ACTION {||oBrowse:ChooseCachedColumn(GetList)}
ENDIF
*/

DCGETOPTIONS RESIZE ;
   BUSYMESSAGE 'Building Browse. Please wait..' ;
     COLOR GRA_CLR_DARKGREEN ;
   SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT OPTIONS GetOptions ;
   TITLE 'Browsing Objects: ' + Alias() ;
   EVAL {|oDlg|saRowCount[ThreadId()]:refresh(), ;
               oDlg:connection := oConnection, ;
               ::SetWindowPos(oDlg)} ;
   NOAUTORESTORE PARENT @oDlg ;
   APPWINDOW ::oBrowseParentWindow ;

saStatement[ThreadID()] := nil
saRowCount[ThreadID()] := nil

RETURN nil

* -----------

STATIC FUNCTION ObjectColor( oBrowse, oColumn, lDatabase, self )

LOCAL aColor, aObjects := oBrowse:dataSource, aRowColor

IF lDatabase .AND. (aObjects)->(Deleted())
  aColor := {GRA_CLR_YELLOW,GRA_CLR_RED}
ELSEIF lDatabase .AND. (aObjects)->(DC_Tagged())
  aColor := {GRA_CLR_BLACK,GRA_CLR_YELLOW}
ELSEIF !lDatabase .AND. aObjects[oBrowse:arrayElement,2]
  aColor := {GRA_CLR_BLACK,GRA_CLR_YELLOW}
ELSEIF oColumn:isTagged
  IF oBrowse:evenRow
    aColor := ::aOddColorCol
  ELSE
    aColor := ::aEvenColorCol
  ENDIF
ELSEIF !Empty(aColor := oBrowse:customColor)
  IF oBrowse:evenRow
    aColor := oBrowse:customColor[1]
  ELSE
    aColor := oBrowse:customColor[2]
  ENDIF
ENDIF

RETURN aColor

* -----------

STATIC FUNCTION _SortBlock( cFieldName, aObjects )

RETURN {||ASort(aObjects,,,{|a,b|a[1]:&cFieldName<b[1]:&cFieldName})}

* -------------

STATIC FUNCTION StruArrayBlock(aStru)

RETURN {|o|o:struArray := aStru}

* -------------

METHOD Sqlquery:EditRecord( oRecord, aFields, cAlias, oConnection, oBrowse, lCursor )

LOCAL GetList[0], nRow := 0, nCol := 0, i, lStatus, nGetSize, ;
      GetOptions, aButtons[0], nMode := 0, nColSize := 50, lUseTabs := .t., ;
      aTabs[0], nTab, nColumns := 2, nSaySize, lUpdate := .t., lInsert := .t., ;
      oAdsStatement, cFieldName, oSession, oOwner := oBrowse:parent:parent, ;
      oButtonConfig, aTabFields[0]

BEGIN SEQUENCE

oSession := oConnection:sessionDict
IF Empty(oSession)
  oSession := oConnection:sessionFree
ENDIF

oAdsStatement := saAdsStatement[ThreadID()]

IF lCursor
  (cAlias)->(DC_DbScatter(oRecord))
ENDIF

IF Valtype(oAdsStatement) == 'O'
  lUpdate := oAdsStatement:isUpdate
  lInsert := oAdsStatement:isInsert
ENDIF

nColSize := 60

nTab := 0
nRow := 0
nCol := 0

nSaySize := 0
FOR i := 1 TO Len(aFields)
  aSize(aFields[i],9)
  cFieldName := aFields[i,1]
  aFields[i,8] := ''
  aFields[i,7] := Len(DC_XtoC(oRecord:&(cFieldName)))
  IF aFields[i,2] $ 'Q'
    oRecord:&(cFieldName) := Pad(oRecord:&(cFieldName),aFields[i,3])
  ELSEIF aFields[i,2] $ 'L'
    aFields[i,8] := 'Y'
  ELSEIF aFields[i,2] == 'M' .AND. oRecord:&(cFieldName) == nil
    oRecord:&(cFieldName) := ''
  ELSEIF aFields[i,2] $ 'NI'
    aFields[i,8] := Repl('9',aFields[i,3])
    IF aFields[i,4] > 0
      aFields[i,8] += '.' + Repl('9',aFields[i,4])
    ENDIF
  ELSEIF aFields[i,2] = 'D'
    aFields[i,9] := {|d|DC_PopDate(d,,,,,,2)}
  ELSEIF aFields[i,2] == 'M' .AND. aFields[i,3] = 10
    aFields[i,9] := _PopMemoBlock(aFields[i])
  ENDIF
  nSaySize := Max(nSaySize,DC_GraQueryTextBox(cFieldName,'8.Arial')[1])
NEXT
nSaySize *= 1.1
nSaySize /= 7

nColSize := 60 + nSaySize

IF Len(aFields) > 35
  nColumns := 2
ELSE
  nColumns := 1
ENDIF

FOR i := 1 TO Len(aFields)

  cFieldName := aFields[i,1]
  IF nRow == 0 .AND. nCol == 0
    nTab++
    ASize( aTabs, nTab )
    ASize( aTabFields,nTab)
    aTabFields[nTab] := {}
    IF lUseTabs
      IF nTab == 1
        @ 0,0 DCTABPAGE aTabs[nTab] SIZE (nColSize+20)*nColumns, 38 CAPTION 'Page ' + Alltrim(Str(nTab)) ;
          TABWIDTH 10 CARGO nTab
      ELSE
        @ 0,0 DCTABPAGE aTabs[nTab] RELATIVE aTabs[nTab-1] CAPTION 'Page ' + Alltrim(Str(nTab)) ;
          TABWIDTH 10 CARGO nTab GOTFOCUS {|a,b,o|BuildEditRecordPage(o,GetList,aTabFields,oRecord)}
      ENDIF
    ENDIF
    nRow := 2
    nCol := 2
  ENDIF
  nGetSize := aFields[i,3]

  IF nGetSize > nColSize - nSaySize + 5
    nGetSize := nColSize - nSaySize + 5
  ELSEIF nGetSize > nColSize - 10
    nGetSize := nColSize - 10
  ELSEIF aFields[i,2] = 'M' .AND. (oConnection:type ='ADS' .OR. Empty(oConnection:type))
    aFields[i,9] := _PopMemoBlock(aFields[i])
    nGetSize := 50 // nGetSize
  ELSE
    nGetSize := nil
  ENDIF

  IF nTab == 1
    @ nRow, nCol DCSAY aFields[i,1] SAYSIZE nSaySize SAYRIGHTBOTTOM PARENT aTabs[nTab]
    @ DCGUI_ROW, DCGUI_COL + 10 DCGET oRecord:&(cFieldName) SIZE nGetSize ;
         PARENT aTabs[nTab] PICTURE aFields[i,8] POPUP aFields[i,9] CARGO cFieldName
  ENDIF
  AAdd(aTabFields[nTab],{nRow,nCol,nSaySize,cFieldName,nGetSize,aFields[i,8],aFields[i,9]})
  nRow ++
  IF nRow > 35
    nCol += nColSize + 10
    IF nCol > (nColSize*(nColumns))
      nCol := 0
      nRow := 0
    ELSE
      nRow := 2
    ENDIF
  ENDIF

NEXT

oButtonConfig := DC_XbpPushButtonXPConfig():new()
oButtonConfig:mouseOverScale := 1.1
oButtonConfig:font := '10.Lucida Console'
oButtonConfig:mouseOverFont := '12.Lucida Console'
oButtonConfig:fgColorMouse := GRA_CLR_BLACK
oButtonConfig:gradientStep := 3
oButtonConfig:bgColor := GRA_CLR_WHITE

IF lUpdate .OR. (IsMemberVar(oRecord,'UUID') .AND. !Empty(oRecord:uuid))
  AAdd( aButtons, { 'Update Record', 130, 22, {||nMode := 1, DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}})
ENDIF
IF lInsert .OR. (IsMemberVar(oRecord,'UUID'))
  AAdd( aButtons, { 'Add New Record', 130, 22, {||nMode := 2, DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}})
ENDIF
AAdd( aButtons, { IIF(lUpdate .OR. lInsert,'Cancel','OK'), 100, 22, {||nMode = 0, DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)}})

AAdd( aButtons, { '<<', 50, 22, {||EditNavigate(oBrowse,oRecord,1,GetList)},,,oButtonConfig } )
AAdd( aButtons, {  '<', 50, 22, {||EditNavigate(oBrowse,oRecord,2,GetList)},,,oButtonConfig } )
AAdd( aButtons, {  '>', 50, 22, {||EditNavigate(oBrowse,oRecord,3,GetList)},,,oButtonConfig } )
AAdd( aButtons, { '>>', 50, 22, {||EditNavigate(oBrowse,oRecord,4,GetList)},,,oButtonConfig } )

DCGETOPTIONS COLOR GRA_CLR_WHITE NORESIZE BUTTONS aButtons ;
   SCALEFACTOR ::aScaleFactor SAYFONT '8.Arial'

DCREAD GUI FIT ;
   TITLE cAlias + ' - Editing Record ' + Alltrim(Str((cAlias)->(Recno()))) + ' [ ' + oConnection:name + ' ]' ;
   MODAL SETAPPWINDOW TO lStatus NOAUTORESTORE ;
   OPTIONS GetOptions ;
   EVAL {|o|::SetWindowPos(o)} ;
   OWNER oOwner

IF lStatus
  (cAlias)->(DC_DbGather(oRecord,nMode == 2,,,,oSession))
  oBrowse:refreshAll()
ENDIF

END SEQUENCE

RETURN lStatus

* -------------

STATIC FUNCTION BuildEditRecordPage( oTabPage, aGetList, aTabFields, oRecord )

LOCAL GetList[0], nTab := DC_GetCargo(oTabPage), i, nRow, nCol, nSaySize, ;
      cFieldName, nGetSize, cPicture, bPopup, aFields

IF !Empty(oTabPage:childList())
  RETURN nil
ENDIF

aFields := aTabFields[nTab]

FOR i := 1 TO Len(aFields)
  nRow := aFields[i,1]
  nCol := aFields[i,2]
  nSaySize := aFields[i,3]
  cFieldName := aFields[i,4]
  nGetSize := aFields[i,5]
  cPicture := aFields[i,6]
  bPopup := aFields[i,7]

  @ nRow, nCol DCSAY cFieldName SAYSIZE nSaySize SAYRIGHTBOTTOM PARENT oTabPage FONT '8.Arial'
  @ DCGUI_ROW, DCGUI_COL + 10 DCGET oRecord:&(cFieldName) SIZE nGetSize ;
         PARENT oTabPage PICTURE cPicture POPUP bPopup
NEXT

DCREAD GUI PARENT oTabPage EXIT

DC_MergeGetLists(aGetList,GetList)

RETURN nil

* -------------

STATIC FUNCTION EditNavigate( oBrowse, oRecord, nWhich, aGetList )

IF nWhich == 1
  oBrowse:goTop()
ELSEIF nWhich == 2
  oBrowse:up()
ELSEIF nWhich == 3
  oBrowse:down()
ELSEIF nWhich == 4
  oBrowse:goBottom()
ENDIF
oBrowse:forceStable()
oBrowse:refreshAll()

(oBrowse:dataSource)->(DC_DbScatter(oRecord))
DC_GetRefresh(aGetList)

RETURN nil

* -------------

STATIC FUNCTION _PopMemoBlock( aField )

RETURN {|c,o|c:=_PopMemo(c,aField[1]),o:bufferLength := Len(c), c}

* -------------

STATIC FUNCTION _PopMemo( cMemo, cFieldName )

LOCAL GetList[0], GetOptions

@ 0,0 DCMULTILINE cMemo SIZE 80,20 NOHSCROLL FONT '10.Lucida Console'

DCGETOPTIONS RESIZE RESIZEDEFAULT DCGUI_RESIZE_RESIZEONLY

DCREAD GUI FIT ADDBUTTONS MODAL OPTIONS GetOptions ;
   TITLE 'Editing Field: ' + cFieldName

RETURN cMemo

* -------------

METHOD SqlQuery:reExecuteSql( oBrowse, cAlias, oConnection, nBrowseType, lNewThread, oOwner )

LOCAL cStatement := saStatement[ThreadID()]:getData(), bExecute

DEFAULT lNewThread := .t.

bExecute := {||::ExecuteSql( cStatement, cAlias, oConnection, oBrowse, nBrowseType, oOwner,.t. )}

IF lNewThread
  GuiRun(bExecute)
ELSE
  Eval(bExecute)
ENDIF

RETURN nil

* -------------

METHOD SqlQuery:resetFilter( oBrowse, cAlias, oConnection, lDataBrowse )

LOCAL cStatement := oBrowse:sqlStatementOriginal, oColumn, i, aData, lSql

FOR i := 1 TO oBrowse:colCount
  oColumn := oBrowse:getColumn(i)
  IF oColumn:isDerivedFrom('DC_XbpColumnFiltered')
    oColumn:resetFilter()
  ENDIF
NEXT

lSql := !Empty(oBrowse:sqlSessionDict) .OR. !Empty(oBrowse:sqlSessionFree)

IF lDataBrowse
  IF lSql
    oConnection:sqlStatement := cStatement
    oBrowse:filterSqlStatement := ''
    (cAlias)->(DC_RecTagClear())
    saStatement[ThreadID()]:refresh()
    RETURN ::ExecuteSql( cStatement, cAlias, oConnection, oBrowse )
  ELSE
    (oBrowse:dataSource)->(DC_ClrScope())
    (oBrowse:dataSource)->(dbClearFilter())
    oBrowse:filterExpression := ''
  ENDIF
  oBrowse:displayedRows := -1
ELSE
  aData := oBrowse:dataSource
  FOR i := 1 TO Len(aData)
    aData[i,2] := .f.
  NEXT
  oBrowse:displayedRows := Len(oBrowse:dataSource)
ENDIF

oBrowse:goTop()
oBrowse:forceStable()
oBrowse:refreshAll()
oBrowse:refresh()
saRowCount[ThreadId()]:refresh()
saStatement[ThreadID()]:refresh()

RETURN .t.

* -------------

METHOD Sqlquery:UnixTime2DateTime(nUnixTime)

LOCAL aData := DC_UnixTime2DateTime(nUnixTime)

RETURN DC_XtoC(aData[1]) + ' ' + aData[2]

* ---------------

FUNCTION GuiRun( bBlock )

LOCAL oThread

oThread := Thread():new()
oThread:atEnd := {||dbCloseAll()}
oThread:start( {||_GuiRun(bBlock)} )

RETURN .t.

* ----------------

STATIC FUNCTION _GuiRun( bBlock )

Set(_SET_NULLVALUE,.f.)
DbSetNullValue(.f.)

BEGIN SEQUENCE

Eval( bBlock )

END SEQUENCE

dbCloseAll()

RETURN nil

* ------------------

METHOD SqlQuery:TableProperties( aData, oConnection, oTreeItem )

LOCAL GetList[0], GetOptions, oBrowse1, oBrowse2, aFields[0], aIndexTags[0], ;
      cTableName := aData[2,1], aProperties, nProperty, xValue, nColor, nLen, ;
      nError, oTab1, oTab2, oTab3, i, nRow, oReindexButton, oDlg, ;
      nTagElement := 6

IF Valtype(aData[2,2]) == 'A' .AND. !Empty(aData[2,2])
  IF aData[1] $ {'Index File','Table'}
    aIndexTags := aData[2,2,1,2]
  ENDIF
ELSEIF oConnection:type = 'ODBC'
  aIndexTags := ::BuildIndexArrayODBC( cTableName, oConnection, oTreeItem )
ELSEIF oConnection:type = 'ADS'
  aIndexTags := ::BuildIndexArrayADS( cTableName, oConnection, oTreeItem )
ENDIF

IF Valtype(aData[2,3]) == 'A' .AND. !Empty(aData[2,3])
  IF aData[1] $ {'Fields','Table'}
    aFields := aData[2,3]
  ENDIF
ELSEIF oConnection:type = 'ADS'
  aFields := ::GetFieldNameArrayADS( cTableName, oConnection:handleDict )
  aData[2,3] := aFields
ENDIF

ASort(aFields,,,{|a,b|a[1]<b[1]})

IF !Empty(aFields)

  IF Len(aFields[1]) < 6
    nTagElement := Len(aFields[1]) + 1
    FOR i := 1 TO Len(aFields)
      AAdd(aFields[i],.f.)
    NEXT
  ENDIF

  @ 0,0 DCTABPAGE oTab1 SIZE 100,30 CAPTION 'Fields'

  @ 2,2 DCSAY 'Press SPACE BAR to Tag/Untag' PARENT oTab1 FONT '9.Lucida Console' ;
        SAYSIZE 0 RESIZE DCGUI_RESIZE_REPOSONLY_Y ;

  @ 3,2 DCSAY 'Fields:' SAYSIZE 0 FONT '9.Lucida Console Bold' ;
        PARENT oTab1 SAYBOTTOM RESIZE DCGUI_RESIZE_REPOSONLY_Y ;

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Add Field(s) to File' SIZE 18,1.2 ;
        ACTION {|a,b,o|::AddFieldSql(cTableName,oBrowse1,oConnection,oDlg,nTagElement)} ;
        PARENT oTab1 RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
        TOOLTIP 'Add a field to the file'

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Alter TAGGED Fields' SIZE 18,1.2 ;
        ACTION {|a,b,o|::AlterFieldSql(cTableName,oBrowse1,oConnection,oDlg,nTagElement)} ;
        PARENT oTab1  RESIZE DCGUI_RESIZE_REPOSONLY_Y

  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Delete TAGGED Fields' SIZE 18,1.2 ;
        ACTION {|a,b,o|::DropFieldSql(cTableName,oBrowse1,oConnection,oDlg,nTagElement)} ;
        PARENT oTab1 RESIZE DCGUI_RESIZE_REPOSONLY_Y

  DCHOTKEY xbeK_SPACE ;
      ACTION {||aFields[oBrowse1:arrayElement,nTagElement] := ;
                !aFields[oBrowse1:arrayElement,nTagElement], ;
                oBrowse1:refreshCurrent(), ;
                oBrowse1:down(), ;
                oBrowse1:forceStable()} ;
      WHEN {||SetAppFocus()==oBrowse1}

  @ 4.5,2 DCBROWSE oBrowse1 DATA aFields SIZE 55,24 FIT ;
      FONT '9.Lucida Console' ;
      HEADLINES 2 ;
      NOHSCROLL ;
      PARENT oTab1 ;
      SORTCONFIG ::oSortConfig ;
      CURSORMODE XBPBRW_CURSOR_ROW ;
      COLOR {||IIF(aFields[oBrowse1:arrayElement,nTagElement],{nil,GRA_CLR_YELLOW},{nil,nil})}

  DCBROWSECOL ELEMENT 1 HEADER 'Field;Name' WIDTH 22 PARENT oBrowse1 ;
     SORT {||ASort(aFields,,,{|a,b|a[1]<b[1]})}

  DCBROWSECOL ELEMENT 2 HEADER 'Field;Type' WIDTH 10 PARENT oBrowse1 ;
     SORT {||ASort(aFields,,,{|a,b|a[2]<b[2]})}

  DCBROWSECOL ELEMENT 3 HEADER 'Field;Len' WIDTH 10 PARENT oBrowse1 PICTURE '99999' ;
     SORT {||ASort(aFields,,,{|a,b|a[3]<b[3]})}

  DCBROWSECOL ELEMENT 4 HEADER 'Field;Dec' WIDTH 10 PARENT oBrowse1 PICTURE '99999' ;
     SORT {||ASort(aFields,,,{|a,b|a[4]<b[4]})}

  IF nTagElement == 6
    DCBROWSECOL ELEMENT 5 HEADER 'Field;Pos' WIDTH 10 PARENT oBrowse1 PICTURE '99999' ;
       SORT {||ASort(aFields,,,{|a,b|a[5]<b[5]})}
  ENDIF

ENDIF

@ 0,0 DCTABPAGE oTab2 RELATIVE oTab1 CAPTION 'Indexes' SIZE 100, 30

@ 2,2 DCSAY 'Index Tags:' SAYSIZE 0 FONT '9.Lucida Console Bold' ;
      PARENT oTab2 SAYBOTTOM

IF oConnection:type = 'ADS'
  @ DCGUI_ROW, DCGUI_COL + 20 DCPUSHBUTTON CAPTION 'Rebuild Index File' SIZE 21,1.2 ;
      ACTION {||::BuildAdsIndexSql(cTableName,aIndexTags,oConnection)} PARENT oTab2 ;
      OBJECT oReindexButton  RESIZE DCGUI_RESIZE_REPOSONLY_Y
ENDIF

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Add an Index to File' SIZE 21,1.2 ;
      ACTION {|a,b,o|o:disable(), IIF(Valtype(oReindexButton)=='O',oReindexButton:disable(),nil), ;
                     IIF(oConnection:type='ADS', ;
                        ::AddAdsIndexSql(cTableName,oBrowse2, oConnection,oDlg), ;
                        ::AddODBCIndexSql(cTableName,oBrowse2, oConnection,oDlg)), ;
                         o:enable(),IIF(Valtype(oReindexButton)=='O',oReindexButton:enable(),nil)} ;
      PARENT oTab2 RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Delete Selected Index' SIZE 21,1.2 ;
      ACTION {|a,b,o|::DropAdsIndexSql(cTableName,oBrowse2,oConnection,oDlg)} ;
      PARENT oTab2 RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ 3.5, 2 DCBROWSE oBrowse2 DATA aIndexTags SIZE 95,20 ;
    FONT '9.Lucida Console' ;
    NOHSCROLL PARENT oTab2 ;
    CURSORMODE XBPBRW_CURSOR_ROW

DCBROWSECOL ELEMENT 1 HEADER 'Tag Name' WIDTH 20 PARENT oBrowse2
DCBROWSECOL ELEMENT 2 HEADER 'Index Key' WIDTH 40 PARENT oBrowse2 ;
   DATATOOLTIP {||.t.}
DCBROWSECOL ELEMENT 3 HEADER 'For' WIDTH 35 PARENT oBrowse2 ;
   DATATOOLTIP {||.t.}

IF oConnection:handleDict > 0

  @ 0,0 DCTABPAGE oTab3 RELATIVE oTab2 CAPTION 'Properties'

  aProperties := { ;
   { ADS_DD_COMMENT, Space(200), 200, 'Comment' }, ;
   { ADS_DD_USER_DEFINED_PROP, Space(200), 200, 'User Defined Table Property'}, ;
   { ADS_DD_TABLE_VALIDATION_EXPR, Space(200), 200, 'Record Level Validation Expression'}, ;
   { ADS_DD_TABLE_VALIDATION_MSG, Space(200), 200, 'Table Validation Error Message'}, ;
   { ADS_DD_TABLE_PRIMARY_KEY, Space(200), 200, 'Table Primary Key'}, ;
   { ADS_DD_TABLE_TYPE, 2, 2, 'Type of Base Table'}, ;
   { ADS_DD_TABLE_FIELD_COUNT, 100, 100, 'Field Count'}, ;
   { ADS_DD_TABLE_ENCRYPTION, 2, 2, 'Encryption State'}, ;
   { ADS_DD_TABLE_DEFAULT_INDEX, Space(200), 200, 'Default Index'}, ;
   { ADS_DD_TABLE_IS_RI_PARENT, 2, 2, 'Is Referential Integrity Rule?'}, ;
   { ADS_DD_TABLE_AUTO_CREATE, 2, 2, 'Is Auto Created?'}, ;
   { ADS_DD_TABLE_PERMISSION_LEVEL, 2, 2, 'Table Permission Level'}, ;
   { ADS_DD_TABLE_MEMO_BLOCK_SIZE, 2, 2, 'Memo Block Size'} }

  nRow := 2

  FOR i := 1 TO Len(aProperties)

    ASize(aProperties[i],7)
    nProperty := aProperties[i,1]
    xValue := aProperties[i,2]
    nLen := aProperties[i,3]

    nError := AdsDDGetTableProperty( oConnection:handleDict, ;
                         cTableName, ;
                         nProperty, ;
                         @xValue, ;
                         @nLen )

    IF Valtype(xValue) = 'C'
      xValue := Strtran(xValue,Chr(0),'')
    ENDIF
    aProperties[i,5] := xValue
    aProperties[i,6] := nError
    aProperties[i,7] := AllTrim(DC_AdsGetLastError())

    IF nError == 0 .OR. !Empty(oTreeItem)
      nColor := GRA_CLR_WHITE
    ELSE
      nColor := GRA_CLR_PALEGRAY
    ENDIF

    @ nRow++, 5 DCSAY aProperties[i,4] + ':' SAYSIZE 0 SAYBOTTOM PARENT oTab3
    @ nRow++, 5 DCGET aProperties[i,5] GETSIZE IIF(aProperties[i,3]> 80,50,nil) ;
                TOOLTIP aProperties[i,7] COLOR nil, nColor PARENT oTab3

  NEXT

ENDIF

DCGETOPTIONS RESIZE ;
   RESIZEDEFAULT DCGUI_RESIZE_RESIZEONLY_Y ;
   SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT TITLE 'Properties (' + cTableName + ')' ;
   OPTIONS GetOptions NOAUTORESTORE PARENT @oDlg ;
   EVAL {|o|::SetWindowPos(o),o:connection := oConnection}

RETURN nil

* -----------

METHOD SqlQuery:AddAdsIndexSQL( cTableName, oBrowse, oConnection, oOwner )

LOCAL GetList[0], aIndexTags, GetOptions, lStatus

aIndexTags := {Space(10),Space(100),Space(100),.f.,.f.}

@ 0,0 DCSAY 'Table Name: ' + cTableName SAYSIZE 0 FONT ::cMessageFont
@ 2,0 DCSAY 'Tag Name' GET aIndexTags[1]
@ 3,0 DCSAY 'Expression' GET aIndexTags[2]
@ 4,0 DCSAY 'For Condition' GET aIndexTags[3]
@ 5,0 DCCHECKBOX aIndexTags[4] PROMPT 'Unique'
@ 6,0 DCCHECKBOX aIndexTags[5] PROMPT 'Descending'

DCGETOPTIONS SAYWIDTH 120 SAYRIGHTBOTTOM NORESIZE NOMINBUTTON ;
   SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT ADDBUTTONS TITLE 'Add new Index' ;
   TO lStatus OPTIONS GetOptions NOAUTORESTORE OWNER oOwner

IF lStatus
  lStatus := ::BuildAdsIndexSQL( cTableName, {aIndexTags}, oConnection, 3 )
  IF lStatus
    AAdd( oBrowse:dataSource, aIndexTags )
    oBrowse:refreshAll()
  ENDIF
ENDIF

RETURN lStatus

* -----------

METHOD SqlQuery:AddODBCIndexSQL( cTableName, oBrowse, oConnection, oOwner )

LOCAL i, GetList[0], cIndexName, GetOptions, lStatus, aColumns, aIndexTags

aColumns := {Space(25),Space(25),Space(25),Space(25)}
cIndexName := Space(30)

@ 0,0 DCSAY 'Table Name: ' + cTableName SAYSIZE 0 FONT ::cMessageFont
@ 2,0 DCSAY 'Index Name' GET cIndexName SAYSIZE 10 SAYRIGHTBOTTOM
@ 4,0 DCSAY 'Columns' SAYSIZE 0 SAYSIZE 10 SAYRIGHTBOTTOM

FOR i := 1 TO Len(aColumns)
  @ DCGUI_ROW, DCGUI_COL + 10 DCGET aColumns[i] ;
    LOSTFOCUS {||DC_GetWhen(GetList)} ;
    WHEN _ODBCIndexWhenBlock(aColumns,i-1)
NEXT

DCGETOPTIONS SAYWIDTH 120 SAYRIGHTBOTTOM NORESIZE NOMINBUTTON ;
   SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT ADDBUTTONS TITLE 'Add new Index' ;
   TO lStatus OPTIONS GetOptions NOAUTORESTORE OWNER oOwner

IF lStatus .AND. !Empty(aColumns[1])
  lStatus := ::BuildODBCIndexSQL( cTableName, cIndexName, aColumns, oConnection, 3 )
  IF lStatus
    aIndexTags := {cIndexName,'','',.f.,.f.}
    FOR i := 1 TO Len(aColumns)
      IF !Empty(aColumns[i])
        aIndexTags[2] += IIF(i>1,',','') + Trim(aColumns[i])
      ENDIF
    NEXT
    AAdd( oBrowse:dataSource, aIndexTags )
    oBrowse:refreshAll()
  ENDIF
ENDIF

RETURN lStatus

* -----------

STATIC FUNCTION _ODBCIndexWhenBlock( aColumns, i )

RETURN {||i == 0 .OR. !Empty(aColumns[i])}

* -----------

METHOD SqlQuery:BuildODBCIndexSQL( cTableName, cIndexName, aColumns, oConnection )

LOCAL cSql, i

DD_SqlErrorWindow(nil)

cSql := 'CREATE INDEX ' + Alltrim(cIndexName) + ' ON ' + cTableName + CRLF + ;
        ' ('

FOR i := 1 TO Len(aColumns)
  IF !Empty(aColumns[i])
    cSql += IIF(i>1,',','') + Alltrim(aColumns[i])
  ENDIF
NEXT

cSql += ')' + CRLF

RETURN ::ExecuteSQL( cSql,,oConnection,,0,,.f.,,'Creating Index: ' + cIndexName  )

* -----------

METHOD SqlQuery:AdsDebugSqlMode( lOn )

LOCAL GetList[0], lStatus, cFileName := Pad(DC_AdsDebugFile(),50)

IF lOn
  @ 0,0 DCSAY 'Debug File Name' GET cFileName SAYSIZE 0 SAYBOTTOM ;
        VALID {||DC_ReadEmpty(cFileName)}
  DCREAD GUI FIT TO lStatus MODAL TITLE 'ADS SQL Debug Mode' ADDBUTTONS
  IF lStatus
    DC_AdsDebugFile(Alltrim(cFileName))
    DC_AdsDebugMode(.t.)
    DC_AdsDebugWriteInfo(CRLF + 'ADS Debug Mode Started: ' + DtoC(Date()) + ' ' + Time() + CRLF )
    DCMSGBOX 'ADS Debug Mode is Active' FONT ::cMessageFont OWNER AppDeskTop()
  ENDIF
ELSE
  DC_AdsDebugWriteInfo(CRLF + 'ADS Debug Mode Stopped: ' + DtoC(Date()) + ' ' + Time() + CRLF )
  DC_AdsDebugMode(.f.)
  DCMSGBOX 'ADS Debug Mode is OFF', ;
           'View the Debug Log now?' YESNO TO lStatus ;
           FONT ::cMessageFont OWNER AppDeskTop()
  IF lStatus
    DC_SpawnUrl(DC_AdsDebugFile())
  ENDIF
ENDIF

RETURN lStatus

* -----------

METHOD SqlQuery:DropAdsIndexSql( cTableName, oBrowse, oConnection, oOwner )

LOCAL lStatus, aIndexTags := oBrowse:dataSource, aTags := aIndexTags[oBrowse:arrayElement]

DD_SqlErrorWindow(nil)

DCMSGBOX 'This selection will DROP index tag ' + aTags[1] + ' from ' + cTableName, ;
         '', ;
         'Continue?' YESNO TO lStatus FONT ::cMessageFont OWNER oOwner

IF lStatus
  IF oConnection:type = 'ADS'
    lStatus := ::BuildAdsIndexSQL( cTableName, {aTags}, oConnection, 2 )
  ELSEIF oConnection:type = 'ODBC'
    lStatus := ::DropODBCIndexSQL( cTableName, aTags[1], oConnection, 2 )
  ENDIF
  IF lStatus
    ARemove( aIndexTags, oBrowse:arrayElement)
    oBrowse:refreshAll()
  ENDIF
ENDIF

RETURN .f.

* -----------

METHOD SqlQuery:DropODBCIndexSQL( cTableName, cIndexName, oConnection )

LOCAL cSql := ''

DD_SqlErrorWindow(nil)

cTableName := Strtran(Upper(cTablename),'.DBF','')

IF 'SQL SERVER' $ Upper(oConnection:driver)
  cSql := 'DROP INDEX ' + cTableName + '.' + cIndexName
ELSEIF 'MYSQL' $ Upper(oConnection:driver)
  cSql := 'ALTER TABLE "' + cTableName + '" DROP INDEX ' + cIndexName
ELSE
  cSql := 'DROP INDEX ' + cIndexName + ' ON ' + cTableName
ENDIF

cSql += ';'

RETURN ::ExecuteSQL( cSql,,oConnection,,0,,.f.,,'Dropping Index: ' + cIndexName )

* -----------

METHOD SqlQuery:BuildAdsIndexSqlAll( aTables, aData, oConnection, oBrowse, oDlg )

LOCAL lStatus, aIndexTags, nPointer, oMessage

DCMSGBOX 'This selection will rebuild all indexes for all tables', ;
         'which have been tagged (YELLOW)', ;
         'Continue?' YESNO TO lStatus FONT '10.Lucida Console' ;
         OWNER oDlg

IF !lStatus .OR. AScan(aTables,{|a|a[4]}) == 0
  RETURN .f.
ENDIF

oBrowse:goTop()
oBrowse:forceStable()

oMessage := DC_BrowseMessage():new():create({400,300},'Rebuilding Indexes',.t.,25)

BEGIN SEQUENCE

FOR nPointer := 1 TO Len(aTables)

   IF aTables[nPointer,4]

     aIndexTags := _GetIndexTags(aData[nPointer,2], ;
                                 aTables[nPointer,1],;
                                 oConnection, self)

     IF !Empty(aIndexTags)
       oMessage:addMessage('Creating index ' + aTables[nPointer,1],GRA_CLR_BLACK,'10.Lucida Console')
       ::BuildAdsIndexSQL( aTables[nPointer,1], aIndexTags, oConnection, 0 )
       Sleep(10)
     ENDIF
     IF oMessage:isCancelled
       BREAK
     ENDIF
   ENDIF

   oBrowse:down()
   oBrowse:forceStable()

NEXT

END SEQUENCE

IF oMessage:isCancelled
  oMessage:addMessage('Indexing Cancelled',GRA_CLR_RED,'12.Lucida Console Bold')
ELSE
  oMessage:addMessage('Indexing complete',GRA_CLR_DARKGREEN,'12.Lucida Console Bold')
ENDIF
oMessage:setDone()

RETURN lStatus

* -----------

METHOD SqlQuery:BuildAdsIndexSQL( cTableName, aIndexTags, oConnection, nMode )

LOCAL i, cSql := '', nOptions, lStatus

DEFAULT nMode := 1

IF nMode == 1
  DCMSGBOX 'This selection will rebuild all Index Tags', ;
         'in ' + cTableName + '.cdx', ;
         '', ;
         'Continue?' YESNO TO lStatus ;
         FONT ::cMessageFont OWNER AppDeskTop()

  IF !lStatus
    RETURN .f.
  ENDIF
ENDIF

cTableName := Strtran(Upper(cTableName),'.DBF','')

IF !Empty(oConnection:sessionDict)
  cSql := "EXECUTE PROCEDURE sp_ModifyTableProperty( '" + cTablename + "'," + ;
            "'TABLE_AUTO_CREATE', 'False', NULL ,NULL);" + CRLF + CRLF
ENDIF

// nMode = 1 - Rebuild All
// nMode = 2 - Drop Index
// nMode = 3 - Add Index

FOR i := 1 TO Len(aIndexTags)

  IF nMode == 1 .OR. nMode == 2 .OR. nMode == 0
    cSql += CRLF + 'DROP INDEX ' + cTableName + '.[' + Alltrim(aIndexTags[i,1]) + '];' + CRLF
    IF nMode == 2
      LOOP
    ENDIF
  ENDIF

  cSql += CRLF + 'EXECUTE PROCEDURE sp_CreateIndex(' + CRLF
  nOptions := 2
  IF aIndexTags[i,4] // unique
    nOptions += 1
  ENDIF
  IF aIndexTags[i,5] // descending
    nOptions += 8
  ENDIF
  cSql += "  '" + cTableName + "'," + CRLF
  cSql += "  '" + cTableName + ".cdx'," + CRLF
  cSql += "  '" + Alltrim(aIndexTags[i,1]) + "'," + CRLF
  cSql += "  '" + Strtran(Alltrim(aIndexTags[i,2]),"'",'"') + "'," + CRLF
  cSql += "  '" + Strtran(Alltrim(aIndexTags[i,3]),"'",'"') + "'," + CRLF
  cSql += "  " + Alltrim(Str(nOptions)) + "," + CRLF
  cSql += "  " + Alltrim(Str(512)) + " );" + CRLF
NEXT

IF !Empty(oConnection:sessionDict)
  cSql += CRLF + "EXECUTE PROCEDURE sp_ModifyTableProperty( '" + cTablename + "'," + ;
            "'TABLE_AUTO_CREATE', 'True', NULL ,NULL);" + CRLF
ENDIF

lStatus := ::ExecuteSQL( cSql,,oConnection,,0,,.f.,,'Rebuilding Index: ' + cTableName + '.cdx' )

IF lStatus .AND. nMode > 0
  DCMSGBOX 'Done!' FONT '10.Lucida Console' TIMEOUT 3
ENDIF

RETURN lStatus

* -----------

METHOD SqlQuery:AddTableSQL( oConnection, oOwner )

LOCAL GetList[0], cIndexName, GetOptions, lStatus, aColumns, aIndexTags, ;
      aFields[0], nRow, i, j, cSQL, cFieldName, cFieldType, nFieldLen, ;
      cTableName := Space(30), lAds := oConnection:type = 'ADS', ;
      cTypes, oDlg

DD_SqlErrorWindow(nil)

IF lAds .OR. oConnection:type = 'PG'
  cTypes := 'CMNLD'
ELSEIF oConnection:type = 'ODBC'
  cTypes := oConnection:sessionDict:setProperty( ODBCSSN_DATATYPES )
ENDIF

aColumns := {Space(25),Space(25),Space(25),Space(25)}

@ 0,0 DCSAY 'Table Name' GET cTableName SAYSIZE 0 SAYBOTTOM ;
      VALID {||DC_ReadEmpty(cTableName)}

@ 3,0 DCSAY 'Field Name' SAYSIZE 0 FONT '10.Lucida Console Bold'
@ 3,25 DCSAY 'Type' SAYSIZE 0 FONT '10.Lucida Console Bold'
@ 3,43 DCSAY 'Length' SAYSIZE 0 FONT '10.Lucida Console Bold'
@ 3,53 DCSAY 'Decimals' SAYSIZE 0 FONT '10.Lucida Console Bold'
@ 2,68 DCSAY 'Qty to' SAYSIZE 0 FONT '10.Lucida Console Bold'
@ 3,68 DCSAY 'Replicate' SAYSIZE 0 FONT '10.Lucida Console Bold'

nRow := 4
FOR i := 1 TO 30
  AAdd(aFields,{Space(20),Space(10),0,0,.f.,0})
  @ nRow,0 DCGET aFields[i,1] PICTURE '@!' LOSTFOCUS {||DC_GetWhen(GetList)}
  @ nRow,25 DCGET aFields[i,2] PICTURE '@!' LOSTFOCUS {||DC_GetWhen(GetList)} ;
     VALID _ValidBlock(aFields[i,2],cTypes) PICTURE '@!' ;
     POPUP _PopupBlock(aFields[i,2],cTypes,@oDlg)
  @ nRow,43 DCGET aFields[i,3] PICTURE '9999' WHEN _LengthBlock(aFields[i],2)
  @ nRow,53 DCGET aFields[i,4] PICTURE '99' WHEN _DecimalBlock(aFields[i],2)
  @ nRow,68 DCGET aFields[i,6] PICTURE '999' WHEN _ReplicateBlock(aFields[i])
  nRow++
NEXT

DCGETOPTIONS NORESIZE SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT ADDBUTTONS TITLE 'Create table' PARENT @oDlg ;
  TO lStatus MODAL NOAUTORESTORE OWNER oOwner OPTIONS GetOptions

IF lStatus
   cSQL := 'CREATE TABLE ' + Alltrim(cTableName) + ' ('
   FOR i := 1 TO Len(aFields)
     cFieldName := Alltrim(aFields[i,1])
     cFieldType := Alltrim(aFields[i,2])
     IF cFieldType == 'D'
       aFields[i,3] := 8
     ELSEIF cFieldType == 'L'
       aFields[i,3] := 1
     ELSEIF cFieldType == 'M'
       aFields[i,3] := 10
     ENDIF
     nFieldLen := aFields[i,3]
     IF !Empty(cFieldname) .AND. !Empty(cFieldType) .AND. !Empty(nFieldLen)
       cSQL += CRLF + cFieldName + ' ' + _GetType(aFields[i],2,lAds) + ','
       FOR j := 2 TO aFields[i,6]
         cFieldName := DC_NumIncr(cFieldName)
         cSQL += CRLF + cFieldName + ' ' + _GetType(aFields[i],2,lAds) + ','
       NEXT
     ENDIF
   NEXT

   IF Right(cSql,1) = ','
     cSql := Substr(cSql,1,Len(cSql)-1)
   ENDIF

   cSQL += ' );' + CRLF

   lStatus := ::ExecuteSQL( cSql,,oConnection,,0,,.f.,,'Creating Table: ' + cTableName  )
ENDIF

RETURN lStatus

* -----------

METHOD SqlQuery:AddFieldSQL( cTableName, oBrowse, oConnection, oOwner, nTagElement )

LOCAL lStatus, GetList[0], aFields[0], nRow, i, j, cSQL, cFieldName, ;
      cFieldType, nFieldLen, lAds := oConnection:type == 'ADS', cTypes, ;
      GetOptions, oDlg, nLen

DD_SqlErrorWindow(nil)

IF lAds .OR. oConnection:type = 'PG'
  cTypes := 'CMNLD'
ELSEIF oConnection:type = 'ODBC'
  cTypes := oConnection:sessionDict:setProperty( ODBCSSN_DATATYPES )
ENDIF

@ 1,0 DCSAY 'Field Name' SAYSIZE 0 FONT '10.Lucida Console Bold'
@ 1,25 DCSAY 'Type' SAYSIZE 0 FONT '10.Lucida Console Bold'
@ 1,43 DCSAY 'Length' SAYSIZE 0 FONT '10.Lucida Console Bold'
@ 1,53 DCSAY 'Decimals' SAYSIZE 0 FONT '10.Lucida Console Bold'
@ 0,68 DCSAY 'Qty to' SAYSIZE 0 FONT '10.Lucida Console Bold'
@ 1,68 DCSAY 'Replicate' SAYSIZE 0 FONT '10.Lucida Console Bold'

nRow := 3
FOR i := 1 TO 30
  AAdd(aFields,{Space(20),Space(10),0,0,.f.,0})
  @ nRow,0 DCGET aFields[i,1] PICTURE '@!' LOSTFOCUS {||DC_GetWhen(GetList)}
  @ nRow,25 DCGET aFields[i,2] PICTURE '@!' LOSTFOCUS {||DC_GetWhen(GetList)} ;
     VALID _ValidBlock(aFields[i,2],cTypes) PICTURE '@!' ;
     POPUP _PopupBlock(aFields[i,2],cTypes,@oDlg)
  @ nRow,43 DCGET aFields[i,3] PICTURE '9999' WHEN _LengthBlock(aFields[i],2)
  @ nRow,53 DCGET aFields[i,4] PICTURE '99' WHEN _DecimalBlock(aFields[i],2)
  @ nRow,68 DCGET aFields[i,6] PICTURE '999' WHEN _ReplicateBlock(aFields[i])
  nRow++
NEXT

DCGETOPTIONS NORESIZE SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT ADDBUTTONS TITLE 'Add field(s) to table: ' + cTableName ;
  TO lStatus MODAL NOAUTORESTORE OWNER oOwner OPTIONS GetOptions ;
  PARENT @oDlg

IF lStatus
   cTableName := Strtran(Upper(cTableName),'.DBF','')
   cSQL := 'ALTER TABLE "' + cTableName + '"'
   FOR i := 1 TO Len(aFields)
     cFieldName := Alltrim(aFields[i,1])
     cFieldType := Alltrim(aFields[i,2])
     IF cFieldType == 'D'
       aFields[i,3] := 8
     ELSEIF cFieldType == 'L'
       aFields[i,3] := 1
     ELSEIF cFieldType == 'M'
       aFields[i,3] := 10
     ENDIF
     nFieldLen := aFields[i,3]
     IF !Empty(cFieldname) .AND. !Empty(cFieldType) .AND. !Empty(nFieldLen)
       cSQL += CRLF + ' ADD COLUMN "' + ;
               Alltrim(aFields[i,1]) + '" ' + _GetType(aFields[i],2,lAds)
       FOR j := 2 TO aFields[i,6]
         cFieldName := DC_NumIncr(cFieldName)
         cSQL += CRLF + ' ADD COLUMN ' + ;
           cFieldName + ' ' + _GetType(aFields[i],2,lAds)
       NEXT
     ENDIF
   NEXT
   cSQL += ';' + CRLF

   lStatus := ::ExecuteSQL( cSql,,oConnection,,0,,.f.,,'Rebuilding Table: ' + cTableName  )

   IF lStatus
     FOR i := 1 TO Len(aFields)
       IF !Empty(aFields[i,1])
         nLen := Len(oBrowse:dataSource)+1
         cFieldName := aFields[i,1]
         AAdd(oBrowse:dataSource,{cFieldName,aFields[i,2],aFields[i,3],aFields[i,4],nLen,.f.})
         FOR j := 2 TO aFields[i,6]
           cFieldName := DC_NumIncr(cFieldName)
           nLen := Len(oBrowse:dataSource)+1
           AAdd(oBrowse:dataSource,{cFieldName,aFields[i,2],aFields[i,3],aFields[i,4],nLen,.f.})
         NEXT
       ENDIF
     NEXT
     oBrowse:refreshAll()
   ENDIF
ENDIF

RETURN lStatus

* --------------

METHOD SqlQuery:AlterFieldSQL( cTableName, oBrowse, oConnection, oOwner, nTagElement )

LOCAL lStatus, GetList[0], aFields[0], nRow, i, j, cSQL, cFieldName, ;
      cFieldType, nFieldLen, cFieldNameOld, cFieldNameNew, ;
      lAds := oConnection:type = 'ADS', cTypes, oDlg, GetOptions

DD_SqlErrorWindow(nil)

IF lAds .OR. oConnection:type = 'PG'
  cTypes := 'CMNLD'
ELSEIF oConnection:type = 'ODBC'
  cTypes := oConnection:sessionDict:setProperty( ODBCSSN_DATATYPES )
ENDIF

IF AScan(oBrowse:dataSource,{|a|a[nTagElement]}) == 0
  DCMSGBOX 'No fields are tagged for Altering' FONT ::cMessageFont ;
     OWNER AppDeskTop()
  RETURN .f.
ENDIF

@ 0,0 DCSAY 'Field Name' SAYSIZE 0 FONT '10.Lucida Console Bold'
@ 0,25 DCSAY 'New Name' SAYSIZE 0 FONT '10.Lucida Console Bold'
@ 0,50 DCSAY 'Type' SAYSIZE 0 FONT '10.Lucida Console Bold'
@ 0,65 DCSAY 'Length' SAYSIZE 0 FONT '10.Lucida Console Bold'
@ 0,75 DCSAY 'Decimals' SAYSIZE 0 FONT '10.Lucida Console Bold'

nRow := 1
FOR i := 1 TO Len(oBrowse:dataSource)
  IF !oBrowse:dataSource[i,nTagElement]
    LOOP
  ENDIF
  AAdd(aFields,{Pad(oBrowse:dataSource[i,1],20), ;
                Pad(oBrowse:dataSource[i,1],20), ;
                Pad(oBrowse:dataSource[i,2],10), ;
                oBrowse:dataSource[i,3], ;
                oBrowse:dataSource[i,4], ;
                i})
NEXT

FOR i := 1 TO Len(aFields)
  @ i, 0 DCGET aFields[i,1] PICTURE '@!' EDITPROTECT {||.t.}
  @ i,25 DCGET aFields[i,2] PICTURE '@!' LOSTFOCUS {||DC_GetWhen(GetList)}
  @ i,53 DCGET aFields[i,3] PICTURE '@!' LOSTFOCUS {||DC_GetWhen(GetList)} ;
        VALID _ValidBlock(aFields[i,3],cTypes) PICTURE '@!' ;
        POPUP _PopupBlock(aFields[i,3],cTypes,@oDlg)
  @ i,68 DCGET aFields[i,4] PICTURE '9999' WHEN _LengthBlock(aFields[i],3)
  @ i,78 DCGET aFields[i,5] PICTURE '99' WHEN _DecimalBlock(aFields[i],3)
  nRow++
NEXT

DCGETOPTIONS SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT ADDBUTTONS TITLE 'Add field(s) to table: ' + cTableName ;
  TO lStatus MODAL NOAUTORESTORE OWNER oOwner PARENT @oDlg OPTIONS GetOptions

IF lStatus
   cTableName := Strtran(Upper(cTableName),'.DBF','')
   cSQL := 'ALTER TABLE "' + cTableName + '"'
   FOR i := 1 TO Len(aFields)
     cFieldNameOld := Alltrim(aFields[i,1])
     cFieldNameNew := Alltrim(aFields[i,2])
     cFieldType := Alltrim(aFields[i,3])
     IF cFieldType == 'D'
       aFields[i,4] := 8
     ELSEIF cFieldType == 'L'
       aFields[i,4] := 1
     ELSEIF cFieldType == 'M'
       aFields[i,4] := 10
     ENDIF
     nFieldLen := aFields[i,4]
     IF !Empty(cFieldnameNew) .AND. !Empty(cFieldType) .AND. !Empty(nFieldLen)
       cSQL += CRLF + ' ALTER COLUMN "' + ;
               cFieldNameOld + '" "' + cFieldNameNew + '" ' + _GetType(aFields[i],3,lAds)
     ENDIF
   NEXT
   cSQL += ';' + CRLF

   lStatus := ::ExecuteSQL( cSql,,oConnection,,0,,.f.,,'Rebuilding Table: ' + cTableName  )
   IF lStatus
     FOR i := 1 TO Len(aFields)
       oBrowse:dataSource[aFields[i,6],1] := aFields[i,2]
       oBrowse:dataSource[aFields[i,6],2] := aFields[i,3]
       oBrowse:dataSource[aFields[i,6],3] := aFields[i,4]
       oBrowse:dataSource[aFields[i,6],4] := aFields[i,5]
     NEXT
     oBrowse:refreshAll()
   ENDIF
ENDIF

RETURN lStatus

* -----------

STATIC FUNCTION _ReplicateBlock( aField )

RETURN {||Val(Right(Alltrim(aField[1]),1))>0}

* ------------

STATIC FUNCTION _LengthBlock( aField, n )

RETURN {||Alltrim(aField[n]) $ 'CNI'}

* ------------

STATIC FUNCTION _DecimalBlock( aField, n )

RETURN {||Alltrim(aField[n]) $ 'NF'}

* ------------

STATIC FUNCTION _ValidBlock( cType, cTypes )

RETURN {|o,cType,y| cType := o:getData(), y := (Alltrim(cType) $ cTypes), ;
                    IIF(!y,DC_WinAlert('Valid Types are: ' + cTypes),nil),y}

* ------------

STATIC FUNCTION _PopupBlock( aField, cTypes, oOwner )

RETURN {|x,o| x := _PopupFieldTypes( x, cTypes, oOwner ), x}

* -----------

STATIC FUNCTION _PopupFieldTypes( cType, cTypes, oOwner )

LOCAL GetList[0], oBrowse, aTypes[0], i, nPointer := 1, lStatus

FOR i := 1 TO Len(cTypes)
  AAdd(aTypes,{cTypes[i],_TypeDesc(cTypes[i])})
NEXT

@ 0,0 DCBROWSE oBrowse DATA aTypes FONT '10.Lucida Console' SIZE 10,20 FIT ;
      POINTER nPointer ;
      ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
      CURSORMODE XBPBRW_CURSOR_ROW ;
      NOHSCROLL

DCBROWSECOL ELEMENT 1 HEADER 'Type' WIDTH 4 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER 'Description' WIDTH 20 PARENT oBrowse

DCREAD GUI FIT TITLE 'Data Types' MODAL SETAPPWINDOW TO lStatus ;
   NOAUTORESTORE OWNER oOwner

IF lStatus
  cType := aTypes[nPointer,1]
ENDIF

RETURN cType

* -----------

STATIC FUNCTION _GetType(aField,n,lAds)

LOCAL cType := Alltrim(aField[n]), nLen := aField[n+1], nDec := aField[n+2]

IF Upper(cType) == 'C'
  cType := 'Char(' + Alltrim(Str(nLen)) + ')'
ELSEIF Upper(cType) == 'N'
  cType := 'Numeric(' + Alltrim(Str(nLen)) + IIF( nDec==0,'',',' + Alltrim(Str(nDec))) + ')'
ELSEIF Upper(cType) == 'F'
  cType := 'Double(' + Alltrim(Str(nLen)) + IIF( nDec==0,'',',' + Alltrim(Str(nDec))) + ')'
ELSEIF Upper(cType) == 'I'
  cType := 'Integer(' + Alltrim(Str(nLen))+ ')'
ELSEIF Upper(cType) == 'T'
  cType := 'Time Stamp'
ELSEIF Upper(cType) == 'D'
  cType := 'Date'
ELSEIF Upper(cType) = 'L'
  IF lAds
    cType := 'Logical'
  ELSE
    cType := 'Bit'
  ENDIF
ELSEIF Upper(cType) = 'M'
  IF lAds
    cType := 'Memo'
  ELSE
    cType := 'Text'
  ENDIF
ELSEIF Upper(cType) = 'Y'
  cType := 'Currency'
ENDIF

RETURN cType

* --------------

STATIC FUNCTION _TypeDesc( cType, nLen, lAds )

LOCAL cDesc

DEFAULT lAds := .t.

IF cType = 'C'
  cDesc := 'Char'
ELSEIF cType = 'N'
  cDesc := 'Numeric'
ELSEIF cType = 'D'
  IF .t. // lAds
    cDesc := 'Date'
  ELSE
    cDesc := 'DateTime'
  ENDIF
  nLen := 0
ELSEIF cType = 'L'
  IF lAds
    cDesc := 'Logical'
  ELSE
    cDesc := 'Bit'
  ENDIF
  nLen := 0
ELSEIF cType = 'F'
  cDesc := 'Float'
  nLen := 0
ELSEIF cType = 'X'
  IF lAds
    cDesc := 'Char'
  ELSE
    cDesc := 'Binary'
  ENDIF
ELSEIF cType = 'O'
  cDesc := 'Generic'
ELSEIF cType = 'I'
  cDesc := 'Integer'
  nLen := 0
ELSEIF cType = 'M'
  IF lAds
    cDesc := 'Memo'
  ELSE
    cDesc := 'VarChar'
  ENDIF
  nLen := 0
ELSEIF cType = 'V'
  IF lAds
    cDesc := 'Memo'
  ELSE
    cDesc := 'VarBinary'
  ENDIF
ELSEIF cType = 'T'
  cDesc := 'TimeStamp'
  nLen := 0
ELSEIF cType = 'W'
  cDesc := 'nchar'
ELSEIF cType = 'Y'
  cDesc := 'Currency'
  nLen := 0
ELSEIF Upper(cType) == 'TIME'
  nLen := 0
ENDIF

RETURN cDesc

* -----------

METHOD SqlQuery:DropFieldSql( cTableName, oBrowse, oConnection, oOwner )

LOCAL cSql, lStatus, aFields := oBrowse:dataSource, i, nField

DD_SqlErrorWindow(nil)

IF AScan(oBrowse:dataSource,{|a|a[6]}) == 0
  DCMSGBOX 'No fields are tagged for Deleting' FONT ::cMessageFont ;
     OWNER AppDeskTop()
  RETURN .f.
ENDIF

DCMSGBOX 'This selection will DROP the TAGGED fields from ' + cTableName, ;
         '', ;
         'Continue?' YESNO TO lStatus FONT ::cMessageFont OWNER oOwner

IF lStatus
  cTableName := Strtran(Upper(cTableName),'.DBF','')
  cSql := 'ALTER TABLE "' + cTableName + '"'
  FOR i := 1 TO Len(aFields)
    IF aFields[i,6]
      cSql += CRLF + '  DROP COLUMN "' + aFields[i,1] + '"'
    ENDIF
  NEXT
  cSql += ';' + CRLF

  lStatus := ::ExecuteSQL( cSql,,oConnection,,0,,.f.,,'Rebuilding Table: ' + cTableName  )
  IF lStatus
    DO WHILE (nField := AScan(aFields,{|a|a[6]})) > 0
      ARemove( aFields, nField)
    ENDDO
    oBrowse:refreshAll()
  ENDIF
ENDIF

RETURN lStatus

* -----------

METHOD SqlQuery:DropTableSQL( cTableName, oConnection, oTreeItem )

LOCAL cSql, lStatus

DD_SqlErrorWindow(nil)

DCMSGBOX 'This selection will DROP the table: ' + cTableName, ;
         'from the datbase: ' + oConnection:database, ;
         '', ;
         'Continue?' YESNO TO lStatus FONT ::cMessageFont OWNER AppDeskTop()

IF lStatus
  cSql := 'DROP TABLE ' + cTableName
  lStatus := ::ExecuteSQL( cSql,,oConnection,,0,,.f.,,'Dropping Table: ' + cTableName  )
  IF lStatus
    oTreeItem:getParentItem():delItem(oTreeItem)
  ENDIF
ENDIF

RETURN lStatus

* -----------

METHOD SqlQuery:ZapTableSQL( cTableName, oConnection )

LOCAL cSql, lStatus

DD_SqlErrorWindow(nil)

DCMSGBOX 'This selection will ZAP (Delete all records) in the table: ' + cTableName, ;
         '', ;
         'Continue?' YESNO TO lStatus FONT ::cMessageFont OWNER AppDeskTop()

IF lStatus
  cSql := 'DELETE FROM ' + cTableName
  lStatus := ::ExecuteSQL( cSql,,oConnection,,0,,.f.,,'Dropping Table: ' + cTableName  )
ENDIF

RETURN lStatus

* -----------

METHOD SqlQuery:ZapTableADS( cTableName, oConnection )

LOCAL cSql, lStatus, oSession

DD_SqlErrorWindow(nil)

DCMSGBOX 'This selection will ZAP (Delete all records) in the table: ' + cTableName, ;
         '', ;
         'Continue?' YESNO TO lStatus FONT ::cMessageFont OWNER AppDeskTop()

IF lStatus
  dbeSetDefault('ADSDBE')
  IF !Empty(oConnection:sessionDict)
    oSession := oConnection:sessionDict
  ELSE
    oSession := oConnection:sessionFree
  ENDIF
  USE (cTableName) EXCLUSIVE VIA (oSession)
  dbZap()
  dbCloseArea()
ENDIF

RETURN lStatus

* ------------------

METHOD SqlQuery:DictTableProperties( cTableName, nConnectHandle, oTreeItem )

LOCAL aProperties, i, nProperty, xValue, nLen, nError, nRow, ;
      GetList[0], GetOptions, nColor, lStatus, ;
      nButtons, aTokens, cCaption

aProperties := { ;
   { ADS_DD_COMMENT, Space(200), 200, 'Comment' }, ;
   { ADS_DD_USER_DEFINED_PROP, Space(200), 200, 'User Defined Table Property'}, ;
   { ADS_DD_TABLE_VALIDATION_EXPR, Space(200), 200, 'Record Level Validation Expression'}, ;
   { ADS_DD_TABLE_VALIDATION_MSG, Space(200), 200, 'Table Validation Error Message'}, ;
   { ADS_DD_TABLE_PRIMARY_KEY, Space(200), 200, 'Table Primary Key'}, ;
   { ADS_DD_TABLE_TYPE, 2, 2, 'Type of Base Table'}, ;
   { ADS_DD_TABLE_FIELD_COUNT, 100, 100, 'Field Count'}, ;
   { ADS_DD_TABLE_ENCRYPTION, 2, 2, 'Encryption State'}, ;
   { ADS_DD_TABLE_DEFAULT_INDEX, Space(200), 200, 'Default Index'}, ;
   { ADS_DD_TABLE_IS_RI_PARENT, 2, 2, 'Is Referential Integrity Rule?'}, ;
   { ADS_DD_TABLE_AUTO_CREATE, 2, 2, 'Is Auto Created?'}, ;
   { ADS_DD_TABLE_PERMISSION_LEVEL, 2, 2, 'Table Permission Level'}, ;
   { ADS_DD_TABLE_MEMO_BLOCK_SIZE, 2, 2, 'Memo Block Size'} }

nRow := 0

FOR i := 1 TO IIF( !Empty(oTreeItem),1,Len(aProperties))

  ASize(aProperties[i],7)
  nProperty := aProperties[i,1]
  xValue := aProperties[i,2]
  nLen := aProperties[i,3]

  nError := AdsDDGetTableProperty( nConnectHandle, ;
                         cTableName, ;
                         nProperty, ;
                         @xValue, ;
                         @nLen )

  IF Valtype(xValue) = 'C'
    xValue := Strtran(xValue,Chr(0),'')
  ENDIF
  aProperties[i,5] := xValue
  aProperties[i,6] := nError
  aProperties[i,7] := AllTrim(DC_AdsGetLastError())

  IF nError == 0 .OR. !Empty(oTreeItem)
    nColor := GRA_CLR_WHITE
  ELSE
    nColor := GRA_CLR_PALEGRAY
  ENDIF

  @ nRow++, 0 DCSAY aProperties[i,4] + ':' SAYSIZE 0 SAYBOTTOM
  @ nRow++, 0 DCGET aProperties[i,5] GETSIZE IIF(aProperties[i,3]>100,50,nil) ;
              TOOLTIP aProperties[i,7] COLOR nil, nColor

NEXT

DCGETOPTIONS NORESIZE ;
   EDITPROTECT {||Empty(oTreeItem)} ;
   COLOR GRA_CLR_WHITE

IF !Empty(oTreeItem)
  nButtons := DCGUI_BUTTON_OK + DCGUI_BUTTON_CANCEL
ELSE
  nButtons := DCGUI_BUTTON_OK
ENDIF

DCREAD GUI FIT ;
   NOAUTORESTORE ;
   MODAL ;
   BUTTONS nButtons ;
   TITLE 'Table: ' + cTableName + IIF( Empty(oTreeItem),' Properties',' - Edit Comment')  ;
   OPTIONS GetOptions ;
   ENTEREXIT ;
   TO lStatus EVAL {|o|::SetWindowPos(o)}

IF lStatus .AND. !Empty(oTreeItem)

  FOR i := 1 TO 1

    nProperty := aProperties[i,1]
    xValue := Trim(aProperties[i,5])
    nLen := Len(aProperties[i,5])

    nError := AdsDDSetTableProperty( nConnectHandle, ;
                         cTableName, ;
                         nProperty, ;
                         @xValue, ;
                         @nLen )

  NEXT

  aTokens := DC_TokenArray(oTreeItem:caption,' ')
  cCaption := aTokens[1] + ' (' + Alltrim(StrTran(xValue,Chr(0),'')) + ')'
  oTreeItem:setCaption(cCaption)

ENDIF

RETURN xValue

* ------------------

METHOD SqlQuery:DictIndexProperties( lGetData, cTableName, acIndexName, nConnectHandle )

LOCAL aProperties, i, nProperty, xValue, nLen, nError, nRow, ;
      GetList[0], GetOptions, nColor, aTagInfo, cTagName, aTagData

DEFAULT lGetData := .f.

IF Valtype(acIndexName) == 'A'
  cTagName := acIndexName[1]
ELSEIF Valtype(acIndexName) == 'C'
  cTagName := Alltrim(acIndexName)
ELSE
  RETURN nil
ENDIF

IF nConnectHandle > 0

  aProperties := { ;
   { ADS_DD_COMMENT, Space(200), 200, 'Comment' }, ;
   { ADS_DD_INDEX_FILE_NAME, Space(200), 200, 'Index File Name'}, ;
   { 0, Pad(cTagName,20),20, 'Index Tag Name'}, ;
   { ADS_DD_INDEX_EXPRESSION, Space(200), 200, 'Index Expression'}, ;
   { ADS_DD_INDEX_CONDITION, Space(200), 200, 'Index Condition'}, ;
   { ADS_DD_INDEX_OPTIONS, 4, 4, 'Index Options'}, ;
   { ADS_DD_INDEX_KEY_LENGTH, 2, 2, 'Index Key Length'}, ;
   { ADS_DD_INDEX_KEY_TYPE, 2, 2, 'Index Key Type'} }

ELSE

  aProperties := { ;
   { nil, nil, 50, 'Index Tag Name'}, ;
   { nil, nil, 50, 'Index Expression'}, ;
   { nil, nil, 50, 'For Condition'}, ;
   { nil, nil, 50, 'Unique'}, ;
   { nil, nil, 50, 'Descending'} }

ENDIF

nRow := 0

aTagData := { cTagName }

FOR i := 1 TO Len(aProperties)

  ASize(aProperties[i],7)
  nProperty := aProperties[i,1]
  xValue := aProperties[i,2]
  nLen := aProperties[i,3]

  IF nConnectHandle > 0
    IF nProperty > 0
      nError := AdsDDGetIndexProperty( nConnectHandle, ;
                         cTableName, ;
                         cTagName, ;
                         nProperty, ;
                         @xValue, ;
                         @nLen )

    ENDIF
    IF Valtype(xValue) = 'C'
      xValue := Strtran(xValue,Chr(0),'')
    ENDIF

    IF i $ {4,5}
      AAdd(aTagData,Trim(xValue))
    ELSEIF i $ {6,7}
      AAdd(aTagData,.f.)
    ENDIF

  ELSE

    xValue := acIndexName[i]

  ENDIF

  aProperties[i,5] := xValue
  aProperties[i,6] := nError
  aProperties[i,7] := AllTrim(DC_AdsGetLastError())

  IF nError == 0
    nColor := GRA_CLR_WHITE
  ELSE
    nColor := GRA_CLR_PALEGRAY
  ENDIF

  IF lGetData
    LOOP
  ENDIF

  @ nRow++, 0 DCSAY aProperties[i,4] + ':' SAYSIZE 0 SAYBOTTOM
  @ nRow++, 0 DCGET aProperties[i,5] GETSIZE IIF(aProperties[i,3]>100,100,nil) ;
              TOOLTIP aProperties[i,7] COLOR nil, nColor

NEXT

IF lGetData
  RETURN aTagData
ENDIF
DCGETOPTIONS NORESIZE EDITPROTECT {||.t.} COLOR GRA_CLR_WHITE

DCREAD GUI FIT ;
   NOAUTORESTORE ;
   MODAL ;
   BUTTONS DCGUI_BUTTON_OK ;
   TITLE 'Table: ' + cTableName + ' Tag: ' + cTagName + ' - Properties' ;
   OPTIONS GetOptions ;
   EVAL {|o|::SetWindowPos(o)}

RETURN nil

* ---------------

METHOD SqlQuery:DropProcedureSQL( cProcedure, oConnection, oTreeItem )

LOCAL cSql, lStatus

DD_SqlErrorWindow(nil)

DCMSGBOX 'This routine will Delete (DROP) the procedure: ' + cProcedure, ;
         'from the database: ' + oConnection:database, ;
         '', ;
         'Are you Sure you want to Continue?' YESNO TO lStatus ;
         FONT ::cMessageFont OWNER AppDeskTop()

IF lStatus
  cSql := 'DROP PROCEDURE ' + cProcedure
  lStatus := ::ExecuteSQL(cSql,'QUERY',oConnection,,0)
  IF lStatus
    oTreeItem:getParentItem():delItem(oTreeItem)
    DCMSGBOX 'Procedure ' + cProcedure + ' was deleted.' ;
      FONT ::cMessageFont OWNER AppDeskTop()
  ENDIF
ENDIF

RETURN lStatus

* ---------------

METHOD Sqlquery:UpdateProcedureCommentADS( cProcedure, oConnection, oTreeItem )

LOCAL GetList[0], lStatus, cSql, cAlias, cComment := Space(200)

cSql := 'SELECT comment FROM system.storedprocedures WHERE name = ?'
cSql := DC_ApplySqlParams(cSql,{cProcedure})

::ExecuteSQL(cSql,'QUERY',oConnection,,0)

cAlias := Alias()

cComment := Pad((cAlias)->comment,200)
(cAlias)->(dbCloseArea())

@ 0,0 DCSAY 'Comment:' SAYSIZE 0 SAYBOTTOM
@ 1,0 DCGET cComment GETSIZE 100

DCREAD GUI FIT ADDBUTTONS TITLE 'Update Procedure Comment' ;
   TO lStatus MODAL

IF lStatus

  cSql := "EXECUTE PROCEDURE sp_ModifyProcedureProperty( ?, 'COMMENT', ? )"
  cSql := DC_ApplySqlParams(cSql,{cProcedure,Trim(cComment)})

  lStatus := ::ExecuteSQL(cSql,'QUERY',oConnection,,0,,,,,,.t.)
ENDIF

RETURN lStatus

* ---------------

METHOD SqlQuery:CreateProcedureSQL( oConnection, oTreeItem )

LOCAL cSql := '', GetList[0], cPrompt, cSample, lStatus, ;
      lAdsODBC, i, aItems, GetOptions

DD_SqlErrorWindow(nil)

cSample := '<unknown>'
cPrompt := '<unknown>'

lAdsODBC := (oConnection:type = 'ODBC' .AND. 'ADVANTAGE STREAMLINESQL' $ Upper(oConnection:driver))

IF oConnection:type = 'ODBC' .AND. 'SQL SERVER' $ Upper(oConnection:driver)

TEXT INTO cPrompt WRAP
/* Place comment here */
CREATE PROCEDURE SelectAllCustomers
@City nvarchar(30), @PostalCode nvarchar(10)
AS
SELECT * FROM Customers WHERE City = @City AND PostalCode = @PostalCode
ENDTEXT

cSample := 'SqlServer (ODBC)'

TEXT INTO cSql WRAP
/* <place comment here> */
CREATE PROCEDURE <procedure>
  @<column name> <type>
AS
  <SQL code>
ENDTEXT

ELSEIF oConnection:type = 'ADS' .OR. lAdsODBC

TEXT INTO cPrompt WRAP
CREATE PROCEDURE SelectAllCustomers
 (
 City char(20),
 Postalcode char(20),
 CURSOR VARYING OUTPUT
 )
BEGIN
  SELECT * FROM Customers WHERE City = _City AND PostalCode = _PostalCode ;
END;
ENDTEXT

cSample := 'Advantage Server (ADS)'

TEXT INTO cSql WRAP
CREATE PROCEDURE <procedure>
  (
  <column name> <type>,
  CURSOR VARYING OUTPUT
  )
  BEGIN
    <SQL code> ;
  END;
ENDTEXT

ENDIF

DO WHILE .t.

  ASize(GetList,0)

  @ 0,0 DCSAY 'Sample Script for ' + cSample

  @ 2,0 DCSAY cPrompt SAYSIZE 100,6 SAYWORDBREAK FONT ::cMessageFont ;
      COLOR GRA_CLR_BLACK, DC_ICEGREY

  @  9,0 DCSAY 'Enter script:' SAYSIZE 0

  @ 10,0 DCMULTILINE cSql SIZE 100,10 FONT ::cMessageFont NOHSCROLL ;
         RESIZE DCGUI_RESIZE_RESIZEONLY

  DCGETOPTIONS RESIZE RESIZEDEFAULT DCGUI_RESIZE_REPOSONLY_Y ;
    SCALEFACTOR ::aScaleFactor

  DCREAD GUI FIT ADDBUTTONS TO lStatus ;
   TITLE 'Create Procedure (' + oConnection:database + ')' ;
   NOAUTORESTORE OPTIONS GetOptions EVAL {|o|::SetWindowPos(o)}

  IF lStatus
    lStatus := ::ExecuteSQL(cSql,'QUERY',oConnection,,0)
    IF lStatus
      DCMSGBOX 'Procedure was created' FONT ::cMessageFont OWNER AppDeskTop()
      IF !Empty(oTreeItem)
        aItems := oTreeItem:getChildItems()
        FOR i := 1 TO Len(aItems)
          oTreeItem:delItem(aItems[i])
        NEXT
      ENDIF
      EXIT
    ENDIF
  ELSE
    EXIT
  ENDIF
ENDDO

RETURN lStatus

* ---------------

METHOD SqlQuery:DictProcedurePropertiesADS( lGetData, cProcedure, oConnection, oTreeItem, nError )

LOCAL aProperties, i, nProperty, nRow, nButtons, xValue, nLen, ;
      GetList[0], GetOptions, nColor, aProcData[0], lMemo, lStatus, cAlias

DEFAULT lGetData := .f.

aProperties := { ;
   { ADS_DD_COMMENT, Space(200), 200, 'Comment',.f. }, ;
   { ADS_DD_PROC_INPUT, Space(200), 200, 'Input Parameters',.f.}, ;
   { ADS_DD_PROC_OUTPUT, Space(200), 200, 'Output Parameters',.f.}, ;
   { ADS_DD_PROC_DLL_NAME, Space(200), 200, 'Dll Name',.f.}, ;
   { ADS_DD_PROC_DLL_FUNCTION_NAME, Space(200), 200, 'Function Name',.f.}, ;
   { ADS_DD_PROC_INVOKE_OPTION, 2, 2, 'Format',.f.}, ;
   { ADS_DD_PROC_SCRIPT, Space(10000), 10000, 'Script',.t.} }

nRow := 0

FOR i := 1 TO IIF( !Empty(oTreeItem),1,Len(aProperties))

  ASize(aProperties[i],8)
  nProperty := aProperties[i,1]
  xValue := aProperties[i,2]
  nLen := aProperties[i,3]

  nError := AdsDDGetProcedureProperty( oConnection:handleDict, ;
                         cProcedure, ;
                         nProperty, ;
                         @xValue, ;
                         @nLen )

  IF Valtype(xValue) = 'C'
    xValue := Strtran(xValue,Chr(0),'')
  ENDIF

  AAdd(aProcData,IIF(Valtype(xValue)='C',Alltrim(xValue),xValue))

  lMemo := aProperties[i,5]
  aProperties[i,6] := xValue
  aProperties[i,7] := nError
  aProperties[i,8] := AllTrim(DC_AdsGetLastError())

  IF nError == 0 .OR. !Empty(oTreeItem)
    nColor := GRA_CLR_WHITE
  ELSE
    nColor := GRA_CLR_PALEGRAY
  ENDIF

  IF lGetData
    LOOP
  ENDIF

  @ nRow++, 0 DCSAY aProperties[i,4] + ':' SAYSIZE 0 SAYBOTTOM
  IF lMemo
    @ nRow++, 0 DCMULTILINE aProperties[i,6] SIZE 100,5 FONT ::cMessageFont NOHSCROLL ;
                RESIZE DCGUI_RESIZE_RESIZEONLY
    nRow += 5
  ELSE
    @ nRow++, 0 DCGET aProperties[i,6] GETSIZE IIF(aProperties[i,3]>100,100,nil) ;
              TOOLTIP aProperties[i,8] COLOR nil, nColor
  ENDIF

NEXT

IF lGetData
  RETURN aProcData
ENDIF

DCGETOPTIONS ;
   EDITPROTECT {||Empty(oTreeItem)} ;
   COLOR GRA_CLR_WHITE ;
   RESIZE RESIZEDEFAULT DCGUI_RESIZE_REPOSONLY_Y ;
   SCALEFACTOR ::aScaleFactor

IF !Empty(oTreeItem)
  nButtons := DCGUI_BUTTON_OK + DCGUI_BUTTON_CANCEL
ELSE
  nButtons := DCGUI_BUTTON_OK
ENDIF

DCREAD GUI FIT ;
   NOAUTORESTORE ;
   MODAL ;
   BUTTONS nButtons ;
   ENTEREXIT ;
   TITLE 'Procedure: ' + cProcedure + ' - Properties' ;
   OPTIONS GetOptions TO lStatus ;
   EVAL {|o|::SetWindowPos(o)}

IF lStatus .AND. !Empty(oTreeItem)

  nProperty := aProperties[1,1]
  xValue := Trim(aProperties[1,6])
  nLen := Len(aProperties[1,6])

  nError := AdsDDSetProcedureProperty( oConnection:handleDict, ;
                       Trim(cProcedure), ;
                       nProperty, ;
                       @xValue, ;
                       @nLen )

ENDIF

RETURN nil

* ------------------

METHOD SqlQuery:DictProcedurePropertiesODBC( lGetData, cProcedure, oConnection, oTreeItem, nError )

LOCAL aProperties, i, nProperty, nRow, nButtons, cSql, lAds, ;
      GetList[0], GetOptions, nColor, aProcData[0], lMemo, lStatus, cAlias

DEFAULT lGetData := .f.

nRow := 0

lAds := .f.
IF 'ADVANTAGE STREAMLINESQL' $ Upper(oConnection:driver)
  TEXT INTO cSql WRAP
  SELECT * FROM system.storedprocedures where name = ?
  ENDTEXT
  lAds := .t.
ELSEIF lGetData
  TEXT INTO cSql WRAP
  SELECT * FROM INFORMATION_SCHEMA.PARAMETERS WHERE specific_name = ?
  ENDTEXT
ELSE
  TEXT INTO cSql WRAP
  SELECT SPECIFIC_NAME, ROUTINE_DEFINITION, CREATED, LAST_ALTERED
  FROM INFORMATION_SCHEMA.ROUTINES WHERE ROUTINE_TYPE = 'PROCEDURE'
  AND SPECIFIC_NAME = ?
  ENDTEXT
ENDIF

cSql := DC_ApplySqlParams( cSql, {cProcedure} )

DDSTATEMENT (cSql) VIA oConnection:sessionDict

cAlias := Alias()

IF lAds
  aProcData := {Trim((cAlias)->comment), ;
                Trim((cAlias)->Proc_input), ;
                Trim((cAlias)->Proc_Output), ;
                Trim((cAlias)->SQL_Script), ;
                Trim((cAlias)->Proc_DLL_Name), ;
                Trim((cAlias)->Proc_DLL_Function_Name), ;
                (cAlias)->Proc_Invoke_Option }

  IF !lGetData
    @ nRow++,0 DCSAY 'Procedure Name:'
    @ nRow++,0 DCGET cProcedure

    @ nRow++,0 DCSAY 'Comment:'
    aProcData[1] := Pad(aProcData[1],60)
    @ nRow++,0 DCGET aProcData[1]

    aProcData[2] := Pad(aProcData[2],80)
    @ nRow++,0 DCSAY 'Procedure Input:'
    @ nRow++,0 DCGET aProcData[2]

    aProcData[3] := Pad(aProcData[3],60)
    @ nRow++,0 DCSAY 'Procedure Output:'
    @ nRow++,0 DCGET aProcData[3]

    @ nRow++,0 DCSAY 'SQL Script:'
    @ nRow++,0 DCMULTILINE aProcData[4] SIZE 100,10 FONT ::cMessageFont NOHSCROLL ;
           RESIZE DCGUI_RESIZE_RESIZEONLY

  ENDIF

ELSEIF lGetData

  aProcData := { '', '', '', '', '', '',0 }
  DO WHILE !(cAlias)->(Eof())
    aProcData[2]+=Strtran((cAlias)->parameter_name,'@','') +','+Trim((cAlias)->data_type) + ';'
    (cAlias)->(dbSkip())
  ENDDO

ELSE

  aProcData := { (cAlias)->routine_definition, ;
                 (cAlias)->created, ;
                 (cAlias)->last_altered }

  IF Empty(oTreeItem)
    @ nRow++,0 DCSAY 'Procedure Name:'
    @ nRow++,0 DCGET cProcedure

    @ nRow++,0 DCSAY 'Procedure Created:'
    @ nRow++,0 DCGET aProcData[2]

    @ nRow++,0 DCSAY 'Procedure Last Altered:'
    @ nRow++,0 DCGET aProcData[3]

    @ nRow++,0 DCSAY 'SQL Script:'
    @ nRow++,0 DCMULTILINE aProcData[1] SIZE 100,15 FONT ::cMessageFont NOHSCROLL ;
               RESIZE DCGUI_RESIZE_RESIZEONLY
  ENDIF

ENDIF

IF lGetData
  IF (cAlias)->(RecCount()) == 0
    nError := 1
  ENDIF
  (cAlias)->(dbCloseArea())
  RETURN aProcData
ENDIF

DCGETOPTIONS RESIZE RESIZEDEFAULT DCGUI_RESIZE_REPOSONLY_Y ;
  SAYWIDTH 0 SAYBOTTOM SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT TITLE 'Properties of Procedure: ' + cProcedure ;
   MODAL SETAPPWINDOW NOAUTORESTORE OPTIONS GetOptions ;
   BUTTONS DCGUI_BUTTON_OK EVAL {|o|::SetWindowPos(o)}

(cAlias)->(dbCloseArea())

RETURN nil

* ------------------

/*
METHOD SqlQuery:DictViewProperties( cViewName, nConnectHandle, oConnection, oTreeItem )

LOCAL aProperties, i, nProperty, xValue, nLen, nError, nRow, ;
      GetList[0], GetOptions, nColor

aProperties := { ;
   { ADS_DD_COMMENT, Space(200), 200, 'Comment'}, ;
   { ADS_DD_VIEW_STMT_LEN, 2, 2, 'Statement Length'}, ;
   { ADS_DD_VIEW_STMT, Space(1000), 1000, 'Statement' } }

nRow := 0

FOR i := 1 TO Len(aProperties)

  ASize(aProperties[i],7)
  nProperty := aProperties[i,1]
  xValue := aProperties[i,2]
  nLen := aProperties[i,3]

  nError := AdsDDGetViewProperty( nConnectHandle, ;
                         cViewName, ;
                         nProperty, ;
                         @xValue, ;
                         @nLen )

  IF nError = 5132
    DCMSGBOX DC_AdsGetLastError() FONT ::cMessageFont
    RETURN .f.
  ENDIF

  IF Valtype(xValue) = 'C'
    xValue := Strtran(xValue,Chr(0),'')
  ENDIF
  aProperties[i,5] := xValue
  aProperties[i,6] := nError
  aProperties[i,7] := AllTrim(DC_AdsGetLastError())

  IF nError == 0
    nColor := GRA_CLR_WHITE
  ELSE
    nColor := GRA_CLR_PALEGRAY
  ENDIF

  @ nRow++, 0 DCSAY aProperties[i,4] + ':' SAYSIZE 0 SAYBOTTOM
  IF i < 3
    @ nRow++, 0 DCGET aProperties[i,5] GETSIZE IIF(aProperties[i,3]>100,50,nil) ;
                TOOLTIP aProperties[i,7] COLOR nil, nColor
  ELSE
    @ nRow++, 0 DCMULTILINE aProperties[i,5] NOHSCROLL FONT ::cMessageFont ;
                SIZE 130,10
  ENDIF

NEXT

DCGETOPTIONS ;
  NORESIZE ;
  EDITPROTECT {||.t.} ;
  COLOR GRA_CLR_WHITE

DCREAD GUI FIT ;
   NOAUTORESTORE ;
   MODAL ;
   BUTTONS DCGUI_BUTTON_OK ;
   TITLE 'View: ' + cViewName + ' Properties' ;
   OPTIONS GetOptions

RETURN .t.

*/

* -------------

METHOD SqlQuery:SqlScriptProperties( cScriptName, oConnection, oTreeItem )

LOCAL nRow, GetList[0], GetOptions, nColor, lStatus, cTitle, ;
      cStatement, nSaveRec, oStatement, oDlg, cScriptType, nViewType

nRow := 0

::openViewsFile()

IF !SqlQuery->(dbSeek(Pad(oConnection:GroupName,10)+Pad(cScriptName,50),,'TITLE'))
  DCMSGBOX 'Script not found in SqlQuery.DBF file' FONT ::cMessageFont ;
      OWNER AppDeskTop()
  lStatus := .f.
ELSE
  IF SqlQuery->viewtype == 2
    RETURN ::SaveLinkedView( nil, nil, nil, .f. )
  ENDIF
  cStatement := Sqlquery->statement
  cTitle := Sqlquery->title
  nViewType := SqlQuery->viewtype
  lStatus := .t.
ENDIF
nSaveRec := SqlQuery->(RecNo())
IF !lStatus
  SqlQuery->(dbCloseArea())
  RETURN .f.
ENDIF
IF nViewType $ { 0,1,2,3 }
  cScriptType := 'SQL Script'
ELSEIF nViewType = VIEWTYPE_XBASECOMMANDS
  cScriptType := 'Command Script'
ELSEIF nViewType = VIEWTYPE_ISAMBROWSE
  cScriptType := 'ISAM Script'
ELSE
  cScriptType := '<unknown type>'
ENDIF

@ nRow++, 0 DCSAY 'Script type: ' SAYSIZE 0 SAYBOTTOM ;
       RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ DCGUI_ROW, DCGUI_COL + 10 DCSAY cScriptType SAYSIZE 0 SAYBOTTOM ;
       COLOR GRA_CLR_BLUE FONT '10.Lucida Console' ;
       RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ nRow++, 0 DCSAY 'Title:' SAYSIZE 0 SAYBOTTOM ;
            RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ nRow++, 0 DCGET cTitle ;
            RESIZE DCGUI_RESIZE_REPOSONLY_Y

IF nViewType $ { 0,1,2,3 }
  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Execute this Script' ;
     SIZE 15,1  ACTION {||oStatement:getData(), ;
                          DD_SqlErrorWindow(soMessageBox), ;
                          GuiRun({|a,b|::ExecuteSQL(cStatement,,oConnection)})}
ELSEIF nViewType = VIEWTYPE_XBASECOMMANDS
  @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Execute this Script' ;
     SIZE 15,1  ACTION {||GuiRun({|a|::ExecuteCommands(cStatement,soMessageBox,.f.,oConnection)})}
ENDIF

nRow++

@ nRow++, 0 DCMULTILINE cStatement NOHSCROLL FONT ::cMessageFont ;
             SIZE 100,25 RESIZE DCGUI_RESIZE_RESIZEONLY OBJECT oStatement

DCGETOPTIONS ;
   RESIZE SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT ;
   NOAUTORESTORE ;
   MODAL  ;
   ADDBUTTONS ;
   TO lStatus ;
   TITLE 'Script: ' + cScriptName + ' Properties' ;
   OPTIONS GetOptions ;
   NODESTROY ;
   PARENT @oDlg ;
   SETAPPWINDOW ;
   EVAL {|o|::SetWindowPos(o)}

IF lStatus
  DCMSGBOX 'Save changes to this Script?' YESNO FONT ::cMessageFont ;
     TO lStatus OWNER oDlg
  IF lStatus .AND. SqlQuery->(DC_RecLock())
    SqlQuery->(dbGoTo(nSaveRec))
    REPLACE SqlQuery->title WITH cTitle, ;
            SqlQuery->statement WITH cStatement
    cScriptName := Trim(cTitle)
    SqlQuery->(dbRUnlock())
    oTreeItem:setCaption(Alltrim(cTitle))
  ENDIF
ENDIF
oDlg:destroy()
SetAppWindow(::oMainWindow)
SqlQuery->(dbCloseArea())

RETURN .t.

* ------------------

METHOD SqlQuery:DictFieldProperties( cTableName, cFieldName, nConnectHandle )

LOCAL aProperties, i, nProperty, xValue, nLen, nError, nRow, ;
      GetList[0], GetOptions, nColor

aProperties := { ;
   { ADS_DD_COMMENT, Space(200), 200, 'Comment'}, ;
   { ADS_DD_USER_DEFINED_PROP, Space(200), 200, 'User Defined Property' }, ;
   { ADS_DD_FIELD_DEFAULT_VALUE, Space(200), 200, 'Default Value'}, ;
   { ADS_DD_FIELD_CAN_NULL, 2, 2, 'Null Value Allowed'}, ;
   { ADS_DD_FIELD_MIN_VALUE, Space(200), 200, 'Minimum Value'}, ;
   { ADS_DD_FIELD_MAX_VALUE, Space(200), 200, 'Maximum Value'}, ;
   { ADS_DD_FIELD_VALIDATION_MSG, Space(200), 200, 'Validation Error Message'}, ;
   { ADS_DD_FIELD_LENGTH, 2, 2, 'Field Length'}, ;
   { ADS_DD_FIELD_TYPE, 2, 2, 'Field Type'}, ;
   { ADS_DD_FIELD_DECIMAL, 2, 2, 'Field Decimals'} }

nRow := 0

FOR i := 1 TO Len(aProperties)

  ASize(aProperties[i],7)
  nProperty := aProperties[i,1]
  xValue := aProperties[i,2]
  nLen := aProperties[i,3]

  nError := AdsDDGetFieldProperty( nConnectHandle, ;
                         cTableName, ;
                         cFieldName, ;
                         nProperty, ;
                         @xValue, ;
                         @nLen )

  IF Valtype(xValue) = 'C'
    xValue := Strtran(xValue,Chr(0),'')
  ENDIF
  aProperties[i,5] := xValue
  aProperties[i,6] := nError
  aProperties[i,7] := AllTrim(DC_AdsGetLastError())

  IF nError == 0
    nColor := GRA_CLR_WHITE
  ELSE
    nColor := GRA_CLR_PALEGRAY
  ENDIF

  @ nRow++, 0 DCSAY aProperties[i,4] + ':' SAYSIZE 0 SAYBOTTOM
  @ nRow++, 0 DCGET aProperties[i,5] GETSIZE IIF(aProperties[i,3]>100,50,nil) ;
              TOOLTIP aProperties[i,7] COLOR nil, nColor

NEXT

DCGETOPTIONS NORESIZE EDITPROTECT {||.t.} COLOR GRA_CLR_WHITE ;
   SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT ;
   NOAUTORESTORE ;
   MODAL ;
   BUTTONS DCGUI_BUTTON_OK ;
   TITLE 'Field: ' + cTableName + '.' + cFieldName + ' Properties' ;
   OPTIONS GetOptions ;
   EVAL {|o|::SetWindowPos(o)}

RETURN nil

* ------------------

METHOD SqlQuery:DictGroupProperties( cGroupName, nConnectHandle )

LOCAL aProperties, i, nProperty, xValue, nLen, nError, nRow, ;
      GetList[0], GetOptions, nColor

aProperties := { ;
   { ADS_DD_COMMENT, Space(200), 200, 'Comment'}, ;
   { ADS_DD_USER_DEFINED_PROP, Space(200), 200, 'User Defined Property' } }

nRow := 0

FOR i := 1 TO Len(aProperties)

  ASize(aProperties[i],7)
  nProperty := aProperties[i,1]
  xValue := aProperties[i,2]
  nLen := aProperties[i,3]

  nError := AdsDDGetUserGroupProperty( nConnectHandle, ;
                         cGroupName, ;
                         nProperty, ;
                         @xValue, ;
                         @nLen )

  IF Valtype(xValue) = 'C'
    xValue := Strtran(xValue,Chr(0),'')
  ENDIF
  aProperties[i,5] := xValue
  aProperties[i,6] := nError
  aProperties[i,7] := AllTrim(DC_AdsGetLastError())

  IF nError == 0
    nColor := GRA_CLR_WHITE
  ELSE
    nColor := GRA_CLR_PALEGRAY
  ENDIF

  @ nRow++, 0 DCSAY aProperties[i,4] + ':' SAYSIZE 0 SAYBOTTOM
  @ nRow++, 0 DCGET aProperties[i,5] GETSIZE IIF(aProperties[i,3]>100,50,nil) ;
              TOOLTIP aProperties[i,7] COLOR nil, nColor

NEXT

DCGETOPTIONS NORESIZE EDITPROTECT {||.t.} COLOR GRA_CLR_WHITE ;
   SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT ;
   NOAUTORESTORE ;
   MODAL ;
   BUTTONS DCGUI_BUTTON_OK ;
   TITLE 'Group: ' + cGroupName + ' Properties' ;
   OPTIONS GetOptions ;
   EVAL {|o|::SetWindowPos(o)}

RETURN nil

* ------------------

METHOD SqlQuery:DictUserProperties( cUserName, nConnectHandle )

LOCAL aProperties, i, nProperty, xValue, nLen, nError, nRow, ;
      GetList[0], GetOptions, nColor

aProperties := { ;
   { ADS_DD_COMMENT, Space(200), 200, 'Comment'}, ;
   { ADS_DD_USER_DEFINED_PROP, Space(200), 200, 'User Defined Property' }, ;
   { ADS_DD_USER_GROUP_MEMBERSHIP, Space(200), 200, 'Group Membership' } }

nRow := 0

FOR i := 1 TO Len(aProperties)

  ASize(aProperties[i],7)
  nProperty := aProperties[i,1]
  xValue := aProperties[i,2]
  nLen := aProperties[i,3]

  nError := AdsDDGetUserProperty( nConnectHandle, ;
                         cUserName, ;
                         nProperty, ;
                         @xValue, ;
                         @nLen )

  IF Valtype(xValue) = 'C'
    xValue := Strtran(xValue,Chr(0),'')
  ENDIF
  aProperties[i,5] := xValue
  aProperties[i,6] := nError
  aProperties[i,7] := AllTrim(DC_AdsGetLastError())

  IF nError == 0
    nColor := GRA_CLR_WHITE
  ELSE
    nColor := GRA_CLR_PALEGRAY
  ENDIF

  @ nRow++, 0 DCSAY aProperties[i,4] + ':' SAYSIZE 0 SAYBOTTOM
  @ nRow++, 0 DCGET aProperties[i,5] GETSIZE IIF(aProperties[i,3]>100,50,nil) ;
              TOOLTIP aProperties[i,7] COLOR nil, nColor

NEXT

DCGETOPTIONS NORESIZE EDITPROTECT {||.t.} COLOR GRA_CLR_WHITE ;
   SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT ;
   NOAUTORESTORE ;
   MODAL ;
   BUTTONS DCGUI_BUTTON_OK ;
   TITLE 'User: ' + cUserName + ' Properties' ;
   OPTIONS GetOptions ;
   EVAL {|o|::SetWindowPos(o)}

RETURN nil

* ------------------

METHOD SqlQuery:DictRIProperties( cRIName, nConnectHandle )

LOCAL aProperties, i, nProperty, xValue, nLen, nError, nRow, ;
      GetList[0], GetOptions, nColor

aProperties := { ;
   { ADS_DD_COMMENT, Space(200), 200, 'Comment'}, ;
   { ADS_DD_RI_PRIMARY_TABLE, Space(200), 200, 'Primary Table' }, ;
   { ADS_DD_RI_PRIMARY_INDEX, Space(200), 200, 'Primary Index' }, ;
   { ADS_DD_RI_FOREIGN_TABLE, Space(200), 200, 'Foreign Table' }, ;
   { ADS_DD_RI_FOREIGN_INDEX, Space(200), 200, 'Foreign Index' }, ;
   { ADS_DD_RI_NO_PKEY_ERROR, Space(200), 200, 'Primary Key Violation Error Message' }, ;
   { ADS_DD_RI_CASCADE_ERROR, Space(200), 200, 'Cascade Error Message' }, ;
   { ADS_DD_RI_UPDATERULE, 2, 2, 'Update Rule for RI Constraint' }, ;
   { ADS_DD_RI_DELETERULE, 2, 2, 'Delete Rule for RI Constraint' } }

nRow := 0

FOR i := 1 TO Len(aProperties)

  ASize(aProperties[i],7)
  nProperty := aProperties[i,1]
  xValue := aProperties[i,2]
  nLen := aProperties[i,3]

  nError := AdsDDGetRefIntegrityProperty( nConnectHandle, ;
                         cRIName, ;
                         nProperty, ;
                         @xValue, ;
                         @nLen )

  IF Valtype(xValue) = 'C'
    xValue := Strtran(xValue,Chr(0),'')
  ENDIF
  aProperties[i,5] := xValue
  aProperties[i,6] := nError
  aProperties[i,7] := AllTrim(DC_AdsGetLastError())

  IF nError == 0
    nColor := GRA_CLR_WHITE
  ELSE
    nColor := GRA_CLR_PALEGRAY
  ENDIF

  @ nRow++, 0 DCSAY aProperties[i,4] + ':' SAYSIZE 0 SAYBOTTOM
  @ nRow++, 0 DCGET aProperties[i,5] GETSIZE IIF(aProperties[i,3]>100,50,nil) ;
              TOOLTIP aProperties[i,7] COLOR nil, nColor

NEXT

DCGETOPTIONS NORESIZE EDITPROTECT {||.t.} COLOR GRA_CLR_WHITE ;
   SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT ;
   NOAUTORESTORE ;
   MODAL ;
   BUTTONS DCGUI_BUTTON_OK ;
   TITLE 'Relation (RI): ' + cRIName + ' Properties' ;
   OPTIONS GetOptions ;
   EVAL {|o|::SetWindowPos(o)}

RETURN nil

* -------------

METHOD SqlQuery:AdsIsTableEncrypted( cTableName, oConnection )

LOCAL nTableHandle := 0, lIsEncrypted := .f., nError

IF Valtype(oConnection:handleDict) == 'N'
  nError := AdsOpenTable( oConnection:handleDict, ;
              cTableName, ;
              '', ;
              ADS_DEFAULT, ;
              ADS_OEM, ;
              ADS_PROPRIETARY_LOCKING, ;
              ADS_IGNORERIGHTS, ;
              ADS_EXCLUSIVE, ;
              @nTableHandle )

  IF nError == 0
    nError := AdsIsTableEncrypted( nTableHandle, @lIsEncrypted )
    AdsCloseTable( nTableHandle )
  ENDIF

ENDIF

RETURN lIsEncrypted

* -------------

METHOD SqlQuery:AdsListFilesNotInDictionary( aTables, oConnection, oTreeItem )

LOCAL cDataFolder, aDir, i, cTableName, GetList[0], oBrowse, nPointer := 1, ;
      nFound, GetOptions

cDataFolder := Alltrim(oConnection:serverFree)

IF Empty(cDataFolder)
  cDataFolder := DC_Path(Alltrim(oConnection:serverDict))
ENDIF

aDir := Directory(cDataFolder+'/' + '*.DBF' )

FOR i := 1 TO Len(aDir)
  cTableName := Upper(aDir[i,1])
  cTableName := Strtran(cTableName,'.DBF','')
  nFound := AScan( aTables,{|a|Upper(a[1])==cTableName})
  AAdd(aDir[i],nFound > 0)
NEXT

@ 0,0 DCBROWSE oBrowse DATA aDir SIZE 100,25 FIT ;
      FONT '10.Lucida Console' NOHSCROLL ;
      COLOR {||FileColor(aDir,oBrowse)} ;
      RESIZE DCGUI_RESIZE_RESIZEONLY_Y ;
      POINTER nPointer ;
      ITEMMARKED {||DC_GetWhen(GetList)} ;
      ITEMSELECTED {|o|o:=Thread():new(), ;
                       o:start({||_BrowseFile(aDir[nPointer,1],self,oConnection,cDataFolder)})}

DCBROWSECOL ELEMENT 1 HEADER 'File Name' WIDTH 35 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER 'Size' WIDTH 10 PARENT oBrowse
DCBROWSECOL ELEMENT 3 HEADER 'Date' WIDTH 10 PARENT oBrowse
DCBROWSECOL ELEMENT 4 HEADER 'Time' WIDTH 10 PARENT oBrowse

DCBROWSECOL ELEMENT 11 HEADER 'In Dictionary' WIDTH 12 PARENT oBrowse

@ 26,0 DCPUSHBUTTON CAPTION 'Delete File' SIZE 12,1.2 ;
       ACTION {||Ferase(cDataFolder + aDir[nPointer,1]), ;
                 ARemove(aDir,nPointer), ;
                 oBrowse:refreshAll()} ;
       WHEN {||!aDir[nPointer,11]}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Add to Dictionary' SIZE 15,1.2 ;
       ACTION {||AdsAddTableToDD(cDataFolder, aDir[nPointer], oConnection, aTables, oBrowse, oTreeItem)} ;
       WHEN {||!aDir[nPointer,11]}

DCGETOPTIONS RESIZE

DCREAD GUI FIT TITLE 'Data files NOT in Data Dictionary are YELLOW' ;
   MODAL OPTIONS GetOptions NOAUTORESTORE

RETURN nil

* -------------

STATIC FUNCTION _BrowseFile( cFileName, self, oConnection, cDataFolder )

IF !Empty(oConnection:sessionFree)
  dbeSetDefault('ADSDBE')
  DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE, oConnection:AdsTableType )
  DbeInfo( COMPONENT_ORDER, ADSDBE_TBL_MODE, oConnection:AdsTableType )
  DbeInfo( COMPONENT_DATA, ADSDBE_LOCK_MODE, oConnection:AdsLockingType )
  DbeInfo( COMPONENT_DATA, ADSDBE_TABLENAME_IS_ALIAS, .f. )

  USE (cDataFolder+cFileName) VIA (oConnection:sessionFree)
  ::dataBrowse(,,oConnection)
ELSE
  DCMSGBOX 'There is no FREE TABLE connection to browse this file' ;
      FONT '10.Lucida Console' TIMEOUT 5
ENDIF

RETURN nil

* -------------

STATIC FUNCTION FileColor( aDir, oBrowse )

LOCAL aColor

IF aDir[oBrowse:arrayElement,11]
  aColor := {nil,GRA_CLR_WHITE}
ELSE
  aColor := {nil,GRA_CLR_YELLOW}
ENDIF

RETURN aColor

* -------------

STATIC FUNCTION AdsAddTableToDD( cDataFolder, aDirItem, oConnection, aTables, oBrowse, oTreeitem )

LOCAL lStatus, GetList[0], nError, nHandle, cDesc := Space(100), cFileName

cFileName := cDataFolder + aDirItem[1]

@ 0,0 DCSAY cFileName + ' will be added to the Data Dictionary' SAYSIZE 0 ;
      FONT '10.Lucida Console'

@ 2,0 DCSAY 'Description' GET cDesc GETSIZE 50 SAYSIZE 0 SAYBOTTOM

DCREAD GUI FIT ADDBUTTONS MODAL TO lStatus

IF lStatus

  nHandle := oConnection:handleDict

  nError := AdsDDAddTable( nHandle, nil, cFileName, ADS_CDX, ADS_OEM, nil, Alltrim(cDesc) )

  IF nError == 0
    aDirItem[11] := .t.
    oBrowse:refreshCurrent()
  ELSE
    DCMSGBOX DC_AdsGetLastError()
  ENDIF

ENDIF

RETURN lStatus

* -------------

METHOD Sqlquery:AdsTestDictionary( aTables, oConnection, oTreeItem )

LOCAL GetList[0], oBrowse, aFiles[0], i

FOR i := 1 TO Len(aTables)
  AAdd( aFiles, { aTables[i,1], Pad('Pending',100), .f.} )
NEXT

DCHOTKEY xbeK_SPACE ;
   ACTION {||aFiles[oBrowse:arrayElement,3] := ;
             !aFiles[oBrowse:arrayElement,3], ;
             oBrowse:refreshCurrent()} ;
   WHEN {||SetAppFocus() == oBrowse}

@ 0,0 DCSAY 'Use Space bar to tag/untag' SAYSIZE 0 FONT ::cMessageFont

@ 1,0 DCBROWSE oBrowse DATA aFiles SIZE 60,25 FIT ;
      FONT '9.Lucida Console' ;
      COLOR {||IIF( aFiles[oBrowse:arrayElement,3],{nil,GRA_CLR_YELLOW},{nil,GRA_CLR_WHITE})}

DCBROWSECOL ELEMENT 1 HEADER 'Table Name' WIDTH 25 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER 'Status' WIDTH 25 PARENT oBrowse

@ 27,0 DCPUSHBUTTON CAPTION 'Start Test' SIZE 12, 1.2 ;
      ACTION {||_TestTables( aFiles, oBrowse, oConnection )}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Remove Tagged Tables from Dictionary' ;
      SIZE 35, 1.2  ACTION {||_RemoveTables( self, aFiles, oBrowse, oConnection )}

DCREAD GUI FIT TITLE 'Test Tables in ADS Dictionary' MODAL ;

RETURN nil

* -------------

STATIC FUNCTION _TestTables( aFiles, oBrowse, oConnection )

LOCAL i, bError := ErrorBlock({|e|Break(e)}), lError

oBrowse:goTop()
oBrowse:forceStable()

FOR i := 1 TO Len(aFiles)

  lError := .t.
  BEGIN SEQUENCE
  USE (aFiles[i,1]) VIA (oConnection:sessionDict)
  lError := .f.
  END SEQUENCE
  IF lError
    aFiles[i,2] := 'Error Opening Table'
    aFiles[i,3] := .t.
  ELSE
    aFiles[i,2] := 'Success'
    aFiles[i,3] := .f.
    dbCloseArea()
  ENDIF
  oBrowse:down()
  oBrowse:forceStable()
  oBrowse:refreshCurrent()

NEXT

ErrorBlock(bError)
dbCloseAll()

RETURN nil

* -------------

STATIC FUNCTION _RemoveTables( self, aFiles, oBrowse, oConnection )

LOCAL i

oBrowse:goTop()
oBrowse:forceStable()

FOR i := 1 TO Len(aFiles)

  IF aFiles[i,3]
    IF ::AdsDDRemoveTable( aFiles[i,1], oConnection,,.f. )
      aFiles[i,2] := 'Table was Removed'
    ELSE
      aFiles[i,2] := 'Error Removing Table'
    ENDIF
  ENDIF

  oBrowse:down()
  oBrowse:forceStable()
  oBrowse:refreshCurrent()

NEXT

RETURN nil

* -------------

METHOD SqlQuery:AdsTableSetEncrypted( cTableName, oConnection, oTreeItem )

LOCAL cSql, lStatus := .f., nIcon, lIsEncrypt

lIsEncrypt := !::AdsIsTableEncrypted( cTableName, oConnection )

cSql := "EXECUTE PROCEDURE sp_ModifyTableProperty('" + cTablename +"','TABLE_ENCRYPTION','" + ;
        IIF(lIsEncrypt,'TRUE','FALSE') + "','','');"

IF ::ExecuteSQL(cSql,,oConnection)
  IF lIsEncrypt
    nIcon := ICON_TABLE_LOCKED
  ELSE
    nIcon := ICON_TABLE
  ENDIF
  oTreeItem:setImage(nIcon)
  oTreeItem:setExpandedImage(nIcon)
  oTreeItem:setMarkedImage(nIcon)
  lStatus := .t.
ENDIF

RETURN lStatus

* -------------

METHOD SqlQuery:DictReindexTable( cTableName, oConnection )

LOCAL nError, nTablehandle := 0, lStatus, oScrn


DCMSGBOX 'This selection will reindex all keys in ' + cTableName + '.cdx', ;
         '', ;
         'Continue?' YESNO TO lStatus FONT ::cMessageFont OWNER AppDeskTop()

IF !lStatus
  RETURN .f.
ENDIF

nError := AdsOpenTable( oConnection:handleDict, ;
              cTableName, ;
              '', ;
              ADS_DEFAULT, ;
              ADS_OEM, ;
              ADS_PROPRIETARY_LOCKING, ;
              ADS_IGNORERIGHTS, ;
              ADS_EXCLUSIVE, ;
              @nTableHandle )

IF nError > 0
  DC_WinAlert(DC_AdsGetLastError())
  RETURN .f.
ENDIF

oScrn := DC_WaitOn('Reindexing ' + cTableName + '.cdx ...')
nError := AdsReindex( nTableHandle )
AdsCloseTable(nTableHandle)
DC_Impl(oScrn)

IF nError > 0
  DC_WinAlert(DC_AdsGetLastError())
  RETURN .f.
ELSE
  DCMSGBOX 'Reindex Complete!' FONT ::cMessageFont
ENDIF

RETURN .t.

* -------------

METHOD SqlQuery:ViewProperties( cViewname, nConnectHandle, oConnection )

LOCAL nProperty, cStatement := Space(1000), nLen, nError, lStatus, cSql, ;
      GetList[0], GetOptions

IF oConnection:type == 'ADS' .AND. nConnectHandle > 0

  nProperty := ADS_DD_VIEW_STMT
  nLen := 1000

  nError := AdsDDGetViewProperty( nConnectHandle, ;
                         cViewName, ;
                         nProperty, ;
                         @cStatement, ;
                         @nLen )

ELSEIF oConnection:type == 'ODBC'

  IF 'ADVANTAGE STREAMLINESQL' $ Upper(oConnection:driver)
    cSql := "SELECT name AS table_name, view_stmt AS statement FROM system.views " + ;
            "WHERE name = '" + cViewName + "'"
  ELSE
    cSql := "SELECT table_name, view_definition as statement " + ;
            "FROM INFORMATION_SCHEMA.VIEWS " + ;
            "WHERE table_name = '" + cViewName + "'"
  ENDIF

  DDSTATEMENT (cSql) VIA oConnection:sessionDict

  IF Empty(Alias())
    RETURN .f.
  ENDIF

  cStatement := (Alias())->statement

ENDIF

lStatus := .f.
IF !Empty(cStatement)
  DCGETOPTIONS RESIZE RESIZEDEFAULT DCGUI_RESIZE_RESIZEONLY SCALEFACTOR ::aScaleFactor
  @ 0,0 DCSAY 'View Statement:' SAYSIZE 0 SAYBOTTOM RESIZE DCGUI_RESIZE_REPOSONLY_Y
  @ 1,0 DCMULTILINE cStatement SIZE 120,20 NOHSCROLL FONT ::cMessageFont
  DCREAD GUI FIT TITLE 'Properties of View: ' + cViewName ;
      NOAUTORESTORE MODAL OPTIONS GetOptions EVAL {|o|::SetWindowPos(o)}
  lStatus := .t.
ELSE
  DCMSGBOX 'View: ' + cViewName + ' not found in database' ;
     FONT ::cMessageFont OWNER AppDeskTop()
ENDIF

RETURN lStatus

* -------------

METHOD SqlQuery:ViewExecute( cViewName, oConnection, nBrowseType )

LOCAL cStatement

IF ' ' $ cViewName
  cStatement := 'SELECT * FROM [' + cViewName + ']'
ELSE
  cStatement := 'SELECT * FROM ' + cViewName
ENDIF

GuiRun({|a|::ExecuteSQL(cStatement,'QUERY',oConnection,,nBrowseType)})

RETURN .t.

* ---------------

METHOD SqlQuery:DictProcedureExecuteSQL( cProcedure, oConnection, nBrowseType, lAllowCancel )

LOCAL GetList[0], GetOptions, aProcData, cParameters, aTokens, i, ;
      nRow := 0, lStatus, cVarName, cStatement, aData, aInput[0], cAlias, ;
      lAdsODBC, nFound, cType, nError := 0

IF oConnection:type = 'ADS'
  aProcData := ::DictProcedurePropertiesADS( .t., cProcedure, oConnection,,  @nError )
ELSEIF oConnection:type = 'ODBC'
  aProcData := ::DictProcedurePropertiesODBC( .t., cProcedure, oConnection )
ELSE
  RETURN .f.
ENDIF

IF nError > 0
  DCMSGBOX 'Procedure "' + cProcedure + '" not found' ;
     FONT ::cMessageFont OWNER AppDeskTop()
  RETURN .f.
ENDIF

cParameters := Alltrim(aProcData[2])

BEGIN SEQUENCE
IF Empty(cParameters)
  lStatus := .t.
  BREAK
ENDIF

aTokens := DC_TokenArray(cParameters,';')
FOR i := 1 TO Len(aTokens)
  IF Empty(aTokens[i])
    ARemove(aTokens,i)
    i--
    LOOP
  ENDIF
  aData := DC_TokenArray(aTokens[i],',')
  nFound := At(',',aTokens[i])
  cVarName := Substr(aTokens[i],1,nFound-1)
  cType := Substr(aTokens[i],nFound+1)
  aData := _GetDataValue( cType )
  AAdd(aInput,{cVarName,aData[1],aData[2],aData[3]})
NEXT
FOR i := 1 TO Len(aInput)
  cVarName := DC_CapFirst(aInput[i,1])
  @ nRow++,0 DCSAY cVarName GET aInput[i,2] PICTURE aInput[i,3] POPUP aInput[i,4]
  @ DCGUI_ROW, DCGUI_COL DCSAY '' SAYSIZE 30
NEXT

DCGETOPTIONS SAYWIDTH 100 SAYRIGHTBOTTOM SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT ADDBUTTONS TITLE 'Execute Procedure: ' + cProcedure TO lStatus ;
   OPTIONS GetOptions MODAL SETAPPWINDOW ENTEREXIT

END SEQUENCE

IF lStatus

  lAdsODBC := (oConnection:type = 'ODBC' .AND. 'ADVANTAGE STREAMLINESQL' $ Upper(oConnection:driver))

  IF oConnection:type = 'ADS'
    IF Left(Upper(Alltrim(aProcData[7])),6) = 'SELECT'
      cStatement := Alltrim(aProcData[7])
      FOR i := 1 TO Len(aInput)
        cStatement := Strtran(cStatement,'_' + aInput[i,1], DC_Var2Sql(aInput[i,2]))
      NEXT
      cStatement := Trim(cStatement)
      IF Right(cStatement,1) == ';'
        cStatement := Substr(cStatement,1,Len(cStatement)-1)
      ENDIF
    ELSE
      cStatement := 'EXECUTE PROCEDURE ' + cProcedure + '('
      FOR i := 1 TO Len(aInput)
        cStatement += DC_Var2Sql(aInput[i,2]) + IIF( i<Len(aInput),',','' )
      NEXT
      cStatement += ');'
    ENDIF
  ELSEIF oConnection:type = 'ODBC' .AND. 'SQL SERVER' $ Upper(oConnection:driver)
    cStatement := 'EXECUTE ' + cProcedure + ' '
    FOR i := 1 TO Len(aInput)
      cStatement += '@' + aInput[i,1] + ' = ' + ;
         DC_Var2Sql(aInput[i,2]) + IIF( i<Len(aInput),',','' )
    NEXT
    cStatement += ';'
  ELSEIF lAdsODBC
    IF Left(Upper(Alltrim(aProcData[4])),6) = 'SELECT'
      cStatement := Alltrim(aProcData[4])
      FOR i := 1 TO Len(aInput)
        cStatement := Strtran(cStatement,'_' + aInput[i,1], DC_Var2Sql(aInput[i,2]))
      NEXT
    ELSE
      DCMSGBOX 'Cannot execute this procedure due to bug in ADS ODBC', ;
               'We are working on it!' FONT ::cMessageFont ;
               OWNER AppDeskTop()
      RETURN .f.
    ENDIF
  ENDIF

  cAlias := 'QUERY'
  ::ExecuteSQL(cStatement,cAlias,oConnection,,nBrowseType,,lAllowCancel)
ENDIF

RETURN lStatus

* ---------------

STATIC FUNCTION _GetDataValue( cType )

LOCAL xValue, cPicture, bPopup, nLen := 0, nDec := 0, aTokens

cType := Upper(cType)

IF '(' $ cType
  aTokens := DC_TokenArray(cType,'()')
  ASize(aTokens,3)
  DEFAULT aTokens[3] := ''
  cType := aTokens[1]
  nLen := Val(aTokens[2])
  nDec := Val(aTokens[3])
ELSE
  aTokens := DC_TokenArray(cType,',')
  ASize(aTokens,3)
  cType := aTokens[1]
  DEFAULT aTokens[2] := '', ;
          aTokens[3] := ''
  nLen := Val(aTokens[2])
  nDec := Val(aTokens[3])
ENDIF

IF cType $ {'INT','INTEGER','SMALLINT','BIGINT','TINYINT'}
  xValue := 0
  cPicture := '999999'
ELSEIF cType $ {'NUMERIC','DECIMAL','FLOAT','REAL'}
  xValue := 0
  cPicture := Repl('9',nLen)
  IF nDec > 0
    cPicture += '.' + Repl('9',nDec)
  ENDIF
ELSEIF cType $ {'DATE','DATETIME'}
  xValue := Date()
  bPopup := {|d|DC_PopDate(d,,,,,,2)}
ELSEIF cType $ {'LOGICAL','BIT'}
  xValue := .f.
  cPicture := 'Y'
ELSEIF cType $ {'CHAR','NVARCHAR','VARCHAR','CHARACTER','NCHAR','NTEXT','TEXT','VARBINARY'}
  IF nLen > 0
    xValue := Space(nLen)
  ELSE
    xValue := Space(30)
  ENDIF
ELSE
  xValue := 'NULL'
ENDIF

RETURN { xValue, cPicture, bPopup }

* ---------------

METHOD SqlQuery:ShowTableProperties( aData, oConnection )

LOCAL i, GetList[0], aTables[0], aIndexTags[0], aFields[0], ;
      oBrowse1, oBrowse2, oBrowse3, nPointer := 1, GetOptions, ;
      lUpdatingComments := .f., aTableComments[0], lStatus, oDlg, ;
      oButton1

FOR i := 1 TO Len(aData)
  AAdd( aTables, { aData[i,1], aData[i,4], aData[i,4], .f. })
NEXT

DCHOTKEY xbeK_F12 ACTION {||soSqlQuery:updateTableCommentAds()}

@ 0,1 DCSAY 'Tables:' SAYSIZE 0 FONT '9.Lucida Console Bold' ;
       RESIZE DCGUI_RESIZE_REPOSONLY_Y

IF oConnection:type = 'ADS' .AND. oConnection:handleDict > 0
  @ -.2, DCGUI_COL + 20 DCPUSHBUTTON CAPTION 'Update Comments' ;
     SIZE 15,1 ACTION {||lUpdatingComments := .t., ;
                         oBrowse1:right(), oBrowse1:forceStable(), ;
                         PostAppEvent(xbeBRW_ItemSelected,,,oBrowse1)} ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y

  FOR i := 1 TO Len(aTables)
    aTables[i,2] := Pad(aTables[i,2],50)
    aTables[i,3] := Pad(aTables[i,3],50)
  NEXT
ENDIF

@ 1,0 DCBROWSE oBrowse1 DATA aTables SIZE 50,25 ;
      FONT '9.Lucida Console' ;
      POINTER nPointer ;
      NOHSCROLL ;
      COLOR {||IIF(aTables[oBrowse1:arrayElement,4],{nil,GRA_CLR_YELLOW},{nil,nil})} ;
      EDIT IIF(oConnection:type='ADS'.AND.oConnection:handleDict>0, xbeBRW_ItemSelected,-1000) ;
         MODE DCGUI_BROWSE_EDITDOWN ;
      ITEMMARKED {||aFields := _GetFields(aData[nPointer,3], ;
                                          aTables[nPointer,1], ;
                                          oConnection, self ), ;
                    oBrowse2:dataSource := aFields, ;
                    oBrowse2:arrayElement := 1, ;
                    oBrowse2:refreshAll(), ;
                    oButton1:refresh(), ;
                    aIndexTags := _GetIndexTags(aData[nPointer,2], ;
                                                aTables[nPointer,1],;
                                                oConnection, self),;
                    oBrowse3:dataSource := aIndexTags, ;
                    oBrowse3:arrayElement := 1, ;
                    oBrowse3:refreshAll(), ;
                    nil}

DCBROWSECOL ELEMENT 1 HEADER 'Table Name' WIDTH 20 PARENT oBrowse1 ;
   EDITPROTECT {||.t.}

DCBROWSECOL ELEMENT 2 HEADER 'Comment' WIDTH 25 PARENT oBrowse1 ;
   EDITPROTECT {||!lUpdatingComments}

@ 27,0 DCSAY 'Press SPACE bar to tag/untag' SAYSIZE 0 FONT '10.Arial Bold' ;
             RESIZE DCGUI_RESIZE_NONE

@ 0,52 DCSAY 'Fields:' SAYSIZE 0 FONT '9.Lucida Console Bold' ;
       RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ 1, 51 DCBROWSE oBrowse2 DATA aFields SIZE 60,25 FIT ;
      FONT '9.Lucida Console' ;
      HEADLINES 2 ;
      NOHSCROLL

DCBROWSECOL ELEMENT 1 HEADER 'Field;Name' WIDTH 22 PARENT oBrowse2
DCBROWSECOL ELEMENT 2 HEADER 'Field;Type' WIDTH 10 PARENT oBrowse2
DCBROWSECOL ELEMENT 3 HEADER 'Field;Len' WIDTH 5 PARENT oBrowse2 PICTURE '99999'
DCBROWSECOL ELEMENT 4 HEADER 'Field;Dec' WIDTH 5 PARENT oBrowse2 PICTURE '99999'
DCBROWSECOL ELEMENT 5 HEADER 'Field;Pos' WIDTH 5 PARENT oBrowse2 PICTURE '99999'

@ 0,110 DCSAY 'Index Tags:' SAYSIZE 0 FONT '9.Lucida Console Bold' ;
       RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ 1,110 DCBROWSE oBrowse3 DATA aIndexTags SIZE 60,25 ;
      FONT '9.Lucida Console' ;
      NOHSCROLL

DCBROWSECOL ELEMENT 1 HEADER 'Tag Name' WIDTH 15 PARENT oBrowse3
DCBROWSECOL ELEMENT 2 HEADER 'Index Key' WIDTH 20 PARENT oBrowse3 ;
   DATATOOLTIP {||.t.}
DCBROWSECOL ELEMENT 3 HEADER 'For' WIDTH 20 PARENT oBrowse3 ;
   DATATOOLTIP {||.t.}

@ 27,110 DCPUSHBUTTON CAPTION {||'Reindex ' + aTables[nPointer,1]} ;
         SIZE 25,1.2 OBJECT oButton1 WHEN {||oConnection:type = 'ADS'} ;
         ACTION {||::BuildAdsIndexSql(aTables[nPointer,1],aIndexTags,oConnection)} ;
         RESIZE DCGUI_RESIZE_NONE

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION {||'Reindex All Tables'} ;
         SIZE 20,1.2 WHEN {||oConnection:type = 'ADS'} ;
         ACTION {||::BuildAdsIndexSqlAll(aTables,aData,oConnection,oBrowse1,oDlg)} ;
         RESIZE DCGUI_RESIZE_NONE


DCHOTKEY xbeK_SPACE ;
   ACTION {||aTables[nPointer,4] := !aTables[nPointer,4], ;
             oBrowse1:refreshCurrent(), ;
             oBrowse1:down(), ;
             oBrowse1:forceStable(), ;
             DC_CompleteEvents()} ;
   WHEN {||SetAppFocus() == oBrowse1}

DCGETOPTIONS RESIZE ;
   RESIZEDEFAULT DCGUI_RESIZE_RESIZEONLY_Y SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT TITLE 'Tables (' + oConnection:name + ')' ;
   OPTIONS GetOptions MODAL NOAUTORESTORE EVAL {|o|::SetWindowPos(o)} ;
   NODESTROY PARENT @oDlg

IF oConnection:type = 'ADS'
  FOR i := 1 TO Len(aTables)
    IF !(aTables[i,2] == aTables[i,3])
      AAdd(aTableComments,{aTables[i,1],aTables[i,2]})
    ENDIF
  NEXT
  IF !Empty(aTableComments)
    DCMSGBOX 'Comments have been updated.', ;
             'Update the Data-Dictionary with the new Comments?' ;
             YESNO TO lStatus FONT ::cMessageFont TO lStatus ;
             OWNER AppDeskTop()
    IF lStatus
      ::UpdateTableCommentADS( aTableComments, oConnection )
    ENDIF
  ENDIF
ENDIF

oDlg:destroy()

RETURN nil

* ---------------

STATIC FUNCTION _GetIndexTags( aTags, cTableName, oConnection, self )

IF Empty(aTags)
  IF oConnection:type = 'ODBC'
    RETURN (aTags := ::BuildIndexArrayODBC( cTableName, oConnection ))
  ELSEIF oConnection:type = 'ADS'
    RETURN (aTags := ::BuildIndexArrayADS( cTableName, oConnection ))
  ENDIF
  RETURN {}
ELSE
  aTags := aTags[1,2]
  RETURN aTags
ENDIF

RETURN {}

* ---------------

STATIC FUNCTION _GetFields( aFields, cTableName, oConnection, self )

IF Empty(aFields)
  IF oConnection:type = 'ADS'
    RETURN (aFields := ::GetFieldNameArrayADS( cTableName, oConnection:handleDict ))
  ENDIF
ENDIF

RETURN aFields

* -----------

METHOD SqlQuery:UpdateTableCommentADS( aTables, oConnection )

LOCAL cSql := '', i, cTableName, cComment, lStatus

FOR i := 1 TO Len(aTables)
  IF !Empty(aTables[i,1]) .AND. !Empty(aTables[i,2])
    cTableName := aTables[i,1]
    cComment := Trim(aTables[i,2])
    cSql += "EXECUTE PROCEDURE sp_ModifyTableProperty( '" + cTablename + "'," + ;
            "'COMMENT','" + cComment + "', NULL ,NULL);" + CRLF
  ENDIF
NEXT

IF Empty(cSql)
  RETURN .f.
ENDIF

lStatus := ::ExecuteSQL( cSql,,oConnection,,0,,.f.,,'Updating Comments' )

IF lStatus
  DCMSGBOX 'Comments updated Successfully!' FONT ::cMessageFont OWNER AppDeskTop()
ELSE
  DCMSGBOX 'Comments update failed!' FONT ::cMessageFont OWNER AppDeskTop()
ENDIF

RETURN lStatus

* ---------------

METHOD SqlQuery:ShowDataTypes( oConnection )

LOCAL GetList[0], oBrowse1, oBrowse2, i, GetOptions
LOCAL aTypes1 := oConnection:sessionDict:setProperty( ODBCSSN_ODBC_TO_XPP )
LOCAL aTypes2 := oConnection:sessionDict:setProperty( ODBCSSN_XPP_TO_ODBC )

FOR i := 1 TO Len(aTypes2)
  aTypes2[i,2] := Alltrim(DC_Xtoc(aTypes2[i,2]))
NEXT

@ 0,0 DCBROWSE oBrowse1 DATA aTypes1 FONT '10.Lucida Console' SIZE 30,30 FIT NOHSCROLL
DCBROWSECOL ELEMENT 1 HEADER 'ODBC (DBMS-type)' WIDTH 10 PARENT oBrowse1
DCBROWSECOL ELEMENT 2 HEADER 'XPP (DDL-type)' WIDTH 10 PARENT oBrowse1

@ 0,42 DCBROWSE oBrowse2 DATA aTypes2 FONT '10.Lucida Console' SIZE 30,30 FIT NOHSCROLL
DCBROWSECOL ELEMENT 1 HEADER 'XPP (DDL-type)' WIDTH 10 PARENT oBrowse2
DCBROWSECOL ELEMENT 2 HEADER 'FLen' WIDTH 4 PARENT oBrowse2
DCBROWSECOL ELEMENT 3 HEADER 'FDec' WIDTH 4 PICTURE '9999' PARENT oBrowse2
DCBROWSECOL ELEMENT 4 HEADER 'ODBC (DBMS-type)' WIDTH 10 PARENT oBrowse2

DCGETOPTIONS SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT MODAL TITLE 'Data Type Mapping' ;
   NOAUTORESTORE EVAL {|o|::SetWindowPos(o)} ;
   OPTIONS GetOptions

RETURN nil

* ---------------

METHOD SqlQuery:ShowConnectionProperties(oConnection)

LOCAL GetList[0], GetOptions, nRow := 0, cString, aTokens[0]

@ nRow++,0 DCSAY 'INI Group Name:'
@ nRow++,0 DCGET oConnection:GroupName GETSIZE 50

@ nRow++,0 DCSAY 'Connection Name:'
@ nRow++,0 DCGET oConnection:name GETSIZE 100

@ nRow++,0 DCSAY 'Connection Type:'
@ nRow++,0 DCGET oConnection:type GETSIZE 50

@ nRow++,0 DCSAY 'Driver:'
@ nRow++,0 DCGET oConnection:driver GETSIZE 100

@ nRow++,0 DCSAY 'Server:'
IF !Empty(oConnection:Server)
  @ nRow++,0 DCGET oConnection:server GETSIZE 100
ELSE
  @ nRow++,0 DCGET oConnection:serverDict GETSIZE 100
ENDIF

@ nRow++,0 DCSAY 'Database:'
@ nRow++,0 DCGET oConnection:database GETSIZE 100

@ nRow++,0 DCSAY 'User ID:'
@ nRow++,0 DCGET oConnection:uid GETSIZE 50

@ nRow++,0 DCSAY 'Password:'
@ nRow++,0 DCGET oConnection:pwd GETSIZE 50

IF oConnection:type = 'ADS'

  @ nRow++,0 DCSAY 'Server Dictionary:'
  @ nRow++,0 DCGET oConnection:serverDict GETSIZE 100

  @ nRow++,0 DCSAY 'Server Free Table Directory:'
  @ nRow++,0 DCGET oConnection:serverFree GETSIZE 100

  nRow++
  @ nRow++,0 DCSAY 'ADS Server Type:'
  @ DCGUI_ROW, DCGUI_COL + 20 DCRADIO oConnection:AdsServerType PROMPT 'Local' VALUE 1 FONT '10.Lucida Console'
  @ DCGUI_ROW, DCGUI_COL + 10 DCRADIO oConnection:AdsServerType PROMPT 'Remote' VALUE 2 FONT '10.Lucida Console'
  @ DCGUI_ROW, DCGUI_COL + 10 DCRADIO oConnection:AdsServerType PROMPT 'Try Remote fall Back to Local' VALUE 3 FONT '10.Lucida Console'

  nRow++
  @ nRow++,0 DCSAY 'ADS Locking Type:'
  @ DCGUI_ROW, DCGUI_COL + 20 DCRADIO oConnection:AdsLockingType PROMPT 'Compatible' VALUE 0 FONT '10.Lucida Console'
  @ DCGUI_ROW, DCGUI_COL + 10 DCRADIO oConnection:AdsLockingType PROMPT 'Proprietary' VALUE 1 FONT '10.Lucida Console'

  nRow++
  @ nRow++,0 DCSAY 'ADS Table Type:'
  @ DCGUI_ROW, DCGUI_COL + 20 DCRADIO oConnection:AdsTableType PROMPT 'NTX' VALUE 1 FONT '10.Lucida Console'
  @ DCGUI_ROW, DCGUI_COL + 10 DCRADIO oConnection:AdsTableType PROMPT 'CDX' VALUE 2 FONT '10.Lucida Console'
  @ DCGUI_ROW, DCGUI_COL + 10 DCRADIO oConnection:AdsTableType PROMPT 'ADT' VALUE 3 FONT '10.Lucida Console'
  @ DCGUI_ROW, DCGUI_COL + 10 DCRADIO oConnection:AdsTableType PROMPT 'VFP' VALUE 4 FONT '10.Lucida Console'
  nRow++
ENDIF

@ nRow++,0 DCSAY 'Additional Connection String:'
@ nRow++,0 DCGET oConnection:connectString GETSIZE 100

IF Valtype(oConnection:SessionDict) == 'O'
  cString := oConnection:SessionDict:getConnectionString()
  aTokens := DC_TokenArray(cString,';')
  @ nRow++,0 DCSAY 'DacSession Dictionary Connection String:'
  @ nRow++,0 DCSAY oConnection:SessionDict:getConnectionString() ;
     COLOR GRA_CLR_BLUE ;
     SAYWORDBREAK ;
     SAYSIZE 100,Len(aTokens)+2
ENDIF

IF Valtype(oConnection:SessionFree) == 'O'
  IF Len(aTokens) > 0
    nRow += Len(aTokens)-1
  ENDIF
  cString := oConnection:SessionFree:getConnectionString()
  aTokens := DC_TokenArray(cString,';')
  @ nRow++,0 DCSAY 'DacSession Free Table Connection String:'
  @ nRow++,0 DCSAY oConnection:SessionFree:getConnectionString() ;
     COLOR GRA_CLR_BLUE ;
     SAYWORDBREAK ;
     SAYSIZE 50,Len(aTokens)+2
ENDIF

DCGETOPTIONS SAYWIDTH 0 ;
             SAYBOTTOM ;
             SAYFONT '10.Lucida Console' ;
             GETFONT '10.Lucida Console' ;
             EDITPROTECT {||.t.} ;
             SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT BUTTONS DCGUI_BUTTON_OK MODAL ;
   TITLE 'Connection Properties' OPTIONS GetOptions ;
   NOAUTORESTORE EVAL {|o|::SetWindowPos(o)}

RETURN nil

* ---------------

METHOD SqlQuery:ReplaceNullValues( cTableName )

LOCAL i, aStru, xValue, nLen, nCount := 0

dbSetNullValue(.t.)
Set(_SET_NULLVALUE,.t.)

::Use(cTableName,.t.)
OrdSetFocus(0)
aStru := dbStruct()
nLen := Len(aStru)
dbGoTop()

DC_PointerWait()

DO WHILE !Eof()
  FOR i := 1 TO nLen
    IF FieldGet(i) == nil
      IF aStru[i,2] == 'C'
        xValue := ' '
      ELSEIF aStru[i,2] == 'N'
        xValue := 0
      ELSEIF aStru[i,2] == 'D'
        LOOP
        xValue := CtoD('')
      ELSEIF aStru[i,2] == 'L'
        xValue := .f.
      ELSE
        LOOP
      ENDIF
      FieldPut(i,xValue)
      IF ++nCount % 1000 == 0
        soMessageBox:setCaption( Alltrim(Str(nCount)) + ' fields replaced' )
      ENDIF
    ENDIF
  NEXT
  DbSkip()
ENDDO
DC_PointerArrow()

soMessageBox:setCaption( Alltrim(Str(nCount)) + ' fields replaced' )

RETURN nil

* --------------

METHOD SqlQuery:SetDefaultValues( cTableName, nConnectHandle )

LOCAL i, aFields, xValue, nLen, nError, cFieldName, cSQL, ;
      nStatementHandle, nCursor, nFieldCount := 0

aFields := ::GetFieldNameArrayADS( cTableName, nConnectHandle )

FOR i := 1 TO Len(aFields)

  cFieldName := aFields[i]
  xValue := Space(30)
  nLen := 30

  nError := AdsDDGetFieldProperty( nConnectHandle, ;
                         cTableName, ;
                         cFieldName, ;
                         ADS_DD_FIELD_DEFAULT_VALUE, ;
                         @xValue, ;
                         @nLen )

  xValue := Alltrim(Strtran(xValue,Chr(0),''))

  IF nError # 5138 // property was already set
    LOOP
  ENDIF

  xValue := 0
  nLen := 2

  nError := AdsDDGetFieldProperty( nConnectHandle, ;
                         cTableName, ;
                         cFieldName, ;
                         ADS_DD_FIELD_TYPE, ;
                         @xValue, ;
                         @nLen )

  IF xValue == ADS_NUMERIC
    xValue := '0'
  ELSEIF xValue == ADS_DATE
    xValue := ' '
  ELSEIF xValue == ADS_STRING
    xValue := ' '
  ELSEIF xValue == ADS_MEMO
    LOOP
  ELSEIF xValue == ADS_LOGICAL
    xValue := 'FALSE'
  ELSE
    LOOP
  ENDIF

  cSQL := "EXECUTE PROCEDURE sp_ModifyFieldProperty(" + ;
            "'?'," + ;
            "'?'," + ;
            "'FIELD_DEFAULT_VALUE'," + ;
            "?," + ;
            "'RETURN_ERROR'," + ;
            "NULL );"

  cSQL := ::ApplySQLParams( cSQL, { cTableName, cFieldName, xValue } )

  nStatementHandle := 0
  nError := AdsCreateSQLStatement( nConnectHandle, @nStatementHandle)

  nCursor := 0
  nError := AdsExecuteSQLDirect( nStatementHandle, cSQL, @nCursor )

  IF nError > 0
    DC_WinAlert( DC_AdsGetLastError() )
  ELSE
    nFieldCount++
  ENDIF

  AdsCloseSQLStatement( nStatementHandle )

NEXT

soMessageBox:setCaption( Alltrim(Str(nFieldCount)) + ' field default values were updated' )

RETURN nil

* --------------

METHOD SqlQuery:GetFieldNameArrayADS( cTableName, nDictHandle )

LOCAL cData, nLen, nHandle, nError, aFields[0], aStru, nFieldPos := 1

cData := Space(ADS_DD_MAX_OBJECT_NAME_LEN)
nLen := ADS_DD_MAX_OBJECT_NAME_LEN
nHandle := 0
nError := AdsDDFindFirstObject( nDictHandle, ;
                      ADS_DD_FIELD_OBJECT, ;
                      cTableName, ;
                      @cData, ;
                      @nLen, ;
                      @nHandle )

IF nError == 0
  cData := Alltrim(Strtran(cData,Chr(0),''))
  aStru := ::AdsDDGetFieldStructure( cTableName, cData, nDictHandle )
  AAdd(aStru,nFieldPos)
  AAdd( aFields, aStru )
ENDIF

nFieldPos := 1
DO WHILE nError == 0 .AND. nHandle > 0
  cData := Space(ADS_DD_MAX_OBJECT_NAME_LEN)
  nLen := ADS_DD_MAX_OBJECT_NAME_LEN
  nError := AdsDDFindNextObject( nDictHandle, ;
                      nHandle, ;
                      @cData, ;
                      @nLen )
  IF nError == 0 .AND. !Empty(cData)
    cData := Alltrim(Strtran(cData,Chr(0),''))
    aStru := ::AdsDDGetFieldStructure( cTableName, cData, nDictHandle )
    nFieldPos++
    AAdd(aStru,nFieldPos)
    AAdd( aFields, aStru )
  ENDIF
ENDDO
AdsDDFindClose(nHandle)

ASort(aFields,,,{|a,b|a[1]<b[1]})

RETURN aFields

* -----------

METHOD SqlQuery:AdsDDAddTable( aData, oConnection, oTreeItem )

LOCAL lStatus, cFileName, cErrorString, cUserName, nHandle := 0, ;
      nError, cDictName, cPassword, cTableName, cDesc, GetList[0], ;
      i, aChildItems, nFound, GetOptions

cUserName := 'AdsSys'
cPassword := ''

cDictName := oConnection:database

cFileName := DC_PopFile( nil, nil, nil, 'Choose a DBF File', ;
                         { {"DBF Files","*.DBF"}, {"All Files","*.*"} } )

IF Empty(cFileName)
  RETURN .f.
ENDIF

cTableName := DC_CapFirst(DC_Path(cFileName,.t.))
nFound := At('.DBF',Upper(cTablename))
IF nFound > 0
  cTableName := Substr(cTableName,1,nFound-1)
ENDIF

nError := AdsConnect60( Alltrim(cDictName), ;
          oConnection:AdsServerType, ;
          cUserName, ;
          cPassword, ;
          ADS_DEFAULT, ;
          @nHandle )

IF nHandle <= 0 .OR. nError > 0
  cErrorString := DC_AdsGetLastError()
  DC_WinAlert(cErrorString)
  RETURN .F.
ENDIF

cDesc := Space(50)
@ 0,0 DCSAY 'Enter a Description for table ' + cTableName SAYSIZE 0 ;
      FONT '10.Lucida Console'
@ 1,0 DCGET cDesc
DCGETOPTIONS SCALEFACTOR ::aScaleFactor
DCREAD GUI FIT MODAL TITLE 'Description' TO lStatus ADDBUTTONS OPTIONS GetOptions
IF !lStatus
  RETURN .f.
ENDIF

nError := AdsDDAddTable( nHandle, cTableName, cFileName, ADS_CDX, ADS_OEM, '', Trim(cDesc) )

IF nError > 0
  cErrorString := DC_AdsGetLastError()
  DC_WinAlert(cErrorString)
  RETURN .F.
ENDIF

DCMSGBOX cTableName + ' was added to ' + cFileName ;
   FONT '10.Lucida Console' OWNER AppDeskTop()

::oTree:lockUpdate(.t.)
aChildItems := oTreeItem:getChildItems()
FOR i := 1 TO Len(aChildItems)
  oTreeItem:delItem(aChildItems[i])
NEXT
::oTree:lockUpdate(.f.)
::oTree:invalidateRect()
::BuildTreeBranch(oTreeItem,.t.)

RETURN .t.

* -----------

METHOD SqlQuery:AdsDDRemoveTable( cTableName, oConnection, oTreeItem, lPrompt )

LOCAL lStatus, cUserName, cPassword, nHandle := 0, cErrorString, nError

DEFAULT lPrompt := .t.

cUserName := 'AdsSys'
cPassword := ''

IF lPrompt
  DCMSGBOX 'This selection will remove the table ' + cTableName + ;
           ' from ' + oConnection:database, ;
           'Continue?' YESNO TO lStatus FONT '10.Lucida Console' ;
           OWNER AppDeskTop()
ELSE
  lStatus := .t.
ENDIF

IF lStatus

  nError := AdsConnect60( oConnection:database, ;
            oConnection:AdsServerType, ;
            cUserName, ;
            cPassword, ;
            ADS_DEFAULT, ;
            @nHandle )

  IF nHandle <= 0 .OR. nError > 0
    cErrorString := DC_AdsGetLastError()
    DC_WinAlert(cErrorString)
    RETURN .F.
  ENDIF

  nError := AdsDDRemoveTable( nHandle, cTableName, .f. )

  IF nError > 0
    cErrorString := DC_AdsGetLastError()
    DC_WinAlert(cErrorString)
    RETURN .F.
  ENDIF

  IF lPrompt
    DCMSGBOX cTableName + ' was removed from ' + oConnection:database ;
       FONT '10.Lucida Console' OWNER AppDeskTop()
    oTreeItem:getParentItem():delItem(oTreeItem)
  ENDIF

ENDIF

RETURN .t.

* -----------

METHOD SqlQuery:AdsDDGetFieldStructure( cTableName, cFieldName, nDictHandle )

LOCAL i, xValue, nLen, nHandle, nError, aFields[4], aFieldProperties

aFieldProperties := ;
   { ADS_DD_FIELD_TYPE, ;
     ADS_DD_FIELD_LENGTH, ;
     ADS_DD_FIELD_DECIMAL }

aFields[1] := cFieldName

FOR i := 1 TO Len(aFieldProperties)

  xValue := 0
  nLen := 2
  nError := AdsDDGetFieldProperty( nDictHandle, ;
                                   cTableName, ;
                                   cFieldName, ;
                                   aFieldProperties[i], ;
                                   @xValue, ;
                                   @nLen )

  IF i == 1
    IF xValue == ADS_NUMERIC
      xValue := 'N'
    ELSEIF xValue == ADS_DATE
      xValue := 'D'
    ELSEIF xValue $ { ADS_STRING, ADS_CISTRING, ADS_AUTOINC, ADS_TIMESTAMP }
      xValue := 'C'
    ELSEIF xValue $ { ADS_MEMO, ADS_VARCHAR }
      xValue := 'M'
    ELSEIF xValue == ADS_LOGICAL
      xValue := 'L'
    ELSEIF xValue $ { ADS_BINARY, ADS_IMAGE }
      xValue := 'B'
    ELSEIF xValue $ { ADS_INTEGER, ADS_DOUBLE, ADS_SHORTINT, ADS_CURDOUBLE, ;
                      ADS_MONEY, ADS_LONGLONG, ADS_TIME }
      xValue := 'N'
    ELSE
      xValue := '?'
    ENDIF
  ENDIF
  aFields[i+1] := xValue

NEXT

RETURN aFields

* ----------

METHOD SqlQuery:FieldList( nDictHandle )

LOCAL GetList[0], GetOptions, aFields, lStatus, cFieldList, cTableName

cTableName := Space(25)

@ 0,0 DCSAY 'Table Name' GET cTableName PICT '@!' SAYSIZE 0 SAYBOTTOM

DCGETOPTIONS NORESIZE SCALEFACTOR ::aScaleFactor
DCREAD GUI FIT ADDBUTTONS TO lStatus MODAL TITLE 'Insert Field List' ;
   OPTIONS GetOptions ENTEREXIT NOAUTORESTORE EVAL {|o|::SetWindowPos(o)}

IF lStatus
  aFields := ::GetFieldNameArrayADS( Alltrim(cTableName), nDictHandle )
ELSE
  RETURN ''
ENDIF

IF Empty(aFields)
  DC_WinAlert('Invalid Table name')
ENDIF

cFieldList := DC_Array2String(aFields)
cFieldList := StrTran(cFieldList,'{','')
cFieldList := StrTran(cFieldList,'}','')
cFieldList := StrTran(cFieldList,'"','')

RETURN cFieldList

* ----------------

METHOD SqlQuery:BuildDDAds( oConnection )

LOCAL GetList[0], GetOptions, lStatus, aFiles[0], i, cFileName, cIndexName, ;
      aDir, cFilePath, cDictFile, aHeaders, oBrowse, nTagElement := 3, ;
      lCancelled := .f., lBuildingDD := .f.

cFilePath := Alltrim(oConnection:serverFree) + '\'

aDir := Directory(cFilePath + '*.Dbf')

FOR i := 1 TO Len(aDir)
  cFileName := Upper(aDir[i,1])
  AAdd( aFiles, { cFileName, Space(30)} )
NEXT

cDictFile := Pad(cFilePath + '<DictionaryName>.add',150)

@ 0,0 DCSAY 'Enter a full-path Name for the Data-Dictionary to create:' SAYSIZE 0 ;
      FONT '10.Lucida Console'

@ 1,0 DCGET cDictFile SIZE 100

FOR i := 1 TO Len(aFiles)
  AAdd(aFiles[i],.f.)
  AAdd(aFiles[i],Space(40))
NEXT

DCHOTKEY xbeK_SPACE ;
   ACTION {||aFiles[oBrowse:arrayElement,nTagElement] := ;
             !aFiles[oBrowse:arrayElement,nTagElement], ;
             oBrowse:refreshCurrent()} ;
   WHEN {||SetAppFocus() == oBrowse}

@ 3,0 DCSAY 'Use Space bar to tag/untag' SAYSIZE 0 FONT ::cMessageFont
@ 4,0 DCSAY 'Use ENTER to enter description' SAYSIZE 0 FONT ::cMessageFont

@ 6,0 DCPUSHBUTTON CAPTION 'Tag All' SIZE 10 ;
      ACTION {||AEval(aFiles,{|a|a[nTagElement] := .t.}),oBrowse:refreshAll()}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'UnTag All' SIZE 10 ;
      ACTION {||AEval(aFiles,{|a|a[nTagElement] := .f.}),oBrowse:refreshAll()}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Build Dictionary' SIZE 20 ;
      ACTION {||lBuildingDD := .t., ;
                ::AdsArray2DD( cDictFile, aFiles, oBrowse, oConnection, @lCancelled, ;
                               cFilePath), ;
                lBuildingDD := .f. } ;
      WHEN {||AScan(aFiles,{|a|a[3]})>0 .AND. !lBuildingDD}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Cancel' SIZE 10 ;
      ACTION {||lCancelled := .t.} ;
      WHEN {||lBuildingDD}

@ 7.5,0 DCBROWSE oBrowse DATA aFiles SIZE 100,25 FIT ;
      FONT ::cMessageFont ;
      EDIT xbeBRW_ItemSelected ;
      RESIZE DCGUI_RESIZE_RESIZEONLY_X ;
      COLOR {||IIF( aFiles[oBrowse:arrayElement,nTagElement],{nil,GRA_CLR_YELLOW},{nil,GRA_CLR_WHITE})}

DCBROWSECOL ELEMENT 1 HEADER 'File Name' WIDTH 25 PARENT oBrowse PROTECT {||.t.}
DCBROWSECOL ELEMENT 2 HEADER 'Description' WIDTH 30 PARENT oBrowse
DCBROWSECOL ELEMENT 4 HEADER 'Status' WIDTH 45 PARENT oBrowse PROTECT {||.t.}

DCGETOPTIONS SCALEFACTOR ::aScaleFactor RESIZE

DCREAD GUI FIT ADDBUTTONS TO lStatus TITLE 'Create ADS Data Dictionary' ;
   MODAL NOAUTORESTORE EVAL {|o|::SetWindowPos(o)} OPTIONS GetOptions

RETURN lStatus

* ------------

METHOD SqlQuery:AdsArray2DD( cFileName, aFiles, oBrowse, oConnection, lCancelled, cFilePath )

LOCAL nHandle := 0, cErrorString, lStatus, cTableName, i, j, ;
      cIndexes, cComments, cFile, nError, aIndex, cIndexName, ;
      cDesc, cGroupName, aData, aRef, nTags

LOCAL nChoice := 2, cUserName := 'AdsSys', cPassWord := '', cFileDesc := cFilePath + ' Dictionary'

IF File(Alltrim(cFileName))

  DCMSGBOX Alltrim(cFileName), 'Dictionary file already exists.', ;
     BUTTONS {'Add tables to existing file', ;
              'Create new file','Cancel'} CHOICE @nChoice ;
              FONT '10.Lucida Console' OWNER AppDeskTop()

  IF nChoice $ {0,3}
    RETURN .f.
  ENDIF

  IF nChoice == 1
    nError := AdsConnect60( Alltrim(cFileName), ;
                oConnection:AdsServerType, ;
                cUserName, ;
                cPassword, ;
                ADS_DEFAULT, ;
                @nHandle )

  ENDIF

ENDIF

IF nChoice ==2
  nError := AdsDDCreate( Alltrim(cFileName), .F., Alltrim(cFileDesc), @nHandle )
  IF nError == 0 .AND. !Empty(cUserName)
    AdsDDCreateUser( nHandle, '', cUserName, cPassword, 'Administrative User' )
  ENDIF
ENDIF

IF nHandle <= 0 .OR. nError > 0
  cErrorString := DC_AdsGetLastError()
  DC_WinAlert(cErrorString)
  RETURN .F.
ENDIF

nTags := 0
FOR i := 1 TO Len(aFiles)
  IF aFiles[i,3]
    nTags++
  ENDIF
NEXT

oBrowse:goTop()
oBrowse:forceStable()
oBrowse:refreshAll()

FOR i := 1 TO Len(aFiles)

  DC_CompleteEvents()

  IF lCancelled
    EXIT
  ENDIF

  IF !aFiles[i,3] .AND. !Empty(nTags)
    LOOP
  ENDIF

  cIndexes := ''
  cComments := ''

  cTableName := Alltrim(aFiles[i,1])
  cDesc := Alltrim(aFiles[i,2])+Chr(0)

  nError := AdsDDAddTable( nHandle, nil, cFilePath + cTableName, ADS_CDX, ADS_OEM, nil, cDesc )
  IF nError > 0
    cErrorString := DC_AdsGetLastError()
    aFiles[i,4] := cErrorString
  ELSE
    aFiles[i,4] := 'Table Added - Success'
  ENDIF
  oBrowse:down()
  oBrowse:forceStable()
  oBrowse:refreshAll()
NEXT

AdsDisconnect(nHandle)

IF nError == 0
  DCMSGBOX 'Done!', ;
    '', ;
    'Add this new dictionary connection to ' + ::cIniFile + '?' ;
    YESNO TO lStatus FONT '10.Lucida Console' OWNER AppDeskTop()
  IF lStatus
    FOR i := 1 TO 40
      cGroupName := 'ADS_' + Alltrim(Str(i))
      IF Empty(DC_IniRead(::cIniFile,cGroupName,'Name'))
        aRef := {'Type','Database','Name','UID','AdsLockingType','AdsTableType'}
        aData := { 'ADS',cFileName,cFileName,'ADSSYS', ;
                    oConnection:adsLockingType,oConnection:adsTableType }
        DC_IniSave(::cIniFile,cGroupName,aData,aRef)
        oConnection := ::loadSessions(cGroupName)
        ::buildTree(oConnection)
        EXIT
      ENDIF
    NEXT
  ENDIF

ENDIF

RETURN .T.

* -----------

METHOD SqlQuery:ApplySQLParams( cSqlStatement, aParams )

LOCAL i, cValue, cDate, xValue, nError

FOR i := 1 TO Len(aParams)
   IF aParams[i] == NIL
      LOOP
   ENDIF
   xValue := aParams[i]
   IF Valtype(xValue) == 'N'
      cValue := Alltrim(Str(xValue))
   ELSEIF Valtype(xValue) == 'L'
      IF xValue
         cValue := 'TRUE'
      ELSE
         cValue := 'FALSE'
      ENDIF
   ELSEIF Valtype(xValue) == 'D'
      cDate := DtoS(xValue)
      cDate := Ltrim(Rtrim(SubStr(cDate,1,4) + '-' + ;
         SubStr(cDate,5,2) + '-' + ;
         SubStr(cDate,7,2)))
      cValue := "{ d '" + cDate + "'}"
   ELSEIF Valtype(xValue) == 'C'
      cValue := "'" + xValue + "'"
   ELSE
      cValue := Trim(DC_XtoC(xValue))
   ENDIF
   cSqlStatement := StrTran(cSqlStatement,'?',cValue,,1)
NEXT

RETURN cSqlStatement

* -------------

METHOD SqlQuery:RunProc()

LOCAL GetList[0], cExpression := Space(200), cRunMode := 'G', lStatus, ;
   GetOptions, bExpr, bError

@ 4,0 DCSAY 'Expression to Run' GET cExpression ;
   GETSIZE 100 ;
   SAYSIZE 0 ;
   SAYBOTTOM ;
   GETID 'EXPRESSION' ;
   VALID {||DC_ValidateBlock(cExpression,,@bExpr,.f.)}

DCGETOPTIONS NOMINBUTTON NOMAXBUTTON NORESIZE SCALEFACTOR ::aScaleFactor
DCREAD GUI FIT ADDBUTTONS TITLE 'Run a Program' MODAL TO lStatus ;
   OPTIONS GetOptions ENTEREXIT SETFOCUS 'EXPRESSION' NOAUTORESTORE;
   EVAL {|o|::SetWindowPos(o)}

IF lStatus
   GuiRun( bExpr )
ENDIF

RETURN nil

* -----------

METHOD SqlQuery:AdsTest1( oConnection )

RETURN nil

* -----------

METHOD SqlQuery:OdbcTest1( oConnection )

LOCAL cSql, oSession, cResult

dbeSetDefault('ODBCDBE')

oSession := oConnection:sessionDict

//oSession:setProperty(ODBCSSN_MORE_RESULTS,1)
oSession:setProperty(ODBCSSN_MORE_RESULTS, ODBC_MORE_RESULT_AUTO)

// cSql := 'Select SUM(Balance) AS Total, Sum(Sales) AS Sales FROM Invoices;'

cSql := 'EXECUTE TwoResultSets;'

// DDSQLRESULT (cSql) INTO @cResult VIA oSession

USE (cSql) VIA (oSession) ALIAS 'Result'

wtf cResult

result->(dbCloseArea())

RETURN nil

* -----------

FUNCTION DD_SqlErrorWindow( oWindow )

STATIC soWindow
LOCAL oOldWindow

oOldWindow := soWindow
IF Pcount() == 1
  soWindow := oWindow
ENDIF

RETURN oOldWindow

* -----------

FUNCTION DD_SqlStmtExec(cSql,oSession,cAlias)

LOCAL oError, lStatus := .f., GetList[0], GetOptions, ;
      bError := ErrorBlock({|oError|break(oError)}), ;
      cSqlError, lShowDialog := .t., oErrorWindow

cSql := Strtran(cSql,CRLF,' ')

oErrorWindow := DD_SqlErrorWindow()
IF Valtype(oErrorWindow) == 'O'
  lShowDialog := .f.
ENDIF

BEGIN SEQUENCE

  dbeSetDefault('ODBCDBE')

  lStatus := SqlStmtExec(cSql,oSession,,,.F.,cAlias)

RECOVER USING oError

  cSqlError := OdbcDebug(oSession)[15,2]

  IF lShowDialog
    @ 0,0 DCSAY 'Error in SQL statement:' SAYSIZE 0 FONT '10.Lucida Console' ;
          RESIZE DCGUI_RESIZE_REPOSONLY_Y

    @ 1,0 DCMULTILINE cSql SIZE 120,18 FONT '10.Lucida Console' NOHSCROLL ;
          RESIZE DCGUI_RESIZE_RESIZEONLY

    @ 20,0 DCMULTILINE cSqlError SIZE 120,3 FONT '8.Lucida Console' NOHSCROLL ;
          RESIZE DCGUI_RESIZE_RESIZEONLY_X

    DCGETOPTIONS RESIZE

    DCREAD GUI FIT TITLE 'SQL Error' BUTTONS DCGUI_BUTTON_OK ;
       MODAL OPTIONS GetOptions
  ELSE
    oErrorWindow:setData(cSqlError)
  ENDIF
END SEQUENCE

DD_SqlErrorWindow(nil)

ErrorBlock(bError)

RETURN lStatus

* -----------

FUNCTION DD_SqlProcedure(cSql,oSession)

LOCAL oError, lStatus := .f., GetList[0], GetOptions, ;
      bError := ErrorBlock({|oError|break(oError)}), ;
      i := 1, cSqlError, oErrorWindow, lShowDialog := .t.

oErrorWindow := DD_SqlErrorWindow()
IF Valtype(oErrorWindow) == 'O'
  lShowDialog := .f.
ENDIF

BEGIN SEQUENCE

  dbeSetDefault('ODBCDBE')

  lStatus := SqlStmtExec(cSql,oSession,,,.F.)

RECOVER USING oError

  cSqlError := OdbcDebug(oSession)[15,2]

  IF lShowDialog

    @ 0,0 DCSAY 'Error in SQL statement:' SAYSIZE 0 FONT '10.Lucida Console' ;
          RESIZE DCGUI_RESIZE_REPOSONLY_Y

    @ 1,0 DCMULTILINE cSql SIZE 120,18 FONT '10.Lucida Console' NOHSCROLL ;
          RESIZE DCGUI_RESIZE_RESIZEONLY

    @ 20,0 DCMULTILINE cSqlError SIZE 120,3 FONT '8.Lucida Console' NOHSCROLL ;
          RESIZE DCGUI_RESIZE_REPOSY_RESIZEX

    DCGETOPTIONS RESIZE

    DCREAD GUI FIT TITLE 'SQL Error' BUTTONS DCGUI_BUTTON_OK ;
       MODAL OPTIONS GetOptions

  ELSE
    oErrorWindow:setData(cSqlError)
  ENDIF
END SEQUENCE

DD_SqlErrorWindow(nil)

ErrorBlock(bError)

RETURN lStatus

* -----------

FUNCTION DD_SqlResult(cSql,oSession,xResult)

LOCAL oError, lStatus := .f., GetList[0], GetOptions, ;
      bError := ErrorBlock({|oError|break(oError)}), ;
      i := 1, cSqlError

BEGIN SEQUENCE

  dbeSetDefault('ODBCDBE')

  xResult := SqlGetResult(cSql,oSession, .F.)

RECOVER USING oError

  cSqlError := OdbcDebug(oSession)[15,2]

  /*
  @ 0,0 DCSAY 'Error in SQL statement:' SAYSIZE 0 FONT '10.Lucida Console' ;
        RESIZE DCGUI_RESIZE_REPOSONLY_Y

  @ 1,0 DCMULTILINE cSql SIZE 120,18 FONT '10.Lucida Console' NOHSCROLL ;
        RESIZE DCGUI_RESIZE_RESIZEONLY

  @ 20,0 DCMULTILINE cSqlError SIZE 120,3 FONT '8.Lucida Console' NOHSCROLL ;
        RESIZE DCGUI_RESIZE_REPOSY_RESIZEX

  DCGETOPTIONS RESIZE

  DCREAD GUI FIT TITLE 'SQL Error' BUTTONS DCGUI_BUTTON_OK ;
     MODAL OPTIONS GetOptions
  */

  xResult := cSqlError

END SEQUENCE

ErrorBlock(bError)

RETURN lStatus

* -----------

FUNCTION DD_SqlCmd(cSql,oSession)

LOCAL oError, lStatus := .f., GetList[0], GetOptions, ;
      bError := ErrorBlock({|oError|break(oError)}), ;
      i := 1, cSqlError

BEGIN SEQUENCE

  dbeSetDefault('ODBCDBE')

  SqlCmd(cSql,(oSession), .F.)

RECOVER USING oError

  cSqlError := OdbcDebug(oSession)[15,2]

  @ 0,0 DCSAY 'Error in SQL statement:' SAYSIZE 0 FONT '10.Lucida Console' ;
        RESIZE DCGUI_RESIZE_REPOSONLY_Y

  @ 1,0 DCMULTILINE cSql SIZE 120,18 FONT '10.Lucida Console' NOHSCROLL ;
        RESIZE DCGUI_RESIZE_RESIZEONLY

  @ 20,0 DCMULTILINE cSqlError SIZE 120,3 FONT '8.Lucida Console' NOHSCROLL ;
        RESIZE DCGUI_RESIZE_REPOSY_RESIZEX

  DCGETOPTIONS RESIZE

  DCREAD GUI FIT TITLE 'SQL Error' BUTTONS DCGUI_BUTTON_OK ;
     MODAL OPTIONS GetOptions

END SEQUENCE

ErrorBlock(bError)

RETURN lStatus

* --------------

METHOD SqlQuery:LoadSessions( cGroup )

LOCAL aData, aRef, i, cType, oConnection, cDbe, lDictConnection, ;
      lExit := !Empty(cGroup), nAdsServerType

DEFAULT ::cIniFile := DC_Path(AppName(.t.)) + 'SqlQuery.Ini'

aRef := { ;
   'Type', ;
   'SessionDict', ;
   'SessionFree', ;
   'Name', ;
   'ConnectString', ;
   'Driver', ;
   'Server', ;
   'ServerDict', ;
   'ServerFree', ;
   'ServerType', ;
   'Database', ;
   'UID', ;
   'PWD', ;
   'Network', ;
   'ConnectTimeOut', ;
   'AdsLockingType', ;
   'AdsTableType', ;
   'AdsServerType', ;
   'BrowseWindowBGColor' }

FOR i := 1 TO 120

 IF !lExit
   IF i < 41
     cGroup := 'ADS_' + Alltrim(Str(i))
     cDbe := 'ADS'
   ELSEIF i < 81
     cGroup := 'ODBC_' + Alltrim(Str(i-40))
     cDbe := 'ODBC'
   ELSE
     cGroup := 'PG_' + Alltrim(Str(i-80))
     cDbe := 'PG'
   ENDIF
 ELSE
   IF Left(cGroup,4) == 'ODBC'
     cDbe := 'ODBC'
   ELSEIF Left(cGroup,3) == 'ADS'
     cDbe := 'ADS'
   ELSEIF Left(cGroup,2) == 'PG'
     cDbe := 'PG'
   ENDIF
 ENDIF

 aData := { ;
  cDbe, ;
  nil, ;
  nil, ;
  Space(50), ;
  Space(500), ;
  Space(60), ;
  Space(100), ;
  Space(100), ;
  Space(100), ;
  Space(100), ;
  Space(100), ;
  Space(100), ;
  Space(50), ;
  Space(50), ;
  0, ;
  0, ;
  2, ;
  0, ;
  Space(20) }

  DC_IniLoad( ::cIniFile, cGroup, aData, aRef )

  IF !Empty(aData[4])
    oConnection := SqlQueryConnection():new(aData,self)
    oConnection:groupName := cGroup
    AAdd( ::sessionsArray, oConnection )
  ENDIF

  IF lExit
    EXIT
  ENDIF

NEXT

RETURN oConnection

* ------------

STATIC FUNCTION BuildDictArrayAdsBlock(self,oConnection)

RETURN {||::BuildDictArrayAds(1,oConnection)}

* ------------

STATIC FUNCTION BuildFreeArrayAdsBlock(self,oConnection)

RETURN {||::BuildFreeArrayAds(1,oConnection)}

* ------------

#if XPPVER > 2000000
STATIC FUNCTION BuildDictArrayPgBlock(self,oConnection)

RETURN {||::BuildDictArrayPg(1,oConnection)}
#endif

* ------------

STATIC FUNCTION BuildDictArrayODBCBlock(self,oConnection)

RETURN {||::BuildDictArrayODBC(1,oConnection)}

* ------------

METHOD SqlQuery:DisconnectSessions()

LOCAL oSession, i

IF !Empty(::sessionsArray)
  FOR i := 1 TO Len(::sessionsArray)
    oSession := ::sessionsArray[i]:sessionDict
    IF Valtype(oSession) == 'O' .AND. oSession:isConnected()
      oSession:disconnect()
    ENDIF
    oSession := ::sessionsArray[i]:sessionFree
    IF Valtype(oSession) == 'O' .AND. oSession:isConnected()
      oSession:disconnect()
    ENDIF
  NEXT
ENDIF

::sessionsArray := {}

RETURN nil

* ------------

METHOD SqlQuery:DisconnectConnections()

LOCAL oConnection, i

FOR i := 1 TO Len(::sessionsArray)
  oConnection := ::sessionsArray[i]
  IF oConnection:isConnected
    ::disconnect(oConnection)
  ENDIF
NEXT

RETURN nil

* ---------

EXIT PROCEDURE SqlDisconnect

IF Valtype(soSqlQuery) == 'O'
  soSqlQuery:DisconnectSessions()
ENDIF

RETURN

* ----------

METHOD SqlQuery:WorkArea2Excel( cAlias, lCsv )

LOCAL GetList[0], cExcelFile, lStatus, nChoice := 0

DEFAULT lCsv := .f.

cExcelFile := Pad(DC_Path(AppName(.t.)) + cAlias + IIF(lCsv,'.Csv','.Xls'),70)

@ 0,0 DCSAY 'Export to ' + IIF(lCsv,'CSV','Excel') SAYSIZE 0 FONT '12.Arial'

@ 2,0 DCSAY IIF(lCsv,'CSV','Excel') + ' File Name to Create' GET cExcelFile  SAYSIZE 0 SAYBOTTOM

DCREAD GUI FIT ADDBUTTONS TITLE 'Export to ' + IIF(lCsv,'CSV','Excel') ;
   MODAL TO lStatus NOAUTORESTORE EVAL {|o|::SetWindowPos(o)}

IF lStatus

  cExcelFile := Alltrim(cExcelFile)
  IF !'.' $ cExcelFile
    IF lCsv
      cExcelFile += '.csv'
    ELSE
      cExcelFile += '.xls'
    ENDIF
  ENDIF
  IF lCsv
    lStatus := DC_WorkArea2Csv( cExcelFile )
  ELSE
    lStatus := DC_WorkArea2Excel( cExcelFile, , .t., .f.,,,,,,,.t.,)
  ENDIF
  IF lStatus
    DC_SpawnUrl(cExcelFile)
  ENDIF

ENDIF

RETURN lStatus

* ------------

METHOD SqlQuery:Array2Sql( cSqlFile, aStruct, aData, oDlg, oSay, oProgress, lAborted, cAlias, lAds )

LOCAL nHandle, i, j, cSql, nCount, cType, cFieldName, cFieldType, nFieldLen, nFieldDec

DEFAULT lAds := .f.

IF Len(aStruct[1]) == 2
  FOR i := 1 TO Len(aStruct)
    aStruct[i] := aStruct[i,2]
  NEXT
ENDIF

nHandle := FCreate( cSqlFile )
IF nHandle <= 0
  RETURN .f.
ENDIF

oSay:setCaption('Exporting (pass 2)...')

cSql := 'CREATE TABLE ' + cAlias + ' (' + CRLF

FOR i := 1 TO Len(aStruct)
  cFieldName := aStruct[i,1]
  cFieldType := aStruct[i,2]
  nFieldLen := aStruct[i,3]
  nFieldDec := aStruct[i,4]
  cType := _TypeDesc(aStruct[i,2],@nFieldLen,lAds )

  cSql += '  ' + cFieldName + ' ' + cType + ;
          IIF(nFieldLen>0,' ( ' + Alltrim(Str(nFieldLen)), '') + ;
          IIF(nFieldDec>0,', ' + Alltrim(Str(nFieldDec)),'') + IIF( nFieldLen>0,' )','') + ;
          IIF( i<Len(aStruct),',','') + CRLF
NEXT

cSql += ' ) ;' + CRLF + CRLF

Fwrite( nHandle, cSql )

cSql := ''

nCount := 0
FOR i := 1 TO Len(aData)

  cSql := 'INSERT INTO ' + cAlias + ' VALUES ( '
  FOR j := 1 TO Len(aData[i])
    cSql += DC_Var2Sql( aData[i,j] ) + IIF( j<Len(aData[i]),',','')
  NEXT
  cSql += ' );' + CRLF
  FWrite(nHandle,cSql)
  nCount++
  IF nCount%20 == 0
    DC_GetProgress(oProgress,nCount,Len(aData))
    DC_CompleteEvents()
  ENDIF
  IF lAborted
    EXIT
  ENDIF

NEXT
DC_GetProgress(oProgress,nCount,nCount)

FClose(nHandle)

RETURN .t.

* ------------

METHOD SqlQuery:WorkArea2Sql( cSqlFile, aStruct, oDlg, oSay, oProgress, lAborted, cAlias, lAds, nHandle )

LOCAL i, cSql, nCount, cType, cFieldName, cFieldType, nFieldLen, nFieldDec, ;
      nRecCount, xValue

DEFAULT lAds := .f.

cSql := 'CREATE TABLE ' + cAlias + ' (' + CRLF

FOR i := 1 TO Len(aStruct)
  cFieldName := aStruct[i,1]
  cFieldType := aStruct[i,2]
  nFieldLen := aStruct[i,3]
  nFieldDec := aStruct[i,4]
  cType := _TypeDesc(aStruct[i,2],@nFieldLen,lAds )

  cSql += '  ' + cFieldName + ' ' + cType + ;
          IIF(nFieldLen>0,' ( ' + Alltrim(Str(nFieldLen)), '') + ;
          IIF(nFieldDec>0,', ' + Alltrim(Str(nFieldDec)),'') + IIF( nFieldLen>0,' )','') + ;
          IIF( i<Len(aStruct),',','') + CRLF
NEXT

cSql += ' ) ;' + CRLF + CRLF

Fwrite( nHandle, cSql )

cSql := ''

nCount := 1
nRecCount := (cAlias)->(RecCount())
DO WHILE !(cAlias)->(Eof())

  cSql := 'INSERT INTO ' + cAlias + ' VALUES ( '
  FOR i := 1 TO Len(aStruct)
    cFieldName := aStruct[i,1]
    xValue := (cAlias)->(&(cFieldName))
    IF Valtype(xValue) $ 'CM'
      xValue := Trim(xValue)
    ENDIF
    cSql += DC_Var2Sql( xValue ) + IIF( i<Len(aStruct),',','')
  NEXT
  cSql += ' );' + CRLF
  FWrite(nHandle,cSql)
  nCount++
  IF nCount%20 == 0
    DC_GetProgress(oProgress,nCount,nRecCount)
    DC_CompleteEvents()
  ENDIF
  IF lAborted
    EXIT
  ENDIF
  (cAlias)->(dbSkip())

ENDDO
DC_GetProgress(oProgress,nRecCount,nRecCount)

FClose(nHandle)

IF !lAborted
  DCMSGBOX 'Done.', ;
         Trim(cSqlFile) + ' was created.' FONT '10.Lucida Console' ;
         OWNER AppDeskTop()
ENDIF

RETURN !lAborted

* ------------

METHOD SqlQuery:Array2Xml( cXmlFile, aStruct, aData, oDlg, oSay, oProgress, lAborted, cAlias, lAds )

LOCAL oRoot, oStructure, oData, oField, oFieldName, oFieldType, i, j, ;
      oFieldLen, oFieldDec, oRecord, cFieldName, xValue, aTagDefault, ;
      nCount, aTags, cFieldType, nFieldLen, nFieldDec

DEFAULT lAds := .f.

aTagDefault := { ;
   'Root', ;
   'Structure', ;
   'Field', ;
   'FieldName', ;
   'FieldType', ;
   'FieldLen', ;
   'FieldDec', ;
   'Data', ;
   'Record' }

DEFAULT aStruct := dbStruct()

aTags := aTagDefault

IF Len(aStruct[1]) == 2
  FOR i := 1 TO Len(aStruct)
    IF Valtype(aStruct[i,2,1]) == 'C'
      cFieldName := aStruct[i,2,1]
    ELSE
      cFieldname := aStruct[i,1]
    ENDIF
    cFieldType := aStruct[i,2,2]
    nFieldLen := aStruct[i,2,3]
    nFieldDec := aStruct[i,2,4]
    aStruct[i] := { cFieldName, cFieldType, nFieldLen, nFieldDec }
  NEXT
ENDIF

oRoot := DC_XmlNode():new(aTags[1])

oStructure := DC_XmlNode():new(aTags[2])

oRoot:addNode(oStructure)

FOR i := 1 TO Len(aStruct)
  oField := DC_XmlNode():new(aTags[3])
  oStructure:addNode(oField)
  oFieldName := DC_XmlNode():new(aTags[4],aStruct[i,1])
  oField:addNode(oFieldName)
  oFieldType := DC_XmlNode():new(aTags[5],_TypeDesc(aStruct[i,2],,lAds))
  oField:addNode(oFieldType)
  oFieldLen := DC_XmlNode():new(aTags[6],aStruct[i,3])
  oField:addNode(oFieldLen)
  oFieldDec := DC_XmlNode():new(aTags[7],aStruct[i,4])
  oField:addNode(oFieldDec)
NEXT

oData := DC_XmlNode():new(aTags[8])
oRoot:addNode(oData)

oSay:setCaption('Exporting (pass 2)...')

nCount := 0

FOR i := 1 TO Len(aData)
  oRecord := DC_XmlNode():new(aTags[9])
  oData:addNode(oRecord)
  FOR j := 1 TO Len(aStruct)
    cFieldName := aStruct[j,1]
    xValue := DC_XmlEscape(Trim(DC_XtoC(aData[i,j])))
    oField := DC_XmlNode():new(cFieldName,xValue)
    oRecord:addNode(oField)
  NEXT
  nCount++
  IF nCount%100 == 0
    DC_GetProgress(oProgress,nCount,Len(aData))
    DC_CompleteEvents()
  ENDIF
  IF lAborted
    EXIT
  ENDIF
NEXT
DC_GetProgress(oProgress,Len(aData),Len(aData))

IF !lAborted .AND. !Empty(cXmlFile)
  RETURN oRoot:writeXml(cXmlFile)
ENDIF

RETURN .f.

* ------------

METHOD SqlQuery:WorkArea2Xml( cXmlFile, aStruct, oDlg, oSay, oProgress, ;
                              lAborted, cAlias, lAds, nHandle )

LOCAL oStructure, oData, oField, oFieldName, oFieldType, i, j, ;
      oFieldLen, oFieldDec, oRecord, cFieldName, xValue, aTagDefault, ;
      nCount, aTags, nRecCount

DEFAULT lAds := .f.

aTagDefault := { ;
   'Root', ;
   'Structure', ;
   'Field', ;
   'FieldName', ;
   'FieldType', ;
   'FieldLen', ;
   'FieldDec', ;
   'Data', ;
   'Record' }

aTags := aTagDefault

Fwrite( nHandle, '<?xml version="1.0" encoding="UTF-8"?>' + CRLF )
Fwrite( nHandle, '<Root>' + CRLF)

oStructure := DC_XmlNode():new(aTags[2])

FOR i := 1 TO Len(aStruct)
  oField := DC_XmlNode():new(aTags[3])
  oStructure:addNode(oField)
  oFieldName := DC_XmlNode():new(aTags[4],aStruct[i,1])
  oField:addNode(oFieldName)
  oFieldType := DC_XmlNode():new(aTags[5],_TypeDesc(aStruct[i,2],,lAds))
  oField:addNode(oFieldType)
  oFieldLen := DC_XmlNode():new(aTags[6],aStruct[i,3])
  oField:addNode(oFieldLen)
  oFieldDec := DC_XmlNode():new(aTags[7],aStruct[i,4])
  oField:addNode(oFieldDec)
NEXT

Fwrite( nHandle, oStructure:asString(,,2) )
Fwrite( nHandle, '  <Data>' + CRLF)

oData := DC_XmlNode():new(aTags[8])

nCount := 0
nRecCount := (cAlias)->(RecCount())
DO WHILE !(cAlias)->(Eof())
  oRecord := DC_XmlNode():new(aTags[9])
  oData:addNode(oRecord)
  FOR j := 1 TO Len(aStruct)
    cFieldName := aStruct[j,1]
    xValue := DC_XmlEscape(Trim((cAlias)->(&(cFieldName))))
    oField := DC_XmlNode():new(cFieldName,xValue)
    oRecord:addNode(oField)
  NEXT
  FWrite(nHandle, oRecord:asString(,,4))
  nCount++
  IF nCount%20 == 0
    DC_GetProgress(oProgress,nCount,nRecCount)
    DC_CompleteEvents()
  ENDIF
  IF lAborted
    EXIT
  ENDIF
  (cAlias)->(dbSkip())
ENDDO
DC_GetProgress(oProgress,nRecCount,nRecCount)

Fwrite( nHandle, '  </Data>' + CRLF)
Fwrite( nHandle, '</Root>' + CRLF)

FClose(nHandle)

IF !lAborted
  DCMSGBOX 'Done.', ;
         Trim(cXmlFile) + ' was created.' FONT '10.Lucida Console' ;
         OWNER AppDeskTop()
ENDIF

RETURN !lAborted

* ------------

METHOD SqlQuery:Array2Html( cHtmlFile, aStruct, aData, oDlg, oSay, oProgress, lAborted, cAlias )

LOCAL cHtml, nCount, i, j, nHandle, oRecord, cHeading

PRIVATE cDate := Dtoc(Date()) + ' ' + Time()

oSay:setCaption('Exporting (pass 2)...')

nHandle := FCreate( Alltrim(cHtmlFile))
IF nHandle <= 0
  RETURN .f.
ENDIF

TEXT INTO cHeading WRAP
<body bgcolor="#FFFFFF" link="blue" vlink="purple" text="#000000" alink="red">
<font color="#004080" face="Arial,Helvetica">
Created: &cDate<br><br>
<table cellspacing="2" cellpadding="4" border="0" bgcolor="#FFFFFF">
<tr valign="top" bgcolor="#336699">
ENDTEXT

FWrite( nHandle, cHeading )

nCount := 0
cHtml := ''
FOR i := 1 TO Len(aStruct)
  cHtml += '  <td><b><font color="#FFFFFF">' + aStruct[i,1] + '</td></font></b></td>' + CRLF
NEXT
cHtml += '</tr>' + CRLF
FWrite( nHandle, cHtml )

FOR i := 1 TO Len(aData)
  cHtml := '<tr>' + CRLF
  FOR j := 1 TO Len(aStruct)
    cHtml += '  <td>' + DC_XmlEscape(Trim(DC_XtoC(aData[i,j]))) + '</td>' + CRLF
  NEXT
  cHtml += '</tr>' + CRLF
  Fwrite( nHandle, cHtml )
  nCount++
  IF nCount%20 == 0
    DC_GetProgress(oProgress,nCount,Len(aData))
    DC_CompleteEvents()
  ENDIF
  IF lAborted
    EXIT
  ENDIF
NEXT
DC_GetProgress(oProgress,nCount,nCount)

cHtml := '</table>' + CRLF

FWrite(nHandle, cHtml + CRLF)
FClose(nHandle)

IF !lAborted
  DC_SpawnUrl( cHtmlFile )
ENDIF

RETURN !lAborted

* ------------

METHOD SqlQuery:WorkArea2Html( cHtmlFile, aStruct, oDlg, oSay, oProgress, lAborted, cAlias, nHandle )

LOCAL cHtml, nCount, i, oRecord, cHeading, nRecCount, cFieldName

PRIVATE cDate := Dtoc(Date()) + ' ' + Time()

TEXT INTO cHeading WRAP
<body bgcolor="#FFFFFF" link="blue" vlink="purple" text="#000000" alink="red">
<font color="#004080" face="Arial,Helvetica">
Created: &cDate<br><br>
<table cellspacing="2" cellpadding="4" border="0" bgcolor="#FFFFFF">
<tr valign="top" bgcolor="#336699">
ENDTEXT

FWrite( nHandle, cHeading )

nCount := 0
cHtml := ''
FOR i := 1 TO Len(aStruct)
  cHtml += '  <td><b><font color="#FFFFFF">' + aStruct[i,1] + '</td></font></b></td>' + CRLF
NEXT
cHtml += '</tr>' + CRLF
FWrite( nHandle, cHtml )

nRecCount := (cAlias)->(RecCount())
DO WHILE !(cAlias)->(Eof())
  cHtml := '<tr>' + CRLF
  FOR i := 1 TO Len(aStruct)
    cFieldName := aStruct[i,1]
    cHtml += '  <td>' + DC_XmlEscape(Trim(DC_XtoC((cAlias)->(&(cFieldName))))) + '</td>' + CRLF
  NEXT
  cHtml += '</tr>' + CRLF
  Fwrite( nHandle, cHtml )
  nCount++
  IF nCount%20 == 0
    DC_GetProgress(oProgress,nCount,nRecCount)
    DC_CompleteEvents()
  ENDIF
  IF lAborted
    EXIT
  ENDIF
  (cAlias)->(dbSkip())
ENDDO
DC_GetProgress(oProgress,nCount,nCount)

cHtml := '</table>' + CRLF

FWrite(nHandle, cHtml + CRLF)

FClose(nHandle)

IF !lAborted
  DCMSGBOX 'Done.', ;
         Trim(cHtmlFile) + ' was created.' FONT '10.Lucida Console' ;
         OWNER AppDeskTop()
ENDIF

RETURN !lAborted

* ------------

METHOD SqlQuery:Array2Text( cTextFile, aStruct, aData, oDlg, oSay, oProgress, lAborted, cAlias )

LOCAL cHtml, nCount, i, j, nHandle, oRecord, cHeading, cText, cLine
LOCAL cDate := Dtoc(Date()) + ' ' + Time()

oSay:setCaption('Exporting (pass 2)...')

nHandle := FCreate( Alltrim(cTextFile))
IF nHandle <= 0
  RETURN .f.
ENDIF

IF Len(aStruct[1]) == 2
  FOR i := 1 TO Len(aStruct)
    aStruct[i] := aStruct[i,2]
  NEXT
ENDIF

cHeading := 'Created: ' + cDate + CRLF + CRLF

FWrite( nHandle, cHeading )

nCount := 1
cText := 'Item '
cLine := '---- '
FOR i := 1 TO Len(aStruct)
  cText += Pad(aStruct[i,1],Max(aStruct[i,3],Len(aStruct[i,1]))) + ' '
  cLine += Repl('-',Max(aStruct[i,3],Len(aStruct[i,1]))) + ' '
NEXT
FWrite( nHandle, cText + CRLF + cLine + CRLF )

cText := ''

FOR i := 1 TO Len(aData)
  cText := Pad(Alltrim(Str(nCount)),5)
  FOR j := 1 TO Len(aStruct)
    cText += Pad(DC_XtoC(aData[i,j]), ;
                Max(aStruct[j,3],Len(aStruct[j,1]))) + ' '
  NEXT
  Fwrite( nHandle, cText + CRLF )
  nCount++
  IF nCount%20 == 0
    DC_GetProgress(oProgress,nCount,Len(aData))
    DC_CompleteEvents()
  ENDIF
  IF lAborted
    EXIT
  ENDIF
NEXT
DC_GetProgress(oProgress,nCount,nCount)

FClose(nHandle)

IF !lAborted
  DC_SpawnUrl( cTextFile)
ENDIF

RETURN .t.

* ------------

METHOD SqlQuery:WorkArea2Text( cHtmlFile, aStruct, oDlg, oSay, oProgress, lAborted, cAlias, nHandle )

LOCAL cHtml, nCount, i, oRecord, cHeading, nRecCount, cFieldName
LOCAL cText, cLine, cDate := Dtoc(Date()) + ' ' + Time()

cHeading := 'Created: ' + cDate + CRLF + CRLF

FWrite( nHandle, cHeading )

nCount := 1
cText := 'Item '
cLine := '---- '
FOR i := 1 TO Len(aStruct)
  cText += Pad(aStruct[i,1],Max(aStruct[i,3],Len(aStruct[i,1]))) + ' '
  cLine += Repl('-',Max(aStruct[i,3],Len(aStruct[i,1]))) + ' '
NEXT
FWrite( nHandle, cText + CRLF + cLine + CRLF )

cText := ''

nRecCount := (cAlias)->(RecCount())
DO WHILE !(cAlias)->(Eof())
  cText := Pad(Alltrim(Str(nCount)),5)
  FOR i := 1 TO Len(aStruct)
    cFieldName := aStruct[i,1]
    cText += Pad(DC_XtoC((cAlias)->(&(cFieldName))), ;
                Max(aStruct[i,3],Len(aStruct[i,1]))) + ' '
  NEXT
  Fwrite( nHandle, cText + CRLF )
  nCount++
  IF nCount%20 == 0
    DC_GetProgress(oProgress,nCount,nRecCount)
    DC_CompleteEvents()
  ENDIF
  IF lAborted
    EXIT
  ENDIF
  (cAlias)->(dbSkip())
ENDDO
DC_GetProgress(oProgress,nCount,nCount)

FClose(nHandle)

IF !lAborted
  DCMSGBOX 'Done.', ;
         Trim(cHtmlFile) + ' was created.' FONT '10.Lucida Console' ;
         OWNER AppDeskTop()
ENDIF

RETURN !lAborted


* ------------

METHOD SqlQuery:Array2Json( cJsonFile, aStruct, aData, oDlg, oSay, oProgress, ;
                            lAborted, cAlias, lCRLF )

LOCAL cJson, nCount, i, nHandle, oRecord

oSay:setCaption('Exporting (pass 2)...')

nHandle := FCreate( Alltrim(cJsonFile))
IF nHandle <= 0
  RETURN .f.
ENDIF
FWrite( nHandle, '[ ' + CRLF )

nCount := 0
FOR i := 1 TO Len(aData)
  oRecord := aData[i]
  #if XPPVER > 2000000
    cJson := DC_Object2Js(oRecord,,lCRLF) + IIF(i<Len(aData),',','') + CRLF
//    cJson := Var2Json(oRecord) + IIF(i<Len(aData),',','') + CRLF
  #else
    cJson := DC_Object2Js(oRecord,,lCRLF) + IIF(i<Len(aData),',','') + CRLF
  #endif
  Fwrite( nHandle, cJson )
  nCount++
  IF nCount%20 == 0
    DC_GetProgress(oProgress,nCount,Len(aData))
    DC_CompleteEvents()
  ENDIF
  IF lAborted
    EXIT
  ENDIF
NEXT

IF !lAborted
  FWrite(nHandle, ']' + CRLF)
ENDIF

FClose(nHandle)

RETURN .t.

* ------------

METHOD SqlQuery:WorkArea2Json( cJsonFile, aStruct, oDlg, oSay, oProgress, ;
                               lAborted, cAlias, nHandle, lCRLF )

LOCAL cJson, nCount, i, oRecord, cClassName, nRecCount

cClassName := 'DATA_' + Alltrim(Str(Seconds(),5))
oRecord := (cAlias)->(DC_DbRecord(cClassName):new())

FWrite( nHandle, '[ ' + CRLF )

nCount := 1
nRecCount := (cAlias)->(RecCount())
DO WHILE !(cAlias)->(Eof())
  (cAlias)->(DC_DbScatter(oRecord))
  #if XPPVER > 2000000
    cJson := DC_Object2Js(oRecord,,lCRLF) + IIF(nCount<nRecCount,',','') + CRLF
//    cJson := Var2Json(oRecord) + IIF(nCount<nRecCount,',','') + CRLF
  #else
    cJson := DC_Object2Js(oRecord,,lCRLF) + IIF(nCount<nRecCount,',','') + CRLF
  #endif
  Fwrite( nHandle, cJson )
  nCount++
  IF nCount%20 == 0
    DC_GetProgress(oProgress,nCount,nRecCount)
    DC_CompleteEvents()
  ENDIF
  IF lAborted
    EXIT
  ENDIF
  (cAlias)->(dbSkip())
ENDDO
DC_GetProgress(oProgress,nCount,nCount)

FWrite(nHandle, ']' + CRLF)

FClose(nHandle)

IF !lAborted
  DCMSGBOX 'Done.', ;
         Trim(cJsonFile) + ' was created.' FONT '10.Lucida Console' ;
         OWNER AppDeskTop()
ENDIF

RETURN !lAborted

* ----------

METHOD SqlQuery:Table2Export( cTableName, oConnection )

LOCAL lStatus, nChoice := 1

DCMSGBOX 'This selection will export the entire table contents ',  ;
         'of Table: ' + cTableName ;
         BUTTONS {'Export to Excel', ;
                  'Export to CSV', ;
                  'Export to Database', ;
                  'Export to XML', ;
                  'Export to SQL code', ;
                  'Export to JSON', ;
                  'Export to HTML', ;
                  'Export to Text', ;
                  'Export Schema', ;
                  'Cancel'} ;
         CHOICE @nChoice FONT '10.Lucida Console' ;
         OWNER AppDeskTop()

IF nChoice == 1
  RETURN ::Table2Database(cTableName,oConnection,0,.f.)
ELSEIF nChoice == 2
  RETURN ::Table2Database(cTableName,oConnection,0,.t.)
ELSEIF nChoice == 3
  RETURN ::Table2Database(cTableName,oConnection,1)
ELSEIF nChoice == 4
  RETURN ::Table2Database(cTableName,oConnection,2)
ELSEIF nChoice == 5
  RETURN ::Table2Database(cTableName,oConnection,3)
ELSEIF nChoice == 6
  RETURN ::Table2Database(cTableName,oConnection,4)
ELSEIF nChoice == 7
  RETURN ::Table2Database(cTableName,oConnection,5)
ELSEIF nChoice == 8
  RETURN ::Table2Database(cTableName,oConnection,6)
ELSEIF nChoice == 9
  RETURN ::Table2Database(cTableName,oConnection,6)
ENDIF

RETURN .f.

* ----------

METHOD SqlQuery:Browse2Export( oBrowse, oOwner, oConnection )

LOCAL lStatus, nChoice := 1

DCMSGBOX 'This selection will export the current browse view' ;
         BUTTONS {'Export to Excel', ;
                  'Export to CSV', ;
                  'Export to Database', ;
                  'Export to XML', ;
                  'Export to SQL code', ;
                  'Export to JSON', ;
                  'Export to HTML', ;
                  'Export to Text', ;
                  'Export Schema', ;
                  'Cancel'} ;
         CHOICE @nChoice FONT '10.Lucida Console' ;
         OWNER AppDeskTop()

IF nChoice == 1
  RETURN oBrowse:Browse2Excel(oOwner,.f.)
ELSEIF nChoice == 2
  RETURN oBrowse:Browse2Excel(oOwner,.t.)
ELSEIF nChoice == 3
  RETURN ::Browse2Database(oBrowse,oOwner,oConnection,1)
ELSEIF nChoice == 4
  RETURN ::Browse2Database(oBrowse,oOwner,oConnection,2)
ELSEIF nChoice == 5
  RETURN ::Browse2Database(oBrowse,oOwner,oConnection,3)
ELSEIF nChoice == 6
  RETURN ::Browse2Database(oBrowse,oOwner,oConnection,4)
ELSEIF nChoice == 7
  RETURN ::Browse2Database(oBrowse,oOwner,oConnection,5)
ELSEIF nChoice == 8
  RETURN ::Browse2Database(oBrowse,oOwner,oConnection,6)
ENDIF

RETURN .f.

* ------------

METHOD SqlQuery:Table2Database(cTableName, oConnection, nMode, lCsv )

LOCAL GetList[0], cDataFile, lStatus, nChoice := 0, i, oDlg, oSay, ;
      lAborted := .f., cFieldName, lRenameFields := .f., nCount, oProgress, ;
      cPath, lAds, nHandle, oOwner := ::oTree, aHeaders[0], oBrowse2, ;
      aStru, cAlias, cDbe, oSession, cTitle, lCRLF := .f., nDbfType := 2, ;
      GetOptions

lAds := oConnection:type = 'ADS' .OR. 'ADVANTAGE STREAMLINESQL' $ Upper(oConnection:driver)

IF !Empty(oConnection:sessionDict)
  oSession := oConnection:sessionDict
ELSE
  oSession := oConnection:sessionFree
ENDIF

IF !Empty(oConnection:serverFree)
  cPath := Trim(oConnection:serverFree) + '\'
ELSEIF !Empty(oConnection:database)
  cPath := Trim(oConnection:database)
ELSE
  cPath := DC_Path(AppName(.t.))
ENDIF

IF oConnection:type = 'ADS'
  cDbe := 'ADSDBE'
ELSEIF oConnection:type = 'ODBC'
  cDbe := 'ODBCDBE'
ELSEIF oConnection:type = 'PG'
  cDbe := 'PBDBE'
ENDIF

dbeSetDefault(cDbe)
IF cDbe == 'ADSDBE'
  DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE, oConnection:AdsTableType )
  DbeInfo( COMPONENT_ORDER, ADSDBE_TBL_MODE, oConnection:AdsTableType )
  DbeInfo( COMPONENT_DATA, ADSDBE_LOCK_MODE, oConnection:AdsLockingType )
  DbeInfo( COMPONENT_DATA, ADSDBE_TABLENAME_IS_ALIAS, .f. )
ENDIF

USE (cTableName) VIA (oSession)

cAlias := Alias()

IF Empty(cAlias)
  DCMSGBOX 'Error opening table: ' + cTableName FONT '10.Lucida Console' ;
     OWNER AppDeskTop()
  RETURN .f.
ENDIF

DCGETOPTIONS SCALEFACTOR ::aScaleFactor
IF nMode = 0
  lStatus := ::WorkArea2Excel( cTableName, lCsv )
  (cAlias)->(dbCloseArea())
  RETURN lStatus
ELSEIF nMode = 1
  cDataFile := Pad(cPath + Alias() + '.dbf',70)
  @ 0,0 DCSAY 'Export to Database' SAYSIZE 0 FONT '12.Arial'
  @ 2,0 DCSAY 'Database File Name to Create' GET cDataFile  SAYSIZE 0
  @ 4,0 DCSAY 'Choose type of Database to export to:' SAYSIZE 0
  @ 5,0 DCRADIO nDbfType PROMPT 'Clipper DBF' VALUE 1
  @ DCGUI_ROW, DCGUI_COL + 10 DCRADIO nDbfType PROMPT 'FOX DBF' VALUE 2
  DCREAD GUI FIT ADDBUTTONS TITLE 'Export to Database' ;
    MODAL TO lStatus NOAUTORESTORE OWNER oOwner
  cTitle := 'Database'
ELSEIF nMode = 2
  cDataFile := Pad(cPath + Alias() + '.xml',70)
  @ 0,0 DCSAY 'Export to XML' SAYSIZE 0 FONT '12.Arial'
  @ 2,0 DCSAY 'XML File Name to Create' GET cDataFile  SAYSIZE 0
  DCREAD GUI FIT ADDBUTTONS TITLE 'Export to XML' ;
    MODAL TO lStatus NOAUTORESTORE OWNER oOwner
  cTitle := 'XML'
ELSEIF nMode = 3
  cDataFile := Pad(cPath + Alias() + '.Sql',70)
  @ 0,0 DCSAY 'Export to SQL Code' SAYSIZE 0 FONT '12.Arial'
  @ 2,0 DCSAY 'SQL File Name to Create' GET cDataFile  SAYSIZE 0
  DCREAD GUI FIT ADDBUTTONS TITLE 'Export to SQL Code' ;
    MODAL TO lStatus NOAUTORESTORE OWNER oOwner
  cTitle := 'SQL'
ELSEIF nMode = 4
  cDataFile := Pad(cPath + Alias() + '.Json',70)
  @ 0,0 DCSAY 'Export to Json (JavaScript Object Notation)' SAYSIZE 0 FONT '12.Arial'
  @ 2,0 DCSAY 'JSON File Name to Create' GET cDataFile  SAYSIZE 0
  @ 4,0 DCCHECKBOX lCRLF PROMPT 'CR/LF after each item'
  DCREAD GUI FIT ADDBUTTONS TITLE 'Export to JSON' ;
    MODAL TO lStatus NOAUTORESTORE OWNER oOwner
  cTitle := 'JSON'
ELSEIF nMode = 5
  cDataFile := Pad(cPath + Alias() + '.Html',70)
  @ 0,0 DCSAY 'Export to HTML' SAYSIZE 0 FONT '12.Arial'
  @ 2,0 DCSAY 'HTML File Name to Create' GET cDataFile  SAYSIZE 0
  DCREAD GUI FIT ADDBUTTONS TITLE 'Export to HTML' ;
    MODAL TO lStatus NOAUTORESTORE OWNER oOwner
  cTitle := 'HTML'
ELSEIF nMode = 6
  cDataFile := Pad(cPath + Alias() + '.Txt',70)
  @ 0,0 DCSAY 'Export to TEXT' SAYSIZE 0 FONT '12.Arial'
  @ 2,0 DCSAY 'TEXT File Name to Create' GET cDataFile  SAYSIZE 0
  DCREAD GUI FIT ADDBUTTONS TITLE 'Export to TEXT' ;
    MODAL TO lStatus NOAUTORESTORE OWNER oOwner
  cTitle := 'TEXT'
ENDIF

IF !lStatus
  (cAlias)->(dbCloseArea())
  RETURN .f.
ENDIF

aStru := (cAlias)->(dbStruct())

FOR i := 1 TO Len(aStru)
  cFieldName := aStru[i,1]
  AAdd(aHeaders,aStru[i])
  IF Len(cFieldName) > 10 .AND. nMode = 1
    lRenameFields := .t.
  ENDIF
NEXT

IF lRenameFields
  FOR i := 1 TO Len(aHeaders)
    aHeaders[i,1] := Pad(aHeaders[i,1],30)
  NEXT
  DO WHILE .t.
    GetList := {}
    @ 0,0 DCSAY 'Field names must not be longer than 10 Characters.;' + ;
                'Please rename fields to 10 or less characters' ;
          SAYSIZE 60,2 SAYWORDBREAK FONT '10.Lucida Console'
    @ 2,0 DCBROWSE oBrowse2 DATA aHeaders SIZE 40,25 FIT ;
          FONT '10.Lucida Console' ;
          EDIT xbeBRW_ItemSelected

    DCBROWSECOL ELEMENT 1 HEADER 'Field Name' WIDTH 30 PARENT oBrowse2
    DCREAD GUI FIT ADDBUTTONS TITLE 'Rename Fields' MODAL TO lStatus;
      NOAUTORESTORE MODAL EVAL {|o|::SetWindowPos(o)}

    IF !lStatus
      RETURN .f.
    ENDIF
    FOR i := 1 TO Len(aHeaders)
      IF Len(Trim(aHeaders[i,1])) > 10
        DCMSGBOX 'Try Again' FONT '10.Lucida Console' OWNER AppDeskTop()
        lStatus := .f.
        EXIT
      ENDIF
    NEXT
    IF lStatus
      EXIT
    ENDIF
  ENDDO
ENDIF

IF nMode > 1
  nHandle := FCreate(Alltrim(cDataFile))
  IF nHandle <= 0
    DC_Winalert('Cannot create ' + cDataFile)
    (cAlias)->(dbCloseArea())
    RETURN .f.
  ENDIF
ENDIF

GetList := {}
@ 0,0 DCSAY 'Exporting...' SAYSIZE 0 FONT '10.Lucida Console' OBJECT oSay
@ 1,0 DCPROGRESS oProgress SIZE 80,1 PERCENT COLOR GRA_CLR_CYAN, GRA_CLR_WHITE
@ 2,0 DCPUSHBUTTON CAPTION 'Cancel' SIZE 10,1.2 ;
      ACTION {||lAborted := .t.}

DCGETOPTIONS SCALEFACTOR ::aScaleFactor
DCREAD GUI FIT EXIT SAVE PARENT @oDlg TITLE 'Exporting to ' + cTitle

IF nMode = 1
  lStatus := ::WorkArea2Database( cDataFile, aHeaders, oDlg, oSay, oProgress, ;
                                  @lAborted, cAlias, nDbfType )
ELSEIF nMode = 2
  lStatus := ::WorkArea2Xml( cDataFile, aStru, oDlg, oSay, oProgress, ;
                          @lAborted, cAlias, lAds, nHandle )
  IF lStatus
    DC_SpawnUrl(cDataFile)
  ENDIF
ELSEIF nMode = 3
  lAds := .f.
  lStatus := ::WorkArea2Sql( cDataFile, aStru, oDlg, oSay, oProgress, ;
                          @lAborted, cAlias, lAds, nHandle )
ELSEIF nMode = 4
  lStatus := ::WorkArea2Json( cDataFile, aStru, oDlg, oSay, oProgress, ;
                           @lAborted, cAlias, nHandle, lCRLF )
ELSEIF nMode = 5
  lStatus := ::WorkArea2Html( cDataFile, aStru, oDlg, oSay, oProgress, ;
                           @lAborted, cAlias, nHandle )
ELSEIF nMode = 6
  lStatus := ::WorkArea2Text( cDataFile, aStru, oDlg, oSay, oProgress, ;
                           @lAborted, cAlias, nHandle )
ENDIF

(cAlias)->(dbCloseArea())

oDlg:destroy()

IF lAborted
  RETURN .f.
ENDIF

RETURN lStatus

* -------------

METHOD SqlQuery:Browse2Database(oBrowse, oOwner, oConnection, nMode )

LOCAL GetList[0], cDataFile, lStatus, nChoice := 0, i, nRows, oDlg, oSay, ;
      nTaggedColumns := 0, nCollapsedColumns := 0, lExportTaggedColumns := .f., ;
      oColumn, nTags := 0, aData[0], lExit := .f., lAborted := .f., ;
      cFieldName, lRenameFields := .f., oBrowse2, nCount, oProgress, ;
      aColData, aColumns[0], aHeaders[0], xValue, bSaveFilter := oBrowse:filter, ;
      cPath, nRecNo, oRecord, cClassName, lAds, cTitle, lCRLF, nDbfType := 2, ;
      GetOptions

lAds := oConnection:type = 'ADS' .OR. 'ADVANTAGE STREAMLINESQL' $ Upper(oConnection:driver)

IF !Empty(oConnection:serverFree)
  cPath := Trim(oConnection:serverFree) + '\'
ELSEIF !Empty(oConnection:database)
  cPath := DC_Path(Trim(oConnection:database))
ELSE
  cPath := DC_Path(AppName(.t.))
ENDIF

DCGETOPTIONS SCALEFACTOR ::aScaleFactor

IF nMode = 2
  cDataFile := Pad(cPath + Alias() + '.xml',70)
  @ 0,0 DCSAY 'Export to XML' SAYSIZE 0 FONT '12.Arial'
  @ 2,0 DCSAY 'XML File Name to Create' GET cDataFile  SAYSIZE 0
  DCREAD GUI FIT ADDBUTTONS TITLE 'Export to XML' ;
    MODAL TO lStatus NOAUTORESTORE OWNER oOwner OPTIONS GetOptions
  cTitle := 'XML'
ELSEIF nMode = 1
  cDataFile := Pad(cPath + Alias() + '.dbf',70)
  @ 0,0 DCSAY 'Export to Database' SAYSIZE 0 FONT '12.Arial'
  @ 2,0 DCSAY 'Database File Name to Create' GET cDataFile  SAYSIZE 0
  @ 4,0 DCSAY 'Choose type of Database to export to:' SAYSIZE 0
  @ 5,0 DCRADIO nDbfType PROMPT 'Clipper DBF' VALUE 1
  @ DCGUI_ROW, DCGUI_COL + 10 DCRADIO nDbfType PROMPT 'FOX DBF' VALUE 2
  DCREAD GUI FIT ADDBUTTONS TITLE 'Export to Database' ;
    MODAL TO lStatus NOAUTORESTORE OWNER oOwner OPTIONS GetOptions
  cTitle := 'Database'
ELSEIF nMode = 3
  cDataFile := Pad(cPath + Alias() + '.Sql',70)
  @ 0,0 DCSAY 'Export to SQL Code' SAYSIZE 0 FONT '12.Arial'
  @ 2,0 DCSAY 'SQL File Name to Create' GET cDataFile  SAYSIZE 0
  DCREAD GUI FIT ADDBUTTONS TITLE 'Export to SQL Code' ;
    MODAL TO lStatus NOAUTORESTORE OWNER oOwner OPTIONS GetOptions
  cTitle := 'SQL'
ELSEIF nMode = 4
  cDataFile := Pad(cPath + Alias() + '.Json',70)
  @ 0,0 DCSAY 'Export to Json (JavaScript Object Notation)' SAYSIZE 0 FONT '12.Arial'
  @ 2,0 DCSAY 'JSON File Name to Create' GET cDataFile  SAYSIZE 0
  @ 4,0 DCCHECKBOX lCRLF PROMPT 'CR/LF after each item'
  DCREAD GUI FIT ADDBUTTONS TITLE 'Export to JSON' ;
    MODAL TO lStatus NOAUTORESTORE OWNER oOwner OPTIONS GetOptions
  cTitle := 'JSON'
ELSEIF nMode = 5
  cDataFile := Pad(cPath + Alias() + '.Html',70)
  @ 0,0 DCSAY 'Export to HTML' SAYSIZE 0 FONT '12.Arial'
  @ 2,0 DCSAY 'HTML File Name to Create' GET cDataFile  SAYSIZE 0
  DCREAD GUI FIT ADDBUTTONS TITLE 'Export to HTML' ;
    MODAL TO lStatus NOAUTORESTORE OWNER oOwner OPTIONS GetOptions
  cTitle := 'HTML'
ELSEIF nMode = 6
  cDataFile := Pad(cPath + Alias() + '.Txt',70)
  @ 0,0 DCSAY 'Export to TEXT' SAYSIZE 0 FONT '12.Arial'
  @ 2,0 DCSAY 'TEXT File Name to Create' GET cDataFile  SAYSIZE 0
  DCREAD GUI FIT ADDBUTTONS TITLE 'Export to TEXT' ;
    MODAL TO lStatus NOAUTORESTORE OWNER oOwner OPTIONS GetOptions
  cTitle := 'TEXT'
ENDIF

IF !lStatus
  RETURN .f.
ENDIF

FOR i := 1 TO oBrowse:colCount
  oColumn := oBrowse:getColumn(i)
  AAdd(aColumns,oColumn)
  IF oColumn:isTagged .AND. !oColumn:isCollapsed
    nTaggedColumns++
  ENDIF
  IF oColumn:isTagged .AND. oColumn:isCollapsed
    nCollapsedColumns++
  ENDIF
NEXT
IF nTaggedColumns > 0
  IF nCollapsedColumns = 0
    nChoice := 1
    DCMSGBOX 'Export Option:' ;
       BUTTONS {'Export only the ' + Alltrim(Str(nTaggedColumns)) + ' Tagged Columns', ;
                'Export ALL Columns','Cancel'} CHOICE @nChoice ;
                 FONT '12.Lucida Console' OWNER oOwner

    IF nChoice == 1
      lExportTaggedColumns := .t.
    ELSEIF nChoice # 2
      RETURN .f.
    ENDIF
  ENDIF
ENDIF

nTags := 0

IF Valtype(oBrowse:dataSource) == 'C'
  nTags := Len((oBrowse:datasource)->(DC_RecTagArray()))
ELSE
  AEval(oBrowse:dataSource,{|a,x|x := a[2],IIF(x,nTags++,nil)})
ENDIF

IF nTags > 0
   nChoice := 1
   DCMSGBOX 'Export Option:' ;
    BUTTONS {'Export only the ' + Alltrim(Str(nTags)) + ' Tagged Rows', ;
             'Export ALL Rows','Cancel'} CHOICE @nChoice ;
             FONT '12.Lucida Console' OWNER oOwner

   IF nChoice == 1
     IF Valtype(oBrowse:dataSource) == 'C'
       (oBrowse:dataSource)->(DC_SetScopeArray(DC_RecTagArray()))
     ELSE
       IF Empty(oBrowse:filter)
         oBrowse:filter := {|a|a[2]}
       ELSE
         oBrowse:filter := {|a|Eval(bSaveFilter) .AND. a[2]}
       ENDIF
     ENDIF
   ELSEIF nChoice # 2
     RETURN .f.
   ENDIF
ENDIF

DC_PointerWait()

oBrowse:hitBottomBlock := {||lExit:=.t.}
oBrowse:goTop()
oBrowse:forceStable()
oBrowse:setParent():lockUpdate(.t.)
lExit := .f.

FOR i := 1 TO Len(aColumns)
  IF Valtype(aColumns[i]) # 'O'
    LOOP
  ELSEIF lExportTaggedColumns .AND. !aColumns[i]:isTagged
    LOOP
  ELSEIF aColumns[i]:isCollapsed
    LOOP
  ENDIF
  cFieldName := aColumns[i]:heading:cargo
  IF nMode == 4 // Json
    AAdd(aHeaders,cFieldName)
  ELSE
    AAdd(aHeaders,{cFieldName,DC_GetCargo(aColumns[i])})
  ENDIF
  IF Len(cFieldName) > 10 .AND. nMode = 1
    lRenameFields := .t.
  ENDIF
NEXT

IF lRenameFields
  FOR i := 1 TO Len(aHeaders)
    aHeaders[i,1] := Pad(aHeaders[i,1],30)
  NEXT
  DO WHILE .t.
    GetList := {}
    @ 0,0 DCSAY 'Field names must not be longer than 10 Characters.;' + ;
                'Please rename fields to 10 or less characters' ;
          SAYSIZE 60,2 SAYWORDBREAK FONT '10.Lucida Console'
    @ 2,0 DCBROWSE oBrowse2 DATA aHeaders SIZE 40,25 FIT ;
          FONT '10.Lucida Console' ;
          EDIT xbeBRW_ItemSelected

    DCBROWSECOL ELEMENT 1 HEADER 'Field Name' WIDTH 30 PARENT oBrowse2
    DCREAD GUI FIT ADDBUTTONS TITLE 'Rename Fields' MODAL TO lStatus;
      NOAUTORESTORE MODAL EVAL {|o|::SetWindowPos(o)}

    IF !lStatus
      RETURN .f.
    ENDIF
    FOR i := 1 TO Len(aHeaders)
      IF Len(Trim(aHeaders[i,1])) > 10
        DCMSGBOX 'Try Again' FONT '10.Lucida Console' OWNER AppDeskTop()
        lStatus := .f.
        EXIT
      ENDIF
    NEXT
    IF lStatus
      EXIT
    ENDIF
  ENDDO
ENDIF

GetList := {}
@ 0,0 DCSAY 'Exporting (Pass 1)...' SAYSIZE 0 FONT '10.Lucida Console' OBJECT oSay
@ 1,0 DCPROGRESS oProgress SIZE 80,1 PERCENT COLOR GRA_CLR_CYAN, GRA_CLR_WHITE
@ 2,0 DCPUSHBUTTON CAPTION 'Cancel' SIZE 10,1.2 ;
      ACTION {||lAborted := .t.}
DCREAD GUI FIT EXIT SAVE PARENT @oDlg TITLE 'Exporting to ' + cTitle

nRows := oBrowse:displayedRows()
nCount := 0
cClassName := 'DATA_' + Alltrim(Str(Seconds(),5))

DO WHILE !lAborted

  nCount++
  IF nRows > 100
    IF nCount%(Int(nRows/100)) == 0
      DC_GetProgress(oProgress,nCount,nRows)
      DC_CompleteEvents()
      IF lAborted
        EXIT
      ENDIF
    ENDIF
  ENDIF

  IF nMode == 4 // Json
    oRecord := (oBrowse:dataSource)->(DC_DbRecord(cClassName,,,,,aHeaders):new())
    (oBrowse:dataSource)->(DC_DbScatter(oRecord))
    AAdd(aData,oRecord)
  ELSE
    aColData := {}
    FOR i := 1 TO Len(aColumns)
      IF Valtype(aColumns[i]) # 'O'
        LOOP
      ELSEIF lExportTaggedColumns .AND. !aColumns[i]:isTagged
        LOOP
      ELSEIF aColumns[i]:isCollapsed
        LOOP
      ENDIF
      xValue := Eval(aColumns[i]:dataLink)
      AAdd(aColData,xValue)
    NEXT
    AAdd(aData,aColData)
  ENDIF

  IF Valtype(oBrowse:dataSource) == 'C'
    nRecno := (oBrowse:dataSource)->(RecNo())
  ELSEIF Valtype(oBrowse:dataSource) == 'A'
    nRecno := oBrowse:arrayElement
  ELSE
    nRecno := 0
  ENDIF
  oBrowse:down()
  oBrowse:forceStable()

  IF lExit
    IF Valtype(oBrowse:dataSource) == 'C'
      IF (oBrowse:dataSource)->(RecNo()) == nRecno
        EXIT
      ENDIF
    ELSEIF Valtype(oBrowse:dataSource) == 'A'
      IF oBrowse:arrayElement == nRecno
        EXIT
      ENDIF
    ELSE
      EXIT
    ENDIF
  ENDIF

ENDDO

oBrowse:filter := bSaveFilter
oBrowse:goTop()
oBrowse:forceStable()
oBrowse:refreshAll()
oBrowse:setParent():lockUpdate(.f.)

DC_PointerArrow()

IF nMode = 1
  lStatus := ::Array2Database( cDataFile, aHeaders, aData, oDlg, oSay, oProgress, @lAborted, nDbfType )
ELSEIF nMode = 2
  lStatus := ::Array2Xml( cDataFile, aHeaders, aData, oDlg, oSay, oProgress, ;
                          @lAborted, oBrowse:dataSource, lAds)
  IF lStatus
    DC_SpawnUrl(cDataFile)
  ENDIF
ELSEIF nMode = 3
  lStatus := ::Array2Sql( cDataFile, aHeaders, aData, oDlg, oSay, oProgress, ;
                          @lAborted, oBrowse:dataSource, lAds )
ELSEIF nMode = 4
  lStatus := ::Array2Json( cDataFile, aHeaders, aData, oDlg, oSay, oProgress, ;
                           @lAborted, oBrowse:dataSource, lCRLF )
ELSEIF nMode = 5
  lStatus := ::Array2Html( cDataFile, aHeaders, aData, oDlg, oSay, oProgress, ;
                           @lAborted, oBrowse:dataSource )
ELSEIF nMode = 6
  lStatus := ::Array2Text( cDataFile, aHeaders, aData, oDlg, oSay, oProgress, ;
                           @lAborted, oBrowse:dataSource )
ENDIF

oDlg:destroy()

IF lAborted
  RETURN .f.
ENDIF

RETURN lStatus

* ---------

METHOD SqlQuery:array2Database( cDataFile, aHeaders, aData, oDlg, oSay, oProgress, lAborted, nDbfType )

LOCAL i, j, lStatus, aStru[0], nCount := 0, oRecord, nFieldType, nFieldLen, ;
      nFieldDec, cFieldName, cDbe

oSay:setCaption('Exporting (pass 2)...')
FOR i := 1 TO Len(aHeaders)
  cFieldName := aHeaders[i,1]
  nFieldType := aHeaders[i,2,2]
  nFieldLen := aHeaders[i,2,3]
  nFieldDec := aHeaders[i,2,4]
  IF nFieldType $ {'I'}
    nFieldType := 'N'
  ENDIF
  IF nFieldType $ {'T'}
    nFieldType := 'D'
    nFieldLen := 8
  ENDIF
  IF nFieldType $ {'M'} .AND. nFieldLen <= 100
    nFieldType := 'C'
  ENDIF
  IF nFieldType == 'N' .AND. nFieldLen > 10
    nFieldLen := 10
  ENDIF
  AAdd( aStru, { cFieldName, nFieldType, nFieldLen, nFieldDec } )
NEXT

DC_GetProgress(oProgress,0,Len(aData))

IF nDbfType == 1
  cDbe := 'DBFNTX'
ELSE
  cDbe := 'FOXCDX'
ENDIF

dbCreate( cDataFile, aStru, cDbe )

USE (cDataFile) NEW VIA (cDbe) ALIAS 'EXPORT'
oRecord := EXPORT->(DC_DbRecord():new())

FOR i := 1 TO Len(aData)
  EXPORT->(dbGoTo(0))
  EXPORT->(DC_DbScatter(oRecord))
  FOR j := 1 TO Len(aStru)
    cFieldName := Alltrim(aStru[j,1])
    oRecord:&(cFieldName) := aData[i,j]
  NEXT
  EXPORT->(DC_DbGather(oRecord,.t.))
  nCount++
  IF nCount%100 == 0
    DC_GetProgress(oProgress,nCount,Len(aData))
    DC_CompleteEvents()
  ENDIF
  IF lAborted
    EXIT
  ENDIF
NEXT

oDlg:destroy()
EXPORT->(dbCloseArea())

IF !lAborted
  DCMSGBOX 'Done.', ;
         Trim(cDataFile) + ' was created.' FONT '10.Lucida Console' ;
         OWNER AppDeskTop()
ENDIF

RETURN !lAborted

* ---------

METHOD SqlQuery:WorkArea2Database( cDataFile, aHeaders, oDlg, oSay, oProgress, ;
                                   lAborted, cAlias, nDbfType )

LOCAL i, lStatus, aStru[0], nCount := 0, oRecord, nFieldType, nFieldLen, ;
      nFieldDec, cFieldName, aStruct := (cAlias)->(dbStruct()), nRecCount, ;
      cDbe, cFieldTo, cFieldFrom

FOR i := 1 TO Len(aHeaders)
  cFieldName := aHeaders[i,1]
  nFieldType := aHeaders[i,2]
  nFieldLen := aHeaders[i,3]
  nFieldDec := aHeaders[i,4]
  IF nFieldType $ {'I'}
    nFieldType := 'N'
  ELSEIF nFieldType $ {'M'} .AND. nFieldLen <= 100
    nFieldType := 'C'
  ELSEIF nFieldType $ {'T'}
    nFieldType := 'D'
    nFieldLen := 8
  ENDIF
  IF nFieldType == 'N' .AND. nFieldLen > 10
    nFieldLen := 10
  ENDIF
  AAdd( aStru, { cFieldName, nFieldType, nFieldLen, nFieldDec } )
NEXT

IF nDbfType == 2
  cDbe := 'FOXCDX'
ELSE
  cDbe := 'DBFNTX'
ENDIF

dbCreate( cDataFile, aStru, cDbe )

USE (cDataFile) NEW VIA (cDbe) ALIAS 'EXPORT'
oRecord := EXPORT->(DC_DbRecord():new())

nRecCount := (cAlias)->(RecCount())
DO WHILE !(cAlias)->(Eof())
  EXPORT->(dbGoTo(0))
  EXPORT->(DC_DbScatter(oRecord))

  FOR i := 1 TO Len(aStru)
    cFieldTo := Alltrim(aStru[i,1])
    cFieldFrom := Alltrim(aStruct[i,1])
    oRecord:&(cFieldTo) := (cAlias)->(&(cFieldFrom))
  NEXT
  EXPORT->(DC_DbGather(oRecord,.t.))
  nCount++
  IF nCount%20 == 0
    DC_GetProgress(oProgress,nCount,nRecCount)
    DC_CompleteEvents()
  ENDIF
  IF lAborted
    EXIT
  ENDIF
  (cAlias)->(dbSkip())
ENDDO
DC_GetProgress(oProgress,nRecCount,nRecCount)

EXPORT->(dbCloseArea())

IF !lAborted
  DCMSGBOX 'Done.', ;
         Trim(cDataFile) + ' was created.' FONT '10.Lucida Console' ;
         OWNER AppDeskTop()
ENDIF

RETURN !lAborted

* ---------

METHOD SqlQuery:parseIt( cStatement )

LOCAL aTokens, cSelect, cOrderBy, cWhere, nFound, nFoundOrderBy

cStatement := Alltrim(Strtran(cStatement,CRLF,' '))

cStatement := Alltrim(Substr(cStatement,7))

nFound := At(' FROM ',Upper(cStatement))

IF nFound > 0
  ::aSelectColumns := Substr(cStatement,1,nFound)
  ::aSelectColumns := DC_TokenArray(::aSelectColumns,',')
ELSE
  RETURN .f.
ENDIF

nFound := At(' FROM ',Upper(cStatement))
cSelect := Alltrim(Substr(cStatement,nFound+5))
nFound := At(' ',cSelect)

IF nFound = 0
  ::cSelectFrom := cSelect
ELSE
  ::cSelectFrom := Alltrim(Substr(cSelect,1,nFound))
ENDIF

nFoundOrderBy := At(' ORDER BY ',Upper(cStatement))
IF nFoundOrderBy > 0
  ::aSelectOrder := Substr(cStatement,nFoundOrderBy+10)
  ::aSelectOrder := DC_TokenArray(::aSelectOrder,',')
  cSelect := Substr(cStatement,nFound)
ENDIF

nFound := At(' WHERE ',Upper(cStatement))
IF nFound > 0
  IF nFoundOrderBy > 0
    nFound += 6
    cSelect := Alltrim(Substr(cStatement,nFound,nFoundOrderBy-nFound))
  ELSE
    cSelect := Substr(cStatement,nFound+6)
  ENDIF
  cSelect := Strtran(cSelect,' AND ',Chr(254))
  cSelect := Strtran(cSelect,' and ',Chr(254))
  cSelect := Strtran(cSelect,' And ',Chr(254))
  cSelect := Strtran(cSelect,' OR ',Chr(253))
  cSelect := Strtran(cSelect,' or ',Chr(253))
  cSelect := Strtran(cSelect,' Or ',Chr(253))
  ::aSelectWhere := DC_TokenArray(cSelect,Chr(254)+Chr(253))
ENDIF

RETURN nil

* ---------------

METHOD SqlQuery:ListODBCDataTypes(oSession)

LOCAL aDDLTypes, aDMLTypes, oBrowse1, oBrowse2, GetList[0], ;
      cText, oMle, oTab1, oTab2, oTab3, GetOptions, cAsterisks

aDDLTypes := { ;
  { 'Signed integer (-2^63, 2^64-1)','SQL_BIGINT','N','N' }, ;
  { 'Fixed length binary data', 'SQL_BINARY', 'X', 'C' }, ;
  { 'Single bit value', 'SQL_BIT', 'L', 'L' }, ;
  { 'Fixed length character string', 'SQL_CHAR', 'C', 'C' }, ;
  { 'Date optionally combined with time','SQL_DATETIME','D','D' }, ;
  { 'Numeric value with fixed decimal places','SQL_DECIMAL','N','N' }, ;
  { 'Numeric value with "double" precision','SQL_DOUBLE','F','N' }, ;
  { 'Floating point numeric value','SQL_FLOAT','F','N' }, ;
  { 'Globally unique identifier','SQL_GUID','C','C' }, ;
  { 'Signed integer (-2^31, 2^32-1)','SQL_INTEGER','I','N' }, ;
  { 'Variable length binary data','SQL_LONGVARBINARY','V','C' }, ;
  { 'Variable length character string','SQL_LONGVARCHAR','M','C' }, ;
  { 'Signed numeric value','SQL_NUMERIC','N','N' }, ;
  { 'Numeric value with "real" precision','SQL_REAL','F','N' }, ;
  { 'Signed integer (-2^15, 2^16-1)','SQL_SMALLINT','N','N' }, ;
  { 'Time','SQL_TIME','C','C' }, ;
  { 'Signed integer (-2^7, 2^8-1)','SQL_TINYINT','N','N' }, ;
  { 'Time stamp','SQL_TIMESTAMP','T','C' }, ;
  { 'Variable length binary data','SQL_VARBINARY','V','C' }, ;
  { 'Variable length character string','SQL_VARCHAR','M','C' }, ;
  { 'Fixed length wide character','SQL_WCHAR','W','C' }, ;
  { 'Variable length wide character','SQL_WLONGVARCHAR','Q','C' }, ;
  { 'Variable length wide character','SQL_WVARCHAR','Q','C' } }

aDMLTypes := { ;
  { 'Single bit value','L','L','SQL_BIT' }, ;
  { 'Fixed length character string','C','C','SQL_CHAR' }, ;
  { 'Date optionally combined with time','D','D','SQL_DATETIME' }, ;
  { 'Numeric value with fixed decimal places','N','N','SQL_NUMERIC' }, ;
  { 'Floating point numeric value','F','N','SQL_FLOAT' }, ;
  { 'Signed integer (-2^31, 2^32-1)','I','N','SQL_INTEGER' }, ;
  { 'Variable length binary data **)','V','C','SQL_LONGVARBINARY or SQL_VARBINARY' }, ;
  { 'Variable length character string ***)','M','C','SQL_LONGVARCHAR or SQL_VARCHAR' }, ;
  { 'Time stamp','T','C','SQL_TIMESTAMP' }, ;
  { 'Variable length binary data','X','C','SQL_VARBINARY' }, ;
  { 'Fixed length wide character','W','C','SQL_WCHAR' }, ;
  { 'Variable length wide character','Q','C','SQL_WLONGVARCHAR' } }

TEXT INTO cText WRAP
Data type mapping

When Xbase++ is used as the data definition language (DDL) and data manipulation language
(DML) for non-Xbase databases, an application programmer must take into account the
differences that may exist between an Xbase database and a foreign database. This applies
mainly to the data types supported by a DBMS which requires to match different data types
when the DBMS supports other or more data types than are available in Xbase++.

An SQL DBMS, for example, supports different numeric data types - such as integer, float
or real - while there is only one numeric data type in Xbase++. This requires the ODBCDBE
to match data types and to convert data when data is read from or written to an SQL table
by an Xbase++ application. This is done automatically and is referred to as Data Type Mapping.
All numeric data types supported by a DBMS are mapped to one numeric data type in an Xbase++
program. Likewise, the data type Logical of an Xbase++ program is mapped to the data type
Bit in an SQL table, because Logical is a data type of Xbase languages and does not exist
in SQL databases. Logical, however, is equivalent to Bit.

Xbase++ data types are identified by a single letter, equivalent to the return value of the
ValType() function. In contrast, data types of non-Xbase databases are usually identified
by symbolic names. This requires a programmer to know what data types are present in an
SQL table and what data type a particular value stored in the table will have when it is
assigned to a memory variable in the Xbase++ program.

The latter raises another issue:
some data types cannot exist in memory but only in tables. An example is variable-length
text stored in a memo field of a DBF table. Assume a memo field having the name NOTES:

   ? Valtype( FIELD->NOTES )  // result: M

   cText := FIELD->NOTES      // assign contents of field to variable

   ? Valtype( cText )         // result: C

These three lines of code demonstrate that data type mapping exists already in Xbase++
(and other Xbase languages). The data type of the field value is "M" (Memo),
and it becomes "C" (Character) when the field value is assigned to a memory variable.
Since Xbase++ can be used as data definition language (DDL) and data manipulation
language (DML), it is important to distinguish data type mapping for data definition
and data manipulation. Data definition means: creation of tables (CREATE FROM, DbCreate()),
and data manipulation covers reading/writing of values stored in fields, or table columns
(REPLACE, FieldGet(), FieldPut()). For example, it makes a difference if two fields are
defined having datatypes "C" and "M", but it makes no difference when the value of either
field is manipulated.

The distinction between DML and DDL is of minor importance as long as data is stored in
DBF tables. However, it becomes important when data sources are created or accessed via
the ODBCDBE. In this case, data type mapping may be different for data definition and
data manipulation. This depends on the data types supported by the data source. For example,
the ODBCDBE is able to create an SQL table having columns of different numeric data types.
Xbase++, used as the DDL, supports different numeric data types for the data definition.
In contrast, Xbase++, used as the DML, makes no difference between numeric data types when
data is manipulated in an application program.

Xbase programmers are usually not aware of the difference between DDL and DML since the
same programming language is used for both, data definition and data manipulation. In
addition, all Xbase programming languages hide data type mapping from a programmer, and
so does Xbase++/ODBCDBE (the value of a memo field has type "M" and is mapped to type "C"
when it is assigned to a memory variable). However, data type mapping is an important
issue when non-Xbase databases are accessed. There is a data type mapping between
DDL data types and DML data types, and a mapping between Xbase data types and non-Xbase
data types. To be able to distinguish the data types from their origin, the following
terms are used:

DDL-type:  Data type for the data definition with Xbase++.
A DDL-type is represented by a single letter used to define the data type of a database
field. DDL-types are listed in the second column of the DbStruct() array.

DML-type:  Data type for the data manipulation with Xbase++.
A DML-type is represented by a single letter equivalent to the return value of the
Valtype() function.

ODBC-type:  Data type exposed by the data source accessed via ODBCDBE.

DBMS-type:  Native data type of the data source. It is usually a symbolic name for
non-Xbase databases.

Since ODBC-types are data source specific, the following documentation uses ODBC
data types for explanations.

Data definition (DDL)

When a table is created by an Xbase++ application, the table structure is defined in an
array having four columns. The second column of the array contains letters representing
the DDL-types for the table columns. The resulting ODBC-types are listed in the
DDL data type mapping table.
ENDTEXT

TEXT INTO cAsterisks WRAP
*) #define constants come from the ODBC 3.0 SDK.
**) When the field length>0 SQL_VARBINARY is used, if length==0 SQL_LONGVARBINARY is used
***) When the field length>0 SQL_VARCHAR is used, if length==0 SQL_LONGVARCHAR is used
ENDTEXT

@ 0,0 DCTABPAGE oTab1 CAPTION 'DDL Mapping' SIZE 120,30 ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

@ 2,2 DCSAY cAsterisks SAYSIZE 110,2.5 ;
      SAYWORDBREAK ;
      FONT '10.Lucida Console' PARENT oTab1 ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ 5.5,2 DCBROWSE oBrowse1 DATA aDMLTypes SIZE 70,20 FIT ;
      FONT '9.Arial' NOHSCROLL FONT '10.Lucida Console' PARENT oTab1 ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCBROWSECOL ELEMENT 1 HEADER 'Type Description' WIDTH 45 PARENT oBrowse1
DCBROWSECOL ELEMENT 2 HEADER 'DDL Type' WIDTH 10 PARENT oBrowse1
DCBROWSECOL ELEMENT 3 HEADER 'DML Type' WIDTH 10 PARENT oBrowse1
DCBROWSECOL ELEMENT 4 HEADER 'ODBC Type *)' WIDTH 25 PARENT oBrowse1

@ 0,0 DCTABPAGE oTab2 RELATIVE oTab1 CAPTION 'DML Mapping' ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

@ 2,2 DCSAY '*) #define constants come from the ODBC 3.0 SDK' SAYSIZE 0 ;
      FONT '10.Lucida Console' PARENT oTab2 ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ 4,2 DCBROWSE oBrowse2 DATA aDDLTypes SIZE 70,25 FIT ;
      FONT '9.Arial' NOHSCROLL FONT '10.Lucida Console' PARENT oTab2 ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCBROWSECOL ELEMENT 1 HEADER 'Type Description' WIDTH 45 PARENT oBrowse2
DCBROWSECOL ELEMENT 2 HEADER 'ODBC Type (*)' WIDTH 20 PARENT oBrowse2
DCBROWSECOL ELEMENT 3 HEADER 'DDL Type' WIDTH 10 PARENT oBrowse2
DCBROWSECOL ELEMENT 4 HEADER 'DML (Xbase) Type' WIDTH 10 PARENT oBrowse2

@ 0,0 DCTABPAGE oTab3 RELATIVE oTab2 CAPTION 'Information' ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

@ 2,2 DCMULTILINE cText OBJECT oMle SIZE 116,25 ;
      FONT '10.Lucida Console' NOHSCROLL PARENT oTab3 ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCGETOPTIONS RESIZE SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT BUTTONS DCGUI_BUTTON_OK MODAL ;
   TITLE 'ODBC Data Types' NOAUTORESTORE OPTIONS GetOptions ;
   EVAL {|o|::SetWindowPos(o)}

RETURN nil

* ---------------

METHOD SqlQuery:ListODBCDrivers( cDriver )

LOCAL aDriver, cDriverName, aAttributes, i, oBrowse, lStatus, ;
      nCol := 42, nCol2 := 105 ,nPointer := 1, GetList[0], ;
      GetOptions, bGet, cTrial := '', oTrial, bItemSelected, ;
      aDbeList := DbeList()

IF !('ODBCDBE'$aDbeList) .AND. !DbeLoad( "ODBCDBE",.f.)
  DC_WinAlert('Database-Engine ODBCDBE not loaded')
  RETURN .f.
ENDIF

dbeSetDefault('ODBCDBE')

aDriver := DbeInfo( COMPONENT_DATA, ODBCDBE_DRIVERS )

FOR i := 1 TO Len(aDriver)

  DEFAULT aDriver[i,2,1] := 0, ;
          aDriver[i,2,2] := Space(3), ;
          aDriver[i,2,3] := Space(100), ;
          aDriver[i,2,4] := Space(100), ;
          aDriver[i,2,5] := Space(8), ;
          aDriver[i,2,6] := Space(100), ;
          aDriver[i,2,7] := 0, ;
          aDriver[i,2,8] := Space(100), ;
          aDriver[i,2,9] := 0, ;
          aDriver[i,2,10] := 0

  aDriver[i,2,6] := Pad(aDriver[i,2,6],100)
  aDriver[i,1] := Pad(aDriver[i,1],100)
  aDriver[i,2,5] := Pad(aDriver[i,2,5],8)

NEXT

IF PCount() == 0
  bItemSelected := ;
    {||IIF(aDriver[nPointer,2,7]==0, ;
         (cTrial := _GetTrial(Trim(aDriver[nPointer,1])), ;
          DC_GetRefresh(oTrial)),nil)}
ELSE
  bItemSelected := {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}
ENDIF

@ 0,0 DCBROWSE oBrowse DATA aDriver SIZE 40,27 ;
      FONT '9.Arial' ;
      POINTER nPointer ;
      ITEMMARKED {||DC_GetRefresh(GetList,,,,'GROUP1')} ;
      ITEMSELECTED bItemSelected

DCBROWSECOL ELEMENT 1 HEADER 'Driver Name' WIDTH 40 PARENT oBrowse

IF Pcount() == 0

  @ 0, nCol2 DCSAY 'Trial Server Connection' SAYSIZE 0
  @ 1, nCol2 DCSAY 'Double-Click Driver Name to Execute trial' SAYSIZE 0
  @ 2, nCol2 DCMULTILINE cTrial SIZE 30,10 OBJECT oTrial ;
       FONT '9.Lucida Console' NOHSCROLL ;
       WHEN {||aDriver[nPointer,2,7]==0}
ENDIF

DCSETGROUP TO 'GROUP1'

bGet := {||aDriver[nPointer,1]}
@ 0, nCol DCSAY 'Driver Name' GET bGet GETSIZE 40

bGet := {||aDriver[nPointer,2,1]}
@ 2, nCol DCSAY 'API Level' GET bGet PICTURE '9'

bGet := {||aDriver[nPointer,2,2,1]}
@ 4, nCol DCSAY 'SQLConnect' GET bGet

bGet := {||aDriver[nPointer,2,2,2]}
@ 6, nCol DCSAY 'SQLDriverConnect' GET bGet

bGet := {||aDriver[nPointer,2,2,3]}
@ 8, nCol DCSAY 'SQLBrowseConnect' GET bGet

bGet := {||aDriver[nPointer,2,3]}
@10, nCol DCSAY 'Description' GET bGet GETSIZE 40

bGet := {||aDriver[nPointer,2,4]}
@12, nCol DCSAY 'Driver DLL Path' GET bGet GETSIZE 40

bGet := {||aDriver[nPointer,2,5]}
@14, nCol DCSAY 'Driver Version' GET bGet PICTURE '99.99'

bGet := {||aDriver[nPointer,2,6]}
@16, nCol DCSAY 'File Extensions' GET bGet GETSIZE 40

bGet := {||aDriver[nPointer,2,7]}
@18, nCol DCSAY 'File Usage' GET bGet PICTURE '9'
@19, nCol + 5 DCSAY '0 = DBMS (SQL), 1 = Single File (Xbase), 2 = Multi File (Access)';
      SAYSIZE 0 COLOR GRA_CLR_BLUE FONT '9.Arial Bold'

bGet := {||aDriver[nPointer,2,8]}
@21, nCol DCSAY 'Setup DLL Path' GET bGet GETSIZE 40

bGet := {||aDriver[nPointer,2,9]}
@23, nCol DCSAY 'Supported SQL Grammar' GET bGet PICTURE '9'
@24,nCol + 5 DCSAY '0 = SQL-92 entry, 1 = FIPS127-2 transitional, 2 = SQL-92 intermediato, 3 = SQL-92 Full' ;
      SAYSIZE 0 COLOR GRA_CLR_BLUE FONT '9.Arial Bold'

bGet := {||aDriver[nPointer,2,10]}
@26, nCol DCSAY 'Usage Count' GET bGet PICTURE '9'

DCGETOPTIONS ;
   SAYWIDTH 125 ;
   SAYRIGHTBOTTOM ;
   SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT ADDBUTTONS MODAL TO lStatus ;
   TITLE 'ODBC Drivers' OPTIONS GetOptions NOAUTORESTORE ;
   EVAL {|o|::SetWindowPos(o)}

IF lStatus
  cDriver := aDriver[nPointer,1]
ENDIF

RETURN cDriver

* -----------

STATIC FUNCTION _GetTrial( cDriver )

LOCAL cTrial := '', oScrn := DC_WaitOn('Getting Trial Data from server...')

dbeSetDefault('ODBCDBE')

// start trial
DbeInfo( COMPONENT_DATA, ODBCDBE_SET_TRIAL_SERVER, ;
         "DRIVER={" + cDriver +"};" )

cTrial := DbeInfo( COMPONENT_DATA, ODBCDBE_GET_TRIAL_SERVER )

// stop trial
DbeInfo( COMPONENT_DATA, ODBCDBE_SET_TRIAL_SERVER)

DC_Impl(oScrn)

IF !Empty(cTrial)
  cTrial := Strtran(cTrial,';',';'+CRLF)
ENDIF

DEFAULT cTrial := 'No Data'

RETURN cTrial

* -----------

METHOD SqlQuery:HexToRGBColor( cHex )

LOCAL aHex[3], i

cHex := Strtran(cHex,'#','')

FOR i := 1 TO 3
  aHex[i] := Substr(cHex,(i*2)-1,2)
  aHex[i] := DC_Hex2Dec(aHex[i])
NEXT

RETURN aHex

* -----------

METHOD SqlQuery:RGBToHexColor( aRGB )

LOCAL i, cHex := '#'

FOR i := 1 TO 3
  cHex += DC_Dec2Hex(aRGB[i])
NEXT

RETURN cHex

* -----------

METHOD SqlQuery:ConvertColor( cColor )

LOCAL nColor := 0

IF '{' $ cColor
  nColor := GraMakeRGBColor(&(cColor))
ELSEIF '#' $ cColor
  nColor := GraMakeRGBColor(::HexToRGBColor(cColor))
ELSEIF Upper(Left(cColor,3)) == 'DC_'
  nColor := ::BrowseColors(cColor)
ELSE
  nColor := Val(cColor)
ENDIF

RETURN nColor

* ------------

METHOD SqlQuery:PackTable( cTableName, oConnection )

LOCAL lStatus, oSession, bError := ErrorBlock({|e|Break(e)}), ;
      lError

DCMSGBOX 'This routine will remove all Deleted Records', ;
         'from table: ' + cTablename,'', ;
         'Continue?' YESNO FONT ::cMessageFont TO lStatus ;
         OWNER AppDeskTop()

IF lStatus
  DC_PointerWait()
  BEGIN SEQUENCE
  lError := .t.
  IF Valtype(oConnection:sessionDict) == 'O'
    oSession := oConnection:sessionDict
  ELSE
    oSession := oConnection:sessionFree
    cTableName := oConnection:serverFree + cTableName
  ENDIF
  dbeSetDefault('ADSDBE')
  DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE, oConnection:AdsTableType )
  DbeInfo( COMPONENT_ORDER, ADSDBE_TBL_MODE, oConnection:AdsTableType )
  DbeInfo( COMPONENT_DATA, ADSDBE_LOCK_MODE, oConnection:AdsLockingType )
  DbeInfo( COMPONENT_DATA, ADSDBE_TABLENAME_IS_ALIAS, .f. )

  USE (cTableName) VIA (oSession) EXCLUSIVE ALIAS 'TABLE'
  TABLE->(dbPack())
  lError := .f.
  END SEQUENCE
  DC_PointerArrow()
  IF lError
    DCMSGBOX 'Pack failed!' FONT ::cMessageFont OWNER AppDeskTop()
  ELSE
    DCMSGBOX 'Pack was successful!' FONT ::cMessageFont OWNER AppDeskTop()
  ENDIF
  ErrorBlock(bError)
  dbCloseAll()
ENDIF

RETURN nil

* =============================

CLASS SqlQueryConnection

EXPORTED:

VAR Type
VAR SessionDict
VAR SessionFree
VAR Name
VAR ConnectString
VAR Driver
VAR Server
VAR ServerDict
VAR ServerFree
VAR ServerType
VAR Database
VAR Dbq
VAR UID
VAR PWD
VAR Network
VAR ConnectTimeOut
VAR HandleDict
VAR HandleFree
VAR TreeArray
VAR TreeBuildBlock
VAR SqlStatement
VAR AdsLockingType
VAR AdsTableType
VAR AdsServerType
VAR GroupName
VAR ConnectionBranch
VAR TableBranch
VAR ViewBranch
VAR ProcedureBranch
VAR SQLScriptBranch
VAR CommandScriptBranch
VAR ISAMScriptBranch
VAR IsConnected
VAR BrowseWindowBGColor
VAR cMessageFont
VAR IsTraceODBC
VAR ODBCTraceFile
VAR ODBCTraceFileSave
VAR isShowDeleted

METHOD Init(), ;
       ConnectAds(), ;
       ConnectODBC(), ;
       CreateConnection(), ;
       Connect(), ;
       DisConnect(), ;
       ImportData(), ;
       ImportDBF(), ;
       ImportCSV(), ;
       ImportXML(), ;
       ImportSQL(), ;
       ImportJSON(), ;
       TraceODBC(), ;
       SessionPropertiesODBC(), ;
       GetDefaultServerType(), ;
       AdsSessionCreate()

#if XPPVER > 2000000
  METHOD ConnectPg()
#endif

ENDCLASS

* ----------

METHOD SqlQueryConnection:Init( aData, oSqlQuery )

::IsConnected := .f.
IF Empty(aData)
  ::Type := Space(4)
  ::Name := Space(30)
  ::Driver := Space(50)
  ::Server := Space(100)
  ::ServerDict := Space(100)
  ::ServerFree := Space(100)
  ::Database := Space(100)
  ::Network := Space(50)
  ::UID := Space(30)
  ::PWD := Space(100)
  ::ConnectTimeOut := 0
  ::AdsLockingType := DC_AdsLockModeDefault()
  ::AdsTableType := DC_AdsIndexModeDefault()
  ::AdsServerType := ::GetDefaultServerType()
  ::ConnectString := Space(500)
  ::HandleDict := 0
  ::HandleFree := 0
  ::BrowseWindowBGColor := GRA_CLR_BACKGROUND
  RETURN self
ENDIF

::Type           := Trim(aData[1])
::SessionDict    := aData[2]
::SessionFree    := aData[3]
::Name           := Trim(aData[4])
::ConnectString  := Trim(aData[5])
::Driver         := Trim(aData[6])
::Server         := Trim(aData[7])
::ServerDict     := Trim(aData[8])
::ServerFree     := Trim(aData[9])
::ServerType     := Trim(aData[10])
::Database       := Trim(aData[11])
::UID            := Trim(aData[12])
::PWD            := Trim(aData[13])
::Network        := Trim(aData[14])
::ConnectTimeOut := aData[15]
::AdsLockingType := aData[16]
::AdsTableType   := aData[17]
::AdsServerType  := aData[18]
::BrowseWindowBGColor := oSqlQuery:ConvertColor(aData[19])
::handleDict     := 0
::handleFree     := 0
::SqlStatement   := ''
::GroupName      := '<unknown>'
::IsTraceODBC    := .f.
::IsShowDeleted  := .t.

/*
IF Left(::PWD,3) == '{||'
  ::PWD := Eval(&(::PWD))
ENDIF
*/
IF Left(::UID,3) == '{||'
  ::UID := Eval(&(::UID))
ENDIF
::cMessageFont := '10.Lucida Console'

IF Left(::Type,3) = 'ADS' .AND. ::AdsServerType == 0
  ::AdsServerType := ::GetDefaultServerType()
ENDIF

RETURN self

* -----------

METHOD SqlQueryConnection:GetDefaultServerType()

LOCAL cIniFile := DC_Path(AppName(.t.)) + 'Ads.Ini'

LOCAL nServerType := Val(DC_IniRead(cIniFile,'SETTINGS','ADS_SERVER_TYPE'))

RETURN nServerType

* -----------

METHOD SqlQueryConnection:AdsSessionCreate( cPath )

LOCAL cConnect, oAdsSession

DEFAULT cPath := DC_Path(AppName(.t.))

cConnect := 'DBE=ADSDBE;SERVER=' + cPath

oAdsSession := DC_DacSession():new( cConnect )

IF !oAdsSession:isConnected()
  DC_WinAlert('ADSDBE Connection Failed to ' + cPath + Chr(13) + ;
              'Error code: ' + Alltrim(Str(oAdsSession:getLastError())) + Chr(13) + ;
                oAdsSession:getLastMessage())
ENDIF

RETURN oAdsSession

* -----------

METHOD SqlQueryConnection:CreateConnection( oSqlQuery, lNew )

LOCAL GetList[0], GetOptions, lStatus, aAdsLocking, aAdsTable, ;
      i, aRef, aData, cGroupName, cType := Space(8), oConnection, ;
      aTypes, aAdsServer, oSayLocking, oSayTable, oSayServer, ;
      cTitle

IF lNew
  cTitle := 'New Connection'
ELSE
  cTitle := 'Edit Connection Properties'
  IF ::type = 'ADS'
    IF '.ADD' $ Upper(::database)
      cType := 'ADS_DICT'
    ELSE
      cType := 'ADS_FREE'
    ENDIF
  ELSE
    cType := Pad(::type,8)
  ENDIF
ENDIF

aTypes := ;
   {'ADS_DICT - Advantage Server (Dictionary)', ;
    'ADS_FREE - Advantage Server (Free Tables)', ;
    'ODBC     - ODBCDBE', ;
    'PG       - PostGreSQL' }

@ 0,0 DCSAY 'Connection Type' GET cType COMBO WIDTH 50 HEIGHT 5 ;
      DATA  aTypes ;
      PICTURE '@!' ;
      VALID {|x|x := Trim(cType)$aTypes, ;
                IIF(!x,DC_WinAlert('Choose a valid Type'),nil), ;
                IIF(x,::type := _GetConnectionType(cType),nil),x}

@ 1,0 DCSAY 'Connection Name' GET ::name PROPER ;
      TOOLTIP 'A name for this connection' ;
      VALID {||DC_ReadEmpty(::name)}

@ 2,0 DCSAY 'Driver' GET ::driver POPUP {||oSqlQuery:ListODBCDrivers(::driver)} ;
      WHEN {||::type = 'ODBC'} ;
      TOOLTIP 'Name of ODBC driver' ;
      VALID {||DC_ReadEmpty(::driver)}

@ 3,0 DCSAY 'Server' GET ::Server ;
      WHEN {||::type $ {'ADS','PG'}} ;
      TOOLTIP 'Name or IP address of server' ;
      ;//VALID {||DC_ReadEmpty(::Server)}

@ 4,0 DCSAY 'Database' GET ::database ;
      HIDE {||!(Alltrim(::type) $ {'ODBC','PG'})};
      TOOLTIP 'Name of Database' ;
      ;// VALID {||DC_ReadEmpty(::database)}

@ 4,0 DCSAY 'Database' GET ::database ;
      HIDE {||Alltrim(cType) # 'ADS_DICT'} ;
      POPUP {|c|DC_PopFile(c,,'*.ADD')} ;
      TOOLTIP 'Name and location of ADS Dictionary (*.ADD) File' ;
      VALID {||DC_ReadEmpty(::database)}

@ 5,0 DCSAY 'Free Tables (path)' GET ::ServerFree POPUP {|c|c := DC_PopDir(c)} ;
      WHEN {||Left(cType,3) = 'ADS'} ;
      TOOLTIP 'Path of Free Tables' ;
      GETSIZE 75

@ 6,0 DCSAY 'User ID' GET ::UID WHEN {||Alltrim(cType) $ {'ODBC','PG','ADS_DICT'}}

@ 7,0 DCSAY 'Password' GET ::PWD WHEN {||Alltrim(cType) $ {'ODBC','PG','ADS_DICT'}}

@ 8,0 DCSAY 'Connect Timeout' GET ::ConnectTimeout

aAdsLocking := {'0 - Compatible', '1 - Proprietary'}
@9,0 DCSAY 'ADS Locking Type' GET ::AdsLockingType ;
      COMBO WIDTH 35 HEIGHT 4 DATA aAdsLocking ;
      RETURN {|n|Val(aAdsLocking[n])} PICTURE '9' ;
      WHEN {||oSayLocking:refresh(),Left(cType,3) = 'ADS'}

@ DCGUI_ROW, DCGUI_COL + 10 ;
      DCSAY {||aAdsLocking[AScan(aAdsLocking,Alltrim(Str(::AdsLockingType)))]} ;
      FONT '10.Lucida Console' COLOR GRA_CLR_BLUE ;
      OBJECT oSayLocking SAYSIZE 20 SAYLEFTBOTTOM

aAdsTable := {'1 - NTX', '2 - CDX', '3 - ADT','4 - VFP'}
@10,0 DCSAY 'ADS Table Type' GET ::AdsTableType ;
      COMBO WIDTH 10 HEIGHT 4 DATA aAdsTable ;
      RETURN {|n|Val(aAdsTable[n])} PICTURE '9' ;
      WHEN {||Left(cType,3) = 'ADS'} ;
      VALID {||DC_GetRefresh(GetList),.t.}

@ DCGUI_ROW, DCGUI_COL + 10 ;
      DCSAY {||aAdsTable[AScan(aAdsTable,Alltrim(Str(::AdsTableType)))]} ;
      FONT '10.Lucida Console' COLOR GRA_CLR_BLUE ;
      OBJECT oSayTable SAYSIZE 20 SAYLEFTBOTTOM

IF Empty(::AdsServerType)
  ::AdsServerType := 3
ENDIF

aAdsServer := {'1 - Local', '2 - Client', '3 - Client/Local'}
@11,0 DCSAY 'ADS Server Type' GET ::AdsServerType ;
      COMBO WIDTH 30 HEIGHT 4 DATA aAdsServer ;
      RETURN {|n|Val(aAdsServer[n])} PICTURE '9' ;
      WHEN {||Left(cType,3) = 'ADS'} ;

@ DCGUI_ROW, DCGUI_COL + 10 ;
      DCSAY {||aAdsServer[AScan(aAdsServer,Alltrim(Str(::AdsServerType)))]} ;
      FONT '10.Lucida Console' COLOR GRA_CLR_BLUE ;
      OBJECT oSayServer SAYSIZE 20 SAYLEFTBOTTOM

@ 10, 60 DCSAY ;
        'If Advantage Server is not installed, ;' + ;
        'Make sure that you enter ADS_SERVER_TYPE=1;' + ;
        'in your ADS.INI file.' SAYWORDBREAK ;
        SAYSIZE 50,2.5 COLOR GRA_CLR_BLUE FONT '9.Lucida Console' ;
        HIDE {||Left(cType,3)#'ADS'}

@13,0 DCSAY 'Additional Connection String' GET ::ConnectString GETSIZE 75

@ 8,65 DCPUSHBUTTON CAPTION 'Test Connection' SIZE 15,1.2 ;
      ACTION {||::type := cType, _TestConnection(self)}

DCGETOPTIONS ;
   SAYWIDTH 150 ;
   SAYRIGHTBOTTOM

DCREAD GUI FIT TITLE cTitle MODAL ;
   ADDBUTTONS TO lStatus OPTIONS GetOptions ;
   SETAPPWINDOW NOAUTORESTORE

IF lStatus
  IF Left(cType,3) = 'ADS'
    ::type := Left(cType,3)
  ELSE
    ::type := Alltrim(cType)
  ENDIF

  IF !lNew
    DCMSGBOX 'Update this dictionary connection in ' + oSqlQuery:cIniFile + '?' ;
      YESNO TO lStatus FONT '10.Lucida Console' OWNER AppDeskTop()
  ELSE
    DCMSGBOX 'Add this new dictionary connection to ' + oSqlQuery:cIniFile + '?' ;
      YESNO TO lStatus FONT '10.Lucida Console' OWNER AppDeskTop()
  ENDIF

  IF lStatus

    aRef := {'Type', ;
             'Name', ;
             'Driver', ;
             'Server', ;
             'Database', ;
             'UID', ;
             'PWD', ;
             'ConnectTimeOut'}

    aData := { ::type, ;
               Trim(::name), ;
               Trim(::driver), ;
               Trim(::server), ;
               Trim(::database), ;
               Trim(::uid), ;
               Trim(::pwd), ;
               ::connectTimeOut }

    IF Trim(::type) == 'ADS'
      AAdd(aRef,'ServerFree')
      AAdd(aRef,'AdsLockingType')
      AAdd(aRef,'AdsTableType')
      AAdd(aRef,'AdsServerType')
      AAdd(aData,Trim(::ServerFree))
      AAdd(aData,::AdsLockingType)
      AAdd(aData,::AdsTableType)
      AAdd(aData,::AdsServerType)
    ENDIF

    IF lNew
      FOR i := 1 TO 40
        cGroupName := Trim(::type) + '_' + Alltrim(Str(i))
        IF Empty(DC_IniRead(oSqlQuery:cIniFile,cGroupName,'Name'))
          DC_IniSave(oSqlQuery:cIniFile,cGroupName,aData,aRef)
          // DCMSGBOX 'Connection data has been saved.' FONT '10.Lucida Console'
          oConnection := oSqlQuery:LoadSessions(cGroupName)
          oSqlQuery:buildTree(oConnection)
          EXIT
        ENDIF
      NEXT
    ELSE
      DC_IniSave(oSqlQuery:cIniFile,::GroupName,aData,aRef)
      DCMSGBOX 'Connection data has been updated.', ;
               'Restart SqlQuery to use this connection' ;
               FONT '10.Lucida Console' OWNER AppDeskTop()
    ENDIF
  ENDIF

ENDIF

RETURN lStatus

* -----------

STATIC FUNCTION _GetConnectionType( cType )

IF Left(cType,3) == 'ADS'
  RETURN 'ADS'
ELSEIF Left(cType,2) == 'PG'
  RETURN 'PG'
ELSEIF Left(cType,4) == 'ODBC'
  RETURN 'ODBC'
ELSEIF Left(cType,6) == 'DBFCDX'
  RETURN 'DBFCDX'
ENDIF
RETURN ''

* -----------

STATIC FUNCTION _TestConnection( self )

LOCAL lStatus := .f., lDictConnection

DC_PointerWait()

IF Left(::type,4) = 'ODBC' .AND. ::ConnectODBC(self)
  lStatus := .t.
  ::GroupName := 'ODBC_'
ELSEIF Left(::type,3) = 'ADS' .AND. ::ConnectADS(@lDictConnection,self)
  ::GroupName := 'ADS_'
  lStatus := .t.
#if XPPVER > 2000000
ELSEIF Left(::type,2) = 'PG' .AND. ::ConnectPG(self)
  ::GroupName := 'PG_'
  lStatus := .t.
#endif
ENDIF
DC_PointerArrow()

IF lStatus
  IF Valtype(::sessionDict) == 'O'
    ::sessionDict:disconnect()
  ENDIF
  IF Valtype(::sessionFree) == 'O'
    ::sessionFree:disconnect()
  ENDIF
  DCMSGBOX 'Connection was successful' OWNER AppDeskTop()
ENDIF

RETURN lStatus

* -----------

METHOD SqlQueryConnection:Connect(oSqlQuery)

LOCAL lDictConnection

IF ::type == 'ADS'
  IF ::ConnectAds( @lDictConnection,oSqlQuery )
    IF lDictConnection
      ::TreeBuildBlock := BuildDictArrayAdsBlock(oSqlQuery,self)
    ELSE
      ::TreeBuildBlock := BuildFreeArrayAdsBlock(oSqlQuery,self)
    ENDIF
  ENDIF
ELSEIF ::type == 'ODBC'
  IF ::ConnectODBC(oSqlQuery)
    ::TreeBuildBlock := BuildDictArrayODBCBlock(oSqlquery,self)
  ENDIF
ELSEIF ::type = 'PG'
  #if XPPVER > 2000000
    IF ::ConnectPG(oSqlQuery)
      ::TreeBuildBlock := BuildDictArrayPGBlock(oSqlquery,self)
    ENDIF
  #endif
ENDIF

IF Valtype(::ConnectionBranch) == 'O'
  IF ::IsConnected
    ::ConnectionBranch:setImage(ICON_DICTIONARY)
    ::ConnectionBranch:setExpandedImage(ICON_DICTIONARY)
    ::ConnectionBranch:setMarkedImage(ICON_DICTIONARY)
  ELSE
    ::ConnectionBranch:setImage(ICON_DICTIONARY_GRAY)
    ::ConnectionBranch:setExpandedImage(ICON_DICTIONARY_GRAY)
    ::ConnectionBranch:setMarkedImage(ICON_DICTIONARY_GRAY)
  ENDIF
ENDIF

RETURN ::IsConnected

* -----------

METHOD SqlQueryConnection:Disconnect(oSqlQuery)

LOCAL i, aChildItems

IF Valtype(::handleDict) == 'N'
  AdsDisconnect(::handleDict)
ENDIF

IF Valtype(::sessionDict) == 'O' .AND. ::sessionDict:isConnected()
  ::sessionDict:disconnect()
  ::IsConnected := .f.
ENDIF

IF Valtype(::sessionFree) == 'O' .AND. ::sessionFree:isConnected()
  ::sessionFree:disconnect()
  ::IsConnected := .f.
ENDIF

IF ::IsConnected
  ::ConnectionBranch:setImage(ICON_DICTIONARY)
  ::ConnectionBranch:setExpandedImage(ICON_DICTIONARY)
  ::ConnectionBranch:setMarkedImage(ICON_DICTIONARY)
ELSE
  ::ConnectionBranch:setImage(ICON_DICTIONARY_GRAY)
  ::ConnectionBranch:setExpandedImage(ICON_DICTIONARY_GRAY)
  ::ConnectionBranch:setMarkedImage(ICON_DICTIONARY_GRAY)

  oSqlQuery:oTree:lockUpdate(.t.)
  aChildItems := ::ConnectionBranch:getChildItems()
  FOR i := 1 TO Len(aChildItems)
    ::ConnectionBranch:delItem(aChildItems[i])
  NEXT
  oSqlQuery:oTree:lockUpdate(.f.)
  oSqlQuery:oTree:invalidateRect()
ENDIF

RETURN ::IsConnected

* -----------

METHOD SqlQueryConnection:TraceODBC( lOn )

IF lOn
  ::ODBCTraceFile := DC_Path(AppName(.t.)) + ::GroupName + '_Trace.Log'
  ::ODBCTraceFileSave := OdbcTraceFile(::ODBCTraceFile)
  OdbcTraceMode(.t.)
  ::IsTraceODBC := .t.
  DCMSGBOX 'ODBC Trace Started.', ;
           'Logging to ' + ::ODBCTraceFile  FONT '10.Lucida Console' ;
           OWNER AppDeskTop()

ELSE
  OdbcTraceMode(.f.)
  OdbcTraceFile(::ODBCTraceFileSave)
  ::IsTraceODBC := .f.
  DC_SpawnUrl(::ODBCTraceFile)
ENDIF

RETURN nil

* -----------

METHOD SqlQueryConnection:ConnectAds( lDictConnection, oSqlquery )

LOCAL cSession,  cName, cSqlConnect, nError := 0, cPwd

lDictConnection := .f.

dbeSetDefault('ADSDBE')

DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE, ::AdsTableType )
DbeInfo( COMPONENT_ORDER, ADSDBE_TBL_MODE, ::AdsTableType )
DbeInfo( COMPONENT_DATA, ADSDBE_LOCK_MODE, ::AdsLockingType )
DbeInfo( COMPONENT_DATA, ADSDBE_TABLENAME_IS_ALIAS, .f. )

BEGIN SEQUENCE

IF !Empty(::serverDict) .OR. !Empty(::database)

  cPwd := AllTrim(::PWD)
  IF Left(cPwd,3) == '{||'
    cPwd := Eval(&(cPwd))
  ENDIF
  nError := AdsConnect60( ::database, ;
                ::AdsServerType, ;
                Trim(::UID), ;
                Trim(cPwd), ;
                ADS_DEFAULT, ;
                @::handleDict )

  cSQLConnect := 'DBE=ADSDBE; '
  IF !Empty(::ServerDict)
    cSQLConnect += 'SERVER=' + Trim(::ServerDict) + '; '
  ELSE
    cSQLConnect += 'SERVER=' + Trim(::database) + '; '
    ::ServerDict := ::database
  ENDIF
  cSQLConnect += 'UID=' + Trim(::UID) + '; '
  cSQLConnect += 'PWD=' + Trim(cPwd) + '; '
  cSQLConnect += Trim(::connectString) + '; '

  ::SessionDict := DC_DacSession():new( cSQLConnect )
  ::SessionDict:sqlExecuteBlock := {|c|oSqlQuery:executeSql(c,,self)}

  cName := ::name

  ::IsConnected := .t.
  IF !::SessionDict:isConnected()
    DC_WinAlert('ADSDBE Connection Failed to ' + Alltrim(cName) + Chr(13) + ;
                'Error code: ' + Alltrim(Str(::SessionDict:getLastError())) + Chr(13) + ;
                ::sessionDict:getLastMessage())
    nError := 1

    ::IsConnected := .f.

    DCMSGBOX 'Many ADS connection problems are due to mis-matched client DLLs.', ;
             'If you have the ADS Architect installed and it has no problems', ;
             'connecting to your server, copy the following ACE client DLLs', ;
             'from the Architect installation folder to the folder that', ;
             'contains ADSDBE.DLL.  This DLL may be in your Sqlquery20 folder', ;
             'or it could be in your SET PATH.', ;
             '', ;
             'ACE32.DLL', ;
             'AXCWS32.DLL', ;
             'ADSLOC32.DLL' FONT '10.Lucida Console'

    BREAK
  ENDIF

  IF nError > 0
    BREAK
  ENDIF

  lDictConnection := .t.

ENDIF

IF !Empty(::serverFree)

  cSQLConnect := 'DBE=ADSDBE; '
  cSQLConnect += 'SERVER=' + Trim(::ServerFree)

  ::SessionFree := DC_DacSession():new( cSQLConnect )

  cName := ::name

  IF !::SessionFree:isConnected()
    DC_WinAlert('ADSDBE Connection Failed to ' + Alltrim(cName) + Chr(13) + ;
                'Error code: ' + Alltrim(Str(::SessionFree:getLastError())) + Chr(13) + ;
                ::sessionFree:getLastMessage())

    nError := 1
    ::IsConnected := .f.
    BREAK
  ELSE
    ::IsConnected := .t.
  ENDIF

ENDIF

END SEQUENCE

IF nError == 6316
  DCMSGBOX 'Ads Error 6316', ;
           'The Ads client driver (ACE32.DLL,AXCWS32.DLL) and Advantage Server', ;
           'communication layer versions are mismatched.' ;
           FONT '10.Lucida Console' OWNER AppDeskTop()
ELSEIF nError > 0
  DCMSGBOX 'Ads Error: ' +  Alltrim(Str(nError)), ;
           DC_AdsGetLastError() ;
           FONT '10.Lucida Console' OWNER AppDeskTop()
ENDIF

RETURN ::IsConnected

* ----------

METHOD SqlQueryConnection:ConnectODBC(oSqlQuery)

LOCAL cSQLConnect, cName, aDbeList := DbeList(), cLogFile, cPwd

IF !('ODBCDBE'$aDbeList) .AND. !DbeLoad( "ODBCDBE",.f.)
  DC_WinAlert('Database-Engine ODBCDBE not loaded')
  RETURN .f.
ENDIF

dbeSetDefault('ODBCDBE')

cSQLConnect := 'DBE=ODBCDBE; '
IF !Empty(::Driver)
  cSQLConnect += 'DRIVER=' + Alltrim(::Driver) + '; '
ENDIF
IF !Empty(::Server)
  cSQLConnect += 'SERVER=' + Alltrim(::Server) + '; '
ELSEIF !Empty(::ServerDict)
  cSQLConnect += 'SERVER=' + Alltrim(::ServerDict) + '; '
ENDIF
IF 'ADVANTAGE STREAMLINESQL ODBC' $ Upper(::Driver)
  cSQLConnect += 'DataDirectory=' + Alltrim(::Database) + '; '
ELSEIF !Empty(::Database)
  cSQLConnect += 'DATABASE=' + Alltrim(::Database) + '; '
//  cSQLConnect += 'DBQ=' + Alltrim(::Database) + '; '
ENDIF
IF !Empty(::UID)
  cSQLConnect += 'UID=' + Alltrim(::UID) + '; '
ENDIF
IF !Empty(::PWD)
  cPwd := AllTrim(::PWD)
  IF Left(cPwd,3) == '{||'
    cPwd := Eval(&(cPwd))
  ENDIF
  cSQLConnect += 'PWD=' + Alltrim(cPwd) + '; '
ENDIF
IF !Empty(::Network)
  cSQLConnect += 'NETWORK=' + ::Network + '; '
ENDIF
IF !Empty(::ConnectTimeout)
  cSQLConnect += 'CONNECTTIMEOUT=' + Alltrim(Str(::ConnectTimeOut)) + '; '
ENDIF
cSQLConnect += ::connectString

::SessionDict := DC_DacSession():new( cSQLConnect )
::SessionDict:sqlExecuteBlock := {|c|oSqlQuery:executeSql(c,,self)}

cName := ::name

::IsConnected := .t.
IF !::SessionDict:isConnected()
  cLogFile := DC_Path(AppName(.t.)) + ::GroupName + '_Debug.Log'
  OdbcWriteDebug(::sessionDict,cLogFile)
  DCMSGBOX 'ODBCDBE Connection Failed to ' + cName, ;
           'Error code: ' + Alltrim(Str(::SessionDict:getLastError())), ;
           ::sessionDict:getLastMessage(), '', ;
           'View ' + cLogFile + ' for more information.' ;
           FONT '10.Lucida Console' OWNER AppDeskTop()
   ::IsConnected := .f.
   Runshell(cLogFile,'Notepad.exe')
   RETURN .f.
ELSE
  ::SessionDict:setProperty(ODBCSSN_INDEX_AUTOOPEN,.t.)
ENDIF

RETURN .t.

* -----------

#if XPPVER > 2000000
METHOD SqlQueryConnection:ConnectPg(oSqlQuery)

LOCAL cSession, cName, cSqlConnect, nError, cPwd, ;
      nDictConnection, aDbeList := DbeList()

IF !('PGDBE'$aDbeList) .AND. !DbeLoad( "PGDBE",.f.)
  DC_WinAlert('Database-Engine PGDBE not loaded')
  RETURN .f.
ENDIF

dbeSetDefault('PGDBE')

cSQLConnect := 'DBE=PGDBE; '
IF !Empty(::server)
  cSQLConnect += 'SERVER=' + Alltrim(::Server) + '; '
ELSE
  cSQLConnect += 'SERVER=' + Alltrim(::ServerDict) + '; '
ENDIF
cSQLConnect += 'DB=' + Alltrim(::Database) + '; '
cSQLConnect += 'UID=' + Alltrim(::UID) + '; '
cPwd := Alltrim(::PWD)
IF Left(cPwd,3) == '{||'
  cPwd := Eval(&(cPwd))
ENDIF
cSQLConnect += 'PWD=' + Alltrim(cPwd) + '; '
cSQLConnect += ::connectString

::SessionDict := DC_DacSession():new( cSQLConnect )
::SessionDict:sqlExecuteBlock := {|c|oSqlQuery:executeSql(c,,self)}

cName := ::name

::IsConnected := .t.
IF !::SessionDict:isConnected()
  DC_WinAlert('PGDBE Connection Failed to ' + Alltrim(cName) + Chr(13) + ;
              'Error code: ' + Alltrim(Str(::SessionDict:getLastError())) + Chr(13) + ;
              ::sessionDict:getLastMessage())
   ::IsConnected := .f.
   RETURN .f.
ENDIF

RETURN .t.
#endif

* --------------

METHOD SqlQueryConnection:SessionPropertiesODBC()

LOCAL GetList[0], GetOptions, aProperties, bColumn, oBrowse, o := ::sessionDict, ;
      oMenu, oTab1, oTab2, cInfo

aProperties := { ;
 {'ODBCSSN_CONCURRENCY','a', 'N', 'ODBC concurrency setting as numeric ID.', ;
    DC_XtoC(o:setProperty(ODBCSSN_CONCURRENCY)),ODBCSSN_CONCURRENCY},;
 {'ODBCSSN_CURRENT_DATABASE','ro','C','String holding database name.', ;
    DC_XtoC(o:setProperty(ODBCSSN_CURRENT_DATABASE)),ODBCSSN_CURRENT_DATABASE},;
 {'ODBCSSN_CURSORTYPE','a','N','ODBC cursor type as numeric ID.', ;
    DC_XtoC(o:setProperty(ODBCSSN_CURSORTYPE)),ODBCSSN_CURSORTYPE},;
 {'ODBCSSN_DATATYPES','ro','C','String of supported data types.', ;
    DC_XtoC(o:setProperty(ODBCSSN_DATATYPES)),ODBCSSN_DATATYPES},;
 {'ODBCSSN_DBMS_NAME','ro','C','Product name of the database', ;
    DC_XtoC(o:setProperty(ODBCSSN_DBMS_NAME)),ODBCSSN_DBMS_NAME},;
 {'ODBCSSN_DBMS_VERSION','ro','C','Version number of the database as ##.##.####', ;
    DC_XtoC(o:setProperty(ODBCSSN_DBMS_VERSION)),ODBCSSN_DBMS_VERSION},;
 {'ODBCSSN_DRIVERODBC_VERSION','ro','C','ODBC version of driver', ;
    DC_XtoC(o:setProperty(ODBCSSN_DRIVERODBC_VERSION)),ODBCSSN_DRIVERODBC_VERSION},;
 {'ODBCSSN_DROP_BEFORE_CREATE','a','L','Issue DROP before CREATE automatically on DbCreate().', ;
    DC_XtoC(o:setProperty(ODBCSSN_DROP_BEFORE_CREATE)),ODBCSSN_DROP_BEFORE_CREATE},;
 {'ODBCSSN_INDEX_AUTOOPEN','a','L','If .T., auto open an index for CREATE (XPP->ODBC type mapping).', ;
    DC_XtoC(o:setProperty(ODBCSSN_INDEX_AUTOOPEN)),ODBCSSN_INDEX_AUTOOPEN},;
 {'ODBCSSN_LONGDATA_THRESHOLD','a','N','Data length to optimize long data access', ;
    DC_XtoC(o:setProperty(ODBCSSN_LONGDATA_THRESHOLD)),ODBCSSN_LONGDATA_THRESHOLD},;
 {'ODBCSSN_MORE_RESULTS','a','N','number of result set, if more expected', ;
    DC_XtoC(o:setProperty(ODBCSSN_MORE_RESULTS)),ODBCSSN_MORE_RESULTS},;
 {'ODBCSSN_NATIVE_ERROR_INFO','a','L','Enable NATIVE Error in :getLastMessage().', ;
    DC_XtoC(o:setProperty(ODBCSSN_NATIVE_ERROR_INFO)),ODBCSSN_NATIVE_ERROR_INFO},;
 {'ODBCSSN_ODBC_TO_XPP','ro','A','Array holding data type mapping information for USE (ODBC->XPP type mapping).', ;
    DC_Array2String(o:setProperty(ODBCSSN_ODBC_TO_XPP)),ODBCSSN_ODBC_TO_XPP},;
 {'ODBCSSN_SCROLLABLE','a','N','Scroll attribute of ODBC cursor as numeric ID.', ;
    DC_XtoC(o:setProperty(ODBCSSN_SCROLLABLE)),ODBCSSN_SCROLLABLE},;
 {'ODBCSSN_SENSITIVITY','a','N','ODBC cursor sensitivity as numeric ID.', ;
    DC_XtoC(o:setProperty(ODBCSSN_SENSITIVITY)),ODBCSSN_SENSITIVITY},;
 {'ODBCSSN_SERVER_NAME','ro','C','Name of the data server or service', ;
    DC_XtoC(o:setProperty(ODBCSSN_SERVER_NAME)),ODBCSSN_SERVER_NAME},;
 {'ODBCSSN_SQLSTATE_INFO','a','L','Include SQLSTATE in :getLastMessage().', ;
    DC_XtoC(o:setProperty(ODBCSSN_SQLSTATE_INFO)),ODBCSSN_SQLSTATE_INFO},;
 {'ODBCSSN_TIMESTAMP_AS_DATE','a','L','map SQL timestamps to Xbase++-Date', ;
    DC_XtoC(o:setProperty(ODBCSSN_TIMESTAMP_AS_DATE)),ODBCSSN_TIMESTAMP_AS_DATE},;
 {'ODBCSSN_USE_CURSOR_LIB','ro','L','Use ODBC cursor library (see DbeInfo()).', ;
    DC_XtoC(o:setProperty(ODBCSSN_USE_CURSOR_LIB)),ODBCSSN_USE_CURSOR_LIB},;
 {'ODBCSSN_XPP_TO_ODBC','ro','A','Array holding data type mapping information', ;
    DC_Array2String(o:setProperty(ODBCSSN_XPP_TO_ODBC)),ODBCSSN_XPP_TO_ODBC} }

@ 0,0 DCTABPAGE oTab1 CAPTION 'Properties' SIZE 140,30
@ 0,0 DCTABPAGE oTab2 RELATIVE oTab1 CAPTION 'Information'

@ 2,2 DCSAY '*) ro = Read Only, a = Assignable' SAYSIZE 0 FONT '10.Lucida Console' PARENT oTab1 ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y

bColumn := {|o|o:dataArea:rbdown := {|x,y,z|oMenu:popup( z, x, 2 , ;
                 XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN ) }}

@ 3,2 DCBROWSE oBrowse DATA aProperties SIZE 100,25 FIT PARENT oTab1 NOHSCROLL ;
      HEADLINES 2 ITEMSELECTED {||_EditValue(aProperties[oBrowse:arrayElement],o,@oBrowse)}

DCBROWSECOL ELEMENT 1 HEADER 'Constant from ODBCDBE.CH' WIDTH 20 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER '*)' WIDTH 2 PARENT oBrowse HFONT '8.Lucida Console'
DCBROWSECOL ELEMENT 3 HEADER 'Data;Type' WIDTH 3 PARENT oBrowse
DCBROWSECOL ELEMENT 4 HEADER 'Description' WIDTH 35 PARENT oBrowse
DCBROWSECOL ELEMENT 5 HEADER 'Value' WIDTH 20 PARENT oBrowse EVAL bColumn

DCSUBMENU oMenu

  DCMENUITEM 'Edit or View this Value' PARENT oMenu ;
     ACTION {||_EditValue(aProperties[oBrowse:arrayElement],o,@oBrowse)} ;
     WHEN {|a| a := aProperties[oBrowse:arrayElement], ;
               a[2] = 'a' .OR. a[3] = 'A'}

TEXT INTO cInfo WRAP
Configuration using DacSession:setProperty()

After a session object was established, these properties can be either read only or also modified using the :setProperty() method. The assignable properties will influence subsequent operations on that session, like DbCreate() or DbUseArea(). The readonly attributes are either properties determined by the driver or are properties configured by a preceding call to DbeInfo().

ODBCSSN_CONCURRENCY and ODBCDBO_CONCURRENCY
Set the concurrency type for the next workarea to open. The value might have been changed after opening a new workarea, see DbInfo().

ODBCSSN_CURRENT_DATABASE
The name of the database the session is connected to. In case of a file-based ODBC driver, this usually is a directory or the full qualified filename of the data file.

ODBCSSN_CURSORTYPE (and ODBCDBO_CURSORTYPE)
Set the cursor type for the next workarea to open. The cursor type can have a different value after opening a new workarea, see DbInfo().

ODBCSSN_DATATYPES
A string containing all Xbase++ data type characters which are supported by this session.

ODBCSSN_DBMS_NAME
Returns the name or the product name of the database management system which is currently connected to that session.

ODBCSSN_DBMS_VERSION
Returns the version of the database management system which is currently connected to that session as a formatted string using the picture ##.##.####.

ODBCSSN_DRIVERODBC_VERSION
Returns the ODBC version fo the driver. This version depicts the version of ODBC the driver was programmed for. It is used inside of ODBCDBE to work with drivers of different ODBC versions. The value can be modified in case a driver does not work correctly on the version level reported. The value is of the data type string and is formatted as ##.##.

ODBCSSN_DROP_BEFORE_CREATE
The DbCreate() function usually destroys the table (and it's content!) without warning before creating a new table. If this is not desired, set ODBCSSN_DROP_BEFORE_CREATE to .F.

ODBCSSN_INDEX_AUTOOPEN
Auto-opening an index in the context of SQL is handled as follows: If an SELECT - statement having an ORDER BY clause was passed to dbUseArea(), the expression of the ORDER BY clause is used as the index expression. Otherwise, the catalog is queried for the first known index expression. This index will be open after dbUseArea().

ODBCSSN_LONGDATA_THRESHOLD
Long data are data that can be of variable length, and therefore need special attention on read and on write. The ODBCDBE will handle long data of the length up to ODBCSSN_LONGDATA_THRESHOLD byte like fixed data. Changing this value might be necessary to either optimize data access or to turn off the special handling because the ODBC driver is not capable of handling variable length data in every case.

ODBCSSN_MORE_RESULTS
If more than one result set is expected for an SQL command, it is possible to determine which result set to retrieve in the workarea by setting this property. The numbering of result sets starts with 1.

ODBCSSN_NATIVE_ERROR_INFO
The native SQL error will be included in the form like

ODBCSSN_ODBC_TO_XPP
This is the data type mapping used on USE.

ODBCSSN_SCROLLABLE and ODBCDBO_SCROLLABLE
Set the scrollability of the cursor for the next workarea to open. The value might have been changed after opening a new workarea, see DbInfo().

ODBCSSN_SENSITIVITY and ODBCDBO_SENSITIVITY
Set the sensitivity of the cursor for the next workarea to open. The value might have been changed after opening a new workarea, see DbInfo().

ODBCSSN_SERVER_NAME
Returns the name of the server the DBMS is running on. Some drivers return the network name of the server (ie. MS-SQL Server), some the name of the database service (ie. Oracle).

ODBCSSN_SQLSTATE_INFO
The SQL state will be included in the form like

ODBCSSN_TIMESTAMP_AS_DATE
Map all SQL-timestamp types (ie.DATETIME, TIMESTAMP etc.) to Xbase++ - Date (XPP_DATE or Valtype(x)=="D"). If the individual remapping of data types using DbInfo() goal is to map timestamps as date, it is simpler to set this session property. Note: If a timestamp is mapped to a date, only the date-part is accessible, the time-part cannot be read or written.

ODBCSSN_USE_CURSOR_LIB
Check if the cursor library could be used if it was configured by DbeInfo(COMPONENT_DICTIONARY, ODBCDBE_USE_CURSOR_LIB) before creating this session.

ODBCSSN_XPP_TO_ODBC
This is the data type mapping used on DbCreate().
ENDTEXT

@ 2,2 DCMULTILINE cInfo SIZE 135,27 FONT '10.Lucida Console' NOHSCROLL PARENT oTab2

DCGETOPTIONS RESIZE RESIZEDEFAULT DCGUI_RESIZE_RESIZEONLY //SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT TITLE 'Session Properties: ' + ::name OPTIONS GetOptions ;
   NOAUTORESTORE MODAL SETAPPWINDOW

RETURN nil

* --------------

STATIC FUNCTION _EditValue(aValue,oSession,oBrowse1)

LOCAL oBrowse, GetList[0], xData, i, GetOptions, bEval, lSelected, nRow, ;
      lStatus, nPointer := 1, aValue2

xData := oSession:setProperty(aValue[6])

IF aValue[6] $ {ODBCSSN_XPP_TO_ODBC,ODBCSSN_ODBC_TO_XPP}
  @ 0,0 DCBROWSE oBrowse DATA xData SIZE 30,22 FIT NOHSCROLL
  FOR i := 1 TO Len(xData[1])
    DCBROWSECOL ELEMENT i WIDTH 10 PARENT oBrowse
  NEXT
ELSEIF aValue[6] = ODBCSSN_CONCURRENCY
  xData := {;
   {'ODBC_CONCUR_LOCK',ODBC_CONCUR_LOCK,'Pessimistic Locking'}, ;
   {'ODBC_CONCUR_READONLY',ODBC_CONCUR_READONLY,'No write no Locking'}, ;
   {'ODBC_CONCUR_ROWVER (default)',ODBC_CONCUR_ROWVER,'Optimistic locking, cheapest method'}, ;
   {'ODBC_CONCUR_VALUES',ODBC_CONCUR_VALUES,'Optimistic locking, if rowver not available'}, ;
   {'ODBC_VALUE_UNCHANGED',ODBC_VALUE_UNCHANGED,'The attribute is not changed. API is skipped'} }
ELSEIF aValue[6] = ODBCSSN_CURSORTYPE
  xData := {;
   {'ODBC_CURSOR_AUTOMATCH (default)',ODBC_CURSOR_AUTOMATCH,'Match cursor type depending on ODBC driver'}, ;
   {'ODBC_CURSOR_DYNAMIC',ODBC_CURSOR_DYNAMIC,'Result set reflects all changes'}, ;
   {'ODBC_CURSOR_FORWARD_ONLY',ODBC_CURSOR_FORWARD_ONLY,'Cursor skips forward only'}, ;
   {'ODBC_CURSOR_KEYSET',ODBC_CURSOR_KEYSET,'Cursor rows are determined by keyset'}, ;
   {'ODBC_CURSOR_STATIC',ODBC_CURSOR_STATIC,'Result set is a snapshot copy'}, ;
   {'ODBC_VALUE_UNCHANGED',ODBC_VALUE_UNCHANGED,'The attribute is not changed. API is skipped'} }
ELSEIF aValue[6] = ODBCSSN_SCROLLABLE
  xData := {;
   {'ODBC_NONSCROLLABLE)',ODBC_NONSCROLLABLE,'Cursor can scroll forward only'}, ;
   {'ODBC_SCROLLABLE (default)',ODBC_SCROLLABLE,'Cursor can scroll in all directions'}, ;
   {'ODBC_VALUE_UNCHANGED',ODBC_VALUE_UNCHANGED,'The attribute is not changed. API is skipped'} }
ELSEIF aValue[6] = ODBCSSN_SENSITIVITY
  xData := {;
   {'ODBC_INSENSITIVE',ODBC_INSENSITIVE,'Do not detect changes of other cursors'}, ;
   {'ODBC_SENSITIVE',ODBC_SENSITIVE,'Detect changes of other cursors'}, ;
   {'ODBC_UNSPECIFIED (default)',ODBC_UNSPECIFIED,'Do not care if changes can occur'}, ;
   {'ODBC_VALUE_UNCHANGED',ODBC_VALUE_UNCHANGED,'The attribute is not changed. API is skipped'} }
ELSEIF aValue[3] == 'L'
  @ 0,0 DCCHECKBOX xData PROMPT aValue[1]
ELSEIF aValue[3] == 'N'
  IF aValue[6] = ODBCSSN_MORE_RESULTS
    xData := Val(DC_Xtoc(xData))
  ENDIF
  @ 0,0 DCSAY aValue[1] GET xData SAYSIZE 0 SAYBOTTOM
ENDIF

IF aValue[6] $ {ODBCSSN_CONCURRENCY,ODBCSSN_CURSORTYPE,ODBCSSN_SCROLLABLE,ODBCSSN_SENSITIVITY}
   FOR i := 1 TO Len(xData)
     lSelected := (Val(aValue[5])==xData[i,2])
     IF lSelected
       nRow := i
     ENDIF
     AAdd(xData[i],IIF(lSelected,'* Yes *',''))
   NEXT
   @ 0,0 DCBROWSE oBrowse DATA xData SIZE 30,8 FIT NOHSCROLL CURSORMODE XBPBRW_CURSOR_ROW ;
         POINTER nPointer ;
         ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}
   DCBROWSECOL ELEMENT 1 HEADER 'Constant' WIDTH 20 PARENT oBrowse
   DCBROWSECOL ELEMENT 3 HEADER 'Description' WIDTH 25 PARENT oBrowse
   DCBROWSECOL ELEMENT 4 HEADER 'Selected' WIDTH 5 PARENT oBrowse
   bEval := {||_GoToBrowseRow(@oBrowse,nRow)}
ENDIF

DCGETOPTIONS NORESIZE
DCREAD GUI FIT ADDBUTTONS TITLE aValue[1] MODAL NOAUTORESTORE OPTIONS GetOptions ;
   EVAL bEval TO lStatus

IF lStatus .AND. aValue[2] = 'a' .AND. aValue[3] $ 'NL'
  IF Valtype(xData) == 'A'
    xData := xData[nPointer,2]
  ENDIF
  oSession:setProperty(aValue[6],xData)
  aValue[5] := DC_XtoC(xData)
  oBrowse1:refreshCurrent()
ENDIF

RETURN lStatus

* --------------

STATIC FUNCTION _GoToBrowseRow(oBrowse,nRow)

LOCAL i

FOR i := 1 TO nRow-1
  oBrowse:down()
  oBrowse:forceStable()
NEXT

RETURN nil

* --------------

METHOD SqlQuery:ListODBCSources()

LOCAL aSources, oBrowse, GetList[0], aDbeList := DbeList(), GetOptions

IF !('ODBCDBE'$aDbeList) .AND. !DbeLoad( "ODBCDBE",.f.)
  DC_WinAlert('Database-Engine ODBCDBE not loaded')
  RETURN .f.
ENDIF

dbeSetDefault('ODBCDBE')

aSources := DbeInfo( COMPONENT_DATA, ODBCDBE_DATASOURCES )

@ 0,0 DCBROWSE oBrowse DATA aSources SIZE 70,10 FIT ;
      FONT '9.Arial' NOHSCROLL

DCBROWSECOL ELEMENT 1 HEADER 'Data Source Name' WIDTH 30 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER 'Driver' WIDTH 40 PARENT oBrowse

DCGETOPTIONS SCALEFACTOR ::aScaleFactor

DCREAD GUI FIT BUTTONS DCGUI_BUTTON_OK MODAL ;
   TITLE 'ODBC Data Sources' NOAUTORESTORE OPTIONS GetOptions

RETURN nil

* ==============

CLASS DD_XbpBrowseFiltered FROM DC_XbpBrowseFiltered

EXPORTED:

VAR isCollapsed
VAR dataStructure
VAR pickedFields
VAR linkedArray
VAR linkedAlias
VAR IndexTags
VAR RecordClipBoard
// VAR ColumnConfiguration
VAR CustomColor


INLINE METHOD Init(a,b,c,d,e,f,g)

::isCollapsed := .f.
::linkedArray := {}
::customColor := {{GRA_CLR_WHITE,GRA_CLR_DARKGRAY}, ;
                  {GRA_CLR_BLACK,GRA_CLR_PALEGRAY}}

::filterRefreshBlock := {|o,x|x := saStatement[ThreadId()], ;
                            IIF(Valtype(x)=='O',x:refresh(),nil), ;
                            x := saRowCount[ThreadId()], ;
                            IIF(Valtype(x)=='O',x:refresh(),nil), ;
                            saAdsStatement[ThreadID()] := o:adsStatement, ;
                            saSqlExecuteTime[ThreadID()] := o:sqlExecuteTime, ;
                            saSqlExecuteTimeObject[ThreadID()]:refresh(), ;
                            PostAppEvent(SCOPE_REFRESH,,,self)}

RETURN ::DC_XbpBrowseFiltered:init(a,b,c,d,e,f,g)

* -----------

INLINE METHOD CollapseAll(oOwner)

LOCAL i, oColumn, nTagged := 0, nChoice := 1

FOR i := 1 TO ::colCount
  oColumn := ::getColumn(i)
  IF oColumn:isTagged
    nTagged++
  ENDIF
NEXT

IF nTagged = 0
  DCMSGBOX 'Columns that are "tagged" can be collapsed.', ;
           'To tag/untag a column, use the Left Mouse-SPACE key' ;
           FONT '10.Lucida Console' OWNER oOwner
  RETURN .f.
ELSE
  DCMSGBOX 'You have tagged ' + Alltrim(Str(nTagged)) + ' columns.', ;
           'Please make a choice on what you want to do' ;
           BUTTONS {'Collapse All Tagged Columns','Collapse All Un-Tagged Columns','Cancel'} ;
           CHOICE @nChoice OWNER oOwner FONT '10.Lucida Console'
ENDIF

IF nChoice $ {1,2}
  FOR i := 1 TO ::colCount
    oColumn := ::getColumn(i)
    IF (nChoice == 1 .AND. oColumn:isTagged) .OR. (nChoice == 2 .AND. !oColumn:isTagged)
      oColumn:collapse(.f.)
    ENDIF
  NEXT
  ::setSize(::currentSize())
  ::isCollapsed := .t.
ENDIF

RETURN self

* -----------

INLINE METHOD RestoreAll()

LOCAL i, oColumn

FOR i := 1 TO ::colCount
  oColumn := ::getColumn(i)
  IF oColumn:isCollapsed
    oColumn:restore(.f.)
  ENDIF
NEXT
::setSize(::currentSize())
::isCollapsed := .f.

RETURN self

ENDCLASS

* ==============

CLASS DD_XbpColumnFiltered FROM DC_XbpColumnFiltered

EXPORTED:

VAR nColumnWidth
VAR isCollapsed

INLINE METHOD Init(a,b,c,d,e,f,g)

LOCAL oColumn

::isCollapsed := .f.

oColumn :=::DC_XbpColumnFiltered:init(a,b,c,d,e,f,g)

::isColumnConfigEnabled := .t.

RETURN oColumn

* -----------

INLINE METHOD Collapse( lResizeBrowse )

DEFAULT lResizeBrowse := .t.

IF !::isCollapsed
  ::nColumnWidth := ::currentSize()[1]
  ::setSize({0,::currentSize()[2]})
  ::hide()
  ::isCollapsed := .t.
  IF lResizeBrowse
    ::parent:setSize(::parent:currentSize())
  ENDIF
ENDIF
RETURN self

* ------------

INLINE METHOD Restore( lResizeBrowse )

DEFAULT lResizeBrowse := .t.

IF ::isCollapsed
  ::setSize({::nColumnWidth,::currentSize()[2]})
  ::show()
  ::isCollapsed := .f.
  IF lResizeBrowse
    ::parent:setSize(::parent:currentSize())
  ENDIF
ENDIF
RETURN self

ENDCLASS

* -------------

STATIC FUNCTION ShowSqlWindow( cStatement )

LOCAL GetList[0]

@ 0,0 DCSAY 'This is the original SQL SELECT statement that created this Data Set;;' + ;
            'Additional filtering will reduce the number of displayed rows.' ;
            SAYSIZE 0,2 SAYWORDBREAK FONT '12.Arial'

@ 2,0 DCMULTILINE cStatement SIZE 100,20 ;
      NOHSCROLL ;
      FONT '10.Lucida Console'

DCREAD GUI FIT TITLE 'Viewing SQL Statement' MODAL NOAUTORESTORE


RETURN nil

* -----------

FUNCTION DtrTest()

LOCAL cSql

TEXT INTO cSql WRAP
select hack,
 Cast(sum(iif(month(enddate)=1,total,0)) as SQL_NUMERIC (8,2)) as Jan_Amt,
 sum(iif(month(enddate)=1,1,0)) as Jan_Trans,
 Cast(sum(iif(month(enddate)=2,total,0)) as SQL_NUMERIC (8,2)) as Feb_Amt,
 sum(iif(month(enddate)=2,1,0)) as Feb_Trans,
 Cast(sum(iif(month(enddate)=3,total,0)) as SQL_NUMERIC (8,2)) as Mar_Amt,
 sum(iif(month(enddate)=3,1,0)) as Mar_Trans,
 Cast(sum(iif(month(enddate)=4,total,0)) as SQL_NUMERIC (8,2)) as Apr_Amt,
 sum(iif(month(enddate)=4,1,0)) as Apr_Trans,
 Cast(sum(iif(month(enddate)=5,total,0)) as SQL_NUMERIC (8,2)) as May_Amt,
 sum(iif(month(enddate)=5,1,0)) as May_Trans,
 Cast(sum(iif(month(enddate)=6,total,0)) as SQL_NUMERIC (8,2)) as Jun_Amt,
 sum(iif(month(enddate)=6,1,0)) as Jun_Trans,
 Cast(sum(iif(month(enddate)=7,total,0)) as SQL_NUMERIC (8,2)) as Jul_Amt,
 sum(iif(month(enddate)=7,1,0)) as Jul_Trans,
 Cast(sum(iif(month(enddate)=8,total,0)) as SQL_NUMERIC (8,2)) as Aug_Amt,
 sum(iif(month(enddate)=8,1,0)) as Aug_Trans,
 Cast(sum(iif(month(enddate)=9,total,0)) as SQL_NUMERIC (8,2)) as Sep_Amt,
 sum(iif(month(enddate)=9,1,0)) as Sep_Trans,
 Cast(sum(iif(month(enddate)=10,total,0)) as SQL_NUMERIC (8,2)) as Oct_Amt,
 sum(iif(month(enddate)=10,1,0)) as Oct_Trans,
 Cast(sum(iif(month(enddate)=11,total,0)) as SQL_NUMERIC (8,2)) as Nov_Amt,
 sum(iif(month(enddate)=11,1,0)) as Nov_Trans,
 Cast(sum(iif(month(enddate)=12,total,0)) as SQL_NUMERIC (8,2)) as Dec_Amt,
 sum(iif(month(enddate)=12,1,0)) as Dec_Trans,
 Cast(sum(iif(transtype='$',total,0)) as SQL_NUMERIC (8,2)) as Cash_Amt,
 sum(iif(transtype='$',1,0)) as Cash_Trans,
 Cast(sum(iif(transtype='C',total,0)) as SQL_NUMERIC (8,2)) as Credit_Amt,
 sum(iif(transtype='C',1,0)) as Credit_Trans,
 Count(total) as Trans,
 Cast(sum(total) as SQL_NUMERIC (8,2)) as Total
 from mn_dtr where year(enddate) = 2018 group by hack order by Total
ENDTEXT

RETURN cSql

* -------------

FUNCTION PickBrowse( GetList, oParent, aOptions, GetOptions )

LOCAL nRow, nCol, nWidth, nHeight, oObject, aSizePixels, oList, oPick, ;
      i, aPres, nPointerList := 1, nPointerPick := 1, ;
      nCol1, nCol2, aList, aPick, lPixel, oMenu, nFound, cKey

nRow := aOptions[3]
nCol := aOptions[4]
nWidth := aOptions[5]
nHeight := aOptions[6]
lPixel := aOptions[15]
aPres := aOptions[22]
aPick := aOptions[1]
aList := aOptions[2]

DEFAULT lPixel := .f.

IF lPixel
  nRow := 3
  nCol1 := 3
  nCol2 := (nWidth/2)
  nWidth := (nWidth/2) - 6
  nHeight := nHeight - 6
ELSE
  nRow := 3/20
  nCol1 := 3/7
  nCol2 := (nWidth/2) + 8
  nWidth := (nWidth/2) - (6/7)
  nHeight := nHeight - (6/20)
ENDIF

@ nRow, nCol1 DCBROWSE oList SIZE nWidth, nHeight ;
   DATA aList ;
   FONT '10.Lucida Console' ;
   PRESENTATION aPres ;
   NOHSCROLL ;
   RESIZE DCGUI_RESIZE_RESIZEONLY_Y ;
   PARENT oParent ;
   EVAL {|o|o:keyboard := {|n,b,o|PickBrowseKeyboard(n,o)}} ;
   POINTER nPointerList ;
   ITEMMARKED {||DC_GetWhen(GetList)} ;
   COLOR {|x|x:=DC_GetColArray(3,oList),IIF(Empty(x),{nil,GRA_CLR_WHITE},{GRA_CLR_WHITE,GRA_CLR_BLUE})} ;
   ITEMSELECTED {||ListSelected(aList,aPick,oList,oPick,nPointerList,nPointerPick), ;
                   DC_GetWhen(GetList)}

DCBROWSECOL ELEMENT 1 WIDTH nWidth PARENT oList ;
   HEADER 'Available Items' ;
   DRAG {|o|o} ;
     DIALOG {|mp1,mp2,oXbp|DragDialog(mp1,mp2,oXbp)} ;
   DROP {|a,b,c|Drop(a,b,c,oList,oPick)} CURSOR POINTER_DATADROP_MOVE

@ nRow, nCol2 DCBROWSE oPick SIZE nWidth, nHeight ;
   DATA aPick ;
   PRESENTATION aPres ;
   FONT '10.Lucida Console' ;
   NOHSCROLL ;
   RESIZE DCGUI_RESIZE_RESIZEONLY_Y ;
   PARENT oParent ;
   EVAL {|o|o:keyboard := {|n,b,o|PickBrowseKeyboard(n,o)}} ;
   RBSELECT ;
   RBDOWN {|x,y,z|oMenu:popup( z:setParent():setParent(), x, 1, ;
                              XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN )} ;
   POINTER nPointerPick ;
   ITEMMARKED {||DC_GetWhen(GetList)} ;
   COLOR {|x|x:=DC_GetColArray(3,oPick),IIF(Empty(x),{nil,GRA_CLR_WHITE},{GRA_CLR_WHITE,GRA_CLR_BLUE})} ;
   ITEMSELECTED {||PickSelected(aList,aPick,oList,oPick,nPointerList,nPointerPick), ;
                   DC_GetWhen(GetList)}

DCBROWSECOL ELEMENT 1 WIDTH nWidth + 10 PARENT oPick ;
   HEADER 'Selected Items' ;
   DRAG {|o|o} ;
     DIALOG {|mp1,mp2,oXbp|DragDialog(mp1,mp2,oXbp)} ;
     DROP {|a,b,c|Drop(a,b,c,oPick,oList)} CURSOR POINTER_DATADROP_MOVE

nRow += .5

DCSUBMENU oMenu

  DCMENUITEM 'Customize this Column' ;
        ACTION {||CustomizeColumn(oPick,.f.)} PARENT oMenu

  DCMENUITEM 'Add a Custom Column' ;
        ACTION {||CustomizeColumn(oPick,.t.)} PARENT oMenu

@ nRow + nHeight, nCol1 DCPUSHBUTTON CAPTION 'Up' SIZE 7,1 ;
           ACTION {|a|a := aList[nPointerList], ;
                      ARemove(aList,nPointerList), ;
                      ASize(aList,Len(aList)+1), ;
                      AIns(aList,nPointerList-1,a), ;
                      oList:up(), ;
                      oList:forceStable(), ;
                      oList:refreshAll(),;
                      DC_GetWhen(GetList)} ;
           TOOLTIP 'Move this item up' ;
           WHEN {||nPointerList > 1} ;
           PARENT oParent ;
           FONT '10.Lucida Console'

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Dn' SIZE 7,1 ;
           ACTION {|a|a := aList[nPointerList], ;
                      ARemove(aList,nPointerList), ;
                      ASize(aList,Len(aList)+1), ;
                      AIns(aList,nPointerList+1,a), ;
                      oList:down(), ;
                      oList:forceStable(), ;
                      oList:refreshAll(), ;
                      DC_GetWhen(GetList)} ;
           TOOLTIP 'Move this item Down' ;
           WHEN {||nPointerList < Len(aList)} ;
           PARENT oParent ;
           FONT '10.Lucida Console'

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Sort' SIZE 7,1 ;
    ACTION {||ASort(aList,,,{|a,b|a[1]<b[1]}), ;
              oList:refreshAll()} ;
    PARENT oParent ;
    FONT '10.Lucida Console'

@ DCGUI_ROW, DCGUI_COL + 30 DCSAY 'Use mouse to drag fields' ;
   SAYSIZE 0 COLOR GRA_CLR_BLUE FONT '10.Arial Bold' PARENT oParent

@ nRow + nHeight, nCol2 DCPUSHBUTTON CAPTION 'Up' SIZE 7,1 ;
           ACTION {|a|a := aPick[nPointerPick], ;
                      ARemove(aPick,nPointerPick), ;
                      ASize(aPick,Len(aPick)+1), ;
                      AIns(aPick,nPointerPick-1,a), ;
                      oPick:up(), ;
                      oPick:forceStable(), ;
                      oPick:refreshAll(), ;
                      DC_GetWhen(GetList)} ;
           TOOLTIP 'Move this item up' ;
           WHEN {||nPointerPick > 1} ;
           PARENT oParent ;
           FONT '10.Lucida Console'

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Dn' SIZE 7,1 ;
           ACTION {|a|a := aPick[nPointerPick], ;
                      ARemove(aPick,nPointerPick), ;
                      ASize(aPick,Len(aPick)+1), ;
                      AIns(aPick,nPointerPick+1,a), ;
                      oPick:down(), ;
                      oPick:forceStable(), ;
                      oPick:refreshAll(), ;
                      DC_GetWhen(GetList)} ;
           TOOLTIP 'Move this item Down' ;
           WHEN {||nPointerPick < Len(aPick)} ;
           PARENT oParent ;
           FONT '10.Lucida Console'

nRow := 2
nCol2 -= 7.8

@ nRow + 0, nCol2 DCPUSHBUTTON CAPTION '>' SIZE 7,1 ;
    ACTION {||ListSelected(aList,aPick,oList,oPick,nPointerList,nPointerPick)} ;
    PARENT oParent ;
    FONT '10.Lucida Console' ;
    RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ nRow + 2, nCol2 DCPUSHBUTTON CAPTION '>>' SIZE 7,1 ;
    ACTION {||ListSelected(aList,aPick,oList,oPick,-1,nPointerPick)} ;
    PARENT oParent ;
    FONT '10.Lucida Console' ;
    RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ nRow + 4, nCol2 DCPUSHBUTTON CAPTION '<<' SIZE 7,1 ;
    ACTION {||PickSelected(aList,aPick,oList,oPick,nPointerList,-1)} ;
    PARENT oParent ;
    FONT '10.Lucida Console' ;
    RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ nRow + 6, nCol2 DCPUSHBUTTON CAPTION '<' SIZE 7,1 ;
    ACTION {||PickSelected(aList,aPick,oList,oPick,nPointerList,nPointerPick)} ;
    PARENT oParent ;
    FONT '10.Lucida Console' ;
    RESIZE DCGUI_RESIZE_REPOSONLY_Y


/*
@ nRow + nHeight, nCol1 DCPUSHBUTTON CAPTION '<<' SIZE 7,1 ;
    ACTION {||PickSelected(aList,aPick,oList,oPick,nPointerList,-1)} ;
    PARENT oParent ;
    FONT '10.Lucida Console'

@ DCGUI_ROW, DCGUI_COL DCPUSHBUTTON CAPTION '<' SIZE 7,1 ;
    ACTION {||PickSelected(aList,aPick,oList,oPick,nPointerList,nPointerPick)} ;
    PARENT oParent ;
    FONT '10.Lucida Console'

@ DCGUI_ROW, DCGUI_COL DCPUSHBUTTON CAPTION '>' SIZE 7,1 ;
    ACTION {||ListSelected(aList,aPick,oList,oPick,nPointerList,nPointerPick)} ;
    PARENT oParent ;
    FONT '10.Lucida Console'

@ DCGUI_ROW, DCGUI_COL DCPUSHBUTTON CAPTION '>>' SIZE 7,1 ;
    ACTION {||ListSelected(aList,aPick,oList,oPick,-1,nPointerPick)} ;
    PARENT oParent ;
    FONT '10.Lucida Console'
*/

RETURN oObject

* -------------

STATIC FUNCTION PickBrowseKeyboard( nKey, oBrowse )

LOCAL cKey, nFound, aData

cKey := Upper(Chr(nKey))
IF !(cKey $ 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')
  RETURN .f.
ENDIF

aData := oBrowse:dataSource

nFound := AScan(aData,{|a|Left(a[1],1)==cKey},oBrowse:arrayElement+1)
IF nFound > 0
  oBrowse:arrayElement := nFound
ELSE
  nFound := AScan(aData,{|a|Left(a[1],1)==cKey},1)
  IF nFound > 0
    oBrowse:arrayElement := nFound
  ELSE
    oBrowse:arrayElement := 1
  ENDIF
ENDIF

oBrowse:refreshAll()

RETURN .t.

* -------------

STATIC FUNCTION CustomizeColumn( oBrowse, lAdd )

LOCAL GetList[0], cField, cPrompt, lStatus

DEFAULT lAdd := .f.

IF lAdd
  cField := Space(100)
ELSE
  cField := Pad(oBrowse:dataSource[oBrowse:arrayElement,1],100)
ENDIF

TEXT INTO cPrompt WRAP
You can modify a column or create a new column using Expressions.

Example:

Right(SSN,4) AS Last4
ENDTEXT

@ 0,0 DCSAY cPrompt FONT '10.Lucida Console' COLOR GRA_CLR_BLUE, GRA_CLR_WHITE ;
      SAYSIZE 80,4 SAYWORDBREAK

@ 5,0 DCGET cField

DCREAD GUI FIT TITLE 'Customized Expression' MODAL ;
   ADDBUTTONS TO lStatus NOAUTORESTORE ENTEREXIT

IF lStatus
  IF lAdd
    AAdd(oBrowse:dataSource,{Alltrim(cField),0,.f.})
    oBrowse:refreshAll()
  ELSE
    oBrowse:dataSource[oBrowse:arrayElement,1] := Alltrim(cField)
    oBrowse:refreshCurrent()
  ENDIF
ENDIF

RETURN nil

* -------------

STATIC FUNCTION Drop( oDrop, oColumn, mp1, oBrowse1, oBrowse2 )

LOCAL nOffset, aData1, aData2, nElement1, nElement2, lSame := .f., aValue

IF oDrop:parent == oColumn:parent // dragging within same browse
  oBrowse2 := oBrowse1
  lSame := .t.
ENDIF

aData1 := oBrowse1:dataSource
aData2 := oBrowse2:dataSource

nOffset := oDrop:dataArea:CellFromPos(mp1) - oBrowse1:RowPos
nElement1 := oBrowse1:arrayElement+nOffset
nElement2 := oBrowse2:arrayElement

IF nElement1 > Len(aData1)
  AAdd(aData1,aData2[nElement2])
  IF lSame
    ARemove( aData2, nElement2 )
  ENDIF
ELSEIF lSame
  aValue := aData1[nElement2]
  ARemove( aData2, nElement2 )
  ASize( aData1,Len(aData1)+1 )
  AIns(aData1,nElement1,aValue)
ELSE
  ASize(aData1,Len(aData1)+1)
  AIns(aData1,nElement1,aData2[nElement2])
ENDIF

oBrowse1:refreshAll()
IF !lSame
  ARemove( aData2, nElement2 )
  oBrowse2:refreshAll()
ENDIF

RETURN nil

* -------------

STATIC FUNCTION lbUp( aArray, nPointer, oBrowse )

IF AppKeyState(xbeK_CTRL) == 1
  aArray[nPointer,2] := !aArray[nPointer,2]
  oBrowse:refreshCurrent()
ENDIF

RETURN nil

* -------------

STATIC FUNCTION ListSelected( aList, aPick, oList, oPick, nPointerList, nPointerPick )

LOCAL i, bError, nTagElement

IF nPointerPick == 0
  nPointerPick := 1
ENDIF

IF nPointerList == 0 .OR. Empty(aList)
  RETURN nil
ENDIF

nTagelement := 3 // Len(aList[1])
IF nPointerList > 0
  aList[nPointerList,nTagElement] := .T.
ENDIF
FOR i := 1 TO Len(aList)
  IF nPointerList == -1
    aList[i,nTagElement] := .T.
  ENDIF
  IF aList[i,nTagElement]
    aList[i,nTagElement] := .F.
    IF .t. // Empty(aPick)
      AAdd( aPick, aList[i])
    ELSE
      ASize(aPick,Len(aPick)+1)
      AIns(aPick,nPointerPick,aList[i])
    ENDIF
    ARemove(aList,i)
    i--
  ENDIF
NEXT
oList:refreshAll()
oPick:refreshAll()

RETURN nil

* -------------

STATIC FUNCTION PickSelected( aList, aPick, oList, oPick, nPointerList, nPointerPick )

LOCAL i, nTagElement

IF nPointerList == 0
  nPointerList := 1
ENDIF

IF nPointerPick == 0 .OR. Empty(aPick)
  RETURN nil
ENDIF

nTagElement := Len(aPick[1])

IF nPointerPick > 0
  aPick[nPointerPick,nTagElement] := .T.
ENDIF
FOR i := 1 TO Len(aPick)
  IF nPointerPick == -1
    aPick[i,nTagElement] := .T.
  ENDIF
  IF aPick[i,nTagElement]
    aPick[i,nTagElement] := .F.
    IF Empty(aList)
      AAdd( aList, aPick[i])
    ELSE
      ASize(aList,Len(aList)+1)
      AIns(aList,nPointerList,aPick[i])
    ENDIF
    ARemove(aPick,i)
    i--
  ENDIF
NEXT

oList:refreshAll()
oPick:refreshAll()

RETURN nil

* -----------

STATIC FUNCTION DragDialog( mp1, mp2, oXbp )

LOCAL GetList[0], GetOptions, oDialog, aPos, cText

IF oXbp:isDerivedFrom('XbpColumn')
  cText := Trim(Eval(oXbp:dataLink))
ELSEIF oXbp:isDerivedFrom('XbpStatic')
  cText := Trim(oXbp:caption)
ELSEIF oXbp:isDerivedFrom('XbpTreeView')
  cText := Trim(oXbp:getData():caption)
ENDIF

@ 2,0 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 10,1.2 ;
   CAPTION "..\..\bitmaps\user_female.Bmp"

@ DCGUI_ROW, DCGUI_COL DCSAY cText ;
   COLOR GRA_CLR_BLACK, GRA_CLR_YELLOW ;
   FONT '10.Courier' SAYSIZE 0,1.2 ;
   OPTION XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_VCENTER

DCGETOPTIONS NOTITLEBAR ORIGIN XBPDLG_ORIGIN_MOUSE ;
   FITPAD 0 COLOR { 240, 240, 255 } ;
   BORDER XBPDLG_NO_BORDER ;
   HIDE ;
   NOTASKLIST

DCREAD GUI FIT OPTIONS GetOptions PARENT @oDialog EXIT NOAUTORESTORE

aPos := DC_CalcAbsolutePosition(mp1,oXbp)
aPos[2] -= (oDialog:currentSize()[2] + 30)
oDialog:setPos( aPos )
oDialog:show()

RETURN oDialog

* ----------

FUNCTION LoadDbes()

LOCAL aDbeList := dbeList(), lStatus := .f.

IF !('ADSDBE'$aDbeList) .AND. !DbeLoad( "ADSDBE",.f.)
  DC_WinAlert('Database-Engine ADSDBE not loaded')
  lStatus := .f.
ENDIF

IF !('FOXDBE'$aDbeList) .AND. !DbeLoad( "FOXDBE",.T.)
  DC_WinAlert( "Database-Engine FOXDBE not loaded" )
  lStatus := .f.
ENDIF

IF !('DBFDBE'$aDbeList) .AND. !DbeLoad( "DBFDBE",.T.)
  DC_WinAlert( "Database-Engine DBFDBE not loaded" )
  lStatus := .f.
ENDIF

IF !('CDXDBE'$aDbeList) .AND. !DbeLoad( "CDXDBE",.T.)
  DC_WinAlert( "Database-Engine CDXDBE not loaded" )
  lStatus := .f.
ENDIF

IF !('FOXCDX'$aDbeList) .AND. !DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
  DC_WinAlert( "FOXCDX Database-Engine, Could not build engine" )
  lStatus := .f.
ELSE
  DbeSetDefault('FOXCDX')
  DbeInfo( COMPONENT_DATA, FOXDBE_CREATE_2X, .F. )
  DbeInfo( COMPONENT_DATA, FOXDBE_LOCKMODE , FOXDBE_LOCKMODE_VISUAL )
ENDIF

IF !('DBFCDX'$aDbeList) .AND. !DbeBuild( "DBFCDX", "DBFDBE", "CDXDBE" )
  DC_WinAlert( "DBFCDX Database-Engine, Could not build engine" )
  lStatus := .f.
ELSE
  DbeInfo( COMPONENT_ORDER, CDXDBE_MODE, CDXDBE_FOXPRO2X ) // works with ADS
ENDIF

RETURN lStatus

* -----------

METHOD SqlQuery:BrowseColors( cColor, cWhich )

LOCAL aColors := {}, oBrowse, GetList[0], nColor, nPointer := 1, ;
      cTitle, lStatus, aColor, GetOptions

IF !Empty(cWhich)
  cTitle := 'Choose a ' + cWhich + ' color'
ELSE
  cTitle := 'Use these colors in your SqlQuery.Ini'
ENDIF

AAdd( aColors, {  DC_ANTIQUEWHITE     ,"DC_ANTIQUEWHITE     " } )
AAdd( aColors, {  DC_AQUAMARINE       ,"DC_AQUAMARINE       " } )
AAdd( aColors, {  DC_ASPARAGUS        ,"DC_ASPARAGUS        " } )
AAdd( aColors, {  DC_AMETHYST         ,"DC_AMETHYST         " } )
AAdd( aColors, {  DC_AUBURN           ,"DC_AUBURN           " } )
AAdd( aColors, {  DC_AZURE            ,"DC_AZURE            " } )
AAdd( aColors, {  DC_BISQUE           ,"DC_BISQUE           " } )
AAdd( aColors, {  DC_BONE             ,"DC_BONE             " } )
AAdd( aColors, {  DC_BRASS            ,"DC_BRASS            " } )
AAdd( aColors, {  DC_BROWN            ,"DC_BROWN            " } )
AAdd( aColors, {  DC_BURLYWOOD        ,"DC_BURLYWOOD        " } )
AAdd( aColors, {  DC_CHOCOLATE        ,"DC_CHOCOLATE        " } )
AAdd( aColors, {  DC_CLOUD            ,"DC_CLOUD            " } )
AAdd( aColors, {  DC_COPPER           ,"DC_COPPER           " } )
AAdd( aColors, {  DC_CORNSILK         ,"DC_CORNSILK         " } )
AAdd( aColors, {  DC_DARKWHEAT        ,"DC_DARKWHEAT        " } )
AAdd( aColors, {  DC_ECRU             ,"DC_ECRU             " } )
AAdd( aColors, {  DC_EGGPLANT         ,"DC_EGGPLANT         " } )
AAdd( aColors, {  DC_EGGSHELL         ,"DC_EGGSHELL         " } )
AAdd( aColors, {  DC_FATIGUES         ,"DC_FATIGUES         " } )
AAdd( aColors, {  DC_FUSHIA           ,"DC_FUSHIA           " } )
AAdd( aColors, {  DC_GRAPE            ,"DC_GRAPE            " } )
AAdd( aColors, {  DC_LIGHTGOLDENROD   ,"DC_LIGHTGOLDENROD   " } )
AAdd( aColors, {  DC_GOLDENROD        ,"DC_GOLDENROD        " } )
AAdd( aColors, {  DC_DARKGOLDENROD    ,"DC_DARKGOLDENROD    " } )
AAdd( aColors, {  DC_INDIGO           ,"DC_INDIGO           " } )
AAdd( aColors, {  DC_IVORY            ,"DC_IVORY            " } )
AAdd( aColors, {  DC_LIGHTCORAL       ,"DC_LIGHTCORAL       " } )
AAdd( aColors, {  DC_LIGHTSALMON      ,"DC_LIGHTSALMON      " } )
AAdd( aColors, {  DC_KHAKI            ,"DC_KHAKI            " } )
AAdd( aColors, {  DC_KEYLIME          ,"DC_KEYLIME          " } )
AAdd( aColors, {  DC_LAVENDER         ,"DC_LAVENDER         " } )
AAdd( aColors, {  DC_LEMONCREME       ,"DC_LEMONCREME       " } )
AAdd( aColors, {  DC_LIME             ,"DC_LIME             " } )
AAdd( aColors, {  DC_LINEN            ,"DC_LINEN            " } )
AAdd( aColors, {  DC_RICHLIME         ,"DC_RICHLIME         " } )
AAdd( aColors, {  DC_MAGENTA          ,"DC_MAGENTA          " } )
AAdd( aColors, {  DC_MANGO            ,"DC_MANGO            " } )
AAdd( aColors, {  DC_MANGOCREME       ,"DC_MANGOCREME       " } )
AAdd( aColors, {  DC_MAROON           ,"DC_MAROON           " } )
AAdd( aColors, {  DC_MILKCHOCOLATE    ,"DC_MILKCHOCOLATE    " } )
AAdd( aColors, {  DC_MISTYROSE        ,"DC_MISTYROSE        " } )
AAdd( aColors, {  DC_MOSS             ,"DC_MOSS             " } )
AAdd( aColors, {  DC_NIGHT            ,"DC_NIGHT            " } )
AAdd( aColors, {  DC_OFFWHITE         ,"DC_OFFWHITE         " } )
AAdd( aColors, {  DC_ORCHID           ,"DC_ORCHID           " } )
AAdd( aColors, {  DC_PEACH            ,"DC_PEACH            " } )
AAdd( aColors, {  DC_PERU             ,"DC_PERU             " } )
AAdd( aColors, {  DC_PALEGOLDENROD    ,"DC_PALEGOLDENROD    " } )
AAdd( aColors, {  DC_PINEBARK         ,"DC_PINEBARK         " } )
AAdd( aColors, {  DC_PINKROSE         ,"DC_PINKROSE         " } )
AAdd( aColors, {  DC_PINKSAND         ,"DC_PINKSAND         " } )
AAdd( aColors, {  DC_SALMON           ,"DC_SALMON           " } )
AAdd( aColors, {  DC_SAND             ,"DC_SAND             " } )
AAdd( aColors, {  DC_SANDSTONE        ,"DC_SANDSTONE        " } )
AAdd( aColors, {  DC_SANDYBROWN       ,"DC_SANDYBROWN       " } )
AAdd( aColors, {  DC_SANDYCORAL       ,"DC_SANDYCORAL       " } )
AAdd( aColors, {  DC_SEAFOAM          ,"DC_SEAFOAM          " } )
AAdd( aColors, {  DC_SEASHELL         ,"DC_SEASHELL         " } )
AAdd( aColors, {  DC_SIENNA           ,"DC_SIENNA           " } )
AAdd( aColors, {  DC_SILVER           ,"DC_SILVER           " } )
AAdd( aColors, {  DC_SNOW             ,"DC_SNOW             " } )
AAdd( aColors, {  DC_SUNSET           ,"DC_SUNSET           " } )
AAdd( aColors, {  DC_WHEAT            ,"DC_WHEAT            " } )
AAdd( aColors, {  DC_BLUESTEEL        ,"DC_BLUESTEEL        " } )
AAdd( aColors, {  DC_BLUEGREY         ,"DC_BLUEGREY         " } )
AAdd( aColors, {  DC_BLUEMIST         ,"DC_BLUEMIST         " } )
AAdd( aColors, {  DC_BLUEVIOLET       ,"DC_BLUEVIOLET       " } )
AAdd( aColors, {  DC_CLEARBLUE        ,"DC_CLEARBLUE        " } )
AAdd( aColors, {  DC_CORNFLOWERBLUE   ,"DC_CORNFLOWERBLUE   " } )
AAdd( aColors, {  DC_DARKBLUE         ,"DC_DARKBLUE         " } )
AAdd( aColors, {  DC_DODGERBLUE       ,"DC_DODGERBLUE       " } )
AAdd( aColors, {  DC_FADEDBLUE        ,"DC_FADEDBLUE        " } )
AAdd( aColors, {  DC_ICEBLUE          ,"DC_ICEBLUE          " } )
AAdd( aColors, {  DC_ISLANDBLUE       ,"DC_ISLANDBLUE       " } )
AAdd( aColors, {  DC_LIGHTBLUE        ,"DC_LIGHTBLUE        " } )
AAdd( aColors, {  DC_LIGHTBLUESKY     ,"DC_LIGHTBLUESKY     " } )
AAdd( aColors, {  DC_LIGHTSTEELBLUE   ,"DC_LIGHTSTEELBLUE   " } )
AAdd( aColors, {  DC_MIDNIGHTBLUE     ,"DC_MIDNIGHTBLUE     " } )
AAdd( aColors, {  DC_NAVYBLUE         ,"DC_NAVYBLUE         " } )
AAdd( aColors, {  DC_PALEBLUE         ,"DC_PALEBLUE         " } )
AAdd( aColors, {  DC_PASTELBLUE       ,"DC_PASTELBLUE       " } )
AAdd( aColors, {  DC_RICHBLUE         ,"DC_RICHBLUE         " } )
AAdd( aColors, {  DC_RUYALBLUE        ,"DC_RUYALBLUE        " } )
AAdd( aColors, {  DC_SKYBLUE          ,"DC_SKYBLUE          " } )
AAdd( aColors, {  DC_BLUEHINT         ,"DC_BLUEHINT         " } )
AAdd( aColors, {  DC_WISPBLUE         ,"DC_WISPBLUE         " } )
AAdd( aColors, {  DC_XBP_BLUE         ,"DC_XBP_BLUE         " } )
AAdd( aColors, {  DC_XBP_CYAN         ,"DC_XBP_CYAN         " } )
AAdd( aColors, {  DC_XBP_DARKCYAN     ,"DC_XBP_DARKCYAN     " } )
AAdd( aColors, {  DC_TEAL             ,"DC_TEAL             " } )
AAdd( aColors, {  DC_LIGHTTEAL        ,"DC_LIGHTTEAL        " } )
AAdd( aColors, {  DC_PALETEAL         ,"DC_PALETEAL         " } )
AAdd( aColors, {  DC_FADEDTEAL        ,"DC_FADEDTEAL        " } )
AAdd( aColors, {  DC_CLEARGREEN       ,"DC_CLEARGREEN       " } )
AAdd( aColors, {  DC_COLDGREEN        ,"DC_COLDGREEN        " } )
AAdd( aColors, {  DC_DARKGREEN        ,"DC_DARKGREEN        " } )
AAdd( aColors, {  DC_DANKGREEN        ,"DC_DANKGREEN        " } )
AAdd( aColors, {  DC_DEEPGREEN        ,"DC_DEEPGREEN        " } )
AAdd( aColors, {  DC_EMERALDGREEN     ,"DC_EMERALDGREEN     " } )
AAdd( aColors, {  DC_EARTHGREEN       ,"DC_EARTHGREEN       " } )
AAdd( aColors, {  DC_FORESTGREEN      ,"DC_FORESTGREEN      " } )
AAdd( aColors, {  DC_LEAFYGREEN       ,"DC_LEAFYGREEN       " } )
AAdd( aColors, {  DC_MUDGREEN         ,"DC_MUDGREEN         " } )
AAdd( aColors, {  DC_ICEGREEN         ,"DC_ICEGREEN         " } )
AAdd( aColors, {  DC_GREENHINT        ,"DC_GREENHINT        " } )
AAdd( aColors, {  DC_GREENFROSTING    ,"DC_GREENFROSTING    " } )
AAdd( aColors, {  DC_ISLANDGREEN      ,"DC_ISLANDGREEN      " } )
AAdd( aColors, {  DC_LAWNGREEN        ,"DC_LAWNGREEN        " } )
AAdd( aColors, {  DC_LAZYGREEN        ,"DC_LAZYGREEN        " } )
AAdd( aColors, {  DC_LIGHTGREEN       ,"DC_LIGHTGREEN       " } )
AAdd( aColors, {  DC_LIGHTSEAGREEN    ,"DC_LIGHTSEAGREEN    " } )
AAdd( aColors, {  DC_PALEGREEN        ,"DC_PALEGREEN        " } )
AAdd( aColors, {  DC_PASTELGREEN      ,"DC_PASTELGREEN      " } )
AAdd( aColors, {  DC_RICHGREEN        ,"DC_RICHGREEN        " } )
AAdd( aColors, {  DC_SEAGREEN         ,"DC_SEAGREEN         " } )
AAdd( aColors, {  DC_WISPGREEN        ,"DC_WISPGREEN        " } )
AAdd( aColors, {  DC_XBP_GREEN        ,"DC_XBP_GREEN        " } )
AAdd( aColors, {  DC_CREME            ,"DC_CREME            " } )
AAdd( aColors, {  DC_CREMESICLE       ,"DC_CREMESICLE       " } )
AAdd( aColors, {  DC_DESSERT          ,"DC_DESSERT          " } )
AAdd( aColors, {  DC_FADEDDESSERT     ,"DC_FADEDDESSERT     " } )
AAdd( aColors, {  DC_LIGHTDESSERT     ,"DC_LIGHTDESSERT     " } )
AAdd( aColors, {  DC_PALEDESSERT      ,"DC_PALEDESSERT      " } )
AAdd( aColors, {  DC_GREY             ,"DC_GREY             " } )
AAdd( aColors, {  DC_ICEGREY          ,"DC_ICEGREY          " } )
AAdd( aColors, {  DC_LIGHTGREY        ,"DC_LIGHTGREY        " } )
AAdd( aColors, {  DC_MICROSOFTGREY    ,"DC_MICROSOFTGREY    " } )
AAdd( aColors, {  DC_GREYGREEN        ,"DC_GREYGREEN        " } )
AAdd( aColors, {  DC_WASHGREY         ,"DC_WASHGREY         " } )
AAdd( aColors, {  DC_DARKGREY         ,"DC_DARKGREY         " } )
AAdd( aColors, {  DC_ROCKGREY         ,"DC_ROCKGREY         " } )
AAdd( aColors, {  DC_SLATEGREY        ,"DC_SLATEGREY        " } )
AAdd( aColors, {  DC_XBP_PALEGRAY     ,"DC_XBP_PALEGRAY     " } )
AAdd( aColors, {  DC_GOLD             ,"DC_GOLD             " } )
AAdd( aColors, {  DC_FADEDGOLD        ,"DC_FADEDGOLD        " } )
AAdd( aColors, {  DC_LIGHTGOLD        ,"DC_LIGHTGOLD        " } )
AAdd( aColors, {  DC_TLCGOLD          ,"DC_TLCGOLD          " } )
AAdd( aColors, {  DC_ORANGE           ,"DC_ORANGE           " } )
AAdd( aColors, {  DC_ORANGEPEEL       ,"DC_ORANGEPEEL       " } )
AAdd( aColors, {  DC_BURNTORANGE      ,"DC_BURNTORANGE      " } )
AAdd( aColors, {  DC_LIGHTORANGE      ,"DC_LIGHTORANGE      " } )
AAdd( aColors, {  DC_PALEORANGE       ,"DC_PALEORANGE       " } )
AAdd( aColors, {  DC_FUCHSIA          ,"DC_FUCHSIA          " } )
AAdd( aColors, {  DC_HOTPINK          ,"DC_HOTPINK          " } )
AAdd( aColors, {  DC_PUFFINK          ,"DC_PUFFINK          " } )
AAdd( aColors, {  DC_XBP_PINK         ,"DC_XBP_PINK         " } )
AAdd( aColors, {  DC_XBP_DARKPINK     ,"DC_XBP_DARKPINK     " } )
AAdd( aColors, {  DC_PURPLE           ,"DC_PURPLE           " } )
AAdd( aColors, {  DC_BRIGHTPURPLE     ,"DC_BRIGHTPURPLE     " } )
AAdd( aColors, {  DC_COOLPURPLE       ,"DC_COOLPURPLE       " } )
AAdd( aColors, {  DC_PURPLEHINT       ,"DC_PURPLEHINT       " } )
AAdd( aColors, {  DC_DEEPPURPLE       ,"DC_DEEPPURPLE       " } )
AAdd( aColors, {  DC_FLATPURPLE       ,"DC_FLATPURPLE       " } )
AAdd( aColors, {  DC_LAZYPURPLE       ,"DC_LAZYPURPLE       " } )
AAdd( aColors, {  DC_LIGHTPURPLE      ,"DC_LIGHTPURPLE      " } )
AAdd( aColors, {  DC_FADEDPURPLE      ,"DC_FADEDPURPLE      " } )
AAdd( aColors, {  DC_PALEPURPLE       ,"DC_PALEPURPLE       " } )
AAdd( aColors, {  DC_RICHPURPLE       ,"DC_RICHPURPLE       " } )
AAdd( aColors, {  DC_TINTEDPURPLE     ,"DC_TINTEDPURPLE     " } )
AAdd( aColors, {  DC_RED              ,"DC_RED              " } )
AAdd( aColors, {  DC_DARKRED          ,"DC_DARKRED          " } )
AAdd( aColors, {  DC_DEEPRED          ,"DC_DEEPRED          " } )
AAdd( aColors, {  DC_CANDYRED         ,"DC_CANDYRED         " } )
AAdd( aColors, {  DC_COTTONCANDYRED   ,"DC_COTTONCANDYRED   " } )
AAdd( aColors, {  DC_LIGHTRED         ,"DC_LIGHTRED         " } )
AAdd( aColors, {  DC_PALERED          ,"DC_PALERED          " } )
AAdd( aColors, {  DC_WISPRED          ,"DC_WISPRED          " } )
AAdd( aColors, {  DC_CRIMSON          ,"DC_CRIMSON          " } )
AAdd( aColors, {  DC_INDIANRED        ,"DC_INDIANRED        " } )
AAdd( aColors, {  DC_REDHINT          ,"DC_REDHINT          " } )
AAdd( aColors, {  DC_TAN              ,"DC_TAN              " } )
AAdd( aColors, {  DC_LIGHTTAN         ,"DC_LIGHTTAN         " } )
AAdd( aColors, {  DC_XBP_BROWN        ,"DC_XBP_BROWN        " } )
AAdd( aColors, {  DC_TURQUOISE        ,"DC_TURQUOISE        " } )
AAdd( aColors, {  DC_PALETURQUOISE    ,"DC_PALETURQUOISE    " } )
AAdd( aColors, {  DC_YELLOW           ,"DC_YELLOW           " } )
AAdd( aColors, {  DC_SUNNYYELLOW      ,"DC_SUNNYYELLOW      " } )
AAdd( aColors, {  DC_DARKYELLOW       ,"DC_DARKYELLOW       " } )
AAdd( aColors, {  DC_DEEPYELLOW       ,"DC_DEEPYELLOW       " } )
AAdd( aColors, {  DC_FLATYELLOW       ,"DC_FLATYELLOW       " } )
AAdd( aColors, {  DC_FADEDYELLOW      ,"DC_FADEDYELLOW      " } )
AAdd( aColors, {  DC_HINTYELLOW       ,"DC_HINTYELLOW       " } )
AAdd( aColors, {  DC_LIGHTYELLOW      ,"DC_LIGHTYELLOW      " } )
AAdd( aColors, {  DC_PALEYELLOW       ,"DC_PALEYELLOW       " } )

IF !Empty(cColor)
  cColor := Trim(Alltrim(Upper(cColor)))
  nColor := AScan(aColors,{|a|Trim(a[2])==cColor})
  IF nColor > 0
    nColor := aColors[nColor,1]
  ENDIF
  RETURN nColor
ENDIF

IF !Empty(cTitle)
  @ 0,0 DCSAY cTitle FONT '12.Arial' SAYSIZE 0 ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y
ENDIF

@ 2,0 DCBROWSE oBrowse DATA aColors SIZE 100,30 FIT ;
      FONT '10.Lucida Console' POINTER nPointer ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

DCBROWSECOL ELEMENT 1 HEADER 'Color' WIDTH 25 PARENT oBrowse  ;
   COLOR {|nColor|{nil,nColor}}

DCBROWSECOL ELEMENT 2 HEADER 'Definition' WIDTH 20 PARENT oBrowse ;

DCGETOPTIONS RESIZE

DCREAD GUI FIT MODAL TITLE 'Colors' NOAUTORESTORE ;
  ADDBUTTONS TO lStatus EVAL {||oBrowse:right(), oBrowse:forceStable()} ;
  OPTIONS GetOptions

IF lStatus
  aColor := aColors[nPointer]
ENDIF

RETURN aColor

* ------------

METHOD SqlQueryConnection:ImportData(oSqlQuery)

LOCAL lStatus, nChoice := 1

DCMSGBOX 'This selection will import the data to a new table in ',  ;
         'the Database: ' + ::database ;
         BUTTONS {'Import from DBF Database', ;
                  'Import from CSV file', ;
                  'Import from XML', ;
                  'Import from SQL code', ;
                  'Import from JSON', ;
                  'Cancel'} ;
         CHOICE @nChoice FONT '10.Lucida Console' OWNER AppDeskTop()

IF nChoice == 1
  RETURN ::ImportDBF(oSqlQuery)
ELSEIF nChoice == 2
  RETURN ::ImportCSV(oSqlQuery)
ELSEIF nChoice == 3
  RETURN ::ImportXML(oSqlQuery)
ELSEIF nChoice == 4
  RETURN ::ImportSQL(oSqlQuery)
ELSEIF nChoice == 5
  RETURN ::ImportJSON(oSqlQuery)
ENDIF

RETURN .f.

* -----------

METHOD SqlQueryConnection:ImportXML(oSqlQuery)

DCMSGBOX 'Not completed!'

RETURN .f.

* -----------

METHOD SqlQueryConnection:ImportSQL(oSqlQuery)

DCMSGBOX 'Not completed!'

RETURN .f.

* -----------

METHOD SqlQueryConnection:ImportJSON(oSqlQuery)

LOCAL GetList[0], cFileName, aFileFilters, cTargetName, lStatus, ;
      aChildItems, i

@ 0,0 DCSAY 'This selection will create a new table in the current ODBC' + ;
            'Database (' + ::database + ') by Importing data from' + ;
            ' a JSON (JavaScript Object Notation) file.' SAYSIZE 60,3 FONT '10.Lucida Console' ;
            SAYWORDBREAK

aFileFilters := { {"JSON Files", "*.JSON"}, ;
                  {"All Files", "*.*"  } }

cTargetName := Space(50)
cFileName := Space(100)
@ 3,0 DCSAY 'Enter JSON file to IMPORT:' SAYSIZE 0 FONT '10.Lucida Console'
@ 4,0 DCGET cFileName POPUP {|c|DC_PopFile(c,,'*.Json','Load a JSON File',aFileFilters)} ;
      VALID {|x|x := File(cFileName), IIF(!x,DC_Winalert('Invalid File Name'),nil),x} ;
      GETSIZE 60

@ 6,0 DCSAY 'Target (ODBC) Table Name:' SAYSIZE 0 FONT '10.Lucida Console'
@ 7,0 DCGET cTargetName PICTURE '@' VALID {||DC_ReadEmpty(cTargetName)}

DCREAD GUI FIT TITLE 'Import a JSON file to current ODBC database' ;
   MODAL SETAPPWINDOW NOAUTORESTORE ADDBUTTONS TO lStatus

IF lStatus .AND. !Empty(cFileName) .AND. File(Alltrim(cFileName))
  IF (lStatus := _ImportJson( Alltrim(cFileName), Alltrim(cTargetName), self ))
    ::disconnect(oSqlQuery)
  ENDIF
ENDIF

RETURN lStatus

* ------------

STATIC FUNCTION _ImportJSON( cJsonFile, cTargetName, oConnection )

LOCAL aStruct[0], aStructNew, i, lGoodUse, bError, cLine, aTokens, ;
      oSession := oConnection:sessionDict, nHandle, aLine, aField

bError := ErrorBlock({|e|_Break(e)})
BEGIN SEQUENCE
lGoodUse := .f.
nHandle := DC_TxtOpen(cJsonFile)
IF nHandle <= 0
  BREAK
ENDIF
lGoodUse := .t.
END SEQUENCE
ErrorBlock(bError)

IF !lGoodUse
  DCMSGBOX 'Error opening file: ' + cJsonFile FONT '10.Lucida Console' ;
     OWNER AppDeskTop()
  RETURN .f.
ENDIF

// Get field names
cLine := DC_TxtLine(nHandle)
DO WHILE !DC_TxtEof(nHandle)
  cLine := Alltrim(DC_TxtLine(nHandle))
  IF Left(cLine,1) = '['
    cLine := Substr(cLine,2)
  ENDIF
  IF !Empty(cLine)
    IF Right(cLine,1) = ','
      cLine := Substr(cLine,1,Len(cLine)-1)
    ENDIF
    IF Left(cLine,1) = '{'
      cLine := Alltrim(Substr(cLine,2))
    ENDIF
    IF Right(cLine,1) = '}'
      cLine := Alltrim(Substr(cLine,1,Len(cLine)-1))
    ENDIF
    aTokens := DC_TokenArray(cLine,',',.t.)
    EXIT
  ELSE
    DC_TxtSkip(nHandle)
  ENDIF
ENDDO

IF !Empty(aTokens)
  FOR i := 1 TO Len(aTokens)
    aField := DC_TokenArray(aTokens[i],':' )
    AAdd( aStruct, { Alltrim(aField[1]),'C',100,0} )
  NEXT
ELSE
  DCMSGBOX 'Error in JSON file' OWNER AppDeskTop()
  FClose(nHandle)
  RETURN .f.
ENDIF

cTargetName := MakeSqlTableName(cTargetName)
aStructNew := AClone(aStruct)
AEval(aStructNew, {|e,i| aStructNew[i][1] := MakeSqlFieldName(aStructNew[i][1],oSession) })
AEval(aStructNew, {|e,i| aStructNew[i] := MakeSqlFieldType(aStructNew[i], oSession) })

bError := ErrorBlock({|e|_Break(e)})
BEGIN SEQUENCE
lGoodUse := .f.

DbCreate(cTargetName, aStructNew, oSession)
USE (cTargetName) EXCLUSIVE VIA (oSession) ALIAS TARGET NEW
lGoodUse := .t.
END SEQUENCE
ErrorBlock(bError)

IF !lGoodUse
  DCMSGBOX 'Error creating table: ' + cTargetName FONT '10.Lucida Console' ;
     OWNER AppDeskTop()
  DC_TxtClose(nHandle)
  RETURN .f.
ENDIF

DO WHILE !DC_TxtEof(nHandle)
  cLine := Alltrim(DC_TxtLine(nHandle))
  IF Left(cLine,1) = ']'
    cLine := Substr(cLine,2)
  ENDIF
  IF Right(cLine,1) = ']'
    cLine := Substr(cLine,1,Len(cLine)-1)
  ENDIF
  IF !Empty(cLine)
    IF Right(cLine,1) = ','
      cLine := Substr(cLine,1,Len(cLine)-1)
    ENDIF
    IF Left(cLine,1) = '{'
      cLine := Alltrim(Substr(cLine,2))
    ENDIF
    IF Right(cLine,1) = '}'
      cLine := Alltrim(Substr(cLine,1,Len(cLine)-1))
    ENDIF
    aTokens := DC_TokenArray(cLine,',',.t.)
    TARGET->(DbAppend())
    FOR i := 1 TO Len(aTokens)
      aField := DC_TokenArray(aTokens[i],':',.t. )
      TARGET->(FieldPut(i, Alltrim(aField[2])))
    NEXT
  ENDIF
  DC_TxtSkip(nHandle)
ENDDO
TARGET->(DbCommit())
TARGET->(dbCloseArea())
DC_TxtClose(nHandle)

DCMSGBOX 'Done. ', ;
         'Table: ' + cTargetName + ' was created in Database: ' + oConnection:database, ;
         '', ;
         'All fields were created as Type C,100,0', ;
         '', ;
         'To change field types, Select Properties from the tree menu' ;
         FONT '10.Lucida Console' OWNER AppDeskTop()

RETURN .T.

* ------------

METHOD SqlQueryConnection:ImportDBF(oSqlQuery,cDbe)

LOCAL GetList[0], cFileName, aFileFilters, cTargetName, lStatus, ;
      aChildItems, i

DEFAULT cDbe := 'ODBC'

@ 0,0 DCSAY 'This selection will create a new table in the current ' + cDbe + ;
            'Database (' + ::database + ') by Importing data from' + ;
            ' another database.' SAYSIZE 60,3 FONT '10.Lucida Console' ;
            SAYWORDBREAK

aFileFilters := { {"DBF Files", "*.DBF"}, ;
                  {"All Files", "*.*"  } }

cTargetName := Space(50)
cFileName := Space(100)
@ 3,0 DCSAY 'Enter database to IMPORT:' SAYSIZE 0 FONT '10.Lucida Console'
@ 4,0 DCGET cFileName POPUP {|c|DC_PopFile(c,,'*.DBF','Load a DBF File',aFileFilters)} ;
      VALID {|x|x := File(cFileName), IIF(!x,DC_Winalert('Invalid File Name'),nil),x} ;
      GETSIZE 60

@ 6,0 DCSAY 'Target (ODBC) Table Name:' SAYSIZE 0 FONT '10.Lucida Console'
@ 7,0 DCGET cTargetName PICTURE '@' VALID {||DC_ReadEmpty(cTargetName)}

DCREAD GUI FIT TITLE 'Import a file to current ' + cDbe + ' database' ;
   MODAL SETAPPWINDOW NOAUTORESTORE ADDBUTTONS TO lStatus

IF lStatus .AND. !Empty(cFileName) .AND. File(Alltrim(cFileName))
  IF (lStatus := _ImportDBF( Alltrim(cFileName), Alltrim(cTargetName), self ))
    ::disconnect(oSqlQuery)
  ENDIF
ENDIF

RETURN lStatus

* ------------

STATIC FUNCTION _ImportDBF( cTable, cTargetName, self )

LOCAL aStruct, aStructNew, i, aTableType, lGoodUse, bError, ;
      oSession := ::sessionDict, cPath, cSavePath := DC_CurPath(), ;
      GetList[0], oProgress, oDlg, nCount, nEvery, nRecCount, ;
      cVia, lCancelled := .f.

aTableType := DC_DbeType(cTable)

IF 'DBF' $ aTableType[3]
  cVia := 'DBFDBE'
ELSEIF 'ADS' $ aTableType[3]
  DbeSetDefault('ADSDBE')
  DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE, ADS_CDX )
  DbeInfo( COMPONENT_ORDER, ADSDBE_TBL_MODE, ADS_CDX )
  DbeInfo( COMPONENT_DATA, ADSDBE_TABLENAME_IS_ALIAS, .f. )

  cPath := DC_Path(cTable)
  cVia := ::AdsSessionCreate(cPath)
  cTable := DC_Path(cTable,.t.)
  DC_ChDir(cPath)
ELSEIF 'FOX' $ aTableType[3]
  cVia := 'FOXDBE'
ELSE
  DC_WinAlert( 'Unknown Database Type' )
  RETURN .f.
ENDIF

bError := ErrorBlock({|e|_Break(e)})
BEGIN SEQUENCE
lGoodUse := .f.

USE (cTable) ALIAS SOURCE EXCLUSIVE VIA (cVia)
lGoodUse := .t.
END SEQUENCE
ErrorBlock(bError)

IF !lGoodUse
  DCMSGBOX 'Error opening file: ' + cTable FONT '10.Lucida Console'  ;
     OWNER AppDeskTop()
  RETURN .f.
ENDIF

aStruct := DbStruct()
IF cTargetName = NIL
  cTargetName := cTable
ENDIF
cTargetName := MakeSqlTableName(cTargetName)
aStructNew := AClone(aStruct)

IF ::type = 'ODBC'
  AEval(aStructNew, {|e,i| aStructNew[i][1] := MakeSqlFieldName(aStructNew[i][1],oSession) })
  AEval(aStructNew, {|e,i| aStructNew[i] := MakeSqlFieldType(aStructNew[i], oSession) })
ENDIF

bError := ErrorBlock({|e|_Break(e)})
BEGIN SEQUENCE
lGoodUse := .f.

DbCreate(cTargetName, aStructNew, oSession)
USE (cTargetName) EXCLUSIVE VIA (oSession) ALIAS TARGET NEW
lGoodUse := .t.
END SEQUENCE
ErrorBlock(bError)

IF !lGoodUse
  DCMSGBOX 'Error creating table: ' + cTargetName FONT '10.Lucida Console' ;
     OWNER AppDeskTop()
  RETURN .f.
ENDIF

@ 0,0 DCSAY 'Creating table: ' + cTargetName

@ 2,0 DCPROGRESS oProgress SIZE 80,1 PERCENT COLOR GRA_CLR_CYAN, GRA_CLR_WHITE

@ 4,0 DCPUSHBUTTON CAPTION 'Cancel' SIZE 10,1.2 ;
      ACTION {||lCancelled := .t.}

DCREAD GUI FIT TITLE 'Importing Data' PARENT @oDlg EXIT

nRecCount := SOURCE->(RecCount())
nEvery := Int(nRecCount/200)
IF nEvery > 5000
  nEvery := 5000
ENDIF

nCount := 0
DO WHILE !SOURCE->(Eof()) .AND. !lCancelled
  nCount++
  IF nCount%100 == 0
    DC_CompleteEvents()
  ENDIF
  IF nEvery > 0 .AND. nCount%nEvery == 0
    DC_GetProgress(oProgress,nCount,nRecCount)
  ENDIF
  TARGET->(DbAppend())
  FOR i:= 1 TO TARGET->(Fcount())
    TARGET->(FieldPut(i, SOURCE->(FieldGet(i))))
  NEXT
  SOURCE->(dbSkip())
ENDDO
TARGET->(DbCommit())
SOURCE->(dbCloseArea())
TARGET->(dbCloseArea())

IF Valtype(cVia) == 'O'
  cVia:disconnect()
ENDIF

IF !lCancelled
  DCMSGBOX 'Done. ', ;
         'Table: ' + cTargetName + ' was created in Database: ' + ::database ;
         FONT '10.Lucida Console' OWNER AppDeskTop()
ENDIF

oDlg:destroy()

DC_ChDir(cSavePath)

RETURN .T.

* ------------

METHOD SqlQueryConnection:ImportCSV(oSqlQuery)

LOCAL GetList[0], cFileName, aFileFilters, cTargetName, lStatus, ;
      aChildItems, i

@ 0,0 DCSAY 'This selection will create a new table in the current ODBC' + ;
            'Database (' + ::database + ') by Importing data from' + ;
            ' a CSV (Comma Separated Text) file.' SAYSIZE 60,3 FONT '10.Lucida Console' ;
            SAYWORDBREAK

aFileFilters := { {"CSV Files", "*.CSV"}, ;
                  {"All Files", "*.*"  } }

cTargetName := Space(50)
cFileName := Space(100)
@ 3,0 DCSAY 'Enter CSV file to IMPORT:' SAYSIZE 0 FONT '10.Lucida Console'
@ 4,0 DCGET cFileName POPUP {|c|DC_PopFile(c,,'*.CSV','Load a CSV File',aFileFilters)} ;
      VALID {|x|x := File(cFileName), IIF(!x,DC_Winalert('Invalid File Name'),nil),x} ;
      GETSIZE 60

@ 6,0 DCSAY 'Target (ODBC) Table Name:' SAYSIZE 0 FONT '10.Lucida Console'
@ 7,0 DCGET cTargetName PICTURE '@' VALID {||DC_ReadEmpty(cTargetName)}

DCREAD GUI FIT TITLE 'Import a file to current ODBC database' ;
   MODAL SETAPPWINDOW NOAUTORESTORE ADDBUTTONS TO lStatus

IF lStatus .AND. !Empty(cFileName) .AND. File(Alltrim(cFileName))
  IF (lStatus := _ImportCSV( Alltrim(cFileName), Alltrim(cTargetName), self ))
    ::disconnect(oSqlQuery)
  ENDIF
ENDIF

RETURN lStatus

* ------------

STATIC FUNCTION _ImportCSV( cCSVFile, cTargetName, oConnection )

LOCAL aStruct[0], aStructNew, i, lGoodUse, bError, cLine, aTokens, ;
      oSession := oConnection:sessionDict, nHandle

bError := ErrorBlock({|e|_Break(e)})
BEGIN SEQUENCE
lGoodUse := .f.
nHandle := DC_TxtOpen(cCSVFile)
IF nHandle <= 0
  BREAK
ENDIF
lGoodUse := .t.
END SEQUENCE
ErrorBlock(bError)

IF !lGoodUse
  DCMSGBOX 'Error opening file: ' + cCSVFile FONT '10.Lucida Console' ;
     OWNER AppDeskTop()
  RETURN .f.
ENDIF

cLine := DC_TxtLine(nHandle)
aTokens := DC_TokenArray(cLine,',')
FOR i := 1 TO Len(aTokens)
  AAdd(aStruct,{Alltrim(aTokens[i]),'C',100,0})
NEXT

cTargetName := MakeSqlTableName(cTargetName)

IF oConnection:type = 'ODBC'
  aStructNew := AClone(aStruct)
  AEval(aStructNew, {|e,i| aStructNew[i][1] := MakeSqlFieldName(aStructNew[i][1],oSession) })
  AEval(aStructNew, {|e,i| aStructNew[i] := MakeSqlFieldType(aStructNew[i], oSession) })
ENDIF

bError := ErrorBlock({|e|_Break(e)})
BEGIN SEQUENCE
lGoodUse := .f.

DbCreate(cTargetName, aStructNew, oSession)
USE (cTargetName) EXCLUSIVE VIA (oSession) ALIAS TARGET NEW
lGoodUse := .t.
END SEQUENCE
ErrorBlock(bError)

IF !lGoodUse
  DCMSGBOX 'Error creating table: ' + cTargetName FONT '10.Lucida Console' ;
     OWNER AppDeskTop()
  DC_TxtClose(nHandle)
  RETURN .f.
ENDIF

DC_TxtSkip(nHandle)
DO WHILE !DC_TxtEof(nHandle)
  cLine := DC_TxtLine(nHandle)
  IF Empty(cLine)
    DC_TxtSkip(nHandle)
    LOOP
  ENDIF
  aTokens := DC_TokenArray(cLine,',')
  TARGET->(DbAppend())
  FOR i:= 1 TO TARGET->(Fcount())
    TARGET->(FieldPut(i, aTokens[i]))
  NEXT
  DC_TxtSkip(nHandle)
ENDDO
TARGET->(DbCommit())
TARGET->(dbCloseArea())
DC_TxtClose(nHandle)

DCMSGBOX 'Done. ', ;
         'Table: ' + cTargetName + ' was created in Database: ' + oConnection:database, ;
         '', ;
         'All fields were created as Type C,100,0', ;
         '', ;
         'To change field types, Select Properties from the tree menu' ;
         FONT '10.Lucida Console'  OWNER AppDeskTop()

RETURN .T.


* ------------

STATIC FUNCTION MakeSqlTableName(cTable)

LOCAL c, i, cNotAllowed := "\/()"

i := Rat("\", cTable)
IF i > 0
  cTable := Substr(cTable, i+1)
ENDIF
i := Rat("/", cTable)
IF i > 0
  cTable := Substr(cTable, i+1)
ENDIF
i := Rat(".", cTable)
IF i > 0
  cTable := Substr(cTable,1, i-1)
ENDIF

c := ""
FOR i:=1 TO len(cTable)
  IF !cTable[i] $ cNotAllowed
    c += cTable[i]
  ENDIF
NEXT

RETURN c


// Check if field name violates SQL syntax by using a keyword
// This will be corrected by adding and underscore automatically.

STATIC FUNCTION MakeSqlFieldName(cFieldName,oSession )

LOCAL c, aKeywords, aMoreWords, i

aMoreWords := { 'DESC' }

c := cFieldName
aKeyWords := OdbcListSqlKeywords(oSession)

FOR i := 1 TO Len(aMoreWords)
  IF AScan(aKeyWords[i],aMoreWords[i])==0
    AAdd(aKeywords,aMoreWords[i])
  ENDIF
NEXT

IF ASCAN(aKeyWords, cFieldName) > 0
  c += "_"
  DCMSGBOX "Field " + cFieldname + " changed to: " + c FONT '10.Lucida Console' ;
     OWNER AppDeskTop()
ENDIF

RETURN c

// Check if source type is supported on target

STATIC FUNCTION MakeSqlFieldType(aFldRec, oSession)

STATIC aAltTypes := { { "C", "MWX" },;
                      { "N", "FI"  },;
                      { "L", "NIF" },;
                      { "D", "C"   } }

LOCAL cTgTypes := oSession:setProperty(ODBCSSN_DATATYPES)
LOCAL aRec := AClone(aFldRec), nPos, i

IF ! aFldRec[2] $ cTgTypes
  // search for alternative types
  nPos := AScan(aAltTypes, {|e| e[1] == aFldRec[2]})
  IF nPos > 0
    // find a supported type
    FOR i:= 1 TO len(aAltTypes[nPos][2])
      IF aAltTypes[nPos][2][i] $ cTgTypes
        aRec[2] := aAltTypes[nPos][2][i]
      ENDIF
    NEXT
  ENDIF
ENDIF

// set memo field to 0 otherwise ODBCDBE assumes this is a var char
IF (aFldRec[2] == "M") .OR. (aFldRec[2] == "V")
  aRec[3] = 0
ENDIF

RETURN aRec


/*
Range of Batch dates (CMDETAIL)

SELECT * FROM cmdetail where batchdate > startdate .AND. batchdate <= enddate

*/

#if XPPVER > 2000000
FUNCTION DecryptFromHex( cEncryptedString, cKey )

LOCAL oAes, cResult

// restore high order bits
cEncryptedString := HexToStr(cEncryptedString)

// create AesCrypt()-instance using the key
oAes := AesCrypt():new(cKey)

// prepare input buffer length
oAes:prepareBuffer(@cEncryptedString)

// encrypt buffer
cResult := oAes:decrypt(cEncryptedString)

RETURN cResult

* ------------

FUNCTION EncryptToHex( cString, cKey )

LOCAL oAes, cResult

// create AesCrypt()-instance using the key
oAes := AesCrypt():new(cKey)

// prepare input buffer length
oAes:prepareBuffer(@cString)

// encrypt buffer
cResult := oAes:encrypt(cString)

// keep only low order bits
cResult := StrToHex(cResult)

RETURN cResult
#endif

* -------------

FUNCTION SqlQueryExecute( cStatement )

LOCAL oConnection := saConnections[ThreadID()]

soSqlQuery:executeSql( cStatement, , oConnection,, 0 )

RETURN nil

* -------------

FUNCTION SqlQueryBrowse( bItemMarked, bItemSelected, bEval )

LOCAL oConnection := saConnections[ThreadID()]

soSqlQuery:DataBrowse( .f.,, oConnection,,,,,,bItemMarked,bItemSelected,bEval )

RETURN nil

* -------------

FUNCTION SqlQueryInput()

LOCAL GetList[0], aInput[9], i, lStatus

AFill(aInput,Space(50))

FOR i := 1 TO Len(aInput)
  @ i,0 DCSAY 'Input Param #' + Alltrim(Str(i)) GET aInput[i] SAYSIZE 15 SAYRIGHTBOTTOM
NEXT

DCREAD GUI FIT MODAL ADDBUTTONS TO lStatus TITLE 'Enter some parameters' NOAUTORESTORE

FOR i := 1 TO Len(aInput)
  aInput[i] := Trim(aInput[i])
NEXT
IF lStatus
ENDIF

RETURN aInput

* -------------

FUNCTION SqlQueryScript( cTitle, nWhich )

LOCAL oConnection := saConnections[ThreadID()]

DEFAULT nWhich := 0

IF nWhich $ { 0,1,2,3,5 }
  RETURN soSqlQuery:LoadScript( cTitle, oConnection, .t., 0 )
ELSEIF nWhich = 4
  RETURN soSqlQuery:CommandWindow( oConnection, cTitle, .t. )
ENDIF

RETURN .f.

* ------------

FUNCTION SqlQueryCommandLineHelp()

 DC_MsgBox({'Command line Options:', ;
            '', ;
            '/co or /conn:<group name> - *REQUIRED* Make connection to <group name> in <cIniFile>', ;
            '/sf or /sqlfile:<cSqlFile> - Load SQL from <cSqlFile> and execute', ;
            '/ss or /sqlscript:<cTitle> - Load and Execute SQL Script <cTitle>', ;
            '/st or /sqltable:<cTable> - Execute SELECT * from <cTable>', ;
            '/sq or /sqlstatement:<cStatement> - Execute <cStatement>', ;
            '/sq or /sql:<cStatement> - Execute <cStatement>', ;
            '/pr or /proc:<cProc> - Run procedure <cProc>', ;
            '/vw or /view:<cView> - Execute View <cView>', ;
            '/cs or /cmdscript:<cCommand> - Load and Execute COMMAND Script <cCommand>', ;
            '/it or /isamtable:<cDbfFile> - Open table <cDbfFile> and browse', ;
            '/is or /isamscript:<cTitle> - Load and Execute ISAM Script <cTitle>', ;
            '', ;
            '/ini:<cIniFile> - Load <inifile>. default is SqlQuery.Ini', ;
            '/cc:<n> - Cache columns greater than <n>', ;
            '', ;
            'ex 1: SqlQuery /co:ADS_15 /sf:arreport.sql /cc:40', ;
            'ex 2: SqlQuery /co:ADS_1  /it:mn_cor.dbf', ;
            'ex 3: SqlQuery /co:ADS_15 /ss:"2018 Sales"', ;
            'ex 4: SqlQuery /co:ADS_1  /pr:"MedallionDrivers"'}, ;
            ,,,,,,,,,,,'10.Lucida Console',,,,,,,,AppDeskTop())

RETURN nil

* ------------

Function Is_Internet(cUrl)

LOCAL nFlag := 0
LOCAL nReserved := 1
DEFAULT cUrl := 'http://bb.donnay-software.com'

RETURN InternetCheckConnectionA( @cUrl, 1, 0 ) > 0

DLLFUNCTION InternetCheckConnectionA( @cUrl, nFlag, nReserved ) USING STDCALL FROM WININET.DLL

* ------------

/*
CLASS AdsCallback FROM DllCallback

EXPORTED:

METHOD init, execute

ENDCLASS

METHOD AdsCallback:init()

SUPER:init(,,DLL_TYPE_UINT64,DLL_TYPE_UINT32)

RETURN self

METHOD AdsCallback:execute( usPercent, uiCallbackId )

WTF ProcName(), usPercent, uiCallbackId

RETURN 0
*/

#include "odbcdbe.ch"
#include "common.ch"

/*
 * SqlStmtExec(<cCmd>, [<oSession>], [<cSqlErr>]) => lReturn
 * Execute any SQL statement. A result set is open.
 *
 * xReturn: .F. if statement execution failed
 *          .T. if statement execution succeeded
 *
 * Usage:
 * IF SqlStmtExec("SELECT * FROM cust")
 *    ? Reccount()
 *    CLOSE
 * ENDIF
 */
FUNCTION SqlStmtExec(cCmd, oSession, cSqlErr, lNoSelect, lSuppressError, cAlias )
LOCAL bErr
LOCAL oError
LOCAL lRet
LOCAL no1, no2, no3

    DEFAULT oSession TO OdbcDefSession()
    DEFAULT lNoSelect TO .F.
    DEFAULT lSuppressError TO .T.

    IF oSession = NIL
        RETURN .F.
    ENDIF

    IF lNoSelect
        no1 := oSession:setProperty(ODBCSSN_CURSORTYPE, ODBC_VALUE_UNCHANGED )
        no2 := oSession:setProperty(ODBCSSN_CONCURRENCY, ODBC_VALUE_UNCHANGED )
        no3 := oSession:setProperty(ODBCSSN_SCROLLABLE, ODBC_VALUE_UNCHANGED )
    ENDIF

    cSqlErr := ""
    IF Rtrim(cCmd)[-1]!=";"
        cCmd += ";"
    ENDIF

    BEGIN SEQUENCE
        DbUseArea( .T., oSession, cCmd, cAlias )
        lRet := .T.
    RECOVER USING oError
        cSqlErr := oSession:getLastMessage()
        lRet := .F.
    END SEQUENCE

    /* restore session settings */
    IF no1 != NIL
        oSession:setProperty(ODBCSSN_CURSORTYPE, no1 )
    ENDIF
    IF no2 != NIL
        oSession:setProperty(ODBCSSN_CONCURRENCY, no2 )
    ENDIF
    IF no3 != NIL
        oSession:setProperty(ODBCSSN_SCROLLABLE, no3 )
    ENDIF

    IF !lRet .AND. !lSuppressError
        RETURN Eval(bErr, oError)
    ENDIF

RETURN lRet
